-- name=int_button_diary
--******************************************************************************************
function public.Init ()
  --
  public.DIRECTION = 0;

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.DIARY_STATE = "old";

  ObjSet("obj_int_button_diary", {
    event_mup = public.MouseDown,
    event_menter = public.MouseEnterAnim,
    event_mleave = public.MouseLeaveAnim
  });
  
  ObjAttach("int_button_diary", interface.originhub);
  ObjSet("int_button_diary",  { pos_z = 5 });

end;
-------------------------------------------------------------------------------------
function public.DiarySetActive( spr_name )
  
  ObjSet("obj_int_button_diary",  { alp = 1, input = 1, active = 1, visible = 1 });
                     
  ObjDelete(spr_name);
  
end;
-------------------------------------------------------------------------------------
function public.DiaryCheckNewMessage()
  
  --DbgTrace(ng_global.map_diary_notes_read[ ng_global.currentprogress ].." "..#ng_global.map_diary_notes[ ng_global.currentprogress ]);
  
  if ng_global.map_diary_notes_read[ ng_global.currentprogress ] and ng_global.map_diary_notes_read[ ng_global.currentprogress ] < #ng_global.map_diary_notes[ ng_global.currentprogress ] then
    
    if private.DIARY_STATE == "old" then
      
      private.DIARY_STATE = "new";
      
      --ObjAttach("vid_int_button_diary_mail_new", "obj_int_button_diary");
      --ObjDetach("vid_int_button_diary_mail");
      --
      --ObjMultiSet( { {"vid_int_button_diary_mail_new", { playing = 1 }},
      --               {"vid_int_button_diary_mail", { playing = 0 }} } );
      
    end;
    
  else
    
    if private.DIARY_STATE == "new" then
      
      private.DIARY_STATE = "old";
      
      --ObjAttach("vid_int_button_diary_mail", "obj_int_button_diary");
      --ObjDetach("vid_int_button_diary_mail_new");
      --
      --ObjMultiSet( { {"vid_int_button_diary_mail_new", { playing = 0 }},
      --               {"vid_int_button_diary_mail", { playing = 1 }} } );
      
    end;
    
  end;
  
end;
-------------------------------------------------------------------------------------
function public.DiaryActivate( spr_name, func_after )
  
  func_after = func_after or false;
  --if not func_after then
  --  func_after = "";
  --end;
  
  ObjSet(spr_name,  { input = 0 });
  
  local func_end = function ()
    
    if func_after then
      func_after();
    end;
    
    ObjSet("obj_int_button_diary",  { input = 1 });
    
  end;
  
  local anm_map = function ()
  
    ObjSet("obj_int_button_diary",  { visible = 1, active = 1 });
    ObjDelete(spr_name);
    
    ObjAnimate("obj_int_button_diary", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  SendMessage( Command_Transporter_MoveObject,
    {
      type       = Trans_SceneToTaskPanel,
      obj_name   = spr_name,
      toobj_name = "obj_int_button_diary",
      end_trig   = anm_map,
      --red_time   = 0.2
    } );
  
end;
--******************************************************************************************
function public.MouseDown()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_book_down_left_click");

  --if common.IsInSubRoom() then
  --  common.CloseSubRoom();
  --end;

  if interface.GetCurrentComplexInv() ~= "" then
    common_impl.HideComplexItem();
  end;

  ObjSet("obj_int_button_diary",  { input = 0 });
  int_diary.ShowDiary();

end;
--******************************************************************************************
function public.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_diary_focus";
  
  local alf = ObjGet( obj ).alp;
  local tme = ( 1 - alf ) * 0.3;;
  
  if tme > 0.2 then
    --cmn.PlayAudio("snd", "assets/levels/common/audio/");
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, 1 });

end;
--******************************************************************************************
function public.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_diary_focus";
  
  local alf = ObjGet( obj ).alp;
  local tme = alf * 0.3;;
  
  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, 0 });

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --
  
  else

    --

  end;

end;
--******************************************************************************************