-- name=int_button_map_impl
--******************************************************************************************
function public.Init ()
  --
  public.DIRECTION = 0;

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  
  private.STATE = 0;
  private.VID_FRAMES = 12;

  ObjSet("obj_int_button_map", {
    event_mup = public.MouseDown,
    event_menter = public.MouseEnterAnim,
    event_mleave = public.MouseLeaveAnim
  });

end;
-------------------------------------------------------------------------------------
function public.MapSetActive( spr_name )
  
  ObjSet("obj_int_button_map",  { alp = 1, input = 1, active = 1, visible = 1 });
                     
  ObjDelete(spr_name);
  
end;
-------------------------------------------------------------------------------------
function public.MapActivate( spr_name, func_after )
  
  func_after = func_after or false;
  --if not func_after then
  --  func_after = "";
  --end;
  
  ObjSet(spr_name,  { input = 0 });
  
  local func_end = function ()
    
    if func_after then
      func_after();
    end;
    
    ObjSet("obj_int_button_map",  { input = 1 });
    
  end;
  
  local anm_map = function ()
  
    ObjSet("obj_int_button_map",  { visible = 1, active = 1 });
    ObjDelete(spr_name);
    
    ObjAnimate("obj_int_button_map", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  SendMessage( Command_Transporter_MoveObject,
    {
      type       = Trans_SceneToTaskPanel,
      obj_name   = spr_name,
      toobj_name = "obj_int_button_map",
      end_trig   = anm_map,
      --red_time   = 0.2
    } );
  
end;
--******************************************************************************************
function public.MouseDown()

  ObjSet("obj_int_button_map",  { input = 0 });
  public.MouseLeaveAnim();
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_map_down_left_click");

  --if common.IsInSubRoom() then
  --  common.CloseSubRoom();
  --end;

  if interface.GetCurrentComplexInv() ~= "" then
    common_impl.HideComplexItem();
  end;

  if ng_global.currentprogress == "std" and ng_global.progress[ "std" ].common.chapter == "level1" then

    if cmn.IsEventDone("tutor_10") and not(cmn.IsEventDone("opn_maptutor")) then

      cmn.SetEventDone("opn_maptutor");

      cmn.TutorialShow( "tutor_16", 0, 512, 384 );

    end;

  end;

  int_button_map.MouseDown();

end;
--******************************************************************************************
function public.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

--  local obj = "spr_int_button_map_focus";
--  
--  local alf = ObjGet( obj ).alp;
--  local tme = ( 1 - alf ) * 0.3;;
--  
--  if tme > 0.2 then
--    --cmn.PlayAudio("snd", "assets/levels/common/audio/");
--  end;
--
--  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, 1 });

  local new_frame = 0;
  
  if private.STATE == 2 then
    
    SndStop("assets/levels/common/audio/aud_map_down_left_2", 0.5);
    
    ObjSet("vid_int_button_map_2",  { playing = 0 });
    local c_frame = ObjGet("vid_int_button_map_2").frame;
    
    new_frame = private.VID_FRAMES - c_frame;
    
    if new_frame >= private.VID_FRAMES or new_frame < 0 then
      new_frame = 0;
    end;
    
  end;
  
  local func_after = function ()
    private.STATE = 0;
  end;
  
  if new_frame < 5 then
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_map_down_left_1");
  end;
  
  private.STATE = 1;
  
  ObjSet("vid_int_button_map_1",  { frame = new_frame });
  
  ObjDetach("vid_int_button_map_2");
  ObjAttach("vid_int_button_map_1", "obj_int_button_map");
  
  --DbgTrace(new_frame)
  
  ObjSet("vid_int_button_map_1",  { playing = 1, endtrig = func_after });

end;
--******************************************************************************************
function public.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  --local obj = "spr_int_button_map_focus";
  --
  --local alf = ObjGet( obj ).alp;
  --local tme = alf * 0.3;;
  --
  --ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, 0 });
  
  local new_frame = 0;
  
  if private.STATE == 1 then
    
    SndStop("assets/levels/common/audio/aud_map_down_left_1", 0.5);
  
    ObjSet("vid_int_button_map_1",  { playing = 0 });
    local c_frame = ObjGet("vid_int_button_map_1").frame;
    
    new_frame = private.VID_FRAMES - c_frame;
    
    if new_frame >= private.VID_FRAMES or new_frame < 0 then
      new_frame = 0;
    end;
    
  end;
  
  local func_after = function ()
    private.STATE = 0;
  end;
  
  if new_frame < 5 then
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_map_down_left_2");
  end;
  
  private.STATE = 2;
  
  ObjSet("vid_int_button_map_2",  { frame = new_frame });
  
  ObjDetach("vid_int_button_map_1");
  ObjAttach("vid_int_button_map_2", "obj_int_button_map");
  
  --DbgTrace(new_frame)
  
  ObjSet("vid_int_button_map_2",  { playing = 1, endtrig = func_after });
  
end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --
  
  else

    --

  end;

end;
--******************************************************************************************