-- name=int_diary
--******************************************************************************************
function public.Init ()
  
  private.SHOW_ANIM_TIME = 0.3;
  private.HIDE_ANIM_TIME = 0.3;
  
  private.MAP_ICON_MOUSE_OVER_ANIM_TIME = 0.3; --время анимации подсветки мест локации
  
  private.HANDS_COUNT = 3;
  private.HANDS_CURRENT = 1;
  private.HANDS_PARTS = {1, 2, 1};
  
  ObjAttach("int_diary", interface.originhub);
  ObjSet("int_diary",  { pos_z = 200 });

  public.active = false;
end;
--******************************************************************************************
function public.MouseEnterBack()

  SetCursor(CURSOR_HAND);

  local obj = "spr_int_diary_btn_back_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MAP_ICON_MOUSE_OVER_ANIM_TIME;
  
  if tme > 0.13 then
    --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_mainmenu_menter");
  end;

  ObjAnimate( obj, 8, 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
------------------------------------------------------------------------------------
function public.MouseLeaveBack()

  SetCursor(CURSOR_DEFAULT);

  local obj = "spr_int_diary_btn_back_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MAP_ICON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, 8, 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
------------------------------------------------------------------------------------
function public.SetVisibleHands( num )
  
  private.HANDS_CURRENT = num;
  
  for i = 1, private.HANDS_COUNT, 1 do
    
    if i == private.HANDS_CURRENT then
      
      for j = 1, private.HANDS_PARTS[ i ], 1 do
        ObjMultiSet( { {"spr_int_diary_hand_right_"..i.."_"..j, { alp = 1 }},
                       {"spr_int_diary_hand_left_"..i.."_"..j, { alp = 1 }} } );
      end;
                     
    else 
       
      for j = 1, private.HANDS_PARTS[ i ], 1 do
        ObjMultiSet( { {"spr_int_diary_hand_right_"..i.."_"..j, { alp = 0 }},
                       {"spr_int_diary_hand_left_"..i.."_"..j, { alp = 0 }} } );
      end;
     
    end;
                     
  end;
  
end;
--******************************************************************************************
function public.AddDiarypage( index )

  local pages_count = #ng_global.map_diary_notes[ ng_global.currentprogress ];
  local clone_check = false;

  for i = 1, pages_count, 1 do
  
    if ng_global.map_diary_notes[ ng_global.currentprogress ][i] == index then
      clone_check = true;
      break;
    end;
    
  end;

  if not clone_check then

    ng_global.map_diary_pages[ ng_global.currentprogress ] = pages_count + 1;
    ng_global.map_diary_current_page[ ng_global.currentprogress ] = ng_global.map_diary_pages[ ng_global.currentprogress ];

    ng_global.map_diary_notes[ ng_global.currentprogress ][ ng_global.map_diary_pages[ ng_global.currentprogress ] ] = index;

    private.AddDiaryPageAnim( index );

  end;

end;
--******************************************************************************************
function private.AddDiaryPageAnim()

  local fx_item = "fx_int_map_effect_add_page";
  
  int_button_diary.DiaryCheckNewMessage();

  if not ObjGet(fx_item) then

    local cur_note = cmn.GetCurrentNote();

    --if cur_note == "" then
    --  cur_note = common.GetCurrentSubRoom();
    --end;
    
    local pos_note;
    
    if cur_note == "" then
      pos_note = { 512, 384 };
    else 
      pos_note = GetObjPosByObj(cur_note);
    end;

    --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_note_fx");

    ObjCreate( fx_item, "partsys" );
    ObjSet( fx_item, { res = "assets/interface/resources/map/fx/p_diary", pos_x = pos_note[1], pos_y = pos_note[2] } );
    ObjAttach(fx_item, GetCurrentRoom());
    
    --DbgTrace( ObjGet(fx_item).pos_x.." "..ObjGet(fx_item).pos_y );

    SendMessage( Command_Transporter_MoveObject,
    {
      type       = Trans_HintFly,
      obj_name   = fx_item,
      toobj_name = "obj_int_button_diary",
      end_trig   = function () ObjDelete( fx_item ); end,
      --red_time   = 0.2
    } );
    
    --DbgTrace( ObjGet(fx_item).pos_x.." "..ObjGet(fx_item).pos_y );

  end;

end;
--******************************************************************************************
function public.ShowDiary()
  
  
  PauseLevel( 1 );
  
  ObjSet( "int_diary", { active = true, visible = true } );

  local trg = function () ObjSet("int_diary", { input = 1 } ); ObjSet("spr_int_button_diary_mail_new", { alp = 0 } ); end;

  local tme = private.SHOW_ANIM_TIME;

  ObjSet( "anm_int_diary_back", { frame = 0, playing = true } );

  ObjAnimate( "int_diary", 8, 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

  --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_opn_journal");

  public.SetDiary();

  public.active = true;
  
end;
--******************************************************************************************
function public.HideDiary()
  
  PauseLevel( 0 );

  ObjSet( "int_diary", { input = 0 } );

  local trg = function () ObjSet( "int_diary", { active = true, visible = true } ); ObjSet("obj_int_button_diary",  { input = 1 }); end;

  local tme = private.HIDE_ANIM_TIME;

  ObjAnimate( "int_diary", 8, 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

  --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_cls_journal");

  public.active = false;
  
end;
--******************************************************************************************
function public.getActive()
  return public.active;
end;  
--******************************************************************************************
function public.SetDiary()

    if ng_global.map_diary_notes_read[ ng_global.currentprogress ] then
      ng_global.map_diary_notes_read[ ng_global.currentprogress ] = #ng_global.map_diary_notes[ ng_global.currentprogress ];
      --ObjStopAnimate("spr_int_map_note_journal_glow", "alp");
      int_button_diary.DiaryCheckNewMessage();
    end;

    local page_num = ng_global.map_diary_current_page[ ng_global.currentprogress ];

    if ( math.fmod( page_num, 2 ) == 0 ) then
      page_num = page_num - 1;
    end;

    if ( page_num > 1 ) then
      ObjMultiSet( {
        { "obj_int_diary_btn_left", { input = 1 } },
        { "spr_int_diary_btn_left_na", { alp = 0 } },
        { "spr_int_diary_btn_left", { alp = 1 } }
      } );
    else
      ObjMultiSet( {
        { "obj_int_diary_btn_left", { input = 0 } },
        { "spr_int_diary_btn_left_na", { alp = 1 } },
        { "spr_int_diary_btn_left", { alp = 0 } }
      } );
    end;

    if ( ( page_num + 1 ) < ng_global.map_diary_pages[ ng_global.currentprogress ] ) then
      ObjMultiSet( {
        { "obj_int_diary_btn_right", { input = 1 } },
        { "spr_int_diary_btn_right_na", { alp = 0 } },
        { "spr_int_diary_btn_right", { alp = 1 } }
      } );
    else
      ObjMultiSet( {
        { "obj_int_diary_btn_right", { input = 0 } },
        { "spr_int_diary_btn_right_na", { alp = 1 } },
        { "spr_int_diary_btn_right", { alp = 0 } }
      } );
    end;

  if ng_global.map_diary_pages[ ng_global.currentprogress ] ~= 0 then

    ObjMultiSet( { {"txt_int_diary_page_left", { text = page_num }},
                   {"txt_int_diary_page_right", { text = page_num + 1 }} } );

    ObjMultiSet( { {"txt_int_diary_left", { text = "str_diary_page_"..ng_global.map_diary_notes[ ng_global.currentprogress ][ page_num ] }},
                   {"spr_int_diary_left", { alp = 1, res = "assets/interface/resources/diary/diary_page_"..ng_global.map_diary_notes[ ng_global.currentprogress ][ page_num ] }}} );

    if ( page_num < ng_global.map_diary_pages[ ng_global.currentprogress ] ) then

      page_num = page_num + 1;

      ObjMultiSet( { {"txt_int_diary_right", { text = "str_diary_page_"..ng_global.map_diary_notes[ ng_global.currentprogress ][ page_num ] }},
                     {"spr_int_diary_right", { alp = 1, res = "assets/interface/resources/diary/diary_page_"..ng_global.map_diary_notes[ ng_global.currentprogress ][ page_num ] }} } );

    else

      ObjMultiSet( { {"txt_int_diary_right", { text = "" }},
                     {"spr_int_diary_right", { alp = 0, res = "" }} } );

    end;

  else 

    ObjMultiSet( { {"txt_int_diary_left", { text = "" }},
                   {"spr_int_diary_left", { alp = 0, res = "" }} } );

  end;

  --ObjAnimate( "obj_int_map_diary", 8,0,0, "", { 0,0,0, 0.3,0,1 } );
  
  ObjAnimate( "txt_int_diary_right", 8,0,0, "", { 0,0,0, 0.3,0,1 } );
  ObjAnimate( "txt_int_diary_left", 8,0,0, "", { 0,0,0, 0.3,0,1 } );
  ObjAnimate( "spr_int_diary_right", 8,0,0, "", { 0,0,0, 0.3,0,1 } );
  ObjAnimate( "spr_int_diary_left", 8,0,0, "", { 0,0,0, 0.3,0,1 } );
  ObjAnimate( "obj_int_diary_page_left", 8,0,0, "", { 0,0,0, 0.3,0,1 } );
  ObjAnimate( "obj_int_diary_page_right", 8,0,0, "", { 0,0,0, 0.3,0,1 } );

end;
--******************************************************************************************
function public.MouseClkBtnDiary( side )

  ObjSet( "obj_int_diary_btn_"..side, { input = 0 } );

  if ( side == "left" ) then

    ng_global.map_diary_current_page[ ng_global.currentprogress ] = ng_global.map_diary_current_page[ ng_global.currentprogress ] - 2;

  elseif ( side == "right" ) and ( math.fmod( ng_global.map_diary_current_page[ ng_global.currentprogress ], 2 ) == 0 ) then

    ng_global.map_diary_current_page[ ng_global.currentprogress ] = ng_global.map_diary_current_page[ ng_global.currentprogress ] + 1;

  elseif ( side == "right" ) and ( math.fmod( ng_global.map_diary_current_page[ ng_global.currentprogress ], 2 ) ~= 0 ) then

    ng_global.map_diary_current_page[ ng_global.currentprogress ] = ng_global.map_diary_current_page[ ng_global.currentprogress ] + 2;

  end;

  --ObjAnimate( "obj_int_map_diary", 8,0,0, public.SetDiary, { 0,0,1, 0.3,0,0 } );
  
  ObjAnimate( "txt_int_diary_right", 8,0,0, public.SetDiary, { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "txt_int_diary_left", 8,0,0, "", { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "spr_int_diary_right", 8,0,0, "", { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "spr_int_diary_left", 8,0,0, "", { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "obj_int_diary_page_left", 8,0,0, "", { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "obj_int_diary_page_right", 8,0,0, "", { 0,0,1, 0.3,0,0 } );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_book_down_left_change");

end;
--******************************************************************************************
function public.MouseEnterBtnDiary( side )

  SetCursor(CURSOR_HAND);

  local obj = "spr_int_diary_btn_"..side.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * 0.3;
  
  if tme > 0.13 then
    --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_mainmenu_menter");
  end;

  ObjAnimate( obj, 8, 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function public.MouseLeaveBtnDiary( side )

  SetCursor(CURSOR_DEFAULT);

  local obj = "spr_int_diary_btn_"..side.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * 0.3;

  ObjAnimate( obj, 8, 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
-----------------------------------------------------------------------------------
function public.FocusClose( inout )

  local obj = "spr_int_diary_close_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_DOWN);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
--*****************************************************************************************