-- name=ho_balcony
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_balcony" );
  game.relations[ "ho_balcony" ].exitroom = "rm_apartment";
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_balcony" ] = 
  {
    type = "win",
    room = "rm_apartment",
    zz = "ho_balcony",
    zz_gate = "gho_apartment_balcony"
  };
  --------------------------------------------------------------------------------------------------
  local win_balcony_func = function ()

    if ( cmn.IsEventDone( "win_balcony" ) ) then
      interface.InventoryItemAdd( "inv_standkey", "spr_balcony_win" );
      ObjDelete("gho_apartment_balcony");
      ObjDelete("spr_apartment_safe_ho");
    end;

  end;
  cmn.AddSubscriber( "win_balcony", win_balcony_func );
  --------------------------------------------------------------------------------------------------
  local start_balcony_func = function ()

    if ( cmn.IsEventStart( "win_balcony" ) ) then

      common_impl.ProcessHoStart( "balcony", true );

    end;

  end;
  cmn.AddSubscriber( "win_balcony", start_balcony_func, "ho_balcony" );
  
  --for secretroom
  private.tasks =  {    
      { "plane",      1, 0, { { "spr_balcony_plane" } } },
      { "snake",      1, 0, { { "spr_balcony_snake" } } },
      { "doll",      1, 0, { { "spr_balcony_doll" } } },
      { "fish",      1, 0, { { "spr_balcony_fish" } } },

      { "ring",      1, 0, { { "spr_balcony_ring" } } },
      { "hand",      1, 0, { { "spr_balcony_hand" } } },
      { "flame",     1, 0, { { "spr_balcony_flame" } } },
      { "key",   1, 0, { { "spr_balcony_key" } } },

      { "pen",  1, 0, { { "spr_balcony_pen" } } },
      { "ship",    1, 0, { { "spr_balcony_ship" } } },
      { "watch", 1, 0, { { "spr_balcony_watch" } } },
      { "pipe",    1, 0, { { "spr_balcony_pipe" } } }
  };
    
  private.tasks_sh =  { 0, 0, 1, 0, 1, 1, 0, 1, 0, 1, 0, 1 };

  private.start = {};
  private.start_sh = {};
  private.start_items = {};
  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, private.tasks[i][2], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][ j ][ 1 ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "itm_"..common.GetObjectName( private.tasks[ i ][ 4 ][ j ][ 1 ] );
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );

    end;
    
    if private.tasks_sh[i] == 1 then
      
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = private.tasks[ i ][ 4 ][ 1 ][ 1 ].."_shadow";
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
      
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  cmn.StopAllEnv("assets/levels/level1/audio/env/aud_ho_balcony_env");
  cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_ho_balcony_env");
  
  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_apartment" );
    cmn.StartTimePassing("ho_balcony");
  else 
    
    private.CreateNewObjects();
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_balcony_apartment",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                      event_menter = function () rm_extra.GateMouseEnter( "balcony_apartment", CURSOR_DOWN, "extra" ); end, 
                                      event_mleave = function () common_impl.GateMouseLeave( "balcony_apartment" ); end });
    
  end;

  if not cmn.IsEventStart( "win_balcony" ) then
    cmn.InitHo( "balcony" );
  end;

  local ho_items = {};

  interface_impl.ItemPanelItemAdd( ho_items, "plane", 0, "spr_balcony_plane" );
  interface_impl.ItemPanelItemAdd( ho_items, "snake", 0, "spr_balcony_snake" );
  interface_impl.ItemPanelItemAdd( ho_items, "doll", 0, "spr_balcony_doll" );
  interface_impl.ItemPanelItemAdd( ho_items, "fish", 0, "spr_balcony_fish" );
  
  interface_impl.ItemPanelItemAdd( ho_items, "ring", 0, "spr_balcony_ring" );
  interface_impl.ItemPanelItemAdd( ho_items, "hand", 0, "spr_balcony_hand" );
  interface_impl.ItemPanelItemAdd( ho_items, "flame", 0, "spr_balcony_flame" );
  interface_impl.ItemPanelItemAdd( ho_items, "key", 0, "spr_balcony_key" );
  
  interface_impl.ItemPanelItemAdd( ho_items, "pen", 0, "spr_balcony_pen" );
  interface_impl.ItemPanelItemAdd( ho_items, "ship", 0, "spr_balcony_ship" );
  interface_impl.ItemPanelItemAdd( ho_items, "watch", 0, "spr_balcony_watch" );
  interface_impl.ItemPanelItemAdd( ho_items, "pipe", 0, "spr_balcony_pipe" );

  if not cmn.IsEventDone("win_balcony") then
  
    interface_impl.ItemPanelShow( ho_items );
  
  else
    common_impl.DialogHo_Show();
  end;
  
end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_ho_balcony_mus", 1);
  
  if ng_global.currentprogress == "std" and not(cmn.IsEventDone("tutor_6")) then

    local arrows = { { pos_x = 0, pos_y = 150, ang = 3.14 } };
    cmn.TutorialShow( "tutor_6", 0, 512, 450, arrows );

  end;
  
  if ng_global.currentprogress == "std" and cmn.IsEventDone("tutor_6") and not(cmn.IsEventDone("tutor_7")) then

    local arrows = { { pos_x = 240, pos_y = 140, ang = -2.6 } };
    cmn.TutorialShow( "tutor_7", 0, 600, 420, arrows );

  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.ItemPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
  
    common_impl.PlayBackgroundMusic();
    
    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_balcony_apartment",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_balcony");

    if ng_global.progress[ ng_global.currentprogress ][ "win_balcony" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_balcony" ] then

      ng_global.nohintho[ "win_balcony" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_balcony" ] then
      ng_global.playedhops[ "win_balcony" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_balcony_apartment",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  
  if item_name == "spr_balcony_ring" or item_name == "spr_balcony_snake" then
    local pos = GetObjPosByObj( item_name );
    ObjSet( item_name, { pos_x = pos[1] + 171, pos_y = pos[2] } );
  end;
  
  ObjDelete(item_name.."_shadow");

  cmn.HoItemFind( item_name, 1 );
  
end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  local ho_itm = private.start_items;
  
  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #ho_itm, 1 do
    
    if not ObjGet( ho_itm[i].name ) then
      
      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_balcony_items" );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_balcony_items" );

    end;
    
  end;
  
end;
--*********************************************************************************************************************
