-- name=ho_crypt
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_crypt" );
  game.relations[ "ho_crypt" ].exitroom = "rm_cemetery";
  --------------------------------------------------------------------------------------------------
  private.doors_open = {2, 6, 9, 10};
  private.doors_objects = { {"eye", "casket", "fan"}, {"key", "crown", "cup"}, {"bat", "scythe", "horseshoe"}, {"dagger", "loop", "compass"} };
  
  private.InitMarked();
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_crypt" ] = 
  {
    type = "win",
    room = "rm_cemetery",
    zz = "ho_crypt",
    zz_gate = "gho_cemetery_crypt"
  };
  --------------------------------------------------------------------------------------------------
  local win_crypt_func = function ()

    if ( cmn.IsEventDone( "win_crypt" ) ) then
      interface.InventoryItemAdd( "inv_scythe", "spr_crypt_win" );
      ObjDelete("gho_cemetery_crypt");
    end;

  end;
  cmn.AddSubscriber( "win_crypt", win_crypt_func );
  --------------------------------------------------------------------------------------------------
  local start_crypt_func = function ()

    if ( cmn.IsEventStart( "win_crypt" ) ) then

      common_impl.ProcessHoStart( "crypt", true );

    end;

  end;
  cmn.AddSubscriber( "win_crypt", start_crypt_func, "ho_crypt" );
  
  --for secretroom
  private.tasks =  {    
  
      { "eye",      1, 0, { { "spr_crypt_eye" } } },
      { "key",    1, 0, { { "spr_crypt_key"} } },
      { "bat",      1, 0, { { "spr_crypt_bat" } } },
      { "dagger",     1, 0, { { "spr_crypt_dagger" } } },
      
      { "casket",      1, 0, { { "spr_crypt_casket" } } },
      { "crown",     1, 0, { { "spr_crypt_crown" } } },
      { "scythe",   1, 0, { { "spr_crypt_scythe" } } },
      { "loop",   1, 0, { { "spr_crypt_loop", "obj_crypt_loop_2" } } },
      
      { "fan",  1, 0, { { "spr_crypt_fan" } } },
      { "cup",    1, 0, { { "spr_crypt_cup" } } },
      { "horseshoe", 1, 0, { { "spr_crypt_horseshoe" } } },
      { "snacompassil",    1, 0, { { "spr_crypt_compass" } } }
      
  };

  private.actions = {
  
    { "clk_hosymbol1", { "obj_crypt_coffin_lights_1", "spr_crypt_door_1", "spr_crypt_door_1_sign", "anm_crypt_open_coffin_1", "obj_crypt_light_1", "anm_crypt_light_1", "spr_crypt_symbol_1",
                         "obj_crypt_light_2", "anm_crypt_light_2", "spr_crypt_symbol_2", "obj_crypt_light_3", "anm_crypt_light_3", "spr_crypt_symbol_3" } },
    { "clk_hosymbol2", { "obj_crypt_coffin_lights_2", "spr_crypt_door_2", "spr_crypt_door_2_sign", "anm_crypt_skeleton", "anm_crypt_open_coffin_2", "anm_crypt_skeleton", "obj_crypt_light_4", "anm_crypt_light_4", "spr_crypt_symbol_4",
                         "obj_crypt_light_5", "anm_crypt_light_5", "spr_crypt_symbol_5", "obj_crypt_light_6", "anm_crypt_light_6", "spr_crypt_symbol_6" } },
    { "clk_hosymbol3", { "obj_crypt_coffin_lights_3", "spr_crypt_door_3", "spr_crypt_door_3_sign", "anm_crypt_open_coffin_3", "obj_crypt_light_7", "anm_crypt_light_7", "spr_crypt_symbol_7",
                         "obj_crypt_light_8", "anm_crypt_light_8", "spr_crypt_symbol_8", "obj_crypt_light_9", "anm_crypt_light_9", "spr_crypt_symbol_9" } },
    { "clk_hosymbol4", { "obj_crypt_coffin_lights_4", "spr_crypt_door_4", "spr_crypt_door_4_sign", "anm_crypt_open_coffin_4", "obj_crypt_light_10", "anm_crypt_light_10", "spr_crypt_symbol_10",
                         "obj_crypt_light_11", "anm_crypt_light_11", "spr_crypt_symbol_11", "obj_crypt_light_12", "anm_crypt_light_12", "spr_crypt_symbol_12" } }
  
  };
  
  private.start_actions = {};
  
  for i = 1, #private.actions, 1 do
    
    private.start_actions[i] = {};
    
    for j = 1, #private.actions[i][2], 1 do
    
      private.start_actions[i][j] = {};
      private.start_actions[i][j].name = private.actions[i][2][j];
      local nme = private.start_actions[i][j].name;
      private.start_actions[i][j].prop = ObjGet( nme );
      private.start_actions[i][j].parent = ObjGetRelations( nme ).parent;
    
    end;
  end;
  
  private.tasks_sh =  { 0, 0, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1 };

  private.start = {};
  private.start_sh = {};

  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
    
    if private.tasks_sh[i] == 1 then
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = "spr_"..common.GetObjectName(private.tasks[ i ][ 4 ][1][1].."_shadow");
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if not ( ng_global.progress[ ng_global.currentprogress ][ "win_crypt" ].stage ) or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_crypt" ].stage = { 1, 1 };   --[1] - номер стадии, [2] - количество стадий
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level1/audio/env/aud_ho_crypt_env");
  cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_ho_crypt_env");
  
  if ng_global.currentprogress == "std" then

    common.SetPreviousRoom( "rm_cemetery" );
    cmn.StartTimePassing("ho_crypt");
    
  else 
    
    ng_global.progress[ ng_global.currentprogress ][ "win_crypt" ].stage = { 1, 1 };
    
    private.CreateNewObjects();
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_crypt_cemetery",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                    event_menter = function () rm_extra.GateMouseEnter( "crypt_cemetery", CURSOR_DOWN, "extra" ); end, 
                                    event_mleave = function () common_impl.GateMouseLeave( "crypt_cemetery" ); end });
    
  end;

  if not cmn.IsEventStart( "win_crypt" ) then
    cmn.InitHo( "crypt" );
  end;
  
  ObjAttach("obj_crypt_doors", "int_taskpanel_impl");
  
  if cmn.IsEventDone("clk_hosymbol2") then
    ObjSet("anm_crypt_skeleton_2",  { alp = 1, playing = 1 });
  else 
    ObjSet("anm_crypt_skeleton_2",  { alp = 0, playing = 0, frame = 0 });
  end;

  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "eye", 1, 0, { { "spr_crypt_eye" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "key", 1, 0, { { "spr_crypt_key" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "bat", 1, 0, { { "spr_crypt_bat" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "dagger", 1, 0, { { "spr_crypt_dagger" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "casket", 1, 0, { { "spr_crypt_casket" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "crown", 1, 0, { { "spr_crypt_crown" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "scythe", 1, 0, { { "spr_crypt_scythe" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "loop", 1, 0, { { "spr_crypt_loop" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "fan", 1, 0, { { "spr_crypt_fan" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "cup", 1, 0, { { "spr_crypt_cup" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "horseshoe", 1, 0, { { "spr_crypt_horseshoe" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "compass", 1, 0, { { "spr_crypt_compass" } } );
  
  if not cmn.IsEventDone("win_crypt")
  and ng_global.progress[ ng_global.currentprogress ][ "win_crypt" ].stage[1] <= ng_global.progress[ ng_global.currentprogress ][ "win_crypt" ].stage[2] then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  if ng_global.currentprogress == "secret" then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_game_2_mus", 1);
  end;
  
  if ng_global.currentprogress == "std" and not(cmn.IsEventDone("tutor_17")) then

    local arrows = { { pos_x = 0, pos_y = 150, ang = 3.14 } };
    cmn.TutorialShow( "tutor_17", 0, 512, 450, arrows );

  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  if ng_global.currentprogress == "std" then
  
    --cmn.StopAllMus();
    --common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    cmn.StopAllMus();
    
    ObjSet("grm_crypt_cemetery",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()
  
  ObjDetach("obj_crypt_doors");
  
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_crypt");

    if ng_global.progress[ ng_global.currentprogress ][ "win_crypt" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_crypt" ] then

      ng_global.nohintho[ "win_crypt" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_crypt" ] then
      ng_global.playedhops[ "win_crypt" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_crypt_cemetery",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name, task_name )
  
  ObjDelete(item_name.."_shadow");

  cmn.HoTaskFind(item_name, task_name, 1);

end;
--*********************************************************************************************************************
function public.TouchSymbol( num )
  
  local door = 0;
  
  for i = 1, 4, 1 do
    
    if num == private.doors_open[i] then
      door = i;
      break;
    end;
    
  end;
  
  if door > 0 then
    
    local func_after = function ()
      
      cmn.Lock( 0 );
      cmn.CallEventHandler("clk_hosymbol"..door);
      
      if door == 2 then
        ObjSet("anm_crypt_skeleton_2",  { alp = 1, playing = 1 });
      end;
      
    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_ho_crypt_click");
    
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_ho_crypt_coffin_opens");
    
    cmn.SetEventDone("clk_hosymbol"..door);
    
    ObjAnimate("obj_crypt_coffin_lights_"..door, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjSet("anm_crypt_open_coffin_"..door,  { playing = 1, endtrig = func_after });
    
    ObjAnimate("spr_crypt_door_"..door, "pos_y", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,    0.8, 0, 90 });
    
  end;

end;
--------------------------------------------------------------------------------
function public.ActivateSymbol( num, inout )

  local obj = "spr_crypt_symbol_"..num;
  local scale = ObjGet( obj ).scale_x;
  local tme = 0;
  local max_scale = 1;  
  local max_tme = 0.3;
  local end_scale = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = scale*max_tme;
  else 
    SetCursor(CURSOR_HAND);
    end_scale = max_scale;
    tme = ( 1 - scale ) * max_tme;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/");
    end;
  end;

  ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale });

end;
--*********************************************************************************************************************
-- function *** MARKED *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.InitMarked()

  public.ho_hint_progress_names = { "clk_hosymbol1", "clk_hosymbol2", "clk_hosymbol3", "clk_hosymbol4" };
  
  --------------------------------------------------------------------------------------------
  -- function clk_hosymbol1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_hosymbol1" ] = {
      type = "click",
      use_place = "obj_crypt_light_"..private.doors_open[1],
      room = "rm_cemetery",
      zz = "ho_crypt",
      zz_gate = "gho_cemetery_crypt"
  };
  --------------------------------------------------------------------------------------------
  local clk_hosymbol1 = function ()
  
    ObjDelete( "obj_crypt_coffin_lights_1" );
    ObjDelete( "spr_crypt_door_1" );
    ObjSet("anm_crypt_open_coffin_1",  { frame = 300 });
    
    for i = 1, 3, 1 do
      ObjSet("spr_crypt_"..private.doors_objects[1][i],  { input = 1 });
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hosymbol1", clk_hosymbol1, "ho_crypt" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_hosymbol2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_hosymbol2" ] = {
      type = "click",
      use_place = "obj_crypt_light_"..private.doors_open[2],
      room = "rm_cemetery",
      zz = "ho_crypt",
      zz_gate = "gho_cemetery_crypt"
  };
  --------------------------------------------------------------------------------------------
  local clk_hosymbol2 = function ()
  
    ObjDelete( "obj_crypt_coffin_lights_2" );
    ObjDelete( "spr_crypt_door_2" );
    ObjDelete( "anm_crypt_skeleton" );
    ObjDelete( "anm_crypt_open_coffin_2" );
    
    --ObjSet("anm_crypt_open_coffin_2",  { frame = 300 });
    
    for i = 1, 3, 1 do
      ObjSet("spr_crypt_"..private.doors_objects[2][i],  { input = 1 });
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hosymbol2", clk_hosymbol2, "ho_crypt" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_hosymbol3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_hosymbol3" ] = {
      type = "click",
      use_place = "obj_crypt_light_"..private.doors_open[3],
      room = "rm_cemetery",
      zz = "ho_crypt",
      zz_gate = "gho_cemetery_crypt"
  };
  --------------------------------------------------------------------------------------------
  local clk_hosymbol3 = function ()
  
    ObjDelete( "obj_crypt_coffin_lights_3" );
    ObjDelete( "spr_crypt_door_3" );
    ObjSet("anm_crypt_open_coffin_3",  { frame = 300 });
    
    for i = 1, 3, 1 do
      ObjSet("spr_crypt_"..private.doors_objects[3][i],  { input = 1 });
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hosymbol3", clk_hosymbol3, "ho_crypt" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_hosymbol4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_hosymbol4" ] = {
      type = "click",
      use_place = "obj_crypt_light_"..private.doors_open[4],
      room = "rm_cemetery",
      zz = "ho_crypt",
      zz_gate = "gho_cemetery_crypt"
  };
  --------------------------------------------------------------------------------------------
  local clk_hosymbol4 = function ()
  
    ObjDelete( "obj_crypt_coffin_lights_4" );
    ObjDelete( "spr_crypt_door_4" );
    ObjSet("anm_crypt_open_coffin_4",  { frame = 300 });
    
    for i = 1, 3, 1 do
      ObjSet("spr_crypt_"..private.doors_objects[4][i],  { input = 1 });
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hosymbol4", clk_hosymbol4, "ho_crypt" );

end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  
  for i = 1, #private.actions, 1 do
    
    if cmn.IsEventDone( private.actions[i][1] ) then
      
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].done = 0;
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].start = 0;
      
      for j = 1, #private.actions[i][2], 1 do
      
        local nme = private.start_actions[i][j].name;
        
        if not ObjGet( nme ) then
          
          local typ = common.GetObjectPrefix( nme );
          
          if typ == "gfx" then
            typ = "partsys_gm";
          elseif typ == "anm" then
            typ = "anim";
          end;
          
          ObjCreate( nme, typ );
          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        else 

          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        end;
          
      end;
      
    end;
    
  end;

  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;

end;
--********************************************************************************************************************