-- name=ho_toys
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_toys" );
  game.relations[ "ho_toys" ].exitroom = "rm_worldofdarkness";
  
  private.tasks_order = { "doll", "flower", "bow", "star", "elephant", "hairpin", "train", "broken", "bookmark", "letterm", "snowflake", "berry" };
  private.light_pos = {
    {59, 391}, {713, 253}, {805, 558}, {913, 364}, {501, 113}, {349, 244},
    {651, 604}, {128, 566}, {661, 469}, {471, 595}, {228, 104}, {83, 258}
  };
  
  private.InitMarked();
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_toys" ] = 
  {
    type = "win",
    room = "rm_chapel",
    zz = "ho_toys",
    zz_gate = "gho_chapel_toys"
  };
  --------------------------------------------------------------------------------------------------
  local win_toys_func = function ()

    if ( cmn.IsEventDone( "win_toys" ) ) then
      ObjDelete("gho_chapel_toys");
      ObjSet("grm_chapel_worldofdarkness",  { alp = 1, input = 1 });
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_chapel_worldofdarkness_focus");
      end;
    end;

  end;
  cmn.AddSubscriber( "win_toys", win_toys_func );
  --------------------------------------------------------------------------------------------------
  local start_toys_func = function ()

    if ( cmn.IsEventStart( "win_toys" ) ) then

      common_impl.ProcessHoStart( "toys", true );

    end;

  end;
  cmn.AddSubscriber( "win_toys", start_toys_func, "ho_toys" );
  
  --------------------------------------------------------------------------------------------
  -- function opn_toys () end;
  --------------------------------------------------------------------------------------------
  local opn_toys = function ()
  
    interface_impl.SetCurrentGlobalTask( 6 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_toys", opn_toys );
  
  --for secretroom
  private.tasks =  {    
  
    { "doll",      1, 0, { { "spr_toys_doll", "anm_toys_light_1", "spr_toys_lamp_light_1" } } },
    { "flower",    1, 0, { { "spr_toys_flower", "anm_toys_light_2", "spr_toys_lamp_light_2"} } },
    { "bow",      1, 0, { { "spr_toys_bow", "anm_toys_light_3", "spr_toys_lamp_light_3" } } },
    { "star",     1, 0, { { "spr_toys_star", "anm_toys_light_4", "spr_toys_lamp_light_4" } } },
      
    { "elephant",      1, 0, { { "spr_toys_elephant", "anm_toys_light_5", "spr_toys_lamp_light_5" } } },
    { "hairpin",     1, 0, { { "spr_toys_hairpin", "anm_toys_light_6", "spr_toys_lamp_light_6" } } },
    { "train",   1, 0, { { "spr_toys_train", "anm_toys_light_7", "spr_toys_lamp_light_7" } } },
    { "broken",   1, 0, { { "spr_toys_broken", "anm_toys_light_8", "spr_toys_lamp_light_8" } } },
      
    { "bookmark",  1, 0, { { "spr_toys_bookmark", "anm_toys_light_9", "spr_toys_lamp_light_9" } } },
    { "letterm",    1, 0, { { "spr_toys_letterm", "anm_toys_light_10", "spr_toys_lamp_light_10" } } },
    { "snowflake", 1, 0, { { "spr_toys_snowflake", "spr_toys_snowflake_2", "anm_toys_light_11", "spr_toys_lamp_light_11" } } },
    { "berry",    1, 0, { { "spr_toys_berry", "anm_toys_light_12", "spr_toys_lamp_light_12" } } }
      
  };

  private.actions = {
  
    { "use_holvl1scissors", { "obj_toys_use_scissors", "spr_toys_scissors_sh", "spr_toys_scissors", "anm_toys_use_scissors" } },
    { "use_holvl1snowflake", { "obj_toys_use_snowflake", "spr_toys_snowflake_part_sh", "spr_toys_snowflake_part" } }

  };
  
  private.start_actions = {};
  
  for i = 1, #private.actions, 1 do
    
    private.start_actions[i] = {};
    
    for j = 1, #private.actions[i][2], 1 do
    
      private.start_actions[i][j] = {};
      private.start_actions[i][j].name = private.actions[i][2][j];
      local nme = private.start_actions[i][j].name;
      private.start_actions[i][j].prop = ObjGet( nme );
      private.start_actions[i][j].parent = ObjGetRelations( nme ).parent;
    
    end;
  end;
  
  private.tasks_sh =  { 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1 };

  private.start = {};
  private.start_sh = {};

  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
    
    if private.tasks_sh[i] == 1 then
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = "spr_"..common.GetObjectName(private.tasks[ i ][ 4 ][1][1].."_shadow");
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if not ng_global.progress[ ng_global.currentprogress ][ "win_toys" ].stage or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_toys" ].stage = { 1, 1 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_toys" ].state = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level1/audio/env/aud_worldofdarkness_env");
  cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_worldofdarkness_env");
  
  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_chapel" );
  else 
    
    ng_global.progress[ ng_global.currentprogress ][ "win_toys" ].stage = { 1, 1 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_toys" ].state = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    
    private.CreateNewObjects();

    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_toys_chapel",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                 event_menter = function () rm_extra.GateMouseEnter( "toys_chapel", CURSOR_DOWN, "extra" ); end, 
                                 event_mleave = function () common_impl.GateMouseLeave( "toys_chapel" ); end });
    
  end;

  if ng_global.currentprogress == "std" and not cmn.IsEventDone("opn_toys") then
    
    cmn.Lock(1);
    ObjSet("ho_toys",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.StopAllEnv();
    
  else
    
    cmn.StopAllEnv("assets/levels/level1/audio/env/aud_worldofdarkness_env");
    cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_worldofdarkness_env");

    if not cmn.IsEventStart( "win_toys" ) then
      
      cmn.InitHo( "toys" );
      
      if ng_global.currentprogress == "std" then
        
        cmn.SetMarkedTask( "toys", "star" );
        cmn.SetMarkedTask( "toys", "snowflake" );
        
        cmn.StartTimePassing("ho_toys");
        
      else 
        
        ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "star" ] = {};
        ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "star" ].done = 0;
        ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "star" ].start = 0;
        
        ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "snowflake" ] = {};
        ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "snowflake" ].done = 0;
        ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "snowflake" ].start = 0;
        
      end;
      
    end;
    
    private.DrawScene();

    private.SetTasks();
    
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  if ng_global.currentprogress == "std" and not cmn.IsEventDone("opn_toys") then
    
    local func_after = function ()
      
      cmn.StopAllEnv("assets/levels/level1/audio/env/aud_worldofdarkness_env");
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_worldofdarkness_env");
    
      cmn.ShowBbt( "toys_open" );
      interface_impl.ShowGlobalTask();
      
      ObjSet("ho_toys",  { color_r = 1, color_g = 1, color_b = 1 });
      
      cmn.StartTimePassing("ho_toys");
      
      cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_bells_mus", 1);
      
      if not cmn.IsEventStart( "win_toys" ) then
      
        cmn.InitHo( "toys" );
        
        if ng_global.currentprogress == "std" then
          
          cmn.SetMarkedTask( "toys", "star" );
          cmn.SetMarkedTask( "toys", "snowflake" );
          
        else 
          
          ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "star" ] = {};
          ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "star" ].done = 0;
          ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "star" ].start = 0;
          
          ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "snowflake" ] = {};
          ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "snowflake" ].done = 0;
          ng_global.progress[ "secret" ][ "win_toys" ].unmark[ "snowflake" ].start = 0;
          
        end;
        
      end;
      
      private.SetTasks();
      
    end;
    
    cmn.Lock(0);
    
    cmn.SetEventDone( "opn_toys" );
    cmn.CallEventHandler("opn_toys");
    
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_chapel/vid_movement2", func_after, "assets/levels/level1/audio/mus/aud_inside_room_naya_mus");
    
  else
  
    cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_bells_mus", 1);
    
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
    
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_toys_chapel",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_toys");

    if ng_global.progress[ ng_global.currentprogress ][ "win_toys" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_toys" ] then

      ng_global.nohintho[ "win_toys" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_toys" ] then
      ng_global.playedhops[ "win_toys" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_toys_chapel",  { input = 0 });
    
  end;
    
end;
--*********************************************************************************************************************
function public.win()
  
  cmn.Lock( 0 );
  
  cmn.SetEventDone("win_toys");
  
  if ng_global.currentprogress == "std" then
    
    cmn.CallEventHandler("win_toys");
    cmn.GotoRoom("rm_worldofdarkness");
    
  else 
    
    int_dialog_secretroom.StopTimer();
    int_dialog_secretroom.ShowAnim();
    
  end;
  
end;
--*********************************************************************************************************************
function private.SetTasks()
  
  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "doll", 1, 0, { { "spr_toys_doll" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "flower", 1, 0, { { "spr_toys_flower" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "bow", 1, 0, { { "spr_toys_bow" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "star", 1, 1, { { "spr_toys_star" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "elephant", 1, 0, { { "spr_toys_elephant" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "hairpin", 1, 0, { { "spr_toys_hairpin" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "train", 1, 0, { { "spr_toys_train" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "broken", 1, 0, { { "spr_toys_broken" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "bookmark", 1, 0, { { "spr_toys_bookmark" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "letterm", 1, 0, { { "spr_toys_letterm" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "berry", 1, 0, { { "spr_toys_berry" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "snowflake", 1, 1, { { "spr_toys_snowflake" } } );
  
  if not cmn.IsEventDone("win_toys")
  and ng_global.progress[ ng_global.currentprogress ][ "win_toys" ].stage[1] <= ng_global.progress[ ng_global.currentprogress ][ "win_toys" ].stage[2] then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    cmn.Lock( 1, { room = 1 } );
    ObjSet("tmr_toys_timer",  { time = 1, playing = 1, endtrig = public.win });
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name, task_name )
  
  local light = private.FindLightInd( task_name );
  ng_global.progress[ ng_global.currentprogress ][ "win_toys" ].state[light] = 1;
  
  if task_name == "star" then
    local pos = GetObjPosByObj( item_name );
    ObjMultiSet( { {item_name, { pos_x = pos[1] + 171, pos_y = pos[2] }},
                   {"anm_toys_light_4", { alp = 1 }} } );
  end;
  
  cmn.HoTaskFind(item_name, task_name, 1);
  
  ObjDelete(item_name.."_shadow");
  private.SetLightFly( light );
  
end;
--------------------------------------------------------------------------------
function private.FindLightInd( name )
  
  local ind = 0;
  
  for i = 1, #private.tasks_order, 1 do
    
    if private.tasks_order[i] == name then
      ind = i;
      break;
    end;
    
  end;
  
  return ind;
  
end;
--------------------------------------------------------------------------------
function private.SetLightFly( num )
  
  local point_a, point_b = {}, {};
  point_a[1] = private.light_pos[num][1];
  point_a[2] = private.light_pos[num][2];
  point_b[1] = 950;
  point_b[2] = 194;
  
  ObjAttach("anm_toys_light_"..num, "obj_toys_fly");
  
  if num == 4 then
    
    local pos = GetObjPosByObj( "anm_toys_light_"..num );
    point_a[1] = pos[1] + 171;
    point_a[2] = pos[2];
    ObjSet( "anm_toys_light_"..num, { pos_x = pos[1] + 171, pos_y = pos[2] } );
    
  end;
  
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.003 * len;
  
  if tme > 0.5 then
    tme = 0.5;
  elseif tme < 0.1 then
    tme = 0.1;
  end;
  
  local func_after = function ( num2 )
    ObjAnimate("spr_toys_lamp_light_"..num2, "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
    ObjAnimate("anm_toys_light_"..num2, "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
  end;
  
  ObjAnimate("anm_toys_light_"..num, "pos_xy", 0, 0, function() func_after(num); end, { 0, 0, private.light_pos[num][1], private.light_pos[num][2],    tme, 0, 950, 194 });
  
end;
--------------------------------------------------------------------------------
function private.DrawScene()
  
  for i = 1, 12, 1 do
    
    if ng_global.progress[ ng_global.currentprogress ][ "win_toys" ].state[i] == 1 then
      ObjDelete("anm_toys_light_"..i);
      ObjSet("spr_toys_lamp_light_"..i,  { alp = 1 });
    end;
    
  end;
  
end;
--*********************************************************************************************************************
-- function *** MARKED *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.InitMarked()

  public.ho_hint_progress_names = { "use_holvl1scissors", "use_holvl1snowflake" };

  --------------------------------------------------------------------------------------------
  -- function use_holvl1scissors () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl1scissors" ] = {
      type = "use",
      inv_obj = "spr_toys_scissors",
      use_place = "obj_toys_use_scissors",
      room = "rm_chapel",
      zz = "ho_toys",
      zz_gate = "gho_chapel_toys"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl1scissors_beg = function ()
  
    ObjDelete( "obj_toys_use_scissors" );
    ObjDelete( "spr_toys_scissors_sh" );
    ObjDelete( "spr_toys_scissors" );
  
  end;
  local use_holvl1scissors_end = function ()
    
    ObjMultiSet( { {"anm_toys_use_scissors", { alp = 1, frame = 300 }},
                   {"spr_toys_star", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl1scissors", use_holvl1scissors_beg, "ho_toys" );
  cmn.AddSubscriber( "use_holvl1scissors", use_holvl1scissors_end, "ho_toys" );
  cmn.AddSubscriber( "use_holvl1scissors_beg", use_holvl1scissors_beg, "ho_toys" );
  cmn.AddSubscriber( "use_holvl1scissors_end", use_holvl1scissors_end, "ho_toys" );
  
  --------------------------------------------------------------------------------------------
  -- function use_holvl1snowflake () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl1snowflake" ] = {
      type = "use",
      inv_obj = "spr_toys_snowflake_part",
      use_place = "obj_toys_use_snowflake",
      room = "rm_chapel",
      zz = "ho_toys",
      zz_gate = "gho_chapel_toys"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl1snowflake_beg = function ()
  
    ObjDelete( "obj_toys_use_snowflake" );
    ObjDelete( "spr_toys_snowflake_part_sh" );
    ObjDelete( "spr_toys_snowflake_part" );
  
  end;
  local use_holvl1snowflake_end = function ()
    
    ObjMultiSet( { {"spr_toys_snowflake_2", { alp = 1 }},
                   {"spr_toys_snowflake", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl1snowflake", use_holvl1snowflake_beg, "ho_toys" );
  cmn.AddSubscriber( "use_holvl1snowflake", use_holvl1snowflake_end, "ho_toys" );
  cmn.AddSubscriber( "use_holvl1snowflake_beg", use_holvl1snowflake_beg, "ho_toys" );
  cmn.AddSubscriber( "use_holvl1snowflake_end", use_holvl1snowflake_end, "ho_toys" );
  
end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function public.StartDrag( name )

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_from_inventory" );
  ObjAttach("spr_toys_"..name, "obj_toys_fly");

  ObjAnimate("spr_toys_"..name.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0 });

end;
------------------------------------------------------------------------------
function public.use_scissors()

  item = "spr_toys_scissors";

  if ( cmn.ApplyObj( item, "obj_toys_use_scissors" ) ) then

    cmn.CallEventHandler( "use_holvl1scissors_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_holvl1scissors" );
      cmn.CallEventHandler( "use_holvl1scissors_end" );

      cmn.UnmarkTask( "toys", "star" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_ho_toys_cut");
    
    ObjSet("anm_toys_use_scissors",  { playing = 1, endtrig = func_after });
    
  else 

    cmn.WrongApply();
    ObjAttach(item, "ho_toys");
    ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
------------------------------------------------------------------------------
function public.use_snowflake()

  item = "spr_toys_snowflake_part";

  if ( cmn.ApplyObj( item, "obj_toys_use_snowflake" ) ) then

    cmn.CallEventHandler( "use_holvl1snowflake_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_holvl1snowflake" );
      cmn.CallEventHandler( "use_holvl1snowflake_end" );

      cmn.UnmarkTask( "toys", "snowflake" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_ho_toys_insert");
    
    ObjAnimate("spr_toys_snowflake_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    
  else 

    cmn.WrongApply();
    ObjAttach(item, "ho_toys");
    ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  
  for i = 1, #private.actions, 1 do
    
    if cmn.IsEventDone( private.actions[i][1] ) then
      
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].done = 0;
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].start = 0;
      
      for j = 1, #private.actions[i][2], 1 do
      
        local nme = private.start_actions[i][j].name;
        
        if not ObjGet( nme ) then
          
          local typ = common.GetObjectPrefix( nme );
          
          if typ == "gfx" then
            typ = "partsys_gm";
          elseif typ == "anm" then
            typ = "anim";
          end;
          
          ObjCreate( nme, typ );
          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        else 

          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        end;
          
      end;
      
    end;
    
  end;

  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;

end;
--********************************************************************************************************************