-- name=mg_cobweb
--*********************************************************************************************************************
function public.Init()

  private.web_pos = { {694,525}, {696,160}, {329,160}, {330,526} };

  private.web_sh_pos = { {694,548}, {696,179}, {329,181}, {326,556} };

  private.web_lamp_on_edge = {
    { false,     4, false, false,     2,     1, false,     5 },
    { false,     1, false, false,     5, false, false, false },
    {     1, false,     4, false, false,     3, false,     2 },
    { false, false, false,     5,     6, false,     1,     2 }
  };

  private.hole_link_on_edge = {
    { false, false, false, false, false,   {1}, false,   {2} },
    --{   {4}, {2,4}, false, false,   {5}, false, false, false },
    {   {4},   {4}, false, false,   {5}, false, false, false },
    {   {5}, false,   {6}, false, false, false, false, false },
    { false, false, false, false,   {7},   {7},   {6}, false }
  };

  private.win_way_segments = { {1, 4}, {4, 5}, {5, 6}, {6, 9} };

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_cobweb";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_spider () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_spider" ] = {
        type = "get",
        get_obj = "spr_cobweb_spider",
        room = "rm_outsidechapel",
        zz = "mg_cobweb",
        zz_gate = "gmg_outsidechapel_cobweb"
    };
  --------------------------------------------------------------------------------------------
  local get_spider_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_spider", "spr_cobweb_spider" );
  
  end;
  
  local get_spider_beg = function ()
  
    ObjDelete( "gfx_cobweb_spider" );

    ObjDelete( "spr_cobweb_spider_shadow" );
  
  end;
  
  local get_spider_end = function ()

    ObjDelete( "anm_cobweb_spider" );

  end;
  
  local get_spider_loc = function ()

    ObjDelete( "spr_outsidechapel_gates_spider_1" );

  end;
  
  cmn.AddSubscriber( "get_spider", get_spider_inv );
  cmn.AddSubscriber( "get_spider", get_spider_beg, private.room_objname );
  cmn.AddSubscriber( "get_spider", get_spider_end, private.room_objname );
  cmn.AddSubscriber( "get_spider_inv", get_spider_inv );
  cmn.AddSubscriber( "get_spider_beg", get_spider_beg, private.room_objname );
  cmn.AddSubscriber( "get_spider_end", get_spider_end, private.room_objname );
  cmn.AddSubscriber( "get_spider", get_spider_loc, "rm_outsidechapel" );
  cmn.AddSubscriber( "get_spider_loc", get_spider_loc, "rm_outsidechapel" );

  --------------------------------------------------------------------------------------------
  -- function use_webspider () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_webspider" ] = {
        type = "use",
        inv_obj = "inv_webspider",
        use_place = "obj_cobweb_use_webspider",
        room = "rm_outsidechapel",
        zz = "mg_cobweb",
        zz_gate = "gmg_outsidechapel_cobweb"
    };
  --------------------------------------------------------------------------------------------
  local use_webspider_inv = function ()
  
    interface.InventoryItemRemove( "inv_webspider" );
  
  end;
  local use_webspider_beg = function ()
  
    ObjDelete( "obj_cobweb_use_webspider" );
  
  end;
  local use_webspider_end = function ()
  
    ObjSet( "obj_cobweb_spider_new", { alp = 1 } );

    for i = 1, 4, 1 do
      ObjSet( "spr_cobweb_web_"..i, { input = true } );
    end;

  end;
  local use_webspider_loc = function ()

    ObjSet( "spr_outsidechapel_gates_spider_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_webspider", use_webspider_beg, private.room_objname );
  cmn.AddSubscriber( "use_webspider", use_webspider_inv );
  cmn.AddSubscriber( "use_webspider", use_webspider_end, private.room_objname );
  cmn.AddSubscriber( "use_webspider_inv", use_webspider_inv, private.room_objname );
  cmn.AddSubscriber( "use_webspider_beg", use_webspider_beg, private.room_objname );
  cmn.AddSubscriber( "use_webspider_end", use_webspider_end, private.room_objname );
  cmn.AddSubscriber( "use_webspider", use_webspider_loc, "rm_outsidechapel" );
  cmn.AddSubscriber( "use_webspider_loc", use_webspider_loc, "rm_outsidechapel" );

  --------------------------------------------------------------------------------------------
  -- function win_cobweb () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_cobweb" ] = {
    type = "win",
    room = "rm_outsidechapel",
    zz = "mg_cobweb",
    zz_gate = "gmg_outsidechapel_cobweb"
  };
  --------------------------------------------------------------------------------------------
  local win_cobweb = function ()

    if cmn.IsEventDone( "win_cobweb" ) then

    end;

  end;
  local win_cobweb_loc = function ()

    if cmn.IsEventDone( "win_cobweb" ) then
      ObjDelete("gmg_outsidechapel_cobweb");
      ObjDelete( "spr_outsidechapel_gates_closed" );
      ObjMultiSet( { {"grm_outsidechapel_chapel", { alp = 1, input = 1 }},
                     {"spr_outsidechapel_gates_open", { alp = 1 }} } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_outsidechapel_chapel_focus");
      end;
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_cobweb", win_cobweb, "mg_cobweb" );
  cmn.AddSubscriber( "win_cobweb", win_cobweb_loc, "rm_outsidechapel" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_cobweb" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_cobweb" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  if ng_global.currentprogress == "std" and cmn.IsEventDone("use_webspider") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_game_2_mus", 1);
  elseif ng_global.currentprogress == "secret" then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_game_2_mus", 1);
  end;
  
  if ng_global.currentprogress == "std" and not cmn.IsEventDone("opn_cobweb") then
    cmn.SetEventDone("opn_cobweb");
    cmn.ShowBbt( "cobweb_open" );
  end;

  if ng_global.currentprogress == "std" and cmn.IsEventDone( "use_webspider" ) and not cmn.IsEventDone( "win_cobweb" ) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_cobweb");
  elseif ng_global.currentprogress == "secret" then
    rm_extra.MiniGameShow();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_outsidechapel" );
  else 
    
    private.CreateNewObjects();
    private.StartConditions();
    private.drawscene_flag = false;
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_cobweb" ].state;
    
    ObjSet("grm_cobweb_outsidechapel",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                         event_menter = function () rm_extra.GateMouseEnter( "cobweb_outsidechapel", CURSOR_DOWN, "extra" ); end, 
                                         event_mleave = function () common_impl.GateMouseLeave( "cobweb_outsidechapel" ); end });
                                     
  end;
  
  private.DrawScene();
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  if ng_global.currentprogress == "std" and cmn.IsEventDone("use_webspider") then
    cmn.StopAllMus();
    common_impl.PlayBackgroundMusic();
  end;
  
  if ng_global.currentprogress == "secret" then
    cmn.StopAllMus();
    ObjSet("grm_cobweb_outsidechapel",  { input = 0 });
  end;
  
  if ng_global.currentprogress == "std" and cmn.IsEventDone( "use_webspider" ) and not cmn.IsEventDone( "win_cobweb" ) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_cobweb" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()

  --DbgTrace( "***Reset" );

  local go_reset = false;

  local old_state = private.state;

  private.StartConditions();
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_cobweb" ].state;

  for i = 1, 4, 1 do

    if ( old_state.web[i][1] ~= private.state.web[i][1] ) then
      go_reset = true;
      ObjAnimate( "spr_cobweb_web_"..i, "pos_xy", 0, 0, "", {
        0,   0, private.web_pos[ old_state.web[i][1] ][1], private.web_pos[ old_state.web[i][1] ][2],
        0.5, 0, private.web_pos[ private.state.web[i][1] ][1], private.web_pos[ private.state.web[i][1] ][2]
      } );
      ObjAnimate( "spr_cobweb_web_"..i.."_sh", "pos_xy", 0, 0, "", {
        0,   0, private.web_sh_pos[ old_state.web[i][1] ][1], private.web_sh_pos[ old_state.web[i][1] ][2],
        0.5, 0, private.web_sh_pos[ private.state.web[i][1] ][1], private.web_sh_pos[ private.state.web[i][1] ][2]
      } );
    end;
    if ( old_state.web[i][2] ~= private.state.web[i][2] ) then
      go_reset = true;
      ObjAnimate( "spr_cobweb_web_"..i, "ang", 0, 0, "", {
        0,   0, math.rad( 45 * old_state.web[i][2] ),
        0.5, 0, math.rad( 45 * private.state.web[i][2] )
      } );
      ObjAnimate( "spr_cobweb_web_"..i.."_sh", "ang", 0, 0, "", {
        0,   0, math.rad( 45 * old_state.web[i][2] ),
        0.5, 0, math.rad( 45 * private.state.web[i][2] )
      } );
      ObjAnimate( "obj_cobweb_button_"..i, "ang", 0, 0, "", { 
        0,   0, -math.rad( 45 * old_state.web[i][2] ),
        0.5, 0, -math.rad( 45 * private.state.web[i][2] )
      } );
    end;

    --DbgTrace(
    --  "web"..i.." pos == "..private.state.web[i][1]..", ang == "..private.state.web[i][2].." = "..math.rad( 45 * private.state.web[i][2] )
    --);

  end;

  for i = 1, 5, 1 do
    for j = 1, #private.state.map[i], 1 do
      if old_state.map[i][j][1] == 1 and private.state.map[i][j][1] == 0 then
        go_reset = true;
        --DbgTrace( "lamp"..i..j.." = "..private.state.map[i][j][1] );
        ObjAnimate( "spr_cobweb_lamp"..i..j, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
      end;
    end;
  end;

  for i = 2, #old_state.way, 1 do
    local line_name = "spr_cobweb_way"..old_state.way[ i-1 ][1]..old_state.way[ i-1 ][2]..old_state.way[ i ][1]..old_state.way[ i ][2];
    local line_fx_name = "fx_cobweb_way"..old_state.way[ i-1 ][1]..old_state.way[ i-1 ][2]..old_state.way[ i ][1]..old_state.way[ i ][2];
    ObjAnimate( line_fx_name, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
    ObjAnimate( line_name, "alp", 0, 0, function () ObjDelete( line_name ); ObjDelete( line_fx_name ); end, { 0, 0, 1,    0.2, 0, 0 } );
  end;

  if go_reset then
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_spider_reset");
    ObjSet( "tmr_cobweb_animlock", { time = 0.5, endtrig = function () cmn.Lock( 0 ); end, playing = true } );
  end;

end;
--*********************************************************************************************************************
function public.Skip()

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_spider_ckick_red_dote");

  --DbgTrace( "***Skip" );

  local old_state = private.state;

  private.StartConditions();
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_cobweb" ].state;
  ng_global.progress[ ng_global.currentprogress ][ "win_cobweb" ].skip = 1;

  private.state.way = { --пройденные точки
    {1,1}, {5,6}, {5,5}, {5,3}, {5,2}, {5,1}, 
    {1,2}, {1,3}, {1,4}, {3,1}, {3,2}, {3,3}, {3,4}, {3,5}, 
    {1,5}, {2,1}, {2,2}, {2,3}, {2,4}, {2,5}, 
    {1,6}, {4,1}, {4,2}, {1,7}, {1,8}, {1,9}
  };
  private.state.web = { {3,5}, {2,0}, {4,2}, {1,7} };  --положение и угол паутинок

  for i = 1, #private.state.way, 1 do
    private.state.map[ private.state.way[i][1] ][ private.state.way[i][2] ][1] = 1;
  end;

  for i = 1, 4, 1 do

    if ( old_state.web[i][1] ~= private.state.web[i][1] ) then
      ObjAnimate( "spr_cobweb_web_"..i, "pos_xy", 0, 0, "", {
        0,   0, private.web_pos[ old_state.web[i][1] ][1], private.web_pos[ old_state.web[i][1] ][2],
        0.5, 0, private.web_pos[ private.state.web[i][1] ][1], private.web_pos[ private.state.web[i][1] ][2]
      } );
      ObjAnimate( "spr_cobweb_web_"..i.."_sh", "pos_xy", 0, 0, "", {
        0,   0, private.web_sh_pos[ old_state.web[i][1] ][1], private.web_sh_pos[ old_state.web[i][1] ][2],
        0.5, 0, private.web_sh_pos[ private.state.web[i][1] ][1], private.web_sh_pos[ private.state.web[i][1] ][2]
      } );
    end;
    if ( old_state.web[i][2] ~= private.state.web[i][2] ) then
      ObjAnimate( "spr_cobweb_web_"..i, "ang", 0, 0, "", {
        0,   0, math.rad( 45 * old_state.web[i][2] ),
        0.5, 0, math.rad( 45 * private.state.web[i][2] )
      } );
      ObjAnimate( "spr_cobweb_web_"..i.."_sh", "ang", 0, 0, "", {
        0,   0, math.rad( 45 * old_state.web[i][2] ),
        0.5, 0, math.rad( 45 * private.state.web[i][2] )
      } );
      ObjAnimate( "obj_cobweb_button_"..i, "ang", 0, 0, "", { 
        0,   0, -math.rad( 45 * old_state.web[i][2] ),
        0.5, 0, -math.rad( 45 * private.state.web[i][2] )
      } );
    end;

    --DbgTrace(
    --  "web"..i.." pos == "..private.state.web[i][1]..", ang == "..private.state.web[i][2].." = "..math.rad( 45 * private.state.web[i][2] )
    --);

  end;

  for i = 1, 5, 1 do
    for j = 1, #private.state.map[i], 1 do
      if old_state.map[i][j][1] == 1 and private.state.map[i][j][1] == 0 then
        --DbgTrace( "lamp"..i..j.." = "..private.state.map[i][j][1] );
        ObjAnimate( "spr_cobweb_lamp"..i..j, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
      elseif private.state.map[i][j][1] == 1 and old_state.map[i][j][1] == 0 then
        --DbgTrace( "lamp"..i..j.." = "..private.state.map[i][j][1] );
        ObjAnimate( "spr_cobweb_lamp"..i..j, "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
      end;
    end;
  end;

  for i = 2, #old_state.way, 1 do
    local line_name = "spr_cobweb_way"..old_state.way[ i-1 ][1]..old_state.way[ i-1 ][2]..old_state.way[ i ][1]..old_state.way[ i ][2];
    local line_fx_name = "fx_cobweb_way"..old_state.way[ i-1 ][1]..old_state.way[ i-1 ][2]..old_state.way[ i ][1]..old_state.way[ i ][2];
    ObjAnimate( line_fx_name, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
    ObjAnimate( line_name, "alp", 0, 0, function () ObjDelete( line_name ); ObjDelete( line_fx_name ); end, { 0, 0, 1,    0.2, 0, 0 } );
  end;

  ObjSet( "tmr_cobweb_animlock", { time = 0.5, endtrig = private.SkipEnd, playing = true } );
  
end;
--*********************************************************************************************************************
function private.SkipEnd()

  --DbgTrace( "way" );
  for i = 1, #private.state.way-1, 1 do
    --DbgTrace( private.state.way[i][1]..","..private.state.way[i][2] );
    private.AnimWay( private.state.way[i], private.state.way[i+1] );
  end;

  ObjSet( "tmr_cobweb_animlock", { time = 0.3, endtrig = private.CheckWin, playing = true } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_webspider()

  local item = "inv_webspider";

  if ( cmn.ApplyObj( item, "obj_cobweb_use_webspider" ) ) then

    cmn.CallEventHandler( "use_webspider_inv" );
    cmn.CallEventHandler( "use_webspider_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_webspider" );
      cmn.CallEventHandler( "use_webspider_end" );
      cmn.CallEventHandler("use_webspider_loc");

      cmn.MiniGameShow();
      cmn.StartTimePassing("mg_cobweb");
      
      cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_game_2_mus", 1);

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_spider_on_web");

    ObjAnimate( "obj_cobweb_spider_new", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_spider()

  cmn.CallEventHandler( "get_spider_inv" );
  cmn.CallEventHandler( "get_spider_beg" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  local func_after = function ()

    cmn.SetEventDone( "get_spider" );
    cmn.CallEventHandler( "get_spider_end" );
    cmn.CallEventHandler( "get_spider_loc" );

    cmn.Lock( 0 );

  end;

  cmn.Lock( 1 );

  ObjAnimate( "anm_cobweb_spider", "pos_y", 0, 0, func_after, { 0, 0, 0,    0.3, 0, -426 } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function public.touch_cobweb_hand()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_mmg_spider");
  
  cmn.ShowBbt( "obj_cobweb_use_webspider" );
  
  ObjSet( "anm_cobweb_hand", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_cobweb" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_cobweb" ].state = {
    way = { {1,1} }, --пройденные точки
    web = { {3,2}, {4,6}, {2,2}, {1,6} },  --положение и угол паутинок
    map = {
      { --основные точки  { состояние , {связанные точки} }
        { 1, { {5,5} } },         { 0, { {1,3} } },         { 0, { {1,2}, {1,4} } },
        { 0, { {1,3}, {4,4} } },  { 0, {} },                { 0, { {2,2}, {3,5} } },    
        { 0, { {1,8} } },         { 0, { {1,7}, {1,9} } },  { 0, { {1,8} } }
      },
      { --точки на драгаемой паутинке 1
        { 0, { {2,2} } },         { 0, { {2,1}, {2,3}, {1,6} } },  { 0, { {2,2}, {2,4} } },
        { 0, { {2,3}, {2,5} } },  { 0, { {2,4} } }
      },
      { --точки на драгаемой паутинке 2
        { 0, { {3,2} } },         { 0, { {3,1}, {3,3} } },  { 0, { {3,2}, {3,4} } }, 
        { 0, { {3,3}, {3,5} } },  { 0, { {3,4}, {1,6} } }
      },
      { --точки на драгаемой паутинке 3
        { 0, { {4,2} } },                 { 0, { {4,1}, {4,3}, {4,4} } },  { 0, { {4,2}, {4,4} } },
        { 0, { {4,2}, {4,3} , {1,4} } }
      },
      { --точки на драгаемой паутинке 4
        { 0, { {5,2} } },        { 0, { {5,1}, {5,3}, {5,4} } },         { 0, { {5,2}, {5,5} } },
        { 0, { {5,2}, {5,5} } }, { 0, { {5,3}, {5,4}, {5,6}, {1,1} } },  { 0, { {5,5} } }
      }
    }
  };

end;
-----------------------------------------------------------------------------------
function private.DrawScene()

  if ( private.drawscene_flag ) then
    return;
  end;

  --DbgTrace( "***DrawScene" );

  --private.FindWay( private.state.way[#private.state.way], {1,9} );

  -----------------------
  local start_lamp = private.state.way[#private.state.way];
  local finish_lamp;

  for j = 1, 4, 1 do
    if private.win_way_segments[ j ][1] == start_lamp[2] then

      for i = j, 4, 1 do

        start_lamp = { 1, private.win_way_segments[ i ][1] };
        finish_lamp = { 1, private.win_way_segments[ i ][2] };

        if not private.FindWay( start_lamp, finish_lamp ) then
          --DbgTrace( "way_is_find "..start_lamp[1]..start_lamp[2].." -> "..finish_lamp[1]..finish_lamp[2].." = false\n" );
          break;
        end;

        --DbgTrace( "way_is_find "..start_lamp[1]..start_lamp[2].." -> "..finish_lamp[1]..finish_lamp[2].." = true\n" );

      end;

      break;

    end;
  end;
  --------------------

  for i = 1, 4, 1 do

    ObjMultiSet( {
      { "spr_cobweb_web_"..i, {
        pos_x = private.web_pos[ private.state.web[i][1] ][1],
        pos_y = private.web_pos[ private.state.web[i][1] ][2],
        ang = math.rad( 45 * private.state.web[i][2] )
      } },
      { "spr_cobweb_web_"..i.."_sh", {
        pos_x = private.web_sh_pos[ private.state.web[i][1] ][1],
        pos_y = private.web_sh_pos[ private.state.web[i][1] ][2],
        ang = math.rad( 45 * private.state.web[i][2] )
      } },
      { "obj_cobweb_button_"..i, { ang = -math.rad( 45 * private.state.web[i][2] ) } }
    } );

    --DbgTrace(
    --  "web"..i.." pos == "..private.state.web[i][1]..
    --  ", ang == "..private.state.web[i][2].." = "..math.rad( 45 * private.state.web[i][2] )
    --);

  end;

  for i = 1, 5, 1 do
    for j = 1, #private.state.map[i], 1 do
      if private.state.map[i][j][1] == 0 then
        --ObjSet( "spr_cobweb_lamp"..i..j, { alp = 0 } );
      else
        --DbgTrace( "lamp"..i..j.." = "..private.state.map[i][j][1] );
        ObjSet( "spr_cobweb_lamp"..i..j, { alp = 1 } );
      end;
    end;
  end;

  --DbgTrace( "way" );
  for i = 1, #private.state.way-1, 1 do
    --DbgTrace( "{"..private.state.way[i][1]..","..private.state.way[i][2].."}, " );
    private.AnimWay( private.state.way[i], private.state.way[i+1], true );
  end;

  private.drawscene_flag = true;

end;
-----------------------------------------------------------------------------------
function private.CheckWin()

  --DbgTrace( "***CheckWin" );

  if  private.state.way[ #private.state.way ][1] == 1
  and private.state.way[ #private.state.way ][2] == 9 then

    --DbgTrace( "WWWWWWWWWWWIIIIIIIIINNNNNNNNNN" );
    cmn.Lock( 1 );
    private.Win();

  else

    --DbgTrace( "last lamp = "..private.state.way[ #private.state.way ][1]..private.state.way[ #private.state.way ][2] );
    cmn.Lock( 0 );

  end;

end;
-----------------------------------------------------------------------------------
function private.AnimWin( num, start_xy, start_ang )

  local start_pos = private.state.way[ num-1 ];
  local end_pos = private.state.way[ num ];
  local end_xy = GetObjPosByObj( "spr_cobweb_lamp"..end_pos[1]..end_pos[2] );
  local end_ang = ObjGet( "spr_cobweb_way"..start_pos[1]..start_pos[2]..end_pos[1]..end_pos[2] ).ang;

  ObjSet( "anm_cobweb_lamp"..start_pos[1]..start_pos[2], { playing = true } );

  --DbgTrace( "" );
  --DbgTrace( "way ".."spr_cobweb_way"..start_pos[1]..start_pos[2]..end_pos[1]..end_pos[2] );

  if (start_pos[1] ~= 1) and (end_pos[1] ~= 1) then
    --DbgTrace( "web"..(start_pos[1]-1).." lamp: end_ang = "..math.deg(end_ang).." = "..math.deg( end_ang + math.rad( 45 * private.state.web[ start_pos[1]-1 ][2] ) ) );
    end_ang = end_ang + math.rad( 45 * private.state.web[ start_pos[1]-1 ][2] );
  end;

  if math.abs( start_ang - end_ang ) > 3.14159 then

    --DbgTrace( "поворот > 180" );

    if ( end_ang > 0 ) then
      --DbgTrace( "end_ang "..math.deg(end_ang).." = "..math.deg(end_ang - 6.28319) );
      end_ang = end_ang - 6.28319;
    elseif ( end_ang < 0 ) then
      --DbgTrace( "end_ang "..math.deg(end_ang).." = "..math.deg(end_ang + 6.28319) );
      end_ang = end_ang + 6.28319;
    end;

  end;

  --DbgTrace( "***AnimWin: num = "..num..", ang = "..math.deg( start_ang ).." -> "..math.deg( end_ang ) );

  local func_after;
  if ( num == #private.state.way ) then

    func_after3 =  function ()
      ObjSet( "anm_cobweb_win_doors", { endtrig = private.WinEnd, playing = true } );
    end;

    func_after2 =  function ()
      if ng_global.currentprogress == "std" then
        for i = 1, 4, 1 do
          ObjAnimate( "spr_cobweb_web_"..i, "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
        end;
        ObjAnimate( "obj_cobweb_webs_sh_hub",     "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
        ObjAnimate( "obj_cobweb_lamps",           "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
        ObjAnimate( "obj_cobweb_ways_hub",        "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
        ObjAnimate( "obj_cobweb_ways_lights_hub", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
        ObjAnimate( "anm_cobweb_web_static",      "alp", 0, 0, func_after3, { 0, 0, 1,    0.5, 0, 0 } );
      else 
        private.WinEnd();
      end;
    end;

    func_after =  function ()
      SndStop("assets/levels/level1/audio/sfx/aud_mmg_spider_win_mmg", 0.5);
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_spider_win_take");
      ObjMultiSet( { { "anm_cobweb_hand", { animfunc = "func_win", endtrig = func_after2, frame = 0, playing = true } },
                     { "obj_cobweb_spider_new", { alp = 0 } } } );
    end;

  else
    func_after = function () private.AnimWin( (num + 1), end_xy, end_ang ); end;
  end;

  local len = common_impl.math.FindSegmentLength( start_xy, end_xy );
  local tme = 0.004 * len;

  ObjAnimate( "obj_cobweb_spider_new", "pos_xy", 0, 0, func_after, { 0, 0, start_xy[1], start_xy[2],    tme, 0, end_xy[1], end_xy[2] } );
  ObjAnimate( "obj_cobweb_spider_new", "ang", 0, 0, "", { 0, 0, start_ang,    tme*0.75, 0, end_ang } );

end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.Lock( 0 );

  cmn.SetEventDone( "win_cobweb" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_cobweb" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_cobweb" ].skip == 0 and not ng_global.noskipgames[ "win_cobweb" ] then

      ng_global.noskipgames[ "win_cobweb" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_cobweb" ] then
      ng_global.playedgames[ "win_cobweb" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );

    cmn.GotoRoom("rm_outsidechapel");
    
  else 
    
    ObjSet("mg_cobweb",  { input = 0 });
    interface_impl.ShowStarsWindow();
    
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()

  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_spider_win_mmg");
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_spider_win_mmg_sound");

  if ng_global.currentprogress == "std" then
  
    cmn.MiniGameHide();

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_cobweb" );
        
  else 
    
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
    
  end;

  ObjMultiSet( {
    { "anm_cobweb_spider_new", { animfunc = "func_spider_moving", playing = true, frame = 0 } },
    { "obj_cobweb_spider_new", { pos_z = 12 } }
  } );

  ObjAnimate( "obj_cobweb_spider_new", "pos_xy", 0, 0, function () private.AnimWin( 2, {580,411}, -0.785398 ); end,
    { 0, 0, 512, 326,    0.5, 0, 580, 411 }
  );
  ObjAnimate( "obj_cobweb_spider_new", "ang", 0, 0, "", { 0, 0, 1.5708,    0.5*0.75, 0, -0.785398 } );

end;
-----------------------------------------------------------------------------------
function public.Focus( name, inout )
  
  local obj = "spr_cobweb_"..name.."_select";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else

    if string.find( name, "web" ) then
      SetCursor(CURSOR_GET);
    else
      SetCursor(CURSOR_HAND);
    end;

    tme = ( 1 - alf ) * 0.3;

  end;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );
  
end;
-----------------------------------------------------------------------------------
function public.ClickLamp( num1, num2, not_block )

  --DbgTrace( "***ClickLamp "..num1..num2..", not_block = "..tostring( not_block ) );

  if not not_block then
    cmn.Lock( 1 );
  end;

  if ( private.state.map[ num1 ][ num2 ][ 1 ] == 0 ) then
    --[[
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_spider_ckick_red_dote");

    private.state.map[ num1 ][ num2 ][ 1 ] = 1;

    ObjSet( "spr_cobweb_lamp"..num1..num2, { input = true } );

    if ( #private.state.way > 0 ) then
      --убираем связи у предыдущей лампочки
      private.LampLinkChange( false, private.state.way[ #private.state.way ] );
      private.AnimWay( private.state.way[ #private.state.way ], { num1, num2 } );
    end;

    --устанавливаем связи у новой лампочки
    table.insert( private.state.way, { num1, num2 } );
    private.LampLinkChange( true, private.state.way[ #private.state.way ] );

    ObjAnimate( "spr_cobweb_lamp"..num1..num2, "alp", 0, 0, function () if not not_block then private.CheckWin(); end; end, { 0, 0, 0,    0.2, 0, 1 } );
    ]]
  else

    local last_lamp;

    for i = #private.state.way, 1, -1 do

      if ( i > 1 ) then
        local line_name = "spr_cobweb_way"..private.state.way[ i-1 ][1]..private.state.way[ i-1 ][2]..private.state.way[ i ][1]..private.state.way[ i ][2];
        local line_fx_name = "fx_cobweb_way"..private.state.way[ i-1 ][1]..private.state.way[ i-1 ][2]..private.state.way[ i ][1]..private.state.way[ i ][2];
        ObjAnimate( line_fx_name, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
        ObjAnimate( line_name, "alp", 0, 0, function () ObjDelete( line_name ); ObjDelete( line_fx_name ); end, { 0, 0, 1,    0.2, 0, 0 } );
      end;

      last_lamp = private.state.way[ i ];

      --DbgTrace( "way lamp"..last_lamp[1]..last_lamp[2].." = 0" );
      private.state.map[ last_lamp[1] ][ last_lamp[2] ][ 1 ] = 0;

      table.remove( private.state.way );

      ObjAnimate( "spr_cobweb_lamp"..last_lamp[1]..last_lamp[2], "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );

      if ( last_lamp[1] == num1 ) and ( last_lamp[2] == num2 ) then
        break;
      end;

    end;

    ObjSet( "tmr_cobweb_animlock", { time = 0.3, endtrig = function () if not not_block then cmn.Lock( 0 ); end; end, playing = true } );

  end;

  --DbgTrace( "way" );
  --for i = 1, #private.state.way, 1 do
  --  DbgTrace( "lamp "..private.state.way[i][1]..private.state.way[i][2] );
  --end;

end;
-----------------------------------------------------------------------------------
function private.WebLinkChange( num )  --изменение связи паутинок

  --DbgTrace( "***WebLinkChange" );

  --убираем старые соединения
  --DbgTrace( "web"..num.." old lamps link:" );

  local web_lamp_num1 = num + 1;
  local web_map = private.state.map[ web_lamp_num1 ];
  local hole_map = private.state.map[ 1 ];

  for i = 1, #web_map, 1 do
    for j = #web_map[i][2], 1, -1 do
      if web_map[i][2][j][1] ~= web_lamp_num1 then
        --DbgTrace( "lamp"..web_lamp_num1..i.." -X-> "..web_map[i][2][j][1]..web_map[i][2][j][2] );
        table.remove( web_map[i][2], j );
      end;
    end;
  end;

  for i = 1, #hole_map, 1 do
    for j = #hole_map[i][2], 1, -1 do
      if hole_map[i][2][j][1] == web_lamp_num1 then
        --DbgTrace( "lamp1"..i.." -X-> "..web_lamp_num1..hole_map[i][2][j][2] );
        table.remove( hole_map[i][2], j );
      end;
    end;
  end;

  -----------------------------
  --ищем новые соединения
  --DbgTrace( "web"..num.." new lamps link:" );

  local web_lamp_on_edge_num = private.state.web[num][2] + 1;
  local hole_num = private.state.web[num][1];

  for i = 1, 8, 1 do

    if private.web_lamp_on_edge[num][ web_lamp_on_edge_num ] and private.hole_link_on_edge[hole_num][i] then
      for j = 1, #private.hole_link_on_edge[hole_num][i], 1 do

        --DbgTrace( 
        --  "lamp"..web_lamp_num1..private.web_lamp_on_edge[num][ web_lamp_on_edge_num ]..
        --  " -> 1"..private.hole_link_on_edge[hole_num][i][j]
        --);

        table.insert( web_map[ private.web_lamp_on_edge[num][ web_lamp_on_edge_num ] ][ 2 ], { 1, private.hole_link_on_edge[hole_num][i][j] } );

        --DbgTrace( 
        --  "lamp1"..private.hole_link_on_edge[hole_num][i][j]..
        --  " -> "..web_lamp_num1..private.web_lamp_on_edge[num][ web_lamp_on_edge_num ]
        --);

        table.insert( hole_map[ private.hole_link_on_edge[hole_num][i][j] ][ 2 ], { web_lamp_num1, private.web_lamp_on_edge[num][ web_lamp_on_edge_num ] } );

      end;
    end;

    web_lamp_on_edge_num = web_lamp_on_edge_num + 1;

    if web_lamp_on_edge_num > 8 then
      web_lamp_on_edge_num = 1;
    end;

  end;

  -----------------------------

  --DbgTrace( "web"..num.." lamps link:" );
  --for i = 1, #web_map, 1 do
  --  for j = #web_map[i][2], 1, -1 do
  --    DbgTrace( "lamp"..web_lamp_num1..i.." -> "..web_map[i][2][j][1]..web_map[i][2][j][2] );
  --  end;
  --end;

  --DbgTrace( "hole lamps link:" );
  --for i = 1, #hole_map, 1 do
  --  for j = #hole_map[i][2], 1, -1 do
  --    DbgTrace( "lamp1"..i.." -> "..hole_map[i][2][j][1]..hole_map[i][2][j][2] );
  --  end;
  --end;

end;
-----------------------------------------------------------------------------------
function public.ClickWeb( num )

  --DbgTrace( "" );
  --DbgTrace( "***ClickWeb "..num );

  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_spider_click_mech");

  cmn.Lock( 1 );

  local old_ang = private.state.web[num][2];

  private.state.web[num][2] = private.state.web[num][2] + 1;

  if ( private.state.web[num][2] == 8 ) then
    old_ang = -1;
    private.state.web[num][2] = 0;
  end;

  --DbgTrace( "web"..num.." ang "..old_ang.." -> "..private.state.web[num][2] );

  -------------------------
  --выключаем лампочки
  local web_lamp_num1 = num + 1;

  for i = 1, #private.state.way, 1 do
    if ( private.state.way[i][1] == web_lamp_num1 ) then
      --DbgTrace( "web lamp"..web_lamp_num1..private.state.way[i][2].." == 1" );
      public.ClickLamp( web_lamp_num1, private.state.way[i][2] );
      break;
    end;
  end;
  -------------------------

  private.WebLinkChange( num );

  -------------------------

  local start_lamp = { 1, private.win_way_segments[ private.state.web[num][1] ][1] };
  local finish_lamp;
  local anim_way_num = #private.state.way;
  local way_is_find = false;

  if private.state.map[ start_lamp[1] ][ start_lamp[2] ][ 1 ] == 1 then
    for i = private.state.web[num][1], 4, 1 do

      start_lamp = { 1, private.win_way_segments[ i ][1] };
      finish_lamp = { 1, private.win_way_segments[ i ][2] };

      if private.FindWay( start_lamp, finish_lamp ) then
        way_is_find = true;
      else
        --DbgTrace( "way_is_find "..start_lamp[1]..start_lamp[2].." -> "..finish_lamp[1]..finish_lamp[2].." = "..tostring(way_is_find).."\n" );
        break;
      end;

      --DbgTrace( "way_is_find "..start_lamp[1]..start_lamp[2].." -> "..finish_lamp[1]..finish_lamp[2].." = "..tostring(way_is_find).."\n" );

    end;
  end;

  local func_after = function ()
    if way_is_find then

      --DbgTrace( "anim_way_num = "..anim_way_num );

      for i = anim_way_num, #private.state.way-1, 1 do
        private.AnimWay( private.state.way[i], private.state.way[i+1] );
        ObjAnimate( "spr_cobweb_lamp"..private.state.way[i+1][1]..private.state.way[i+1][2], "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
      end;

      ObjSet( "tmr_cobweb_animlock", { time = 0.3, endtrig = function () private.CheckWin(); end, playing = true } );

    else
      cmn.Lock( 0 );
    end;
  end;

  ObjAnimate( "spr_cobweb_web_"..num, "ang", 0, 0, func_after, { 
    0,   0, math.rad( 45 * old_ang ),
    0.3, 0, math.rad( 45 * private.state.web[num][2] )
  } );

  ObjAnimate( "spr_cobweb_web_"..num.."_sh", "ang", 0, 0, "", { 
    0,   0, math.rad( 45 * old_ang ),
    0.3, 0, math.rad( 45 * private.state.web[num][2] )
  } );

  ObjAnimate( "obj_cobweb_button_"..num, "ang", 0, 0, "", { 
    0,   0, -math.rad( 45 * old_ang ),
    0.3, 0, -math.rad( 45 * private.state.web[num][2] )
  } );

end;
-----------------------------------------------------------------------------------
function private.FindWay( last_lamp, finish_lamp )

  --DbgTrace( "***FindWay: "..last_lamp[1]..last_lamp[2].." -> "..finish_lamp[1]..finish_lamp[2] );

  local last_lamp_link = private.state.map[ last_lamp[1] ][ last_lamp[2] ][ 2 ];

  for i = 1, #last_lamp_link, 1 do

    if private.state.map[ last_lamp_link[i][1] ][ last_lamp_link[i][2] ][ 1 ] == 0 then

      --DbgTrace( last_lamp[1]..last_lamp[2].." -> "..last_lamp_link[i][1]..last_lamp_link[i][2].." == 0" );

      table.insert( private.state.way, { last_lamp_link[i][1], last_lamp_link[i][2] } );
      private.state.map[ last_lamp_link[i][1] ][ last_lamp_link[i][2] ][ 1 ] = 1;

      if last_lamp_link[i][1] == finish_lamp[1] and last_lamp_link[i][2] == finish_lamp[2] then

        return last_lamp_link[i];

      else

        local way_is_find = private.FindWay( last_lamp_link[i], finish_lamp );
        --DbgTrace( "way_is_find = "..tostring(way_is_find) );

        if not way_is_find then

          table.remove( private.state.way );
          --DbgTrace( "wrong_way_lamp "..last_lamp_link[i][1]..last_lamp_link[i][2].." = 0" );
          private.state.map[ last_lamp_link[i][1] ][ last_lamp_link[i][2] ][ 1 ] = 0;

        else
          return way_is_find;
        end;

      end;

    --else
      --DbgTrace( last_lamp[1]..last_lamp[2].." -> "..last_lamp_link[i][1]..last_lamp_link[i][2].." == 1" );
    end;

  end;

  --DbgTrace( "***FindWay end: "..last_lamp[1]..last_lamp[2].." -> "..finish_lamp[1]..finish_lamp[2] );

end;
-----------------------------------------------------------------------------------
function public.StartDragWeb( num )

  --DbgTrace( "***StartDragWeb "..num );
  private.old_curspos = { ObjGet("spr_cobweb_web_"..num).pos_x, ObjGet("spr_cobweb_web_"..num).pos_y };
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_spider_take_mech");

  public.Focus( "web_"..num, 0 );

  SetCursor(CURSOR_DEFAULT);

  ObjSet( "spr_cobweb_web_"..num, { pos_z = 20 } );

  ObjAnimate( "spr_cobweb_web_"..num.."_sh", "alp", 0, 0, "", { 0, 0, 0.5,    0.05, 0, 0 } );

  -----------------------------
  --выключаем лампочки
  local web_lamp_num1 = num + 1;

  for i = 1, #private.state.way, 1 do
    if ( private.state.way[i][1] == web_lamp_num1 ) then
      --DbgTrace( "web lamp"..web_lamp_num1..private.state.way[i][2].." == 1" );
      public.ClickLamp( web_lamp_num1, private.state.way[i][2], true );
      break;
    end;
  end;

end;
-----------------------------------------------------------------------------------
function public.DropDragWeb( num, poss )

  --DbgTrace( "***DropDragWeb "..num );

  cmn.Lock( 1 );

  local web_name = "spr_cobweb_web_"..num;
  local old_pos = private.state.web[num][1];
  local new_pos = private.state.web[num][1];
  local curspos = poss or GetZoomCursorPos();--GetObjPosByObj();
  if  tostring(GetPlatform()) == "android" then
      curspos[2] = curspos[2] - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        curspos[2] = curspos[2] - 75;
      else
        curspos[2] = curspos[2] - 50;
      end;
    end;
  local start_drag_web = 0;

  --DbgTrace( curspos[1].." "..curspos[2] );

  local replace_aud_flag = false;

  for i = 1, 4, 1 do
    if ( common_impl.math.FindSegmentLength( private.web_pos[i], curspos ) < 100 ) then
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_spider_replace_mech");
      replace_aud_flag = true;
      new_pos = i;
      break;
    end;
  end;

  if ( not replace_aud_flag ) then
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_spider_wrong_place");
  end;

  --DbgTrace( "web"..num.." pos -> "..new_pos );

  if ( private.state.web[num][1] ~= new_pos ) then

    for i = 1, 4, 1 do
      if ( private.state.web[i][1] == new_pos ) then

        --DbgTrace( "web"..i.." pos = "..old_pos..", drag" );
        start_drag_web = i;
        private.state.web[i][1] = old_pos;

        -----------------------------
        --выключаем лампочки
        local web_lamp_num1 = i + 1;

        for j = 1, #private.state.way, 1 do
          if ( private.state.way[j][1] == web_lamp_num1 ) then
            --DbgTrace( "web lamp"..web_lamp_num1..private.state.way[j][2].." == 1" );
            public.ClickLamp( web_lamp_num1, private.state.way[j][2], true );
            break;
          end;
        end;
        -----------------------------

        private.WebLinkChange( i );
        break;

      end;
    end;

    private.state.web[num][1] = new_pos;

    private.WebLinkChange( num );

  end;


  local end_pos_xy = private.web_pos[new_pos];
  local end_sh_pos_xy = private.web_sh_pos[new_pos];

  local len = common_impl.math.FindSegmentLength( curspos, end_pos_xy );
  local tme = 0.002 * len;
  if tme < 0.2 then
    tme = 0.2;
  elseif tme > 0.3 then
    tme = 0.3;
  end;


  ---------------------------
  local start_lamp = { 1, private.win_way_segments[ private.state.web[num][1] ][1] };
  local finish_lamp;
  local anim_way_num = #private.state.way;
  local way_is_find = false;

  if private.state.map[ start_lamp[1] ][ start_lamp[2] ][ 1 ] == 1 then
    for i = private.state.web[num][1], 4, 1 do

      start_lamp = { 1, private.win_way_segments[ i ][1] };
      finish_lamp = { 1, private.win_way_segments[ i ][2] };

      if start_drag_web ~= 0 and private.state.web[start_drag_web][1] == i then
        --DbgTrace( "web"..start_drag_web.." in pos "..private.state.web[start_drag_web][1].." -> drag" );
        break;
      end;

      if private.FindWay( start_lamp, finish_lamp ) then
        way_is_find = true;
      else
        --DbgTrace( "way_is_find "..start_lamp[1]..start_lamp[2].." -> "..finish_lamp[1]..finish_lamp[2].." = "..tostring(way_is_find).."\n" );
        break;
      end;

      --DbgTrace( "way_is_find "..start_lamp[1]..start_lamp[2].." -> "..finish_lamp[1]..finish_lamp[2].." = "..tostring(way_is_find).."\n" );

    end;
  end;
  ---------------------------

  local func_after = function()

    --DbgTrace( "***DropDragWeb func_after "..num );

    if way_is_find then
      --DbgTrace( "anim_way_num = "..anim_way_num );
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_spider_ckick_red_dote");
      for i = anim_way_num, #private.state.way-1, 1 do
        private.AnimWay( private.state.way[i], private.state.way[i+1] );
        ObjAnimate( "spr_cobweb_lamp"..private.state.way[i+1][1]..private.state.way[i+1][2], "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
      end;
    end;

    cmn.Lock( 0 );

    ObjSet( web_name, { pos_z = 4 } );

    if start_drag_web ~= 0 then
      --ObjStartDrag( "spr_cobweb_web_"..start_drag_web ); --начинаем таскать паутину которую заменили
      --DbgTrace( "start drag web "..start_drag_web );
      port.TapDownTimer(0.25,function()
        ObjSet("spr_cobweb_web_"..start_drag_web ,{ pos_x = private.old_curspos[1], pos_y = private.old_curspos[2] });
        public.DropDragWeb(start_drag_web,private.old_curspos);
      end);
    end;

    if start_drag_web == 0 and way_is_find then
      private.CheckWin();
    end;

  end;


  ObjAnimate( web_name, "pos_xy", 0, 0, func_after, { 0, 0, curspos[1], curspos[2],   tme, 0, end_pos_xy[1], end_pos_xy[2] } );

  ObjSet( "spr_cobweb_web_"..num.."_sh", { pos_x = end_sh_pos_xy[1], pos_y = end_sh_pos_xy[2] } );
  ObjAnimate( "spr_cobweb_web_"..num.."_sh", "alp", 0, 0, "", { 0, 0, 0,    (tme-0.05), 0, 0,    tme, 0, 0.5 } );

end;
-----------------------------------------------------------------------------------
function private.AnimWay( point1, point2, not_anim )

  --DbgTrace( "***AnimWay "..point1[1]..point1[2].." -> "..point2[1]..point2[2] );

  local name_suffix = point1[1]..point1[2]..point2[1]..point2[2];
  local way_name = "spr_cobweb_way"..name_suffix;
  local way_fx_name = "fx_cobweb_way"..name_suffix;

  --DbgTrace( "name_suffix = "..name_suffix );

  local point_a   = GetObjPosByObj( "spr_cobweb_lamp"..point1[1]..point1[2] );
  local point_c   = GetObjPosByObj( "spr_cobweb_lamp"..point2[1]..point2[2] );
  point_a[1] = point_a[1]+0.0012; --чтою небыло деления на ноль
  point_a[2] = point_a[2]+0.0034;
  point_c[1] = point_c[1]+0.0067;
  point_c[2] = point_c[2]+0.0089;
  local point_b   = { point_a[1] + point_c[1], point_a[2] };

  local len       = common_impl.math.FindSegmentLength( point_a, point_c );
  local scale     = len / 86;
  local ang       = common_impl.math.FindTriangleApexAng( point_a, point_b, point_c );

  if ( point_a[2] < point_c[2] ) then --если конечная точка ниже начальной, вертим в противоположную сторону
    ang = -ang;
    --DbgTrace( "ниже" );
  end;

  local way_parent = "obj_cobweb_ways_hub";
  local way_light_parent = "obj_cobweb_ways_lights_hub";

  if point1[1] ~= 1 and point2[1] ~= 1 then
    way_parent = "spr_cobweb_web_"..(point1[1]-1);
    way_light_parent = "spr_cobweb_web_"..(point1[1]-1);
    ang = ang - math.rad( 45 * private.state.web[ point1[1]-1 ][2] );
  end;

  ObjClone( "spr_cobweb_way", name_suffix, false, way_parent );

  local pos_xy = GetObjPosByObj( "spr_cobweb_lamp"..point1[1]..point1[2], way_light_parent );

  --DbgTrace(
  --  "way_parent = "..way_parent..", lights = "..way_light_parent..
  --  ", ang = "..ang..", pos_x = "..pos_xy[1]..", pos_y = "..pos_xy[2]..", scale_x = "..scale
  --);

  ObjClone( "fx_cobweb_way", name_suffix, false, way_light_parent );
  ObjSet( way_fx_name, { ang = ang, alp = 1, pos_x = pos_xy[1], pos_y = pos_xy[2] } );

  if ( not_anim ) then

    ObjSet( way_name, { scale_x = scale, ang = ang, alp = 1, pos_x = pos_xy[1], pos_y = pos_xy[2] } );

  else

    ObjSet( way_name, { ang = ang, alp = 1, pos_x = pos_xy[1], pos_y = pos_xy[2] } );

    ObjAnimate( way_name, "scale_x", 0, 0, "", { 0, 0, 0,    0.2, 0, scale } );

  end;

end;
--*********************************************************************************************************************
function private.CreateNewObjects()
  
  ObjDelete( "anm_cobweb_spider_new" );
  ObjCreate("anm_cobweb_spider_new", "anim");
  ObjAttach("anm_cobweb_spider_new", "obj_cobweb_spider_new");
  
  ObjMultiSet( { {"mg_cobweb",  { input = 1 }},
                 {"anm_cobweb_spider_new", { res = "assets/levels/level1/mg_cobweb/anm_mg_cobweb", animfunc = "func_spider", ang = -1.5708, input = 0, playing = 1 }},
                 {"obj_cobweb_spider_new", { pos_x = 512, pos_y = 326, ang = 1.5708, alp = 1 }},
                 {"anm_cobweb_hand", { animfunc = "func_touch_hand", frame = 0 }} } );
  
  ObjDelete( "anm_cobweb_spider" );
  ObjDelete( "obj_cobweb_use_webspider" );
  ObjDelete( "obj_cobweb_ways_lights_hub" );
  ObjDelete( "obj_cobweb_ways_hub" );
  
  ObjCreate("obj_cobweb_ways_lights_hub", "obj");
  ObjAttach("obj_cobweb_ways_lights_hub", "mg_cobweb");
  ObjSet("obj_cobweb_ways_lights_hub",  { input = 0, pos_z = 10 });
  
  ObjCreate("obj_cobweb_ways_hub", "obj");
  ObjAttach("obj_cobweb_ways_hub", "mg_cobweb");
  ObjSet("obj_cobweb_ways_hub",  { input = 0 });
  
  for i = 1, 4, 1 do
    ObjSet( "spr_cobweb_web_"..i, { input = true } );
  end;
  
  for i = 1, 5, 1 do
    for j = 1, #private.state.map[i], 1 do
    
      ObjMultiSet( { {"spr_cobweb_lamp"..i..j, { alp = 0 }},
                     {"anm_cobweb_lamp"..i..j, { playing = 0, frame = 0 }} } );
    
    end;
  end;
                 
  local old_state = private.state;      

  for i = 2, #old_state.way, 1 do
    local line_name = "spr_cobweb_way"..old_state.way[ i-1 ][1]..old_state.way[ i-1 ][2]..old_state.way[ i ][1]..old_state.way[ i ][2];
    local line_fx_name = "fx_cobweb_way"..old_state.way[ i-1 ][1]..old_state.way[ i-1 ][2]..old_state.way[ i ][1]..old_state.way[ i ][2];
    ObjDelete( line_name );
    ObjDelete( line_fx_name );
  end;  
  
end;
--********************************************************************************************************************