-- name=mg_mind
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_mind";
  --------------------------------------------------------------------------------------------
  private.right_answers = {2, 3, 1, 3, 4};
  --------------------------------------------------------------------------------------------
  -- function win_mind () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_mind" ] = {
    type = "win",
    room = "rm_chapel",
    zz = "mg_mind",
    zz_gate = "gmg_chapel_mind"
  };
  --------------------------------------------------------------------------------------------
  local win_mind = function ()

    if cmn.IsEventDone( "win_mind" ) then
      ObjDelete("obj_mind_game");
    end;

  end;
--  local win_mind_loc = function ()
--
--  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_mind", win_mind, "mg_mind" );
--  cmn.AddSubscriber( "win_mind", win_mind_loc, "rm_chapel" );

  --------------------------------------------------------------------------------------------
  -- function opn_mind () end;
  --------------------------------------------------------------------------------------------
  local opn_mind = function ()
  
    ObjDelete("anm_mind_crowd_start");
    ObjDelete("anm_mind_queen_start");
    ObjDelete("anm_mind_ui_start");
    
    ObjMultiSet( { {"anm_mind_crowd", { alp = 1 }},
                   {"anm_mind_queen", { alp = 1 }},
                   {"anm_mind_ui", { alp = 1, input = 1 }},
                   {"obj_mind_levels_count", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_mind", opn_mind, "mg_mind" );
  
  private.action = { "anm_mind_crowd_start", "anm_mind_queen_start", "anm_mind_ui_start", "anm_mind_crowd", "anm_mind_queen", "anm_mind_ui", "obj_mind_levels_count", "anm_mind_queen_2", "tmr_mind_timer_queen" };
  private.start_actions = {};
  
  for j = 1, #private.action, 1 do
    
    private.start_actions[j] = {};
    private.start_actions[j].name = private.action[j];
    local nme = private.start_actions[j].name;
    private.start_actions[j].prop = ObjGet( nme );
    private.start_actions[j].parent = ObjGetRelations( nme ).parent;
  
  end;
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_mind" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_mind" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  if not cmn.IsEventDone("win_mind") then
    cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_mmg_mind_mus", 1);
  end;
  
  if ng_global.currentprogress == "std" and cmn.IsEventDone("opn_mind") and not(cmn.IsEventDone( "win_mind" )) then
    
    cmn.MiniGameShow();
    cmn.StartTimePassing("mg_mind");
    private.RandomChangeQueen();
    
  elseif ng_global.currentprogress == "std" and cmn.IsEventDone( "win_mind" ) then

    local func_after = function ()

      if (iOS_IsBought() == 0) then
        
        iOS_LogEvents(1);
        cmn.LevelSwitch("menu","unlock");
     
      else
        cmn.LevelSwitch( "level2", 2 );
        ng_global.progress["std"].common.chapter = "level2";
        ng_global.progress[ "std" ].common.currentroom = "rm_cargosection";
      end;
    
      ObjSet("mg_mind",  { color_r = 0, color_g = 0, color_b = 0 });

    end;

    cmn.Lock( 0 );
    cmn.StopAllEnv();

    cmn.PlayFullscreenVideo( "assets/levels/level1/mg_mind/vid_outro",
                             func_after,
                             "assets/levels/level1/audio/mus/aud_chapel_outro_vid",
                             "assets/levels/level1/audio/voc/aud_aion_outro_1" );

  end;
                           
  if not cmn.IsEventDone("opn_mind") then
    cmn.SetEventDone("opn_mind");
    private.GameStart();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level1/audio/env/aud_chapel_env");
  cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_chapel_env");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_chapel" );
  else 
    
    private.StartConditions();
    
    ng_global.progress[ ng_global.currentprogress ][ "opn_mind" ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "opn_mind" ].start = 0;
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_mind" ].state;
    
    for i = 1, 5, 1 do
      ObjMultiSet( { {"spr_mind_level_"..i.."_done",  { alp = 0 }},
                     {"spr_mind_level_"..i.."_current",  { alp = 0 }} } );
    end;
    
    private.CreateNewObjects();
    
    ObjSet("grm_mind_chapel",  { input = 1 });
                                     
  end;
  
  if not cmn.IsEventDone("opn_mind") then
    cmn.Lock( 1 );
  else 
    private.DrawScene();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_mind" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_mind" )) then
    rm_extra.MiniGameHide();
  end;
  
  if ng_global.currentprogress == "secret" then
    cmn.StopAllMus();
    ObjSet("grm_mind_chapel",  { input = 0 });
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  if private.state[2] == 1 then
    public.ResetGame();
  else 
    
    if private.state[1] > 1 then
      
      cmn.Lock( 1 );
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_riddle_diss");
      
      local old = private.state[1];
      private.state[1] = 1;
      
      for i = 1, old-1, 1 do
        ObjAnimate("spr_mind_level_"..i.."_done", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      end;
      
      local func_after = function ()
        
        cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_riddle_appears");
        
        ObjSet("txt_mind_question_text",  { text = StringGet("str_mind_question_1") });
        ObjAnimate("txt_mind_question_text", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        ObjAnimate("spr_mind_level_1_current", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 0,   0.5, 0, 1 });
          
        for i = 1, 4, 1 do
          ObjSet("txt_mind_answer_"..i.."_text",  { text = StringGet("str_mind_answer_1_"..i) });
          ObjAnimate("txt_mind_answer_"..i.."_text", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        end;
        
      end;
      
      ObjAnimate("spr_mind_level_"..old.."_current", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("txt_mind_question_text", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      
      for i = 1, 4, 1 do
        ObjAnimate("txt_mind_answer_"..i.."_text", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      end;
      
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_mind" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_mind" ].state = { 6, 0 };
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_click_right_answer");
  
  ObjMultiSet( { {"anm_mind_queen_next",  { animfunc = "func_queen_happy", alp = 1, playing = 1, endtrig = private.Win }},
                 {"anm_mind_queen", { alp = 0 }},
                 {"anm_mind_queen_2", { alp = 0 }} } );
  
  ObjAnimate("spr_mind_answer_"..private.right_answers[ private.state[1] ].."_right", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_mind" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_mind" ].state = { 1, 0 }; --stage

end;
-----------------------------------------------------------------------------------
function private.GameStart()
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_appear");
  
  local func_after = function ()
    
    cmn.CallEventHandler("opn_mind");
    
    local func_end = function ()
      if ng_global.currentprogress == "std" then
        cmn.ShowBbt( "mind_open" );
      end;
    end;
    
    private.ChangeStage( 1 );
    
    if ng_global.currentprogress == "std" then
      cmn.MiniGameShow();
      cmn.StartTimePassing("mg_mind");
    else 
      rm_extra.MiniGameShow();
    end;
    
    ObjSet("anm_mind_ui",  { alp = 1, playing = 1 });
    ObjAnimate("obj_mind_levels_count", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  local anim_ui = function ()
    
    ObjSet("anm_mind_ui_start",  { alp = 1, playing = 1, endtrig = func_after });
    
  end;
  
  local set_queen = function ()
    ObjDelete("anm_mind_queen_start");
    ObjSet("anm_mind_queen",  { alp = 1, playing = 1 });
  end;
  
  local anim_queen = function ()
    
    ObjMultiSet( { {"anm_mind_queen_start", { frame = 0, animfunc = "func_queen_start_2", playing = 1, endtrig = set_queen }},
                   {"tmr_mind_timer", { time = 1, playing = 1, endtrig = anim_ui }} } );
    
  end;
  
  local set_crowd = function ()
    ObjDelete("anm_mind_crowd_start")
    ObjSet("anm_mind_crowd",  { alp = 1, playing = 1 });
  end;
  
  ObjMultiSet( { {"anm_mind_queen_start", { playing = 1, endtrig = anim_queen }},
                 {"anm_mind_crowd_start", { playing = 1, endtrig = set_crowd }} } );

end;
-----------------------------------------------------------------------------------
function private.RandomChangeQueen()
  
  local change_queen_2 = function ()
    
    ObjMultiSet( { {"anm_mind_queen", { alp = 1, playing = 1 }},
                   {"anm_mind_queen_2", { alp = 0, endtrig = "", frame = 0 }} } );
    
  end;
  
  local change_queen = function ()
    
    ObjMultiSet( { {"anm_mind_queen", { alp = 0, playing = 0 }},
                   {"anm_mind_queen_2", { alp = 1, playing = 1, endtrig = change_queen_2 }} } );
    
  end;
  
  ObjSet("tmr_mind_timer_queen",  { time = math.random(10, 20), playing = 1, endtrig = change_queen });
  
end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  ObjMultiSet( { {"anm_mind_crowd", { playing = 1 }},
                 {"anm_mind_queen", { playing = 1 }},
                 {"anm_mind_ui", { playing = 1 }}} );
                 
  if private.state[2] == 1 then
    
    for i = 1, 5, 1 do
      
      ObjMultiSet( { {"spr_mind_level_"..i.."_done", { alp = 0 }},
                     {"spr_mind_level_"..i.."_current", { alp = 0 }} } );
      
    end;
    
    ObjMultiSet( { {"anm_mind_queen_kill", { alp = 1, input = 1, frame = 300 }},
                   {"obj_mind_game", { alp = 0, input = 0 }} } );
                   
  elseif private.state[1] < 6 then
                   
    ObjSet("txt_mind_question_text",  { text = StringGet("str_mind_question_"..private.state[1]) });
    
    for i = 1, 4, 1 do
      ObjSet("txt_mind_answer_"..i.."_text",  { text = StringGet("str_mind_answer_"..private.state[1].."_"..i) });
    end;
                   
    for i = 1, private.state[1]-1, 1 do
      ObjSet("spr_mind_level_"..i.."_done",  { alp = 1 });
    end;
    
    if private.state[1] < 6 then
      ObjSet("spr_mind_level_"..private.state[1].."_current",  { alp = 1 });
    end;
    
  else 
    
    ObjSet("txt_mind_question_text",  { text = StringGet("str_mind_question_5") });
    
    for i = 1, 4, 1 do
      ObjSet("txt_mind_answer_"..i.."_text",  { text = StringGet("str_mind_answer_5_"..i) });
    end;
                   
    for i = 1, private.state[1]-1, 1 do
      ObjSet("spr_mind_level_"..i.."_done",  { alp = 1 });
    end;
    
    if private.state[1] < 6 then
      ObjSet("spr_mind_level_5_current",  { alp = 1 });
    end;
    
    private.ChangeStage( 6, 5 );
     
  end;

end;
-----------------------------------------------------------------------------------
function public.ResetGame()
  
  cmn.Lock( 1 );
  --cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_reset");
  private.state[2] = 0;
  
  ObjSet("txt_mind_question_text",  { text = "" });
    
  for i = 1, 4, 1 do
    ObjSet("txt_mind_answer_"..i.."_text",  { text = "" });
  end;
  
  ObjSet("anm_mind_queen",  { alp = 1, playing = 1 });
  
  local func_after = function ()
    
    private.ChangeStage( private.state[1] );
    
    ObjMultiSet( { {"anm_mind_queen_kill", { alp = 0, input = 0, frame = 0 }},
                   {"obj_mind_game", { input = 1 }} } );
    
  end;
                 
  ObjSet("spr_mind_level_"..private.state[1].."_current",  { alp = 0 });
                 
  ObjAnimate("anm_mind_queen_kill", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("obj_mind_game", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function public.ChooseAnswer( num )
  
  port.TapDown(1.6);
  
  cmn.Lock( 1 );
  local old = private.state[1];
  
  if private.right_answers[ private.state[1] ] == num then
    
    if private.state[1] < 5 then
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_click_right_answer");
    else 
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_win");
    end;
    
    private.state[1] = private.state[1] + 1;
    ObjAnimate("spr_mind_answer_"..num.."_right", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    
    ObjAttach("spr_mind_icon_"..(private.state[1]-1), "obj_mind_answer_"..num);
    ObjAnimate("spr_mind_icon_"..(private.state[1]-1), "alp", 0, 0, "", { 0, 0, 0,   0.4, 0, 0,     0.8, 0, 0.7 });
    
  else 
    
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_click_wrong_answer");
    
    --private.state[1] = 1;
    --private.state[2] = 1;
    ObjAnimate("spr_mind_answer_"..num.."_wrong", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1,   1, 0, 1,   1.5, 0, 0 });
    
  end;
  
  ObjSet("tmr_mind_timer",  { time = 1, playing = 1, endtrig = function() private.ChangeStage( private.state[1], old ); end });
  
end;
-----------------------------------------------------------------------------------
function public.FocusAnswer( num, inout )
  
  local obj = "spr_mind_answer_"..num.."_focus";
  
  if num == "restart" then
    obj = "spr_mind_game_restart_focus";
  end;
  
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_queen_question_arrow_"..math.random(1, 3));
    end;
  end;

  --ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function private.ChangeStage( new, old )
  
  old = old or false;
  
  if not old or old < new then
    
    if not old then
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_riddle_appears");
      
      ObjAnimate("spr_mind_level_"..new.."_current", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
      ObjSet("txt_mind_question_text",  { text = StringGet("str_mind_question_"..new), alp = 0 });
      ObjAnimate("txt_mind_question_text", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,     1, 0, 1 });
      
      for i = 1, 4, 1 do
        ObjSet("txt_mind_answer_"..i.."_text",  { text = StringGet("str_mind_answer_"..new.."_"..i), alp = 0 });
        ObjAnimate("txt_mind_answer_"..i.."_text", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,     1, 0, 1 });
      end;
      
    elseif new < 6 then
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_riddle_diss");
      
      local new_text = function ()
        
        cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_riddle_appears");
        
        ObjAttach("spr_mind_icon_"..old, "obj_mind_game_icons");
        
        ObjSet("txt_mind_question_text",  { text = StringGet("str_mind_question_"..new) });
        ObjAnimate("txt_mind_question_text", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        ObjAnimate("spr_mind_level_"..new.."_current", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        
        for i = 1, 4, 1 do
          ObjSet("txt_mind_answer_"..i.."_text",  { text = StringGet("str_mind_answer_"..new.."_"..i) });
          ObjAnimate("txt_mind_answer_"..i.."_text", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        end;
        
      end;
      
      for i = 1, 4, 1 do
        ObjAnimate("txt_mind_answer_"..i.."_text", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      end;
      
      ObjAnimate("spr_mind_level_"..old.."_done", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_mind_level_"..old.."_current", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
      ObjAnimate("txt_mind_question_text", "alp", 0, 0, new_text, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_mind_answer_"..private.right_answers[old].."_right", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
      ObjAnimate("spr_mind_icon_"..old, "alp", 0, 0, "", { 0, 0, 0.7,   0.5, 0, 0 });
      
    else 
      
      ObjAnimate("spr_mind_level_"..old.."_done", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_mind_level_"..old.."_current", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
      ObjAnimate("obj_mind_game", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,    1, 0, 0 });
      
    end;
    
    local func_after = function ()
      
      if new < 6 then
        cmn.Lock( 0 );
        private.RandomChangeQueen();
      else 
        private.Win();
      end;
      
      ObjMultiSet( { {"anm_mind_queen", { alp = 1, playing = 1 }},
                     {"anm_mind_queen_next", { frame = 0, alp = 0, endtrig = "" }},
                     {"anm_mind_queen_next_2", { frame = 0, alp = 0, endtrig = "" }} } );
      
    end;
                   
    if not old then
      ObjSet("anm_mind_queen_next_2",  { alp = 1, playing = 1, endtrig = func_after });
    else 
      
      if new < 6 then
        ObjSet("anm_mind_queen_next",  { alp = 1, playing = 1, endtrig = func_after });
      else 
        ObjSet("anm_mind_queen_next",  { animfunc = "func_queen_happy", alp = 1, playing = 1, endtrig = func_after });
      end;
      
    end;
    
    ObjMultiSet( { {"anm_mind_queen", { alp = 0, playing = 0 }},
                   {"anm_mind_queen_2", { alp = 0, playing = 0, frame = 0, endtrig = "" }},
                   {"tmr_mind_timer_queen", { playing = 0, endtrig = "" }} } );
    
  elseif old >= new then
                   
    local func_after = function ()
      
      --cmn.Lock( 0 );
      
      private.DrawScene();
      public.ResetGame();
      
    end;
    
    local death = math.random(1, 3);
    
    if death == 3 then
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_reaper_2");
    else 
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_black_queen_reaper");
    end;
    
    ObjAnimate("obj_mind_game", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
    ObjMultiSet( { {"anm_mind_queen", { alp = 0, playing = 0 }},
                   {"anm_mind_queen_2", { alp = 0, playing = 0, frame = 0, endtrig = "" }},
                   {"tmr_mind_timer_queen", { playing = 0, endtrig = "" }},
                   {"anm_mind_queen_kill", { animfunc = "func_queen_game_over_"..death, frame = 0, alp = 1, playing = 1, endtrig = func_after }} } );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.SetEventDone( "win_mind" );
  cmn.CallEventHandler( "win_mind" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_mind" ].skip == 0 and not ng_global.noskipgames[ "win_mind" ] then

    ng_global.noskipgames[ "win_mind" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
    
  if ng_global.playedgames and not ng_global.playedgames[ "win_mind" ] then
    ng_global.playedgames[ "win_mind" ] = 1;
  end;

  common_impl.PauseAchiev( 0 );
  
  ObjSet("mg_mind",  { color_r = 0, color_g = 0, color_b = 0 });
  
  if (iOS_IsBought() == 0) then
        
        iOS_LogEvents(1);
        cmn.LevelSwitch("menu","unlock");
     
  else
    cmn.LevelSwitch( "level2", 2 );
    ng_global.progress["std"].common.chapter = "level2";
    ng_global.progress[ "std" ].common.currentroom = "rm_cargosection";
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  if ng_global.currentprogress == "std" then

    cmn.Lock( 1 );
    cmn.MiniGameHide();

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_mind" );
    
    local play_outro = function ()
      
      cmn.Lock( 0 );
      cmn.StopAllEnv();

      cmn.PlayFullscreenVideo( "assets/levels/level1/mg_mind/vid_outro",
                               private.WinEnd,
                               "assets/levels/level1/audio/mus/aud_chapel_outro_vid",
                               "assets/levels/level1/audio/voc/aud_aion_outro_1" );
      
    end;

    play_outro();
    
  else 
    
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
    cmn.SetEventDone( "win_mind" );
    cmn.Lock(0);
    ObjSet("grm_mind_chapel",  { input = 0 });
    interface_impl.ShowStarsWindow();
    
  end;

end;
--*********************************************************************************************************************
function private.CreateNewObjects()
  
  ObjSet("obj_mind_game",  { alp = 1 });
  
  for i = 1, 5, 1 do
    
    ObjAttach("spr_mind_icon_"..i, "obj_mind_game_icons");
    ObjSet("spr_mind_icon_"..i,  { alp = 0 });
    
  end;
  
  for i = 1, 4, 1 do
    ObjSet("spr_mind_answer_"..i.."_right",  { alp = 0 });
  end;
  
  for j = 1, #private.start_actions, 1 do
      
    local nme = private.start_actions[j].name;
    
    if not ObjGet( nme ) then
      
      local typ = common.GetObjectPrefix( nme );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( nme, typ );
      ObjSet( nme, private.start_actions[j].prop );
      ObjAttach( nme, private.start_actions[j].parent );

    else 

      ObjSet( nme, private.start_actions[j].prop );
      ObjAttach( nme, private.start_actions[j].parent );

    end;
      
  end;
  
end;
--***************************************************************************************************************