-- name=mg_returning
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_returning";
  --------------------------------------------------------------------------------------------
  private.win_state = { {17, 9, 10, 11}, {17, 9, 10, 11, 3}, {9, 8, 15, 17, 3, 11} };
  private.start_state = { { 15, 22, 5, 19 }, { 8, 20, 10, 18, 12 }, { 15, 22, 2, 4, 13, 11 } };
  private.polygon_pos = {
    {237, 164}, {338, 105}, {440, 164}, {542, 105}, {643, 164}, {745, 105},
    {237, 280}, {338, 222}, {440, 280}, {542, 222}, {643, 280}, {745, 222}, {847, 280},
    {237, 396}, {338, 338}, {440, 396}, {542, 338}, {643, 396}, {745, 338},
    {338, 455}, {440, 513}, {542, 455}
  };
  private.connect_pos = {
    {0, -52, -3.14}, {45, -26, -4.21}, {45, 25, 1.07}, {0, 52, 0}, {-45, 26, -1.07}, {-45, -26, -2.1}
  };
  private.polygons_around = {
    { 0, 2, 8, 7, 0, 0 }, { 0, 0, 3, 8, 1, 0 }, { 0, 4, 10, 9, 8, 2 }, { 0, 0, 5, 10, 3, 0, 0 }, { 0, 6, 12, 11, 10, 4 }, { 0, 0, 0, 12, 5, 0 },
    { 1, 8, 15, 14, 0, 0 }, { 2, 3, 9, 15, 7, 1 }, { 3, 10, 17, 16, 15, 8 }, { 4, 5, 11, 17, 9, 3 }, { 5, 12, 19, 18, 17, 10 }, { 6, 0, 13, 19, 11, 5 }, { 0, 0, 0, 0, 19, 12 },
    { 7, 15, 20, 0, 0, 0 }, { 8, 9, 16, 20, 14, 7 }, { 9, 17, 22, 21, 20, 15 }, { 10, 11, 18, 22, 16, 9 }, { 11, 19, 0, 0, 22, 17 }, { 12, 13, 0, 0, 18, 11 },
    { 15, 16, 21, 0, 0, 14 }, { 16, 22, 0, 0, 0, 20 }, { 17, 18, 0, 0, 21, 16 }
  };
  private.win_polygons = {0, 0, 0, 0, 0, 0};
  private.start_conns = { { {6, 1, 2}, {1}, {1}, {1} }, { {6, 1, 2}, {1, 2}, {1, 2}, {1, 2}, {1} }, { {6, 1, 2, 3}, {1, 2}, {1, 2}, {1, 2}, {1}, {1} } };
  
  private.custom_choose_pos = { {160, 250}, {165, 291, 429}, {173, 292, 418, 538} };
  private.custom_functions = { 
    {"func_change_body_man_young", "func_change_body_man_strong", "func_change_body_man_fat"}, 
    {"func_change_body_woman_young", "func_change_body_woman_strong", "func_change_body_woman_fat"} 
  };
  
  private.custom_faces = { {"head_man_young", "head_man_strong", "head_man_fat"}, {"head_woman_young", "head_woman_strong", "head_woman_fat"} };
  private.custom_faces_pos = {
    { { {710, 205}, {711, 202}, {710, 202}, {710, 201} }, { {712, 184}, {712, 181}, {708, 182}, {709, 179} }, { {706, 198}, {706, 194}, {707, 196}, {704, 196} } },
    { { {710, 202}, {710, 199}, {712, 212}, {710, 196} }, { {712, 191}, {712, 188}, {714, 199}, {711, 188} }, { {712, 199}, {712, 196}, {712, 204}, {709, 197} } }
  };
  
  private.custom_faces_tags = { 
    {"tag_head_man_young", "tag_head_man_strong", "tag_head_man_fat"}, {"tag_head_woman_young", "tag_head_woman_strong", "tag_head_woman_fat"}
  };
  
  private.custom_bodies = { {"body_man_young_large", "body_man_strong_large", "body_man_fat_large"}, {"body_woman_young_large", "body_woman_strong_large", "body_woman_fat_large"} };
  private.custom_bodies_pos = { 709, 389 };
  --------------------------------------------------------------------------------------------
  -- function win_returning () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_returning" ] = {
    type = "win",
    room = "rm_apartment",
    zz = "mg_returning",
    zz_gate = "gmg_apartment_returning"
  };
  --------------------------------------------------------------------------------------------
  local win_returning_beg = function ()

    if cmn.IsEventDone( "win_returning" ) then
      ObjSet("obj_returning_game",  { alp = 0, input = 0 });
    end;

  end;
  local win_returning_loc = function ()

    if cmn.IsEventDone( "win_returning" ) then
      --ObjDelete("gmg_apartment_returning");
    end;

  end;
  local win_returning_end = function ()

    if cmn.IsEventDone( "win_returning" ) then
      ObjDelete("anm_returning_start_mg");
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_returning", win_returning_beg, "mg_returning" );
  cmn.AddSubscriber( "win_returning", win_returning_loc, "rm_apartment" );
  cmn.AddSubscriber( "win_returning", win_returning_end, "mg_returning" );
  cmn.AddSubscriber( "win_returning_beg", win_returning_beg, "mg_returning" );
  cmn.AddSubscriber( "win_returning_loc", win_returning_loc, "rm_apartment" );
  cmn.AddSubscriber( "win_returning_end", win_returning_end, "mg_returning" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_customizationsex () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_customizationsex" ] = {
    type = "click",
    use_place = "obj_returning_customization_sex_1",
    room = "rm_apartment",
    zz = "mg_returning",
    zz_gate = "gmg_apartment_returning"
  };
  --------------------------------------------------------------------------------------------
  -- function clk_customizationconfirm () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_customizationconfirm" ] = {
    type = "click",
    use_place = "spr_returning_customization_ok",
    room = "rm_apartment",
    zz = "mg_returning",
    zz_gate = "gmg_apartment_returning"
  };
  --------------------------------------------------------------------------------------------
  local clk_customizationconfirm = function ()

    ObjDelete("gmg_apartment_returning");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_customizationconfirm", clk_customizationconfirm, "rm_apartment" );
  
  --------------------------------------------------------------------------------------------
  -- function opn_returning () end;
  --------------------------------------------------------------------------------------------
  local opn_returning = function ()
    
    ObjMultiSet( { {"anm_returning_start_mg", { alp = 1, frame = 400 }},
                   {"obj_returning_game", { alp = 1, input = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_returning", opn_returning, "mg_returning" );
  --------------------------------------------------------------------------------------------
  -- function opn_customization () end;
  --------------------------------------------------------------------------------------------
  local opn_customization = function ()
    
    ObjMultiSet( { {"obj_returning_customization", { alp = 1, input = 1 }},
                   {"anm_returning_show_sex", { frame = 300 }},
                   {"txt_returning_sex_text", { text = StringGet("str_returning_start_sign").." "..StringGet("str_returning_sex") }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_customization", opn_customization, "mg_returning" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if ng_global.currentprogress == "std" and not ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].state then
    private.StartConditions();
    ng_global.customized_character = { 1, 1, 1 };
  elseif ng_global.currentprogress == "secret" then
    private.StartConditions();  
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].state;
  private.active_connections = ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].active_connections;
  private.pairs_con = ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].pairs_con;
  
  private.player_name = GetCurrentProfile();

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_mg_returning_mus", 1);

  if ng_global.currentprogress == "std" and cmn.IsEventDone("opn_returning") and not(cmn.IsEventDone( "win_returning" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_returning");
  elseif not cmn.IsEventDone("opn_returning") then
    private.AnimGameStart();
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level1/audio/env/aud_mg_returning_env");
  cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_mg_returning_env");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_apartment" );
  else 
    
    private.StartConditions();
    
    ng_global.progress[ ng_global.currentprogress ][ "opn_returning" ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "opn_returning" ].start = 0;
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].state;
    private.active_connections = ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].active_connections;
    private.pairs_con = ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].pairs_con;
    
    ObjMultiSet( { {"anm_returning_start_mg", { alp = 1, frame = 0 }},
                   {"obj_returning_game", { alp = 0, input = 0 }} } );
    
    ObjSet("grm_returning_apartment",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                         event_menter = function () rm_extra.GateMouseEnter( "returning_apartment", CURSOR_DOWN, "extra" ); end, 
                                         event_mleave = function () common_impl.GateMouseLeave( "returning_apartment" ); end });
                                     
  end;
    
  private.DrawScene();
  
  if not cmn.IsEventDone("opn_returning") then
    cmn.Lock( 1 );
  end;
  
  if ng_global.currentprogress == "std" and cmn.IsEventDone("win_returning") then
    private.CustomizationDraw();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_returning" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_returning" )) then
    rm_extra.MiniGameHide();
  end;
  
  if ng_global.currentprogress == "secret" then
    ObjSet("grm_returning_apartment",  { input = 0 });
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  local need_r = false;
  local table_r = {};
  
  for i = 1, #private.state[2][ private.state[1] ], 1 do
    
    if private.state[2][ private.state[1] ][i] ~= private.start_state[ private.state[1] ][i] then
      
      if not need_r then
        need_r = true;
      end;
      
      table.insert(table_r, i);
      
      ObjAnimate("spr_returning_block_"..private.state[1].."_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local old_state = private.CheckConnections();
  local old_win = {0, 0, 0, 0, 0, 0};
  
  for i = 1, 6, 1 do
    old_win[i] = private.win_polygons[i];
  end;
  
  for i = 1, #private.win_state[ private.state[1] ], 1 do
    
    if old_win[i] == 1 then
      ObjAnimate("spr_returning_block_"..private.state[1].."_"..i.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
  end;
  
  local func_end = function ()
    
    private.DrawScene();
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_returning_unclick");
    
    for i = 1, #table_r, 1 do
      ObjAnimate("spr_returning_block_"..private.state[1].."_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
    ObjSet("tmr_returning_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;
  
  if need_r then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_returning_click");
    
    for i = 1, #private.win_state[ private.state[1] ], 1 do
      private.state[2][ private.state[1] ][i] = private.start_state[ private.state[1] ][i];
    end;
    
    for i = 1, #private.state[3][ private.state[1] ], 1 do
      for j = 1, #private.state[3][ private.state[1] ][i], 1 do
      
        private.state[3][ private.state[1] ][i][j] = private.start_conns[ private.state[1] ][i][j];
      
      end; 
    end;
    
    private.win_polygons = {0, 0, 0, 0, 0, 0};
    ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].pairs_con = {};
    private.pairs_con = ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].pairs_con;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].active_connections = { 
      { {0, 0, 0}, {0}, {0}, {0} },
      { {0, 0, 0}, {0, 0}, {0, 0}, {0, 0}, {0} },
      { {0, 0, 0, 0}, {0, 0}, {0, 0}, {0, 0}, {0}, {0} }
    };
    private.active_connections = ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].active_connections;
    
    ObjSet("tmr_returning_timer",  { time = 0.3, playing = 1, endtrig = func_end });
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_returning_click");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].state = { 
    3, { {17, 9, 10, 11}, {17, 9, 10, 11, 3}, {9, 8, 15, 17, 3, 11} },
    { { {6, 1, 2}, {1}, {1}, {1} }, { {6, 1, 2}, {1, 2}, {1, 2}, {1, 2}, {1} }, { {6, 1, 2, 3}, {1, 2}, {1, 2}, {1, 2}, {1}, {1} } }
  };
  
  ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].active_connections = { 
    { {1, 1, 1}, {1}, {1}, {1} },
    { {1, 1, 1}, {1, 1}, {1, 1}, {1, 1}, {1} },
    { {1, 1, 1, 1}, {1, 1}, {1, 1}, {1, 1}, {1}, {1} }
  };
  
  local table_r = {};
  local stage = private.state[1];
  
  for i = 1, #private.state[2][ private.state[1] ], 1 do
    
    if private.state[2][ private.state[1] ][i] ~= private.win_state[ private.state[1] ][i]  then
      
      table.insert(table_r, i);
      ObjAnimate("spr_returning_block_"..private.state[1].."_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  for i = private.state[1]+1, 3, 1 do
    ObjAnimate("spr_returning_game_progress_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.6, 0, 1 });
  end;
  
  local old_state = private.CheckConnections();
  local old_win = {0, 0, 0, 0, 0, 0};
  
  for i = 1, 6, 1 do
    old_win[i] = private.win_polygons[i];
  end;
  
  for i = 1, #private.win_state[ private.state[1] ], 1 do
    
    if old_win[i] == 0 then
      ObjAnimate("spr_returning_block_"..private.state[1].."_"..i.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1  });
    end;
    
  end;
  
  local anm_win = function ()
    
    cmn.MiniGameHide();
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_aud_mg_returning_win_comb");
      
    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_returning" );
    
    for i = 1, #private.win_state[ stage ], 1 do
      ObjAnimate("spr_returning_block_"..stage.."_"..i, "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.3, 0, 1.2, 1.2,   0.6, 0, 1, 1,   0.9, 0, 1.2, 1.2 });
      ObjAnimate("spr_returning_block_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.6, 0, 1,   0.9, 0, 0 });
    end;
    
    ObjSet("tmr_returning_timer",  { time = 1.2, playing = 1, endtrig = private.Win });
    
  end;
  
  local func_end = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_returning_unclick");
    
    for i = 1, #private.win_state[ stage ], 1 do
      private.state[2][ stage ][i] = private.win_state[ stage ][i];
    end;
    
    private.DrawScene( true );
    
    for i = 1, #table_r, 1 do
      ObjAnimate("spr_returning_block_"..stage.."_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
    ObjSet("tmr_returning_timer",  { time = 0.3, playing = 1, endtrig = anm_win });
    
  end;
  
  ObjSet("tmr_returning_timer",  { time = 0.3, playing = 1, endtrig = func_end });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].state = { 
    1, { { 15, 22, 5, 19 }, { 8, 20, 10, 18, 12 }, { 15, 22, 2, 4, 13, 11 } },
    { { {6, 1, 2}, {1}, {1}, {1} }, { {6, 1, 2}, {1, 2}, {1, 2}, {1, 2}, {1} }, { {6, 1, 2, 3}, {1, 2}, {1, 2}, {1, 2}, {1}, {1} } }
  }; --[1] - stage, [2] - position of polygons, [3] - state of connections
  
  ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].active_connections = { 
    { {0, 0, 0}, {0}, {0}, {0} },
    { {0, 0, 0}, {0, 0}, {0, 0}, {0, 0}, {0} },
    { {0, 0, 0, 0}, {0, 0}, {0, 0}, {0, 0}, {0}, {0} }
  };
  
  ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].pairs_con = {};

end;
-----------------------------------------------------------------------------------
function private.AnimGameStart()
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    
    cmn.CallEventHandler("opn_returning");
    
    if ng_global.currentprogress == "std" then
      
      cmn.MiniGameShow();
      cmn.StartTimePassing("mg_returning");
      
      cmn.ShowBbt( "returning_activation" );
      
    else 
      rm_extra.MiniGameShow();
    end;
    
  end;
  
  local anm_game = function ()
    
    ObjAnimate("obj_returning_game", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    
  end;
  
  cmn.SetEventDone("opn_returning");
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_first_appear_mg_returning");
  
  ObjSet("anm_returning_start_mg",  { alp = 1, playing = 1, endtrig = anm_game });

end;
-----------------------------------------------------------------------------------
function private.DrawScene( flag )
  
  flag = flag or false;
  
  local old = private.CheckConnections();
  
  if not flag then
    
    for i = 1, 3, 1 do
      
      if i ~= private.state[1] then
        ObjSet("obj_returning_stage_"..i,  { alp = 0, input = 0 });
      else 
        ObjSet("obj_returning_stage_"..i,  { alp = 1, input = 1 });
      end;
      
    end;
    
  end;
  
  for i = 1, private.state[1], 1 do
    ObjSet("spr_returning_game_progress_"..i,  { alp = 1 });
  end;
  
  for i = private.state[1]+1, 3, 1 do
    ObjSet("spr_returning_game_progress_"..i,  { alp = 0 });
  end;
  
  for i = 1, #private.state[2][ private.state[1] ], 1 do
    
    ObjSet("spr_returning_block_"..private.state[1].."_"..i,  { 
      pos_x = private.polygon_pos[ private.state[2][ private.state[1] ][i] ][1], 
      pos_y = private.polygon_pos[ private.state[2][ private.state[1] ][i] ][2],
      alp = 1,
      scale_x = 1,
      scale_y = 1
    });
    
    --if not flag then
      
      if private.win_polygons[i] == 1 then
        ObjSet("spr_returning_block_"..private.state[1].."_"..i.."_win",  { alp = 1 });
      else 
        ObjSet("spr_returning_block_"..private.state[1].."_"..i.."_win",  { alp = 0 });
      end;
      
    --end;
    
  end;
  
  for i = 1, #private.state[3][ private.state[1] ], 1 do
    for j = 1, #private.state[3][ private.state[1] ][i], 1 do
      
      --if private.state[3][ private.state[1] ][i][j] > 0 then
        
        ObjSet("spr_returning_block_"..private.state[1].."_"..i.."_connect_"..j,  { 
          pos_x = private.connect_pos[ private.state[3][ private.state[1] ][i][j] ][1], 
          pos_y = private.connect_pos[ private.state[3][ private.state[1] ][i][j] ][2],
          ang = private.connect_pos[ private.state[3][ private.state[1] ][i][j] ][3],
          alp = 1
        });
        
      --else 
      --  
      --  ObjSet("spr_returning_block_"..private.state[1].."_"..i.."_connect_"..j,  { alp = 0 });
      --  
      --end;
      
    end;
  end;

end;
-----------------------------------------------------------------------------------
function public.FocusBlock( num, inout )
  
  local stage = private.state[1];
  local obj = "spr_returning_block_"..stage.."_"..num;
  local scale = ObjGet( obj ).scale_x;
  local tme = 0;
  local max_scale = 1.05;  
  local max_tme = 0.3;
  local end_scale = 1;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );
  else 
    SetCursor(CURSOR_GET);
    end_scale = max_scale;
    tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
  end;

  ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale });
  
end;
-----------------------------------------------------------------------------------
function public.ChooseBlock( num )
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_returning_click");
  
  local stage = private.state[1];
  ObjAttach("spr_returning_block_"..stage.."_"..num, "obj_returning_game_fly");
  
end;
-----------------------------------------------------------------------------------
function public.DropBlock( num )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_returning_unclick");
  
  local old_state = private.CheckConnections();
  local old_win = {0, 0, 0, 0, 0, 0};
  
  for i = 1, 6, 1 do
    old_win[i] = private.win_polygons[i];
  end;
  
  local place = 0;
  local stage = private.state[1];
  
  local pos = GetZoomCursorPos();
  if  tostring(GetPlatform()) == "android" then
    pos[2] = pos[2] - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      pos[2] = pos[2] - 75;
    else
      pos[2] = pos[2] - 50;
    end;
  end;
    
  local px = pos[1];
  local py = pos[2];

  for i = 1, #private.polygon_pos, 1 do
    
    if private.CheckHit(px, py, i) then
      place = i;
      break;
    end;
    
  end;
  
  local check_vac = true;
  
  if place > 0 and place ~= private.state[2][ stage ][num] then
    check_vac = private.CheckVacancy( place );
  end;
  
  --place not possible
  if place == 0 or not check_vac then
    
    place = private.state[2][ stage ][num];
    
  else 
    
    for i = 1, #private.state[3][ stage ][num], 1 do
      
      private.active_connections[ stage ][num][i] = 0;
      
      if private.state[3][ stage ][num][i] == 0 then
        private.state[3][ stage ][num][i] = private.FindNewCon( stage, num, i );
      end;
      
    end;
    
    private.CleanTable( 1, stage, num );
    
    private.state[2][ stage ][num] = place;
    
  end;
  
  local point_a, point_b = {}, {};
  point_a[1] = px;
  point_a[2] = py;
  point_b[1] = private.polygon_pos[ place ][1];
  point_b[2] = private.polygon_pos[ place ][2];
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.001 * len;
  
  if tme < 0.1 then
    tme = 0.1;
  elseif tme > 0.4 then
    tme = 0.4;
  end;
  
  local func_after = function () ObjAttach("spr_returning_block_"..stage.."_"..num,  "obj_returning_stage_"..stage); private.AnimNewState(old_win); end;
    
  ObjAnimate("spr_returning_block_"..stage.."_"..num, "pos_xy", 0, 0, func_after, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
  
end;
-----------------------------------------------------------------------------------
function private.FindNewCon( stage, num, c )
  
  local new = 0;
  
  local find = function ( ind )
    
    local found = false;
  
    for i = 1, #private.state[3][ stage ][num], 1 do
      
      if private.state[3][ stage ][num][i] == ind then
        found = true;
        break;
      end;
      
    end;
    
    return found;
    
  end;
  
  for i = 1, 6, 1 do
    
    if not find(i) then
      new = i;
      break;
    end;
    
  end;
  
  return new;
  
end;
-----------------------------------------------------------------------------------
function private.CheckConnections()
  
  private.win_polygons = {0, 0, 0, 0, 0, 0};
  
  local active_connections = private.active_connections[ private.state[1] ];
  local old_connections = {};
  --local pairs_con = private.pairs_con;
  local neighbour, n_p, connection;
  
  for i = 1, #private.state[3][ private.state[1] ], 1 do
    --table.insert( active_connections, {} );
    table.insert( old_connections, {} );
    for j = 1, #private.state[3][ private.state[1] ][i], 1 do
      --active_connections[i][j] = 0;
      --private.state[3][ private.state[1] ][i][j] = private.start_conns[ private.state[1] ][i][j];
      old_connections[i][j] = private.state[3][ private.state[1] ][i][j];
    end;
  end;
  
  local find_first_con = function ( polygon, con )
    
    local first_con = 0;
    
    for i = 1, #private.state[3][ private.state[1] ][polygon], 1 do
      
      if private.state[3][ private.state[1] ][polygon][i] == con then
        first_con = i;
        break;
      end;
      
    end;
    
    if first_con == 0 or active_connections[polygon][first_con] == 1 then
    
      for i = 1, #private.state[3][ private.state[1] ][polygon], 1 do
        
        if active_connections[polygon][i] == 0 then
          first_con = i;
          break;
        end;
        
      end;
      
    end;
    
    return first_con;
    
  end;
  
  local check_pair = function ( pol1, pol2 )
    
    local check = false;
    
    for i = 1, #private.pairs_con, 1 do
      
      if ( private.pairs_con[i][1] == pol1 and private.pairs_con[i][2] == pol2 ) or ( private.pairs_con[i][1] == pol2 and private.pairs_con[i][2] == pol1 ) then
        check = true;
        break;
      end;
      
    end;
    
    return check;
    
  end;
  
  for i = 1, #private.state[3][ private.state[1] ], 1 do
    
    for j = 1, 6, 1 do
      
      neighbour = private.polygons_around[ private.state[2][ private.state[1] ][i] ][j];
      
      if neighbour > 0 then
        
        n_p = private.CheckPolygonBusy( neighbour );
        if n_p > 0 and not check_pair(i, n_p) then
          
          --DbgTrace(neighbour.." "..n_p)
          
          local new_j = j+3;
          if j > 3 then
            new_j = j-3;
          end;
          
          connection = {0, 0};
          connection[1] = find_first_con(i, j);
          connection[2] = find_first_con(n_p, new_j);
          
          if connection[1] > 0 and connection[2] > 0 then
            
            table.insert( private.pairs_con, {} );
            private.pairs_con[#private.pairs_con][1] = i;
            private.pairs_con[#private.pairs_con][2] = n_p;
            private.pairs_con[#private.pairs_con][3] = connection[1];
            private.pairs_con[#private.pairs_con][4] = connection[2];
            
            --DbgTrace(private.pairs_con[#private.pairs_con][1].." "..private.pairs_con[#private.pairs_con][2].." "..private.pairs_con[#private.pairs_con][3].." "..private.pairs_con[#private.pairs_con][4])
            
            active_connections[i][ connection[1] ] = 1;
            active_connections[n_p][ connection[2] ] = 1;
            
            private.state[3][ private.state[1] ][i][ connection[1] ] = j;
            --private.state[3][ private.state[1] ][n_p][ connection[2] ] = 0;
            private.state[3][ private.state[1] ][n_p][ connection[2] ] = new_j;
            
          end;
          
        end;
        
      end;
      
    end;
    
  end;
  
  local sum = 0;
  
  for i = 1, #active_connections, 1 do
    
    sum = 0;
    
    for j = 1, #active_connections[i], 1 do
      sum = sum + active_connections[i][j];
    end;
    
    if sum == #active_connections[i] then
      private.win_polygons[i] = 1;
    end;
    
  end;
  
  return old_connections;
  
end;
-----------------------------------------------------------------------------------
function private.AnimNewState( old_win )
  
  --local old_state = private.CheckConnections();
  local need_tme = false;

  --for i = 1, #old_state, 1 do
  --  for j = 1, #old_state[i], 1 do
  --    
  --    if old_state[i][j] ~= private.state[3][ private.state[1] ][i][j] then
  --      
  --      
  --      
  --    end;
  --    
  --  end;
  --end;

  private.DrawScene( true );
  
  --for i = 1, #private.pairs_con, 1 do
  --    
  --  DbgTrace(private.pairs_con[i][1].." "..private.pairs_con[i][2]);
  --  
  --end;
  
  for i = 1, #private.win_state[ private.state[1] ], 1 do
    
    if old_win[i] ~= private.win_polygons[i] then
      
      need_tme = true;
      
      if old_win[i] == 1 then
        ObjAnimate("spr_returning_block_"..private.state[1].."_"..i.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      else 
        ObjAnimate("spr_returning_block_"..private.state[1].."_"..i.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      end;
      
    end;
    
  end;
  
  if need_tme then
    ObjSet("tmr_returning_timer",  { time = 0.3, playing = 1, endtrig = function() private.CheckWin( true ); end });
  else 
    private.CheckWin( true );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.CheckHit( px, py, num )
  
  local centr = {0, 0}; 
  local accuracy = 50;

  centr[1] = private.polygon_pos[num][1];
  centr[2] = private.polygon_pos[num][2];

  if ( (px - centr[1])^2 + (py - centr[2])^2 ) <= accuracy^2 then 

    return true;

  else

    return false;

  end; 
  
end;
-----------------------------------------------------------------------------------
function private.CheckPolygonBusy( place )
  
  local poly = 0;
  
  for i = 1, #private.state[2][ private.state[1] ], 1 do
    
    if private.state[2][ private.state[1] ][i] == place then
      --DbgTrace(i.." "..place);
      poly = i;
      break;
    end;
    
  end;
  
  return poly;
  
end;
-----------------------------------------------------------------------------------
function private.CleanTable( ind, stage, num )
  
  local i = ind;
  
  if ind <= #private.pairs_con then
  
    if private.pairs_con[i][1] == num then
      
      local n_p = private.pairs_con[i][2];
      local con2 = private.pairs_con[i][4];
      
      --DbgTrace(n_p.." "..con2);
      
      table.remove(private.pairs_con, i);
      
      private.active_connections[ stage ][n_p][ con2 ] = 0;
      
      if private.state[3][ stage ][n_p][con2] == 0 then
        --DbgTrace("new "..private.FindNewCon( stage, n_p, con2 ))
        private.state[3][ stage ][n_p][con2] = private.FindNewCon( stage, n_p, con2 );
      end;
      
    elseif private.pairs_con[i][2] == num then
      
      local n_p = private.pairs_con[i][1];
      local con2 = private.pairs_con[i][3];
      
      --DbgTrace(n_p.." "..con2);
      
      table.remove(private.pairs_con, i);
      
      private.active_connections[ stage ][n_p][ con2 ] = 0;
      
      if private.state[3][ stage ][n_p][con2] == 0 then
        --DbgTrace("new "..private.FindNewCon( stage, n_p, con2 ))
        private.state[3][ stage ][n_p][con2] = private.FindNewCon( stage, n_p, con2 );
      end;
      
    else 
      ind = ind + 1;
    end;
    
    private.CleanTable( ind, stage, num );
    
  end;
    
end;
-----------------------------------------------------------------------------------
function private.CheckVacancy( place )
  
  local check = true;
  
  for i = 1, #private.state[2][ private.state[1] ], 1 do
    
    if private.state[2][ private.state[1] ][i] == place then
      check = false;
      break;
    end;
    
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin( ingame )
  
  ingame = ingame or false;
  
  local win_flag = true;
  
  for i = 1, #private.win_state[ private.state[1] ], 1 do
    
    if private.win_polygons[i] == 0 then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_aud_mg_returning_win_comb");
    
    --win
    if private.state[1] == 3 then
      
      cmn.Lock( 1 );
      
      local stage = private.state[1];
      
      if ng_global.currentprogress == "std" then

        cmn.MiniGameHide();
        common_impl.PauseAchiev( 1 );
        cmn.EndTimePassing( "mg_returning" );
        
      else 
        
        rm_extra.MiniGameHide();
        int_dialog_secretroom.StopTimer();
        
      end;
      
      for i = 1, #private.win_state[ stage ], 1 do
        ObjAnimate("spr_returning_block_"..stage.."_"..i, "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.3, 0, 1.2, 1.2,   0.6, 0, 1, 1,   0.9, 0, 1.2, 1.2 });
        ObjAnimate("spr_returning_block_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.6, 0, 1,   0.9, 0, 0 });
      end;
      
      ObjSet("tmr_returning_timer",  { time = 1.2, playing = 1, endtrig = private.Win });
    
    --change stage  
    elseif ingame then
    
      local stage = private.state[1];
      private.state[1] = private.state[1] + 1;
      
      private.win_polygons = {0, 0, 0, 0, 0, 0};
      ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].pairs_con = {};
      private.pairs_con = ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].pairs_con;
      
      private.DrawScene( true );
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        
        ObjMultiSet( { {"obj_returning_stage_"..stage, { alp = 0, input = 0 }},
                       {"obj_returning_stage_"..private.state[1], { alp = 1, input = 1 }} } );
        
      end;
      
      for i = 1, #private.win_state[ stage ], 1 do
        ObjAnimate("spr_returning_block_"..stage.."_"..i, "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.3, 0, 1.2, 1.2,   0.6, 0, 1, 1,   0.9, 0, 1.2, 1.2 });
        ObjAnimate("spr_returning_block_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.6, 0, 1,   0.9, 0, 0 });
      end;
      
      ObjAnimate("spr_returning_game_progress_"..private.state[1], "alp", 0, 0, "", { 0, 0, 0,   0.9, 0, 0,     1.4, 0, 1 });
      ObjAnimate("obj_returning_stage_"..private.state[1], "alp", 0, 0, func_after, { 0, 0, 0,   0.9, 0, 0,     1.4, 0, 1 });
      
    end;
    
  else 
    cmn.Lock( 0 );
  end;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()
  
  cmn.SetEventDone( "win_returning" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_returning_beg" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_returning" ].skip == 0 and not ng_global.noskipgames[ "win_returning" ] then

      ng_global.noskipgames[ "win_returning" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_returning" ] then
      ng_global.playedgames[ "win_returning" ] = 1;
    end;

    private.CustomizationDraw();
    
  else 
    
    cmn.Lock(0);
    ObjSet("grm_returning_apartment",  { input = 0 });
    interface_impl.ShowStarsWindow();
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.Win()

  private.WinEnd();

end;
--*********************************************************************************************************************
-- function *** CUSTOMIZATION *** () end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------
function private.CustomizationDraw()
  
  if cmn.IsEventDone("opn_customization") then
    ObjSet( "txt_returning_user_name", { text = private.player_name } );
  else 
    private.OpenCustomization();
  end;
  
  ObjSet("anm_returning_current_body", { animfunc = private.custom_functions[ ng_global.customized_character[1] ][ ng_global.customized_character[2] ] });
  
  if cmn.IsEventDone("clk_customizationsex") then
    
    local sex = "male";
    if ng_global.customized_character[1] == 2 then
      sex = "female";
    end;
    
    private.SetCharacter();
    
    ObjMultiSet( { {"obj_returning_customization_game_2", { input = 1 }},
                   {"anm_returning_show_body_"..sex, { frame = 300 }},
                   {"anm_returning_show_face_"..sex, { frame = 300 }},
                   {"anm_returning_current_body", { frame = 0, alp = 0 }},
                   {"obj_returning_customization_character", { alp = 1 }},
                   {"spr_returning_chosen_sex", { alp = 1, pos_x = private.custom_choose_pos[1][ ng_global.customized_character[1] ] }},
                   {"spr_returning_chosen_body", { alp = 1, pos_x = private.custom_choose_pos[2][ ng_global.customized_character[2] ] }},
                   {"spr_returning_chosen_face", { alp = 1, pos_x = private.custom_choose_pos[3][ ng_global.customized_character[3] ] }},
                   {"spr_returning_chosen_last", { alp = 1 }},
                   {"spr_returning_customization_ok", { alp = 1, input = 1 }},
                   {"txt_returning_body_text", { text = StringGet("str_returning_start_sign").." "..StringGet("str_returning_body") }},
                   {"txt_returning_face_text", { text = StringGet("str_returning_start_sign").." "..StringGet("str_returning_face") }} } );
                   
  else 
    ObjSet("anm_returning_current_body", { frame = 0, alp = 0 });
  end;
                 
end;
-----------------------------------------------------------------------------------
function private.SetAnimCharacter()
  
  ObjSet("anm_returning_current_body",  { animfunc = private.custom_functions[ ng_global.customized_character[1] ][ ng_global.customized_character[2] ] });
  
  for i = 1, 4, 1 do
    
    ObjSet("spr_returning_head_"..i,  { 
      res = "assets/levels/level1/mg_returning/mg_customization/"..private.custom_faces[ ng_global.customized_character[1] ][ ng_global.customized_character[2] ].."_"..i,
      anim_tag = private.custom_faces_tags[ ng_global.customized_character[1] ][ ng_global.customized_character[2] ].."_"..i
    });
    
  end;
  
  for i = 1, 4, 1 do
    
    ObjAttach("spr_returning_head_"..i, "anm_returning_current_body");
      
    if i == ng_global.customized_character[3] then
      ObjSet("spr_returning_head_"..i,  { alp = 1 });
    else 
      ObjSet("spr_returning_head_"..i,  { alp = 0 });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.ResetAnimCharacter()
  
  for i = 1, 4, 1 do
    
    ObjAttach("spr_returning_head_"..i, "obj_returning_heads_pull");
      
  end;
  
end;
-----------------------------------------------------------------------------------
function private.SetCharacter()
  
  ObjMultiSet( { 
    {"spr_returning_character_body", 
      { res = "assets/levels/level1/mg_returning/mg_customization/"..private.custom_bodies[ ng_global.customized_character[1] ][ ng_global.customized_character[2] ],
        pos_x = private.custom_bodies_pos[1],
        pos_y = private.custom_bodies_pos[2]
      }},
    {"spr_returning_character_head", 
      { res = "assets/levels/level1/mg_returning/mg_customization/"..private.custom_faces[ ng_global.customized_character[1] ][ ng_global.customized_character[2] ].."_"..ng_global.customized_character[3],
        pos_x = private.custom_faces_pos[ ng_global.customized_character[1] ][ ng_global.customized_character[2] ][ ng_global.customized_character[3] ][1],
        pos_y = private.custom_faces_pos[ ng_global.customized_character[1] ][ ng_global.customized_character[2] ][ ng_global.customized_character[3] ][2]
      }} } );
  
end;
-----------------------------------------------------------------------------------
function private.OpenCustomization()
  
  local text = {"", ""};
  text[1] = private.player_name;
  text[2] = StringGet("str_returning_start_sign").." "..StringGet("str_returning_sex");
  local len = {0, 0};
  len[1] = utf8.len(text[1]);
  len[2] = utf8.len(text[2]);
  local name = {"", ""};
  name[1] = "txt_returning_user_name";
  name[2] = "txt_returning_sex_text";
  
  function private.AnmText( typ, cur )

    if (cur <= len[typ]) then

      ObjMultiSet( { {name[typ], { text = ne.utf8.Sub(text[typ], 1, cur) }},
                     {"tmr_returning_customization_timer", { time = 0.03, playing = 1, endtrig = function () private.AnmText( typ, cur+1 ) end }} } );
    end;

  end;
                   
  function private.AnimTextStart( typ )
    
    ObjSet(name[typ],  { text = StringGet("str_returning_start_sign"), alp = 0 });
    ObjAnimate(name[typ], "alp", 0, 0, function() private.AnmText( typ, 2 ); end, { 0, 0, 0,   0.3, 0, 1,    0.6, 0, 0,    0.9, 0, 1 });
    
  end;                 
  
  local anm_sex = function ()
    
    local func_end = function ()
      
      cmn.Lock( 0 );
      common_impl.PauseAchiev( 0 );
      cmn.CallEventHandler("opn_customization");
      cmn.CallEventHandler( "win_returning_end" );
      
    end;
    
    local anm_pics = function ()
      
      ObjSet("anm_returning_show_sex",  { alp = 1, playing = 1, endtrig = func_end });
      
    end;
    
    private.AnimTextStart( 2 );
    ObjSet("tmr_returning_timer",  { time = 0.9+0.03*len[2], playing = 1, endtrig = anm_pics });
    
  end;
  
  cmn.Lock( 1 );
  
  cmn.SetEventDone("opn_customization");
  
  ObjSet("tmr_returning_timer",  { time = 1.4+0.03*len[1], playing = 1, endtrig = anm_sex });
  
  ObjAnimate("obj_returning_customization", "alp", 0, 0, function() private.AnimTextStart( 1 ); cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_write_cheater"); end, { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function public.FocusCustom( typ, num, inout )
  
  local obj = "spr_returning_customization_"..typ;
  
  if typ ~= "ok" then
    obj = obj.."_"..num.."_focus";
  else 
    obj = obj.."_focus";
  end;
  
  if typ == "body" then
    obj = obj.."_"..ng_global.customized_character[1];
  end;
  
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function private.ContinueCustomization()
  
  local sex = "male";
  if ng_global.customized_character[1] == 2 then
    sex = "female";
  end;
  
  local text = {"", ""};
  text[1] = StringGet("str_returning_start_sign").." "..StringGet("str_returning_body");
  text[2] = StringGet("str_returning_start_sign").." "..StringGet("str_returning_face");
  local len = {0, 0};
  len[1] = utf8.len(text[1]);
  len[2] = utf8.len(text[2]);
  local name = {"", ""};
  name[1] = "txt_returning_body_text";
  name[2] = "txt_returning_face_text";
  
  function private.AnmText( typ, cur )

    if (cur <= len[typ]) then

      ObjMultiSet( { {name[typ], { text = ne.utf8.Sub(text[typ], 1, cur) }},
                     {"tmr_returning_customization_timer", { time = 0.03, playing = 1, endtrig = function () private.AnmText( typ, cur+1 ) end }} } );
    end;

  end;
                   
  function private.AnimTextStart( typ )
    
    ObjSet(name[typ],  { text = StringGet("str_returning_start_sign"), alp = 0 });
    ObjAnimate(name[typ], "alp", 0, 0, function() private.AnmText( typ, 2 ); end, { 0, 0, 0,   0.3, 0, 1,    0.6, 0, 0,    0.9, 0, 1 });
    
  end;                 
  
  local anm_face = function ()
    
    local func_end = function ()
      
      cmn.Lock( 0 );
      private.ResetAnimCharacter();
      ObjMultiSet( { {"obj_returning_customization_game_2", { input = 1 }},
                     {"spr_returning_customization_ok", { input = 1 }},
                     {"obj_returning_customization_character", { alp = 1 }},
                     {"anm_returning_current_body", { alp = 0, frame = 0, endtrig = "", animfunc = "" }},
                     {"anm_returning_show_body_male", { endtrig = "" }},
                     {"anm_returning_show_body_female", { endtrig = "" }},
                     {"anm_returning_show_face_male", { endtrig = "" }},
                     {"anm_returning_show_face_female", { endtrig = "" }} } );
      
    end;
                   
    local anm_avatar = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_character_appears");
      
      private.SetAnimCharacter();
      private.SetCharacter();
      
      ObjSet("anm_returning_current_body",  { playing = 1, endtrig = func_end });
      ObjAnimate("anm_returning_current_body", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_returning_chosen_last", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_returning_customization_ok", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    local anm_pics = function ()
      
      ObjSet("anm_returning_show_face_"..sex,  { alp = 1, playing = 1, endtrig = anm_avatar });
      ObjAnimate("spr_returning_chosen_face", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    private.AnimTextStart( 2 );
    ObjSet("tmr_returning_timer",  { time = 0.9+0.03*len[2], playing = 1, endtrig = anm_pics });
    
  end;
  
  local anm_pics_1 = function ()
      
    ObjSet("anm_returning_show_body_"..sex,  { alp = 1, playing = 1, endtrig = anm_face });
    ObjAnimate("spr_returning_chosen_body", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_write_body");
  
  private.AnimTextStart( 1 );
  ObjSet("tmr_returning_timer",  { time = 0.9+0.03*len[1], playing = 1, endtrig = anm_pics_1 });
  
end;
-----------------------------------------------------------------------------------
function public.ChooseCustom( typ, num )
  
  if typ == "sex" then
    
    if not cmn.IsEventDone("clk_customizationsex") then
      
      cmn.Lock( 1 );
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_returning_click");
      cmn.SetEventDone("clk_customizationsex");
      
      ng_global.customized_character[1] = num;
      
      ObjSet("spr_returning_chosen_sex",  { pos_x = private.custom_choose_pos[1][ ng_global.customized_character[1] ] });
      ObjAnimate("spr_returning_chosen_sex", "alp", 0, 0, private.ContinueCustomization, { 0, 0, 0,   0.3, 0, 1 });
      
    elseif ng_global.customized_character[1] ~= num then
      
      local old = ng_global.customized_character[1];
      ng_global.customized_character[1] = num;
      
      cmn.Lock( 1 );
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_returning_click");
      
      local sex = "male";
      local old_sex = "female";
      if ng_global.customized_character[1] == 2 then
        sex = "female";
        old_sex = "male";
      end;
      
      local func_end = function ()
      
        cmn.Lock( 0 );
        private.ResetAnimCharacter();
        private.SetCharacter();
        ObjMultiSet( { {"obj_returning_customization_character", { alp = 1 }},
                       {"anm_returning_current_body", { alp = 0, frame = 0 }} } );
        
      end;
      
      local change_chosen = function ()
      
        ObjSet("spr_returning_chosen_sex",  { pos_x = private.custom_choose_pos[1][ ng_global.customized_character[1] ] });
        ObjAnimate("spr_returning_chosen_sex", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });
        
      end;
    
      ObjAnimate("spr_returning_chosen_sex", "alp", 0, 0, change_chosen, { 0, 0, 1,   0.15, 0, 0 });
      
      local anm_new_sex = function ()
        
        private.SetAnimCharacter();
        
        cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_character_appears");
        
        ObjMultiSet( { {"anm_returning_current_body",  { frame = 0, playing = 1, endtrig = func_end }},
                       {"anm_returning_show_body_"..sex, { alp = 1, playing = 1, endtrig = "" }},
                       {"anm_returning_show_face_"..sex, { alp = 1, playing = 1, endtrig = "" }} } );
        
        ObjAnimate("anm_returning_current_body", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        
      end;
      
      ObjAnimate("obj_returning_customization_character", "alp", 0, 0, anm_new_sex, { 0, 0, 1,   0.3, 0, 0 });
      
      ObjAnimate("anm_returning_show_body_"..old_sex, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("anm_returning_show_face_"..old_sex, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  elseif typ == "body" and ng_global.customized_character[2] ~= num then
    
    local old = ng_global.customized_character[2];
    ng_global.customized_character[2] = num;
    
    local func_end = function ()
      
      cmn.Lock( 0 );
      private.ResetAnimCharacter();
      private.SetCharacter();
      ObjMultiSet( { {"obj_returning_customization_character", { alp = 1 }},
                     {"anm_returning_current_body", { alp = 0, frame = 0 }} } );
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_returning_click");
    
    local change_chosen = function ()
      
      ObjSet("spr_returning_chosen_body",  { pos_x = private.custom_choose_pos[2][ ng_global.customized_character[2] ] });
      
      ObjAnimate("spr_returning_chosen_body", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });
      
    end;
    
    ObjAnimate("spr_returning_chosen_body", "alp", 0, 0, change_chosen, { 0, 0, 1,   0.15, 0, 0 });
    
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_character_appears");
    
    private.SetAnimCharacter();
    ObjSet("anm_returning_current_body",  { frame = 0, playing = 1, endtrig = func_end });
    ObjAnimate("anm_returning_current_body", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("obj_returning_customization_character", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
  elseif typ == "face" and ng_global.customized_character[3] ~= num then
    
    local old = ng_global.customized_character[3];
    ng_global.customized_character[3] = num;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_returning_click");
    
    local change_chosen = function ()
      
      private.SetCharacter();
      
      ObjSet("spr_returning_chosen_face",  { pos_x = private.custom_choose_pos[3][ ng_global.customized_character[3] ] });
      
      ObjAnimate("spr_returning_chosen_face", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 0,   0.15, 0, 1 });
      ObjAnimate("spr_returning_character_head", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });
      
    end;
    
    ObjAnimate("spr_returning_chosen_face", "alp", 0, 0, change_chosen, { 0, 0, 1,   0.15, 0, 0 });
    ObjAnimate("spr_returning_character_head", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.ConfirmChanges()
  
  local func_move = function ()
    
    cmn.SetEventDone("clk_customizationconfirm");
    cmn.CallEventHandler("clk_customizationconfirm");
    
    ObjSet("mg_returning",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_outsidechapel");
    
  end;
  
  local func_end = function ()
    
    cmn.Lock( 0 );
    cmn.PlayFullscreenVideo( "assets/levels/level1/mg_returning/vid_loading", func_move, "assets/levels/level1/audio/mus/aud_apartment_loading_vid", "");
    
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mg_returning_click_play");
  
  ObjAnimate("spr_returning_customization_ok_down", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("obj_returning_customization", "alp", 0, 0, func_end, { 0, 0, 1,   1, 0, 1,    1.5, 0, 0 });
  
end;
--************************************************************************************************************