-- name=level1

function public.Start ( param )

  game.play_hint_aud = false;

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 10 );
  interface.WidgetAdd( InterfaceWidget_BtnGuide, 6 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 5 );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 5 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 6 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 7 );

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 0 );

  interface.WidgetAdd( InterfaceWidget_TaskHeader, 1 );
  interface.WidgetAdd( InterfaceWidget_Inventory, 2 );
  --interface.WidgetAdd( InterfaceWidget_TaskPanel );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 3, "assets/interface/int_taskpanel");

  interface.WidgetAdd( InterfaceWidget_Effects, 50 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 4 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 260 );

  interface.ButtonLockAdd();

  interface.WidgetAdd( InterfaceWidget_ItemPanel, 3, "assets/interface/int_itempanel" );
  interface.WidgetAdd( InterfaceWidget_Popup, 250 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 300 );
  --interface.WidgetAdd( InterfaceWidget_DialogStory );
  --interface.WidgetAdd( InterfaceWidget_DialogCharacter, 900 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial, 310 );

  interface.WidgetAdd( InterfaceWidget_Map, 200 );

  interface.PanelNotificationAdd();
  interface.ComplexInvAdd();
  interface_impl.DialogHintAdd();
  
  interface_impl.GlobalTaskAdd();
  
  interface_impl.DiaryAdd();
  
  ------------------------------------------------------
  if IsCollectorsEdition() or IsSurveyEdition() then
    
    if IsCollectorsEdition() then
  
      ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
      rm_achievements.Init();
    
      ModLoad( "assets/levels/menu/rm_collectable/mod_collectable" );
      rm_collectable.Init();
      
      ModLoad( "assets/levels/menu/rm_secretroom/mod_secretroom" );
      rm_secretroom.Init();
      
      interface_impl.PopupAchievementAdd();
      
    end;

    interface_impl.AchievAdd();
    
    interface_impl.BonusAdd();
  
  end;
  ------------------------------------------------------
  if IsCollectorsEdition() then
  
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  
  end;
  ------------------------------------------------------
  
  --переменная для того, чтобы из титров не выкидывало в меню
  public.in_progress = true;
  --
  private.Init();
  --
  int_map_impl.CreateRooms( "level1" );

  ModLoad( "assets/levels/level1/mod_inventory1" );
  inventory1.Init();
  
  ModLoad( "assets/levels/level1/rm_demoscreen/mod_demoscreen" );
  rm_demoscreen.Init();
  
  ModLoad( "assets/levels/menu/rm_credits/mod_credits" );
  rm_credits.Init();

  common.LevelLoad( "level1", "std", "rm_apartment", param );
  ng_global.progress[ "std" ].common.gamestart = true;
  
  common_impl.AddAvailibleMusic( 6 );
  common_impl.PlayBackgroundMusic();
  
  common_impl.StartCountGameTime(1);

  common_impl.DialogCustomUpdate();
  interface_impl.RemoveFlowersTotal();
  cmn.RemoveCollectable();
  
  int_button_diary.DiaryCheckNewMessage();

  game.play_hint_aud = true;

  common_impl.is_in_map = 0;

end;
    
function private.Init ()

  game.room_names =
  {
     "rm_apartment"
    ,"rm_outsidechapel"
    ,"rm_cemetery"
    ,"rm_chapel"
    ,"rm_worldoffire"
    ,"rm_worldofdarkness"
    ,"ho_balcony"
    ,"ho_crypt"
    ,"ho_toys"
    ,"mg_returning"
    ,"mg_cobweb"
    ,"mg_mind"
  };
  
  --имена диалогов с подбором предмета (для удаления gfx в кастом моде)
  game.dlg_witems_names =
  {
    "obj_outsidechapel_dialog_stephen1",
    "obj_cemetery_dialog_naya1",
    "obj_chapel_dialog_blackqueen0",
    "obj_worldoffire_dialog_stephen2",
    "obj_worldofdarkness_dialog_naya3"
  };

-- 1 - открыта
-- 2 - таски выполнены
-- 3 - кол-во тасков
-- 4 блокирована
  game.map_rooms = {
    
    [ "rm_apartment" ]       =  { 0, 0, 99, 0, 3 },
    [ "rm_outsidechapel" ]   =  { 0, 0, 3, 0, 2 },
    [ "rm_cemetery" ]        =  { 0, 0, 1, 0, 2 },
    [ "rm_chapel" ]          =  { 0, 0, 99, 0, 4 },
    [ "rm_worldoffire" ]     =  { 0, 0, 99, 0, 3 },
    [ "rm_worldofdarkness" ] =  { 0, 0, 1, 0, 3 }
  
  };
  
  --таблица с координатами открытия зз
  game.zz_end_pos = {
  
    [ "zz_safe" ] = {380, 340},
    [ "zz_computer" ] = {570, 360},
    [ "zz_lvl1desk" ] = {340, 370},
    [ "zz_nightstand" ] = {620, 350},
    
    [ "zz_ivy" ] = {340, 370},
    [ "zz_forge" ] = {620, 350},
    [ "zz_gargoyle" ] = {580, 350},
    [ "zz_gallows" ] = {400, 350},
    [ "zz_fencegate" ] = {380, 350},
    [ "zz_gates" ] = {500, 320},
    
    [ "zz_gardenbed" ] = {340, 360},
    [ "zz_scarecrow" ] = {620, 355},
    [ "zz_grave" ] = {530, 360},
    [ "zz_well" ] = {380, 320},
    
    [ "zz_altar" ] = {530, 350},
    [ "zz_book" ] = {350, 370},
    [ "zz_stainedglass" ] = {380, 320},
    [ "zz_clerksdesk" ] = {620, 355},
    
    [ "zz_fountain" ] = {530, 330},
    [ "zz_stephen" ] = {340, 370},
    [ "zz_mechanism" ] = {440, 370},
    [ "zz_totem" ] = {620, 355},
    
    [ "zz_firtree" ] = {600, 370},
    [ "zz_wardrobe" ] = {620, 355},
    [ "zz_monster" ] = {580, 350},
    [ "zz_bed" ] = {380, 350}
    
  };
  
  --таблицы для динамического хинта
  --таблица для юзов на предметы, получаемые в хо и мультиюзов
  game.progress_multyuse =
  {
    
     {"use_standkey", "win_balcony"},
     {"use_scythe", "win_crypt"},
     
     {"use_sharpdaggerivy", "get_sharpdagger"},
     {"use_sharpdaggerfence", "get_sharpdagger"},
     {"use_sharpdaggerscarecrow", "get_sharpdagger"},
     
     {"use_scoopgarden", "get_scoop"},
     {"use_scoopforge", "get_scoop"},
     
     {"use_dragmagnifier1", "use_magnifier"},
     {"use_dragmagnifier2", "use_magnifier"},
     {"use_dragmagnifier3", "use_magnifier"},
     {"use_dragmagnifier4", "use_magnifier"},
     
     {"use_holvl1scissors", "use_firenecklace"},
     {"use_holvl1snowflake", "use_firenecklace"},
     
     {"use_bedlamppart1", "use_bulb"},
     {"use_bedlamppart2", "use_bulb"}
     
  };

  --таблица на мультипредметы с количеством их частей
  game.progress_multyobj =
  {
    {"use_amuletbook", 4},
    {"use_detail", 3},
    {"use_gargoylepart", 3},
    {"use_totempart", 2},
    {"use_stainedglassshard", 3},
    {"use_square", 3}
  };

  --таблица на юзы, разблокирующиеся другими юзами или кликами
  game.progress_blockeduse =
  {
    {"use_bucket", "use_rope"},
    {"use_chain", "use_bothwheels"},
    {"use_deathfigurine", "use_file"},
    {"get_stephensbag", "use_ancientsign"},
    
    {"get_seal", "use_webspider"},
    {"get_amuletbook3", "use_webspider"},
    {"get_amuletbook2", "use_webspider"},
    
    {"use_ink", "use_stainedglassshard"},
    {"use_feather", "use_stainedglassshard"},
    {"use_water", "use_seedsskull"},
    {"use_scoopwithcoals", "use_tin"},
    
    {"use_totempart", "use_pickaxe"},
    {"use_bowl", "use_amethystheart"},
    {"use_lamp", "use_key"}
  };

  game.progress_names =
  {
     "beg_level1"
    ,"clk_getphone"
    ,"clk_takecall"
    ,"opn_computer"
    ,"get_square1"
    ,"clk_readbrochures"
    ,"get_square2"
    ,"clk_framedphoto"
    ,"get_square3"
    ,"opn_safe"
    ,"use_square"
    ,"win_balcony"
    ,"use_standkey"
    ,"get_router"
    ,"use_router"
    ,"clk_startchat"
    ,"win_computer"
    ,"get_password"
    ,"use_password"
    ,"win_lvl1desk"
    ,"get_documentation"
    ,"opn_apartmentdelivery"
    ,"clk_opendoordelivery"
    ,"use_documentation"
    ,"clk_opencapsule"
    ,"opn_returning"
    ,"win_returning"
    ,"opn_customization"
    ,"clk_customizationsex"
    ,"clk_customizationconfirm"
    
    ,"opn_outsidechapel"
    ,"clk_outsidechapelfirst"
    ,"get_debugger"
    ,"get_dagger"
    ,"get_valve"
    ,"get_bottlewithresin"
    ,"use_valve"
    ,"get_oil"
    ,"use_oil"
    ,"get_sharpdagger"
    ,"get_hammerhandle"
    ,"use_sharpdaggerivy"
    ,"get_bigwheel"
    ,"get_file"
    ,"use_sharpdaggerfence"
    ,"get_smallwheel"
    ,"use_file"
    ,"get_chain"
    ,"get_rod"
    ,"use_hammerhandle"
    ,"get_hammer"
    ,"use_rod"
    ,"use_hammer"
    ,"get_adjuster"
    ,"use_bigwheel"
    ,"use_smallwheel"
    ,"use_bothwheels"
    ,"use_chain"
    ,"use_adjuster"
    ,"win_gallows"
    ,"get_ancientsign"
    ,"opn_outsidechapelskeletonfall"
    ,"use_ancientsign"
    ,"get_stephensbag"
    ,"get_deathfigurine"
    ,"use_deathfigurine"
    ,"win_fencegate"
    
    ,"opn_cemetery"
    ,"clk_cemeteryfirst"
    ,"get_puppet"
    ,"get_gargoylepart1"
    ,"get_hook"
    ,"get_paw1"
    ,"use_hook"
    ,"get_pigfigurine"
    ,"use_pigfigurine"
    ,"get_resin"
    ,"use_resin"
    ,"get_bucket"
    ,"use_sharpdaggerscarecrow"
    ,"get_rope"
    ,"use_rope"
    ,"use_bucket"
    ,"get_water"
    ,"get_gargoylepart2"
    ,"opn_grave"
    ,"get_gargoylepart3"
    ,"get_lense"
    ,"get_puppetarm"
    ,"use_gargoylepart"
    ,"get_seedsskull"
    ,"get_thread"
    ,"use_seedsskull"
    ,"use_water"
    ,"get_pumpkin"
    ,"use_pumpkin"
    ,"get_dateofdeath"
    ,"use_dateofdeath"
    ,"get_puppethead"
    ,"get_photopart1"
    ,"use_puppethead"
    ,"use_puppetarm"
    ,"use_puppetparts"
    ,"use_thread"
    ,"get_fixedpuppet"
    ,"use_fixedpuppet"
    ,"clk_hosymbol1"
    ,"clk_hosymbol2"
    ,"clk_hosymbol3"
    ,"clk_hosymbol4"
    ,"win_crypt"
    ,"opn_cemeteryafterho"
    ,"use_scythe"
    ,"win_gates"
    
    ,"opn_cobweb"
    ,"get_spider"
    ,"get_igrune"
    ,"get_glenrune"
    ,"use_igrune"
    ,"use_glenrune"
    ,"get_dog"
    ,"get_paw2"
    ,"use_paw1"
    ,"use_paw2"
    ,"use_dog"
    ,"get_webspider"
    ,"use_webspider"
    ,"win_cobweb"
    
    ,"opn_chapel"
    ,"get_amuletbook1"
    ,"get_amuletbook2"
    ,"get_seal"
    ,"get_amuletbook3"
    ,"use_seal"
    ,"get_amuletbook4"
    ,"use_amuletbook"
    ,"get_stainedglassshard1"
    ,"get_gravediggerfigurine"
    ,"use_gravediggerfigurine"
    ,"get_scoop"
    ,"get_stainedglassshard2"
    ,"use_scoopgarden"
    ,"get_bluelight"
    ,"use_bluelight"
    ,"get_tin"
    ,"use_scoopforge"
    ,"get_scoopwithcoals"
    ,"use_tin"
    ,"use_scoopwithcoals"
    ,"get_feather"
    ,"get_clerksamulet"
    ,"use_clerksamulet"
    ,"get_badge1"
    ,"get_ink"
    ,"get_stainedglassshard3"
    ,"use_stainedglassshard"
    ,"win_stainedglass"
    ,"use_ink"
    ,"use_feather"
    
    ,"opn_worldoffire"
    ,"get_crackedstone"
    ,"get_pickaxe"
    ,"get_detail1"
    ,"use_pickaxe"
    ,"get_detail2"
    ,"get_detail3"
    ,"use_detail"
    ,"win_mechanism"
    ,"get_pliers"
    ,"use_pliers"
    ,"get_amuletbag"
    ,"use_amuletbag"
    ,"get_shippart"
    ,"get_magnifier"
    ,"get_pipe"
    ,"use_magnifier"
    ,"use_dragmagnifier1"
    ,"use_dragmagnifier2"
    ,"use_dragmagnifier3"
    ,"use_dragmagnifier4"
    ,"use_pipe"
    ,"get_rubyheart"
    ,"use_rubyheart"
    ,"get_totempart1"
    ,"get_amuletfire"
    ,"use_amuletfire"
    ,"get_bowl"
    ,"get_totempart2"
    ,"use_totempart"
    ,"get_amethystheart"
    ,"use_amethystheart"
    ,"use_bowl"
    ,"get_healingpotion"
    ,"use_healingpotion"
    ,"get_firenecklace"
    ,"use_firenecklace"
    
    ,"opn_toys"
    ,"use_holvl1scissors"
    ,"use_holvl1snowflake"
    ,"win_toys"
    
    ,"opn_worldofdarkness"
    ,"get_photobasis"
    ,"get_switch"
    ,"use_switch"
    ,"win_firtree"
    ,"get_bulb"
    ,"get_photopart2"
    ,"clk_oldbulbout"
    ,"use_bulb"
    ,"use_bedlamppart1"
    ,"use_bedlamppart2"
    ,"get_lamp"
    ,"get_key"
    ,"get_photopart3"
    ,"use_key"
    ,"use_lamp"
    ,"win_wardrobe"
    ,"get_photopart4"
    ,"use_photopart1"
    ,"use_photopart2"
    ,"use_photopart3"
    ,"use_photopart4"
    ,"get_photo"
    ,"use_photo"
    ,"get_crownofdarkness"
    ,"use_crownofdarkness"
    
    ,"opn_mind"
    ,"win_mind"
    
    ,"opn_maptutor"
    ,"tutor_enable"
    ,"tutor_1"
    ,"tutor_2"
    ,"tutor_3"
    ,"tutor_4"
    ,"tutor_5"
    ,"tutor_6"
    ,"tutor_7"
    ,"tutor_8"
    ,"tutor_9"
    ,"tutor_10"
    ,"tutor_11"
    ,"tutor_12"
    ,"tutor_13"
    ,"tutor_14"
    ,"tutor_15"
    ,"tutor_16"
    ,"tutor_17"
    ,"tutor_115"
    
  };
  
  game.relations = {};

end;

function Test ()
    
  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;
