-- name=ho_insiderescuecapsule
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_insiderescuecapsule" );
  game.relations[ "ho_insiderescuecapsule" ].exitroom = "rm_maindeck";
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_insiderescuecapsule" ] = 
  {
    type = "win",
    room = "rm_maindeck",
    zz = "ho_insiderescuecapsule",
    zz_gate = "gho_maindeck_insiderescuecapsule"
  };
  --------------------------------------------------------------------------------------------------
  local win_insiderescuecapsule_func = function ()

    if ( cmn.IsEventDone( "win_insiderescuecapsule" ) ) then
      interface.InventoryItemAdd( "inv_display", "spr_insiderescuecapsule_win" );
      ObjDelete("gho_maindeck_insiderescuecapsule");
      ObjDelete("spr_maindeck_capsule_open");
      ObjSet("spr_maindeck_capsule_open_2",  { alp = 1 });
    end;

  end;
  cmn.AddSubscriber( "win_insiderescuecapsule", win_insiderescuecapsule_func );
  --------------------------------------------------------------------------------------------------
  local start_insiderescuecapsule_func = function ()

    if ( cmn.IsEventStart( "win_insiderescuecapsule" ) ) then

      common_impl.ProcessHoStart( "insiderescuecapsule", true );

    end;

  end;
  cmn.AddSubscriber( "win_insiderescuecapsule", start_insiderescuecapsule_func, "ho_insiderescuecapsule" );
  
  --for secretroom
  private.tasks =  {    
      { "cap",       1, 0, { { "spr_insiderescuecapsule_cap" } } },
      { "display",   1, 0, { { "spr_insiderescuecapsule_display" } } },
      { "soda",      1, 0, { { "spr_insiderescuecapsule_soda" } } },
      { "tube",      1, 0, { { "spr_insiderescuecapsule_tube" } } },

      { "screwdriver",   1, 0, { { "spr_insiderescuecapsule_screwdriver" } } },
      { "glove",         1, 0, { { "spr_insiderescuecapsule_glove" } } },
      { "hawk",          1, 0, { { "spr_insiderescuecapsule_hawk" } } },
      { "badge",         1, 0, { { "spr_insiderescuecapsule_badge" } } },

      { "radio",       1, 0, { { "spr_insiderescuecapsule_radio" } } },
      { "goggles",     1, 0, { { "spr_insiderescuecapsule_goggles" } } },
      { "toothbrush",  1, 0, { { "spr_insiderescuecapsule_toothbrush" } } },
      { "wrench",      1, 0, { { "spr_insiderescuecapsule_wrench" } } }
  };
    
    private.tasks_sh =  { 1, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1 };
    
  private.start = {};
  private.start_sh = {};
  private.start_items = {};
  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, private.tasks[i][2], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][ j ][ 1 ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "itm_"..common.GetObjectName( private.tasks[ i ][ 4 ][ j ][ 1 ] );
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );

    end;
    
    if private.tasks_sh[i] == 1 then
      
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = private.tasks[ i ][ 4 ][ 1 ][ 1 ].."_shadow";
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_game_2_mus", 1);
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level2/audio/env/aud_ho_hoinsiderescuecapsule_env");
  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_ho_hoinsiderescuecapsule_env");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_maindeck" );
    cmn.StartTimePassing("ho_insiderescuecapsule");
  else 
    
    private.CreateNewObjects();
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_insiderescuecapsule_maindeck",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                                  event_menter = function () rm_extra.GateMouseEnter( "insiderescuecapsule_maindeck", CURSOR_DOWN, "extra" ); end, 
                                                  event_mleave = function () common_impl.GateMouseLeave( "insiderescuecapsule_maindeck" ); end });
    
  end;

  if not cmn.IsEventStart( "win_insiderescuecapsule" ) then
    cmn.InitHo( "insiderescuecapsule" );
  end;

  local ho_items = {};

  interface_impl.ItemPanelItemAdd( ho_items, "cap", 0, "spr_insiderescuecapsule_cap" );
  interface_impl.ItemPanelItemAdd( ho_items, "display", 0, "spr_insiderescuecapsule_display" );
  interface_impl.ItemPanelItemAdd( ho_items, "soda", 0, "spr_insiderescuecapsule_soda" );
  interface_impl.ItemPanelItemAdd( ho_items, "tube", 0, "spr_insiderescuecapsule_tube" );
  
  interface_impl.ItemPanelItemAdd( ho_items, "screwdriver", 0, "spr_insiderescuecapsule_screwdriver" );
  interface_impl.ItemPanelItemAdd( ho_items, "glove", 0, "spr_insiderescuecapsule_glove" );
  interface_impl.ItemPanelItemAdd( ho_items, "hawk", 0, "spr_insiderescuecapsule_hawk" );
  interface_impl.ItemPanelItemAdd( ho_items, "badge", 0, "spr_insiderescuecapsule_badge" );
  
  interface_impl.ItemPanelItemAdd( ho_items, "radio", 0, "spr_insiderescuecapsule_radio" );
  interface_impl.ItemPanelItemAdd( ho_items, "goggles", 0, "spr_insiderescuecapsule_goggles" );
  interface_impl.ItemPanelItemAdd( ho_items, "toothbrush", 0, "spr_insiderescuecapsule_toothbrush" );
  interface_impl.ItemPanelItemAdd( ho_items, "wrench", 0, "spr_insiderescuecapsule_wrench" );

  if (not cmn.IsEventDone("win_insiderescuecapsule")) then
  
    interface_impl.ItemPanelShow( ho_items );
  
  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.ItemPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then

    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_insiderescuecapsule_maindeck",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_insiderescuecapsule");

    if ng_global.progress[ ng_global.currentprogress ][ "win_insiderescuecapsule" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_insiderescuecapsule" ] then

      ng_global.nohintho[ "win_insiderescuecapsule" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_insiderescuecapsule" ] then
      ng_global.playedhops[ "win_insiderescuecapsule" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_insiderescuecapsule_maindeck",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  
  ObjDelete(item_name.."_shadow");

  cmn.HoItemFind( item_name, 1 );
  
end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  local ho_itm = private.start_items;
  
  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #ho_itm, 1 do
    
    if not ObjGet( ho_itm[i].name ) then
      
      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_insiderescuecapsule_items" );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_insiderescuecapsule_items" );

    end;
    
  end;
  
end;
--*********************************************************************************************************************
