-- name=ho_onarmortable
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_onarmortable" );
  game.relations[ "ho_onarmortable" ].exitroom = "rm_armory";
  
  private.InitMarked();
  
  private.fly_pos = {
    { 
      { {640, 499}, {222, 389}, {575, 80}, {899, 285}, {85, 489}, {924, 416}, {77, 348} },
      { {519, 353}, {519, 220}, {667, 258}, {450, 451}, {233, 507} }
    },
    { 
      { {357, 76}, {421, 108}, {232, 125}, {217, 48}, {140, 108}, {120, 204}, {303, 171} }, 
      { {881, 106}, {730, 81}, {769, 130}, {890, 164}, {810, 101} }
    }
  };
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_onarmortable" ] = 
  {
    type = "win",
    room = "rm_armory",
    zz = "ho_onarmortable",
    zz_gate = "gho_armory_onarmortable"
  };
  --------------------------------------------------------------------------------------------------
  local win_onarmortable_func = function ()

    if ( cmn.IsEventDone( "win_onarmortable" ) ) then
      interface.InventoryItemAdd( "inv_weapon", "spr_onarmortable_win" );
      ObjDelete("gho_armory_onarmortable");
      ObjDelete("spr_armory_table_parts");
      ObjDelete("spr_armory_table_weapon");
    end;

  end;
  cmn.AddSubscriber( "win_onarmortable", win_onarmortable_func );
  --------------------------------------------------------------------------------------------------
  local start_onarmortable_func = function ()

    if ( cmn.IsEventStart( "win_onarmortable" ) ) then

      common_impl.ProcessHoStart( "onarmortable", true );

    end;

  end;
  cmn.AddSubscriber( "win_onarmortable", start_onarmortable_func, "ho_onarmortable" );
  
  --for secretroom
  private.tasks =  {    
      { "gunpart_1_1",  1, 0, { { "spr_onarmortable_gunpart_1_1", "obj_onarmortable_gunpart_1_1" } } },
      { "gunpart_2_1",  1, 0, { { "spr_onarmortable_gunpart_2_1", "obj_onarmortable_gunpart_2_1" } } },
      { "gunpart_1_3",  1, 0, { { "spr_onarmortable_gunpart_1_3", "obj_onarmortable_gunpart_1_3" } } },
      { "gunpart_1_2",  1, 0, { { "spr_onarmortable_gunpart_1_2", "obj_onarmortable_gunpart_1_2" } } },

      { "gunpart_2_2",  1, 0, { { "spr_onarmortable_gunpart_2_2", "obj_onarmortable_gunpart_2_2" } } },
      { "gunpart_1_6",  1, 0, { { "spr_onarmortable_gunpart_1_6", "obj_onarmortable_gunpart_1_6" } } },
      { "gunpart_2_3",  1, 0, { { "spr_onarmortable_gunpart_2_3", "obj_onarmortable_gunpart_2_3" } } },
      { "gunpart_1_4",  1, 0, { { "spr_onarmortable_gunpart_1_4", "obj_onarmortable_gunpart_1_4" } } },

      { "gunpart_2_4",  1, 0, { { "spr_onarmortable_gunpart_2_4", "obj_onarmortable_gunpart_2_4" } } },
      { "gunpart_1_5",  1, 0, { { "spr_onarmortable_gunpart_1_5", "obj_onarmortable_gunpart_1_5" } } },
      { "gunpart_2_5",  1, 0, { { "spr_onarmortable_gunpart_2_5", "obj_onarmortable_gunpart_2_5" } } },
      { "gunpart_1_7",  1, 0, { { "spr_onarmortable_gunpart_1_7", "obj_onarmortable_gunpart_1_7" } } }
  };
    
  private.actions = {
  
    { "use_holvl2wrench", { "obj_onarmortable_use_wrench", "anm_onarmortable_box_touch", "spr_onarmortable_wrench_sh", "spr_onarmortable_wrench", "spr_onarmortable_gunpart_1_6_lock", "anm_onarmortable_use_wrench" } },
    { "clk_holvl2glove", { "spr_onarmortable_gunpart_2_2_lock", "obj_onarmortable_glove", "spr_onarmortable_glove_sh", "spr_onarmortable_glove" } },
    { "clk_holvl2disk", { "spr_onarmortable_gunpart_1_3_lock", "obj_onarmortable_disk", "spr_onarmortable_disk_sh", "spr_onarmortable_disk" } }

  };
  
  private.start_actions = {};
  
  for i = 1, #private.actions, 1 do
    
    private.start_actions[i] = {};
    
    for j = 1, #private.actions[i][2], 1 do
    
      private.start_actions[i][j] = {};
      private.start_actions[i][j].name = private.actions[i][2][j];
      local nme = private.start_actions[i][j].name;
      private.start_actions[i][j].prop = ObjGet( nme );
      private.start_actions[i][j].parent = ObjGetRelations( nme ).parent;
    
    end;
    
  end;
    
  private.tasks_sh =  { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
    
  private.start = {};
  private.start_sh = {};
  private.start_items = {};
  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
    
    table.insert( private.start_items, {} );
    private.start_items[ #private.start_items ].name = "itm_"..common.GetObjectName( private.tasks[ i ][ 4 ][ 1 ][ 1 ] );
    nme = private.start_items[ #private.start_items ].name;
    private.start_items[ #private.start_items ].prop = ObjGet( nme );
    
    if private.tasks_sh[i] == 1 then
      
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = private.tasks[ i ][ 4 ][ 1 ][ 1 ].."_shadow";
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_onarmortable" ].state or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_onarmortable" ].stage = { 1, 1 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_onarmortable" ].state = { {0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0} };
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level2/audio/env/aud_rm_armory_env");
  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_armory_env");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_armory" );
    cmn.StartTimePassing("ho_onarmortable");
  else
    
    ng_global.progress[ ng_global.currentprogress ][ "win_onarmortable" ].stage = { 1, 1 }; 
    ng_global.progress[ ng_global.currentprogress ][ "win_onarmortable" ].state = { {0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0} };
    
    private.CreateNewObjects();
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_onarmortable_armory",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                         event_menter = function () rm_extra.GateMouseEnter( "onarmortable_armory", CURSOR_DOWN, "extra" ); end, 
                                         event_mleave = function () common_impl.GateMouseLeave( "onarmortable_armory" ); end });
    
  end;
  
  private.DrawScene();

  if not cmn.IsEventStart( "win_onarmortable" ) then
    
    cmn.InitHo( "onarmortable" );
    
    cmn.SetMarkedTask( "onarmortable", "gunpart_1_3" );
    cmn.SetMarkedTask( "onarmortable", "gunpart_1_6" );
    cmn.SetMarkedTask( "onarmortable", "gunpart_2_2" );
    
  end;

  local ho_items = {};

  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_1_1", 0, "spr_onarmortable_gunpart_1_1" );
  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_2_1", 0, "spr_onarmortable_gunpart_2_1" );
  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_1_3", 1, "spr_onarmortable_gunpart_1_3" );
  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_1_2", 0, "spr_onarmortable_gunpart_1_2" );
  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_2_2", 1, "spr_onarmortable_gunpart_2_2" );
  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_1_6", 1, "spr_onarmortable_gunpart_1_6" );
  
  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_2_3", 0, "spr_onarmortable_gunpart_2_3" );
  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_1_4", 0, "spr_onarmortable_gunpart_1_4" );
  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_2_4", 0, "spr_onarmortable_gunpart_2_4" );
  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_1_5", 0, "spr_onarmortable_gunpart_1_5" );
  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_2_5", 0, "spr_onarmortable_gunpart_2_5" );
  interface_impl.ItemPanelItemAdd( ho_items, "gunpart_1_7", 0, "spr_onarmortable_gunpart_1_7" );

  if not cmn.IsEventDone("win_onarmortable")
  and ng_global.progress[ ng_global.currentprogress ][ "win_onarmortable" ].stage[1] <= ng_global.progress[ ng_global.currentprogress ][ "win_onarmortable" ].stage[2] then
  
    interface_impl.ItemPanelShow( ho_items );
  
  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_ho_balcony_mus", 1);
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.ItemPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
    
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_onarmortable_armory",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;
  
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_onarmortable");

    if ng_global.progress[ ng_global.currentprogress ][ "win_onarmortable" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_onarmortable" ] then

      ng_global.nohintho[ "win_onarmortable" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_onarmortable" ] then
      ng_global.playedhops[ "win_onarmortable" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_onarmortable_armory",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( gun, part )
  
  ng_global.progress[ ng_global.currentprogress ][ "win_onarmortable" ].state[gun][part] = 1;
  cmn.HoItemFind("obj_onarmortable_gunpart_"..gun.."_"..part);
  
  ObjSet("spr_onarmortable_gunpart_"..gun.."_"..part,  { input = 0 });
  
  ObjDelete("spr_onarmortable_gunpart_"..gun.."_"..part.."_shadow");
  private.ItemFly( gun, part );

end;
--------------------------------------------------------------------------------
function private.DrawScene()
  
  for i = 1, 2, 1 do
    for j = 1, #ng_global.progress[ ng_global.currentprogress ][ "win_onarmortable" ].state[i], 1 do
      if ng_global.progress[ ng_global.currentprogress ][ "win_onarmortable" ].state[i][j] == 1 then
        ObjDelete("spr_onarmortable_gunpart_"..i.."_"..j);
        ObjDelete("spr_onarmortable_gunpart_"..i.."_"..j.."_shadow");
        ObjSet("obj_onarmortable_gun_"..i.."_"..j,  { alp = 1 });
      else 
        ObjSet("obj_onarmortable_gun_"..i.."_"..j,  { alp = 0 });
      end;
    end;
  end;
  
end;
--*********************************************************************************************************************
function private.ItemFly( gun, part )

  local point_a, point_b = {}, {};
  point_a[1] = private.fly_pos[1][gun][part][1];
  point_a[2] = private.fly_pos[1][gun][part][2];
  point_b[1] = private.fly_pos[2][gun][part][1];
  point_b[2] = private.fly_pos[2][gun][part][2];
  
  ObjAttach("spr_onarmortable_gunpart_"..gun.."_"..part, "obj_onarmortable_fly");
  
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.003 * len;
  
  if tme > 0.5 then
    tme = 0.5;
  elseif tme < 0.1 then
    tme = 0.1;
  end;
  
  local func_after = function ( gun, part )
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_ho_onarmotable_insert");
    ObjAnimate("obj_onarmortable_gun_"..gun.."_"..part, "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
    ObjAnimate("spr_onarmortable_gunpart_"..gun.."_"..part, "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
  end;
  
  ObjAnimate("spr_onarmortable_gunpart_"..gun.."_"..part, "pos_xy", 0, 0, function() func_after( gun, part ); end, { 0, 0, point_a[1], point_a[2],    tme, 0, point_b[1], point_b[2] });
  
end;
--*********************************************************************************************************************
function public.touch_box()
  
  cmn.Lock(1, { room = 1 });
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_ho_onarmotable_slide_xx_box");
  
  cmn.ShowBbt( "obj_onarmortable_use_wrench" );
  
  ObjSet("anm_onarmortable_box_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--*********************************************************************************************************************
-- function *** MARKED *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.InitMarked()

  public.ho_hint_progress_names = { "use_holvl2wrench", "clk_holvl2glove", "clk_holvl2disk" };
  
  --------------------------------------------------------------------------------------------
  -- function use_holvl2wrench () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl2wrench" ] = {
      type = "use",
      inv_obj = "spr_onarmortable_wrench",
      use_place = "obj_onarmortable_use_wrench",
      room = "rm_armory",
      zz = "ho_onarmortable",
      zz_gate = "gho_armory_onarmortable"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl2wrench_beg = function ()
  
    ObjDelete( "obj_onarmortable_use_wrench" );
    ObjDelete( "anm_onarmortable_box_touch" );
    ObjDelete( "spr_onarmortable_wrench_sh" );
    ObjDelete( "spr_onarmortable_wrench" );
  
  end;
  local use_holvl2wrench_end = function ()
    
    ObjDelete( "spr_onarmortable_gunpart_1_6_lock" );
    
    ObjDelete("anm_onarmortable_use_wrench");
    ObjSet("spr_onarmortable_gunpart_1_6",  { input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl2wrench", use_holvl2wrench_beg, "ho_onarmortable" );
  cmn.AddSubscriber( "use_holvl2wrench", use_holvl2wrench_end, "ho_onarmortable" );
  cmn.AddSubscriber( "use_holvl2wrench_beg", use_holvl2wrench_beg, "ho_onarmortable" );
  cmn.AddSubscriber( "use_holvl2wrench_end", use_holvl2wrench_end, "ho_onarmortable" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_holvl2glove () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_holvl2glove" ] = {
      type = "click",
      use_place = "obj_onarmortable_glove",
      room = "rm_armory",
      zz = "ho_onarmortable",
      zz_gate = "gho_armory_onarmortable"
  };
  --------------------------------------------------------------------------------------------
  local clk_holvl2glove = function ()
    
    ObjDelete( "spr_onarmortable_gunpart_2_2_lock" );
    
    ObjDelete("obj_onarmortable_glove");
    ObjSet("spr_onarmortable_gunpart_2_2",  { input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_holvl2glove", clk_holvl2glove, "ho_onarmortable" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_holvl2disk () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_holvl2disk" ] = {
      type = "click",
      use_place = "obj_onarmortable_disk",
      room = "rm_armory",
      zz = "ho_onarmortable",
      zz_gate = "gho_armory_onarmortable"
  };
  --------------------------------------------------------------------------------------------
  local clk_holvl2disk = function ()
    
    ObjDelete( "spr_onarmortable_gunpart_1_3_lock" );
    
    ObjDelete("obj_onarmortable_disk");
    ObjSet("spr_onarmortable_gunpart_1_3",  { input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_holvl2disk", clk_holvl2disk, "ho_onarmortable" );
  
end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function public.StartDrag()

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_from_inventory" );
  ObjAttach("spr_onarmortable_wrench", "obj_onarmortable_fly");

  ObjAnimate("spr_onarmortable_wrench_sh", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0 });

end;
------------------------------------------------------------------------------
function public.use_wrench()

  item = "spr_onarmortable_wrench";

  if ( cmn.ApplyObj( item, "obj_onarmortable_use_wrench" ) ) then

    cmn.CallEventHandler( "use_holvl2wrench_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_holvl2wrench" );
      cmn.CallEventHandler( "use_holvl2wrench_end" );

      cmn.UnmarkItem( "onarmortable", "gunpart_1_6" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_ho_onarmotable_slide_open_key");
    
    ObjSet("anm_onarmortable_use_wrench",  { alp = 1, playing = 1, endtrig = func_after });
    
  else 

    cmn.WrongApply();
    ObjAttach(item, "ho_onarmortable");
    ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
------------------------------------------------------------------------------
function public.clk_glove()
  
  local func_after = function ()

    cmn.Lock( 0 );

    cmn.SetEventDone( "clk_holvl2glove" );
    cmn.CallEventHandler( "clk_holvl2glove" );

    cmn.UnmarkItem( "onarmortable", "gunpart_2_2" );

  end;

  cmn.Lock( 1, { room = 1 } );
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_ho_onarmotable_slide");
  
  ObjAttach("obj_onarmortable_glove", "obj_onarmortable_fly");
  
  ObjAnimate("spr_onarmortable_glove", "pos_xy", 0, 0, func_after, { 0, 1, 0, 0,   0.5, 1, -68, -56,   0.8, 2, -68, -56,   1.3, 2, -39, -307 });
  ObjAnimate("spr_onarmortable_glove_sh", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 1,   0.5, 0, 0 });

end;
------------------------------------------------------------------------------
function public.clk_disk()
  
  local func_after = function ()

    cmn.Lock( 0 );

    cmn.SetEventDone( "clk_holvl2disk" );
    cmn.CallEventHandler( "clk_holvl2disk" );

    cmn.UnmarkItem( "onarmortable", "gunpart_1_3" );

  end;

  cmn.Lock( 1, { room = 1 } );
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_ho_onarmotable_slide");
  
  ObjAttach("obj_onarmortable_disk", "obj_onarmortable_fly");
  
  ObjAnimate("spr_onarmortable_disk", "pos_xy", 0, 0, func_after, { 0, 1, 0, 0,   0.5, 1, 46, -46,   0.8, 2, 46, -46,   1.3, 2, 24, -160  });
  ObjAnimate("spr_onarmortable_disk_sh", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  local ho_itm = private.start_items;
  
  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #ho_itm, 1 do
    
    if not ObjGet( ho_itm[i].name ) then
      
      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_onarmortable_items" );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_onarmortable_items" );

    end;
    
  end;
  
  for i = 1, #private.actions, 1 do
    
    if cmn.IsEventDone( private.actions[i][1] ) then
      
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].done = 0;
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].start = 0;
      
      for j = 1, #private.actions[i][2], 1 do
      
        local nme = private.start_actions[i][j].name;
        
        if not ObjGet( nme ) then
          
          local typ = common.GetObjectPrefix( nme );
          
          if typ == "anm" then
            typ = "anim";
          end;
          
          ObjCreate( nme, typ );
          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        else 

          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        end;
          
      end;
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
