-- name=ho_stars
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_stars" );
  game.relations[ "ho_stars" ].exitroom = "rm_accomodations";
  private.win_inprogress = false;
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_stars" ] = 
  {
    type = "win",
    room = "rm_accomodations",
    zz = "ho_stars",
    zz_gate = "gho_accomodations_stars"
  };
  --------------------------------------------------------------------------------------------------
  local win_stars_func = function ()

    if ( cmn.IsEventDone( "win_stars" ) ) then
      interface.InventoryItemAdd( "inv_coordinates", "spr_stars_win" );
      ObjDelete("gho_accomodations_stars");
      ObjDelete("anm_stars_win");
    end;

  end;
  cmn.AddSubscriber( "win_stars", win_stars_func );
  --------------------------------------------------------------------------------------------------
  local start_stars_func = function ()

    if ( cmn.IsEventStart( "win_stars" ) ) then

      common_impl.ProcessHoStart( "stars" );

    end;

  end;
  cmn.AddSubscriber( "win_stars", start_stars_func, "ho_stars" );
  
  --for secretroom
  private.tasks =  {    
      { "constellation_1",      1, 0, { { "obj_stars_constellation_1", "spr_stars_constellation_1" } } },
      { "constellation_2",      1, 0, { { "obj_stars_constellation_2", "spr_stars_constellation_2" } } },
      { "constellation_3",      1, 0, { { "obj_stars_constellation_3", "spr_stars_constellation_3" } } },
      { "constellation_4",      1, 0, { { "obj_stars_constellation_4", "spr_stars_constellation_4" } } },

      { "constellation_5",      1, 0, { { "obj_stars_constellation_5", "spr_stars_constellation_5" } } },
      { "constellation_6",      1, 0, { { "obj_stars_constellation_6", "spr_stars_constellation_6" } } },
      { "constellation_7",      1, 0, { { "obj_stars_constellation_7", "spr_stars_constellation_7" } } },
      { "constellation_8",      1, 0, { { "obj_stars_constellation_8", "spr_stars_constellation_8" } } },

      { "constellation_9",     1, 0, { { "obj_stars_constellation_9", "spr_stars_constellation_9" } } },
      { "constellation_10",    1, 0, { { "obj_stars_constellation_10", "spr_stars_constellation_10" } } },
      { "constellation_11",    1, 0, { { "obj_stars_constellation_11", "spr_stars_constellation_11" } } },
      { "constellation_12",    1, 0, { { "obj_stars_constellation_12", "spr_stars_constellation_12" } } }
  };
    
  private.start = {};
  private.start_items = {};
  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
    
    table.insert( private.start_items, {} );
    private.start_items[ #private.start_items ].name = "itm_"..common.GetObjectName( private.tasks[ i ][ 4 ][ 1 ][ 1 ] );
    nme = private.start_items[ #private.start_items ].name;
    private.start_items[ #private.start_items ].prop = ObjGet( nme );
    
  end;

end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_stars" ].stage or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_stars" ].stage = { 1, 1 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_stars" ].state = {};
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level2/audio/env/aud_cosmos_loop");
  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_cosmos_loop");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_accomodations" );
    cmn.StartTimePassing("ho_stars");
  else 
    
    ng_global.progress[ ng_global.currentprogress ][ "win_stars" ].stage = { 1, 1 }; 
    ng_global.progress[ ng_global.currentprogress ][ "win_stars" ].state = {};
    
    private.win_inprogress = false;
    
    private.CreateNewObjects();
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_stars_accomodations",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                         event_menter = function () rm_extra.GateMouseEnter( "stars_accomodations", CURSOR_DOWN, "extra" ); end, 
                                         event_mleave = function () common_impl.GateMouseLeave( "stars_accomodations" ); end });
    
  end;

  if not cmn.IsEventStart( "win_stars" ) then
    cmn.InitHo( "stars" );
  end;
  
  for i = 1, 19, 1 do
    ObjSet("spr_stars_constellation_"..i,  { pos_x = 0, pos_y = 0 });
    private.AnimatePicFly( i );
  end;
  
  --for i = 1, 3, 1 do
  --  ObjSet("spr_stars_galaxy_"..i,  { ang = 0 });
  --  private.AnimateGalaxy( i );
  --end;

  local ho_items = {};

  interface_impl.ItemPanelItemAdd( ho_items, "constellation_1", 0, "obj_stars_constellation_1" );
  interface_impl.ItemPanelItemAdd( ho_items, "constellation_2", 0, "obj_stars_constellation_2" );
  interface_impl.ItemPanelItemAdd( ho_items, "constellation_3", 0, "obj_stars_constellation_3" );
  interface_impl.ItemPanelItemAdd( ho_items, "constellation_4", 0, "obj_stars_constellation_4" );
  interface_impl.ItemPanelItemAdd( ho_items, "constellation_5", 0, "obj_stars_constellation_5" );
  interface_impl.ItemPanelItemAdd( ho_items, "constellation_6", 0, "obj_stars_constellation_6" );
  
  interface_impl.ItemPanelItemAdd( ho_items, "constellation_7", 0, "obj_stars_constellation_7" );
  interface_impl.ItemPanelItemAdd( ho_items, "constellation_8", 0, "obj_stars_constellation_8" );
  interface_impl.ItemPanelItemAdd( ho_items, "constellation_9", 0, "obj_stars_constellation_9" );
  interface_impl.ItemPanelItemAdd( ho_items, "constellation_10", 0, "obj_stars_constellation_10" );
  interface_impl.ItemPanelItemAdd( ho_items, "constellation_11", 0, "obj_stars_constellation_11" );
  interface_impl.ItemPanelItemAdd( ho_items, "constellation_12", 0, "obj_stars_constellation_12" );

  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_stars" ].stage;

  if not cmn.IsEventDone("win_stars") and ho_stage[1] <= ho_stage[2] then
  
    interface_impl.ItemPanelShow( ho_items );
  
  else
    cmn.Lock( 1, { room = 1 } );
    --common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_ho_balcony_mus", 1);
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_stars" ].stage;
  if ng_global.currentprogress == "std" and cmn.IsEventDone("win_stars") then
    local func_after = function ()
      cmn.GotoRoom("rm_accomodations");
      cmn.Lock(0);
    end;
    ObjSet("tmr_stars_timer",  { time = 0.3, playing = 1, endtrig = func_after });
  elseif ho_stage[1] > ho_stage[2] then
    public.win();
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.ItemPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_stars_accomodations",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_stars");

    if ng_global.progress[ ng_global.currentprogress ][ "win_stars" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_stars" ] then

      ng_global.nohintho[ "win_stars" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_stars" ] then
      ng_global.playedhops[ "win_stars" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_stars_accomodations",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.win()
  
  if not private.win_inprogress then
    
    private.win_inprogress = true;
    cmn.SetEventDone("win_stars");
    
    if ng_global.currentprogress == "std" then
      ng_global.progress[ ng_global.currentprogress ].common.currentroom = "rm_accomodations";
    else 
      int_dialog_secretroom.StopTimer();
    end;
    
    local func_after = function ()
      
      --cmn.CallEventHandler("win_stars");
      --cmn.GotoRoom("rm_accomodations");
      
      cmn.Lock(0);
      --common_impl.DialogHo_Show();
      
      if ng_global.currentprogress == "std" then
      
        PlaySfx( "assets/levels/common/audio/aud_win_ho", 0, "", 0.1 );
        interface.ItemPanelHide();
        interface.DialogHoShow();
        
      else 
        
        int_dialog_secretroom.ShowAnim();
        
      end;

    end;
    
    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_ho_stars_win_anim");
    ObjSet("anm_stars_win",  { alp = 1, playing = 1, endtrig = func_after });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_num )

  cmn.HoItemFind("obj_stars_constellation_"..item_num);
  
end;
-----------------------------------------------------------------------------------
function private.AnimatePicFly( num )
  
  local range_y = math.random(2, 4);
  local range_x = math.random(1, 3);
  local dir_y = math.random(1, 2);
  local dir_x = math.random(1, 2);
  if dir_y == 2 then
    dir_y = -1;
  end;
  if dir_x == 2 then
    dir_x = -1;
  end;
  
  ObjAnimate("spr_stars_constellation_"..num, "pos_y", 1, 0, "", { 
    0, 2, 0,     
    1, 2, range_y*dir_y,    
    3, 3, -range_y*dir_y,    
    4, 1, 0 
  });
  ObjAnimate("spr_stars_constellation_"..num, "pos_x", 1, 0, "", { 
    0, 2, 0,     
    1, 2, range_x*dir_x,    
    3, 3, -range_x*dir_x,    
    4, 1, 0
  });
  
end;
-----------------------------------------------------------------------------------
function private.AnimateGalaxy( num )
  
  local range_tme = math.random(40, 60);
  local dir = math.random(1, 2);

  if dir == 2 then
    dir = -1;
  end;
  
  ObjAnimate("spr_stars_galaxy_"..num, "ang", 1, 0, "", { 
    0, 0, 0,     
    range_tme, 0, 2*math.pi*dir
  });
  
end;
--*********************************************************************************************************************
function private.CreateNewObjects()
  
  ObjSet("anm_stars_win",  { frame = 0 });

  local ho_obj = private.start;
  local ho_itm = private.start_items;
  
  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_itm, 1 do
    
    if not ObjGet( ho_itm[i].name ) then
      
      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_stars_items" );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_stars_items" );

    end;
    
  end;
  
end;
--********************************************************************************************************************