-- name=mg_incapsule
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_incapsule";
  --------------------------------------------------------------------------------------------
  private.in_progress = false;
  
  private.hero_state = { "stand", "run", "jump", "land", "die", "win" };
  private.in_air = false;
  private.falling = false;
  private.doors_closing = false;
  private.doors_closed = true;
  private.die = false;
  private.start_jumping = false;
  private.stop_point = 402;
  private.cur_obstacle = 0;
  private.animals_move = { ["ameba_1"] = {1434, 1954, 0.02, "pos_x"}, ["star_1"] = {230, 456, 0.01, "pos_y"}, ["star_2"] = {-25, 253, 0.006, "pos_y"} };
  --private.animals_move = { ["bird"] = {600, 950, 0.01}, ["dog"] = {2040, 2340, 0.02}, ["cat"] = {3720, 4160, 0.015}, ["rat"] = {5000, 5400, 0.008} };

  private.death_obstacles = { "weed_1", "ameba_1", "precipice", "weed_2", "precipice", "star_1", "weed_3", "star_2", "weed_4", "ball" };
  private.obstacle_env = {};
  --private.obstacle_env = { "aud_crow_env", "", "aud_fireplug_env", "aud_dog_env", "", "aud_cat_env", "", "aud_rat_env", "aud_fireplug_env" };
  private.obstacle_env_playing = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
  private.obstacle_dif_inspace = { 20, 0, 70, 46, 0, 28, 0, 38, 70 };

  private.checkpoins = { 0, -800, -880, -880, -2275, -2275, -2915, -3402, -3978, -3978, -4632 };
  
  --size of precipice
  private.precipice = { {1499, 1621}, {3018, 3148} };

  --pos and size of standable obstacles
  private.obstacles = { 
    {1870, 786, 132}, {4066, 304, 132}, {5465, 90, 86} --platforms
  };
  
  private.obstacles_2 = { {755, 157, 91}, {912, 80, 58}, {5912, 48, 54}, {5959, 100, 81}, {6060, 72, 54}, --cars
                        {1305, 84, 58}, {2410, 84, 58}, {3576, 84, 58},  --fences
                        {6447, 92, 92}, {6539, 92, 184}, {1735, 38, 57}, {5560, 38, 57},  --boxes and hydrants

                        --{1916, 64, 47}, {1932, 30, 92}, {2837, 64, 47}, {2853, 30, 92},
                        --{4266, 64, 47}, {4282, 30, 92}, {4898, 64, 47}, {4914, 30, 92}, {3085, 31, 47} }; --trashcans

                        {1908, 23, 45}, {1931, 34, 92}, {1966, 23, 45}, {2829, 23, 45}, {2852, 34, 92}, {2886, 23, 45},
                        {4266, 23, 45}, {4289, 34, 92}, {4323, 23, 45}, {4898, 23, 45}, {4921, 34, 92}, {4955, 23, 45},  {3084, 40, 45} }; --trashcans
  --------------------------------------------------------------------------------------------
  -- function win_incapsule () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_incapsule" ] = {
    type = "win",
    room = "rm_medicalsection",
    zz = "mg_incapsule",
    zz_gate = "gmg_medicalsection_incapsule"
  };
  --------------------------------------------------------------------------------------------
  local win_incapsule_task = function ()
    interface_impl.SetCurrentGlobalTask( 9 );
  end;
  local win_incapsule = function ()

    if cmn.IsEventDone( "win_incapsule" ) then
      ObjMultiSet( { {"obj_incapsule_buttons", { alp = 0, input = 0 }},
                     {"obj_incapsule_button_6", { alp = 0, input = 0 }} } );
    end;

  end;
  local win_incapsule_loc = function ()

    if cmn.IsEventDone( "win_incapsule" ) then
      ObjDelete("gmg_medicalsection_incapsule");
      ObjDelete("spr_medicalsection_capsule_mg");
      ObjDelete("anm_medicalsection_jean_tocapsule");
      ObjMultiSet( { {"anm_medicalsection_jean_2",  { alp = 1 }},
                     {"obj_medicalsection_capsule", { alp = 1 }} } );
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_incapsule", win_incapsule, "mg_incapsule" );
  cmn.AddSubscriber( "win_incapsule", win_incapsule_loc, "rm_medicalsection" );
  cmn.AddSubscriber( "win_incapsule", win_incapsule_task );
  
  --------------------------------------------------------------------------------------------
  -- function opn_incapsule () end;
  --------------------------------------------------------------------------------------------
  local opn_incapsule = function ()
  
    ObjDelete("anm_incapsule_scan");
    ObjSet("spr_incapsule_game_scan_back",  { alp = 0 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_incapsule", opn_incapsule, "mg_incapsule" );
  
  private.action = {"anm_incapsule_scan"};
  private.start_actions = {};
  
  for j = 1, #private.action, 1 do
    
    private.start_actions[j] = {};
    private.start_actions[j].name = private.action[j];
    local nme = private.start_actions[j].name;
    private.start_actions[j].prop = ObjGet( nme );
    private.start_actions[j].parent = ObjGetRelations( nme ).parent;
  
  end;
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_incapsule" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_incapsule" ].state;

end;
--*********************************************************************************************************************
function public.Open() 

  cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_mg_returning_mus", 1);
  
  if ng_global.currentprogress == "std" and cmn.IsEventDone("opn_incapsule") and not(cmn.IsEventDone( "win_incapsule" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_incapsule");
  elseif not cmn.IsEventDone("opn_incapsule") then
    cmn.SetEventDone("opn_incapsule");
    private.StartGame();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv();
  --cmn.PlayAudio("env", "assets/levels/level2/audio/env/");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_medicalsection" );
  else 
    
    private.StartConditions();
    
    ng_global.progress[ ng_global.currentprogress ][ "opn_incapsule" ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "opn_incapsule" ].start = 0;
    
    private.CreateNewObjects();
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_incapsule" ].state;
    
    ObjSet("grm_incapsule_medicalsection",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                         event_menter = function () rm_extra.GateMouseEnter( "incapsule_medicalsection", CURSOR_DOWN, "extra" ); end, 
                                         event_mleave = function () common_impl.GateMouseLeave( "incapsule_medicalsection" ); end });
                                     
  end;
  
  if private.state[4] > 0 then
    --cmn.PlayAudio("mus", "assets/levels/level4/mg_slotmachine/audio/aud_slotmashine_mus", 1);
  else 
    --cmn.PlayAudio("mus", "assets/levels/level4/mg_slotmachine/audio/aud_gameover_mus", 1);
  end;

  private.die = false;
  private.in_air = false;

  if not(cmn.IsEventDone( "win_incapsule" )) then
    private.state[3] = 1;
  end;

  private.DrawScene(true);
  
  if not cmn.IsEventDone("opn_incapsule") then
    cmn.Lock( 1 );
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  cmn.StopAllMus();
  cmn.StopAllEnv();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;

  --for i = 1, 9, 1 do
  --
  --  if i ~= 2 and i ~= 5 and i ~= 7 then
  --    SndStop("assets/levels/level4/mg_slotmachine/audio/"..private.obstacle_env[i], 0.5);
  --  end;
  --  
  --end;

  if private.state[4] == 0 then
    SndStop("assets/levels/level2/audio/sfx/aud_mmg_robotic_alarm_die", 0.5);
  end;

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_incapsule" )) then
    private.state[2][2] = private.stop_point;
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_incapsule" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  local tme = 0;
  local old_x_back = private.state[1];

  --for i = 1, #private.death_obstacles, 1 do
  --  SndStop("assets/levels/level4/mg_slotmachine/audio/"..private.obstacle_env[i], 0.5);
  --end;

  ObjMultiSet( { {"tmr_incapsule_timer", { playing = 0, endtrig = "" }},
                 {"tmr_incapsule_timer_check", { playing = 0, endtrig = "" }},
                 {"tmr_incapsule_timer_check_env", { playing = 0, endtrig = "" }},
                 {"tmr_incapsule_timer_jump", { playing = 0, endtrig = "" }} } );

  local hero_reapper = function ()
    ObjSet("obj_incapsule_hero",  { pos_x = 240, pos_y = 402 });
    ObjAnimate("obj_incapsule_hero", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  end;

  local move_back = function ()
    ObjAnimate("obj_incapsule_background", "pos_x", 0, 0, hero_reapper, { 0, 0, old_x_back,   tme-1, 0, 0 });
  end;
  
  if private.state[5] > 0 then
    ObjAnimate("obj_incapsule_buttons", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("obj_incapsule_button_6", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  end;

  if private.state[4] > 0 then

    if private.state[1] ~= 0 then
      tme = 0.0003*(private.state[1]+6170) + 1;
      --ObjAnimate("obj_incapsule_button_6", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });  
      ObjAnimate("obj_incapsule_hero", "alp", 0, 0, move_back, { 0, 0, 1,   0.5, 0, 0 });
    elseif private.state[2][1] ~= 240 or private.state[2][2] ~= 402 then
      tme = 1;
      --ObjAnimate("obj_incapsule_button_6", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });  
      ObjAnimate("obj_incapsule_hero", "alp", 0, 0, hero_reapper, { 0, 0, 1,   0.5, 0, 0 });
    end;  

    if private.state[4] == 1 then
      if tme == 0 then
        tme = 0.5;
      end;
      ObjAnimate("spr_incapsule_life_2", "alp", 0, 0, "", { 0, 0, 0,  0.5, 0, 1 });
      ObjAnimate("spr_incapsule_life_3", "alp", 0, 0, "", { 0, 0, 0,  0.5, 0, 1 });
    end;

    if private.state[4] == 2 then
      if tme == 0 then
        tme = 0.5;
      end;
      ObjAnimate("spr_incapsule_life_3", "alp", 0, 0, "", { 0, 0, 0,  0.5, 0, 1 });
    end;

  else 

    public.PressStart(true);

  end;

  if tme > 0 then

    --cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/");
    cmn.Lock(1);
    ObjSet("tmr_incapsule_timer_reset",  { time = tme, playing = 1, endtrig = function () public.PressStart(false); end });

  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  --SndStop("assets/levels/level4/mg_slotmachine/audio/aud_slotmashine_mus", 1);
  --cmn.PlayAudio("snd", "assets/levels/level4/mg_slotmachine/audio/aud_skipslotmashine");

  --for i = 1, #private.death_obstacles, 1 do
  --  SndStop("assets/levels/level4/mg_slotmachine/audio/"..private.obstacle_env[i], 0.5);
  --end;

  ng_global.progress[ ng_global.currentprogress ][ "win_incapsule" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_incapsule" ].state = { -5866, { 640, 402, 1 }, 1, 3, 1 }; 

  cmn.Lock(1);
  local tme = 1;
  local old_x_back = private.state[1];

  ObjMultiSet( { {"tmr_incapsule_timer", { playing = 0, endtrig = "" }},
                 {"tmr_incapsule_timer_check", { playing = 0, endtrig = "" }},
                 {"tmr_incapsule_timer_check_env", { playing = 0, endtrig = "" }},
                 {"tmr_incapsule_timer_jump", { playing = 0, endtrig = "" }} } );

  if private.state[4] == 0 then
    --SndStop("assets/levels/level4/mg_slotmachine/audio/aud_gameover_mus", 1);
    ObjAnimate("obj_incapsule_background", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("obj_incapsule_lives", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("obj_incapsule_game_over", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  end;

  local hero_reapper = function ()
    ObjSet("obj_incapsule_hero",  { pos_x = 240, pos_y = 402 });
    ObjAnimate("obj_incapsule_hero", "alp", 0, 0, private.Win, { 0, 0, 0,   0.4, 0, 1 });
  end;

  local move_back = function ()
    ObjAnimate("obj_incapsule_background", "pos_x", 0, 0, hero_reapper, { 0, 0, old_x_back,   tme-0.5, 0, -5866 });
  end;

  if private.state[1] > -5866 then
    tme = 0.0003*(private.state[1]+5866) + 0.5;
    ObjAnimate("obj_incapsule_hero", "alp", 0, 0, move_back, { 0, 0, 1,   0.5, 0, 0 });
  else 
    ObjAnimate("obj_incapsule_hero", "alp", 0, 0, hero_reapper, { 0, 0, 1,   0.5, 0, 0 });
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_incapsule" ].state;
  --ObjSet("tmr_incapsule_timer_reset",  { time = tme, playing = 1, endtrig = private.Win });

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_incapsule" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_incapsule" ].state = { 0, { 240, 402, 1 }, 1, 3, 0 }; 
  --[1] - pos of background, [2] - pos and direction of hero; [3] - hero state, [4] - lives left

end;
-----------------------------------------------------------------------------------
function private.StartGame()
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    private.CheckWin();
    
    if ng_global.currentprogress == "std" then
    
      cmn.MiniGameShow();
      cmn.StartTimePassing("mg_incapsule");
      
      cmn.CallEventHandler("opn_incapsule");
      
    else 
      rm_extra.MiniGameShow();
    end;
    
    ObjMultiSet( { {"obj_incapsule_hero", { alp = 1 }},
                   {"anm_incapsule_start_mg", { alp = 0, frame = 0, playing = 0, endtrig = "" }},
                   {"anm_incapsule_start_mg_0", { alp = 0, frame = 0, playing = 0, endtrig = "" }} } );
    
  end;
                 
  local anm_start_3 = function () 
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_robotic_begin");
    ObjSet("anm_incapsule_start_mg",  { alp = 1, playing = 1, endtrig = func_after });
  end;
  
  local anm_start_2 = function () 
    ObjAnimate("anm_incapsule_start_mg_0", "alp", 0, 0, anm_start_3, { 0, 0, 1,   0.5, 0, 0 });
    ObjSet("spr_incapsule_game_scan_back",  { alp = 0 });
  end;
  
  local anm_start_1 = function () 
    ObjDelete("anm_incapsule_scan");
    ObjSet("anm_incapsule_start_mg_0",  { alp = 1, playing = 1, endtrig = anm_start_2 });
  end;
  
  local anm_scan_2 = function ()
    ObjSet("anm_incapsule_scan",  { frame = 0, animfunc = "func_start_scaning_2", playing = 1, endtrig = anm_start_1 });
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_robotic_inside_body");
  
  ObjSet("anm_incapsule_scan",  { alp = 1, playing = 1, endtrig = anm_scan_2 });
  
end;
-----------------------------------------------------------------------------------
function private.DrawScene( restart )
  
  --private.state[2][2] = 402;
  
  if private.state[4] == 0 then
    
    SndPlay( "assets/levels/level2/audio/sfx/aud_mmg_robotic_alarm_die", "sfx", 1, 0, 0.5 );

    ObjMultiSet( { {"obj_incapsule_button_6", { alp = 1, input = 1 }},
                   {"obj_incapsule_game_restart", { input = 1 }},
                   {"obj_incapsule_buttons", { input = 0, alp = 0 }},
                   {"obj_incapsule_background", { alp = 0 }},
                   {"obj_incapsule_hero", { alp = 0 }},
                   {"obj_incapsule_lives", { alp = 0 }},
                   {"obj_incapsule_game_over", { alp = 1 }},
                   {"txt_incapsule_button_6_text", { text = StringGet("str_incapsule_restart") }} } );

  else 
                   
    if cmn.IsEventDone("opn_incapsule") then
      ObjSet("obj_incapsule_hero",  { alp = 1 });
    else 
      ObjSet("obj_incapsule_hero",  { alp = 0 });
    end;

    ObjMultiSet( { {"obj_incapsule_background", { alp = 1, pos_x = private.state[1] }},
                   {"obj_incapsule_hero", { pos_x = private.state[2][1], pos_y = private.state[2][2], scale_x = private.state[2][3] }},
                   {"tmr_incapsule_timer_check", { time = 0.1, playing = 1, endtrig = function () private.HeroDie(false); end }},
                   {"tmr_incapsule_timer_check_env", { time = 0.1, playing = 1, endtrig = private.PlayObstacleEnv }},
                   {"obj_incapsule_button_6", { alp = 0, input = 0 }},
                   {"obj_incapsule_game_restart", { input = 0 }},
                   {"obj_incapsule_buttons", { input = 1 }},
                   {"obj_incapsule_lives", { alp = 1 }},
                   {"obj_incapsule_game_over", { alp = 0 }} } );

    for i = 1, 5, 1 do
    
      if private.state[3] == i then
        ObjSet("anm_incapsule_hero_"..private.hero_state[i],  { alp = 1, playing = 1 });
      else 
        ObjSet("anm_incapsule_hero_"..private.hero_state[i],  { alp = 0, playing = 0 });
      end;
      
    end;

    for i = 1, private.state[4], 1 do
      ObjSet("spr_incapsule_life_"..i,  { alp = 1 });
    end;

    for i = private.state[4]+1, 3, 1 do
      ObjSet("spr_incapsule_life_"..i,  { alp = 0 });
    end;

    if restart and not private.in_progress then
      
      private.in_progress = true;

      private.MoveAnimal( true, "ameba_1" );
      private.MoveAnimal( false, "star_1" );
      private.MoveAnimal( true, "star_2" );
      private.MoveBall();
      private.MoveDoors( true );

    end;
    
    if private.state[3] == 6 or private.state[5] == 1 then
      
      ObjMultiSet( { {"obj_incapsule_button_6",  { event_mup = private.Win, alp = 1, input = 1 }},
                     {"obj_incapsule_buttons", { alp = 0, input = 0 }},
                     {"anm_incapsule_hero_"..private.hero_state[1],  { alp = 1, playing = 1 }},
                     {"txt_incapsule_button_6_text", { text = StringGet("str_incapsule_attack") }} } );
      
    end;

  end;

end;
-----------------------------------------------------------------------------------
--focus/unfocus buttons
function public.ButtonsFocus( butt, inout )
   --[[
  local obj = "spr_incapsule_button_"..butt.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = 0;

  local obj_1 = "";
  local obj_2 = "";
  local alp_1 = 0;
  local alp_2 = 0;

  if butt == 4 then
   obj_1 = "spr_incapsule_button_1_focus";
   obj_2 = "spr_incapsule_button_3_focus";
  elseif butt == 5 then
   obj_1 = "spr_incapsule_button_2_focus";
   obj_2 = "spr_incapsule_button_3_focus";
  end;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alp * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alp ) * 0.3;
  end;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 0, alp,
    tme, 0, inout
  } );

  if obj_1 ~= "" then
    alp_1 = ObjGet( obj_1 ).alp;
    alp_2 = ObjGet( obj_2 ).alp;
    ObjAnimate(obj_1, "alp", 0, 0, "", { 0, 0, alp_1,   tme, 0, inout });
    ObjAnimate(obj_2, "alp", 0, 0, "", { 0, 0, alp_2,   tme, 0, inout });
  end;

  --mouse leave - release button if it is pressed
  if butt < 6 and inout == 0 and ObjGet("spr_incapsule_button_"..butt).alp < 1 then
    public.ButtonRelease( butt );
  end;
  ]]
end;
-----------------------------------------------------------------------------------
--press start button
function public.PressStart(flag)

  cmn.Lock(1);
  
  SndStop("assets/levels/level2/audio/sfx/aud_mmg_robotic_alarm_die", 0.5);

  private.StartConditions();
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_incapsule" ].state;

  private.DrawScene(true);

  local restart_game = function ()

    --cmn.PlayAudio("mus", "assets/levels/level4/mg_slotmachine/audio/aud_slotmashine_mus", 1);
    cmn.Lock(0);
    ObjMultiSet( { {"obj_incapsule_button_6", { input = 0 }},
                   {"obj_incapsule_game_restart", { input = 0 }},
                   {"obj_incapsule_buttons", { input = 1 }},
                   {"anm_incapsule_start_mg", { alp = 0, frame = 0, playing = 0, endtrig = "" }},
                   {"anm_incapsule_start_mg_0", { alp = 0, frame = 0, playing = 0, endtrig = "" }},
                   {"obj_incapsule_hero", { alp = 1 }} } );

  end;

  --ObjAnimate("obj_incapsule_button_6", "alp", 0, 0, restart_game, { 0, 0, 1,   0.5, 0, 0 });

  if flag then
    
    ObjAnimate("obj_incapsule_button_6", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });

    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_robotic_restart");

    --SndStop("assets/levels/level4/mg_slotmachine/audio/aud_gameover_mus", 1);
    
    ObjAnimate("obj_incapsule_buttons", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });

    ObjAnimate("obj_incapsule_background", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    --ObjAnimate("obj_incapsule_hero", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("obj_incapsule_lives", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    --ObjAnimate("obj_incapsule_game_over", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
    local anm_start_3 = function () 
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_robotic_begin");
      ObjSet("anm_incapsule_start_mg",  { frame = 0, alp = 1, playing = 1, endtrig = restart_game });
    end;
    
    local anm_start_2 = function () 
      ObjAnimate("anm_incapsule_start_mg_0", "alp", 0, 0, anm_start_3, { 0, 0, 1,   0.5, 0, 0 });
    end;
    
    ObjMultiSet( { {"anm_incapsule_start_mg_0",  { frame = 0, alp = 1, playing = 1, endtrig = anm_start_2 }},
                   {"obj_incapsule_game_over", { alp = 0 }},
                   {"obj_incapsule_hero", { alp = 0 }} } );
                   
  else
    ObjAnimate("obj_incapsule_button_6", "alp", 0, 0, restart_game, { 0, 0, 1,   0.5, 0, 0 });
  end;

end;
-----------------------------------------------------------------------------------
--press button - start act
function public.ButtonDown( butt )

  --cmn.PlayAudio("snd", "assets/levels/level4/mg_slotmachine/audio/aud_pushthebutton");

  private.but_num = butt;
  --anim button press
  local obj = "spr_incapsule_button_"..butt;
  local alp = ObjGet( obj ).alp;
  local tme = alp * 0.3;

  --ObjAnimate(obj, "alp", 0, 0, "", { 0, 0, alp,   tme, 0, 0 });

  --start action
  local state = 0;
  local dir = 0;

  if butt == 1 then
    state = 2;
    dir = -1;
  elseif butt == 2 then
    state = 2;
    dir = 1;
  elseif butt == 3 then
    state = 3;
    dir = 2;
  elseif butt == 4 then
    state = 3;
    dir = -1;
  elseif butt == 5 then
    state = 3;
    dir = 1;
  end;

  if dir < 2 and private.state[2][3] ~= dir then
    private.state[2][3] = dir;
  end;

  local old_sate = private.state[3];
  private.state[3] = state;
  
  private.MoveHero( dir, state );
  
  --if not ( private.in_air and state == 2 ) then
    private.ChangeHeroState( old_sate, state );
  --end;

end;
-----------------------------------------------------------------------------------
--release button - stop act
function public.ButtonRelease( butt )

  --anim button release
  local obj = "spr_incapsule_button_"..butt;
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * 0.3;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 0, alp,   tme, 0, 1 });

  --stop action
  if private.state[3] ~= 3 and private.state[3] ~= 1 and not private.die and not private.in_air and not private.falling then
    private.ChangeHeroState( private.state[3], 1 );
  end;

  if private.state[3] < 6 then
    private.state[3] = 1;
  end;

  ObjSet("tmr_incapsule_timer",  { playing = 0, endtrig = "" });

end;
-----------------------------------------------------------------------------------
--change anim of hero
function private.ChangeHeroState( state1, state2 )

  --DbgTrace("ChangeHeroState "..state1.." "..state2);

  --DbgTrace("state "..private.state[3]);
--  if private.die then
--    DbgTrace("die");
--  else 
--    DbgTrace("not die");
--  end;

  if state2 ~= 2 then
    SndStop("assets/levels/level2/audio/sfx/aud_mmg_robotic_loop_move", 0.5);
  end;

  --for i = 1, 5, 1 do
  --  ObjSet("anm_incapsule_hero_"..private.hero_state[i],  { alp = 0, playing = 0, endtrig = "" });
  --end;

  if private.state[3] < 6 and state1 ~= state2 and state1 ~= 5 then

    if state2 == 2 and not private.in_air then
      SndPlay( "assets/levels/level2/audio/sfx/aud_mmg_robotic_loop_move", "sfx", 1, 0, 0.5 );
    elseif state2 == 3 and not private.in_air then
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_robotic_jump");
    elseif state2 == 5 then
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_robotic_die");
    elseif state1 == 4 then
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_robotic_ground");
    end;

  --no need
--    if not private.in_air and state1 == 4 then
--
--      ObjMultiSet( { {"anm_incapsule_hero_"..private.hero_state[3], { alp = 0, playing = 0, endtrig = "" }},
--                     {"anm_incapsule_hero_"..private.hero_state[4], { alp = 0, playing = 0, endtrig = "" }},
--                     {"anm_incapsule_hero_"..private.hero_state[state2], { alp = 1, playing = 1, endtrig = "" }},
--                     {"obj_incapsule_hero", { scale_x = private.state[2][3] }} } );

    if state1 ~= 3 and state2 ~= 3 and not private.in_air and not private.die then

      ObjMultiSet( { {"anm_incapsule_hero_"..private.hero_state[state1], { alp = 0, playing = 0, endtrig = "" }},
                     {"anm_incapsule_hero_"..private.hero_state[state2], { frame = 0, alp = 1, playing = 1, endtrig = "" }},
                     {"obj_incapsule_hero", { scale_x = private.state[2][3] }} } );

    elseif private.in_air and state2 == 5 then

      ObjMultiSet( { {"anm_incapsule_hero_"..private.hero_state[1], { alp = 0, playing = 0, endtrig = "" }},
                     {"anm_incapsule_hero_"..private.hero_state[3], { alp = 0, playing = 0, endtrig = "" }},
                     {"anm_incapsule_hero_"..private.hero_state[4], { alp = 0, playing = 0, endtrig = "" }},
                     {"anm_incapsule_hero_"..private.hero_state[5], { frame = 0, alp = 1, playing = 1 }},
                     {"obj_incapsule_hero", { scale_x = private.state[2][3] }} } );
    
    elseif private.die then

      ObjMultiSet( { {"anm_incapsule_hero_"..private.hero_state[1], { alp = 0, playing = 0, endtrig = "" }},
                     {"anm_incapsule_hero_"..private.hero_state[state1], { alp = 0, playing = 0, endtrig = "" }},
                     {"anm_incapsule_hero_"..private.hero_state[state2], { frame = 0, alp = 1, playing = 1, endtrig = "" }},
                     {"obj_incapsule_hero", { scale_x = private.state[2][3] }} } );

    --start jump
    elseif state2 == 3 and not private.in_air and not private.die then

      private.HeroJump();
      private.in_air = true;
      
      ObjMultiSet( { {"anm_incapsule_hero_"..private.hero_state[state1], { alp = 0, playing = 0, endtrig = "" }},
                     {"anm_incapsule_hero_"..private.hero_state[state2], { frame = 0, alp = 1, playing = 1 }}, 
                     {"obj_incapsule_hero", { scale_x = private.state[2][3]  }} } );

      --ObjMultiSet( { {"anm_incapsule_hero_"..private.hero_state[state1], { alp = 0, playing = 0, endtrig = "" }},
      --               {"anm_incapsule_hero_"..private.hero_state[state2], { frame = 0, alp = 1, playing = 1, endtrig = function () private.ChangeHeroState( 3, 4 ); end }}, 
      --               {"obj_incapsule_hero", { scale_x = private.state[2][3]  }} } );

    --end jump
    --elseif state1 == 3 or private.falling then
    elseif state2 == 4 and not private.die then

      --private.state[3] = 4;
      
      ObjMultiSet( { {"anm_incapsule_hero_"..private.hero_state[1], { alp = 0, playing = 0, endtrig = "" }},
                     {"anm_incapsule_hero_"..private.hero_state[state1], { alp = 0, playing = 0, endtrig = "" }},
                     {"anm_incapsule_hero_"..private.hero_state[state2], { frame = 0, alp = 1, playing = 1 }},
                     {"obj_incapsule_hero", { scale_x = private.state[2][3]  }} } );
                     
      --if not private.falling then
      --  ObjSet("anm_incapsule_hero_"..private.hero_state[state2],  { playing = 1 });
      --end;

    end;

  end;

end;
-----------------------------------------------------------------------------------
--movement of hero and background
function private.MoveHero( direction, state )

  local speed = 10;
  local back_border = {0, -5866};
  local hero_border = {106, 924};

  local old_x_hero = private.state[2][1];
  local old_x_back = private.state[1];

  local obst = 0;
  local stop_x = false;
  local hero_size = {110, 132};
  local ground = 402;
  
  if private.in_air then
    speed = 15;
  end;
  
  if private.state[3] < 6 then

    --check for any obstacle in a way
    for i = 1, #private.obstacles, 1 do
    
      if direction > 0 then
        
        if private.state[2][1] + hero_size[1]/2 >= private.state[1] + private.obstacles[i][1] and
           private.state[2][1] + hero_size[1]/2 <= private.state[1] + private.obstacles[i][1] + private.obstacles[i][2] then

            obst = i;
            if ObjGet("obj_incapsule_hero").pos_y > ground - private.obstacles[i][3] then
              stop_x = true;
            else  
              stop_x = false;
            end;

          break;

        else  

          stop_x = false;

        end;

      elseif direction < 0 then

        if private.state[2][1] - hero_size[1]/2 <= private.state[1] + private.obstacles[i][1] + private.obstacles[i][2] and 
           private.state[2][1] - hero_size[1]/2 >= private.state[1] + private.obstacles[i][1] then

            obst = i;
            if ObjGet("obj_incapsule_hero").pos_y > ground - private.obstacles[i][3] then
              stop_x = true;
            else  
              stop_x = false;
            end;

          break;

        else  

          stop_x = false;

        end;

      end;

  --    if ObjIntersect("obj_incapsule_hero", "obj_incapsule_obstacle_"..i) then
  --
  --      obst = i;
  --      if ObjGet("obj_incapsule_hero").pos_y > ground - private.obstacles[i][3] then
  --        stop_x = true;
  --      else  
  --        stop_x = false;
  --      end;
  --
  --    end;
      
    end;

    if private.CheckForDoor( private.doors_closed ) then
      stop_x = true;
    end;

    --DbgTrace(obst); --right obst in each frame!!!

  --  if private.cur_obstacle ~= obst and not private.in_air then
  --
  --    if obst == 0 then
  --      private.state[2][2] = ground;
  --    else
  --      private.state[2][2] = ground - private.obstacles[obst][3];
  --    end;
  --
  --  end;

    private.cur_obstacle = obst;

    if obst > 0 then
      private.stop_point = ground - private.obstacles[obst][3];
    else
      private.stop_point = ground;
    end;

    if not private.in_air then

      local fall_to = ground;
      if obst ~= 0 then
        fall_to = ground - private.obstacles[obst][3];
      end;
      private.HeroFallGround(fall_to);

    end;

    if not stop_x then

      --move in axis x
      if (private.state[2][1] >= 512 and direction == 1 and private.state[1] >= back_border[2]+speed) or 
         (private.state[2][1] <= 512 and direction < 0 and private.state[1] <= back_border[1]-speed) then

        private.state[1] = private.state[1] - speed*direction;

      elseif (private.state[2][1] <= hero_border[2]-speed and direction == 1) or
             (private.state[2][1] >= hero_border[1]+speed and direction < 0) then

        private.state[2][1] = private.state[2][1] + speed*direction;

      end;

    end;

    ObjSet("obj_incapsule_hero",  { scale_x = private.state[2][3] });

    local anm_move = function ()
      
      ObjSet("tmr_incapsule_timer",  { time = 0.1, playing = 1, endtrig = function () private.CheckWin(); private.MoveHero( direction, state ); end });

      ObjAnimate("obj_incapsule_background", "pos_x", 0, 0, "", { 0, 0, old_x_back,   0.1, 0, private.state[1] });
      ObjAnimate("obj_incapsule_hero", "pos_x", 0, 0, "", { 0, 0, old_x_hero,   0.1, 0, private.state[2][1] });

    end;

    --delay of movement in jump
    if state == 3 and not private.in_air then
      ObjSet("tmr_incapsule_timer",  { time = 0.3, playing = 1, endtrig = anm_move });
    else 
      anm_move();
    end;
    
  end;

end;
-----------------------------------------------------------------------------------
--check for fall from obstacle to ground
function private.HeroFallGround(fall_to)

  local cur_y = ObjGet("obj_incapsule_hero").pos_y;

  if fall_to > cur_y and not private.in_air and not private.die then
    private.state[2][2] = fall_to;
    private.in_air = true;
    private.falling = true;
    local tme = 0.005*(fall_to-cur_y);
    private.ChangeHeroState( private.state[3], 4 );
    ObjAnimate("obj_incapsule_hero", "pos_y", 0, 0, function () private.in_air = false; private.falling = false; private.ChangeHeroState( 4, private.state[3] ); end, { 0, 1, cur_y,   tme, 2, fall_to });
  else 
    private.in_air = false;
    private.falling = false;
  end;

end;
-----------------------------------------------------------------------------------
--check for fall
function private.HeroFall()

  local hero_size = {110, 132};
  local ground = 402;
  local obst_num = {3, 5};
  local obst = 0;

  local game_over = function ()

    local start_button = function ()

      private.die = false;
      private.in_air = false;
      
      ObjMultiSet( { {"obj_incapsule_button_6", { input = 1 }},
                     {"txt_incapsule_button_6_text", { text = StringGet("str_incapsule_restart") }},
                     {"obj_incapsule_game_restart", { input = 1 }},
                     {"obj_incapsule_buttons", { input = 0 }} } );

      ObjAnimate("obj_incapsule_button_6", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 0,   0.5, 0, 1 });

    end;
      
    ObjAnimate("obj_incapsule_buttons", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });

    ObjAnimate("obj_incapsule_background", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("obj_incapsule_hero", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("obj_incapsule_lives", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("obj_incapsule_game_over", "alp", 0, 0, start_button, { 0, 0, 0,   0.5, 0, 1 });

  end;

  local set_hero = function ()

    local hero_new_pos = function ()

      private.DrawScene();

      ObjAnimate("obj_incapsule_hero", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 0,   0.5, 0, 1 });

    end;

    local move_back = function ()

      private.die = false;
      private.in_air = false;

      local old_x_back = private.state[1];
      private.state[1] = private.checkpoins[obst];
      ObjAnimate("obj_incapsule_background", "pos_x", 0, 0, hero_new_pos, { 0, 0, old_x_back,   0.5, 0, private.state[1] });

    end;

    ObjAnimate("obj_incapsule_hero", "alp", 0, 0, move_back, { 0, 0, 1,   0.5, 0, 0 });

  end;

  for i = 1, 2, 1 do

    --fall
    if (private.state[2][1] > private.state[1]+private.precipice[i][1] and private.state[2][1] < private.state[1]+private.precipice[i][2]) and
       (ObjGet("obj_incapsule_hero").pos_y >= ground) then

      obst = obst_num[i];
      private.die = true;
      
      --DbgTrace("fall")

      cmn.Lock(1);
      private.ChangeHeroState( private.state[3], 4 );

      private.state[2][2] = 402;
      private.state[3] = 1;
      private.state[2][3] = 1;

      ObjMultiSet( { {"tmr_incapsule_timer", { playing = 0, endtrig = "" }},
                     {"tmr_incapsule_timer_check", { playing = 0, endtrig = "" }},
                     {"tmr_incapsule_timer_jump", { playing = 0, endtrig = "" }} } );

      ObjStopAnimate("obj_incapsule_hero", "pos_y");

      private.state[4] = private.state[4] - 1;

      local func_after = function ()

        --ObjSet("tmr_incapsule_timer", { playing = 0, endtrig = "" });
        private.ChangeHeroState( 4, 5 );

        if private.state[4] == 0 then
          ObjAnimate("spr_incapsule_life_"..(private.state[4]+1), "alp", 0, 0, game_over, { 0, 0, 1,   0.1, 0, 0,    0.2, 0, 1,    0.3, 0, 0,  0.4, 0, 1,    0.5, 0, 0,    1, 0, 0 });
        else 
          ObjAnimate("spr_incapsule_life_"..(private.state[4]+1), "alp", 0, 0, set_hero, { 0, 0, 1,   0.1, 0, 0,    0.2, 0, 1,    0.3, 0, 0,  0.4, 0, 1,    0.5, 0, 0 });
        end;

      end;

      --ObjSet("tmr_incapsule_timer", { time = 0.5, playing = 1, endtrig = func_after });
      ObjAnimate("obj_incapsule_hero", "pos_y", 0, 0, func_after, { 0, 1, private.state[2][2],   0.5, 2, private.state[2][2]+60 });

      break;

    end;
    
  end;

end;
-----------------------------------------------------------------------------------
--add height to the jump
function private.HeroJump()
  
  local j_tme = 2;

  local jump_height = 220;
  local end_jump = private.state[2][2]-jump_height;
  local dev = 0;
  
  private.start_jump = true;
  
  --if end_jump < 160 then
  --  dev = 160 - end_jump;
  --  end_jump = 160;
  --end;

  local func_after = function ()
    private.start_jump = false;
    ObjAnimate("obj_incapsule_hero", "pos_y", 0, 0, function () private.HeroEndJump(private.state[2][2]); end, { 0, 2, start_jump,   j_tme, 2, end_jump });
  end;

  --jump
  if private.state[3] == 3 and not private.in_air then
    local start_jump = private.state[2][2];
    private.state[2][2] = private.state[2][2]-jump_height;
    --ObjAnimate("obj_incapsule_hero", "pos_y", 0, 0, func_after, { 0, 0, start_jump,   0.4, 0, start_jump });
    
    ObjSet("tmr_incapsule_timer_jump",  { time = j_tme-0.3, playing = 1, endtrig = function () private.ChangeHeroState( 3, 4 ); end });
    
    ObjAnimate("obj_incapsule_hero", "pos_y", 0, 0, function () private.HeroEndJump(private.state[2][2]); end, { 0, 0, start_jump,   0.2, 2, start_jump,   j_tme, 2, end_jump });
  end;

end;

function private.HeroEndJump(start_point)
  
  --DbgTrace(dev)

  local jump_height = 220;
  local tme = 0.6;
  local ground = 402;
  local continue = true;

  local cur_y = ObjGet("obj_incapsule_hero").pos_y;

  local fall_to = ground;

  if private.cur_obstacle ~= 0 then
    fall_to = ground-private.obstacles[private.cur_obstacle][3];
  end;

  if cur_y >= fall_to then
    private.state[2][2] = fall_to;
    continue = false;
  end;

  local func_after = function ()

    private.in_air = false;
    
    if not private.die then
      private.ChangeHeroState( 4, private.state[3] );
    end;

  end;
  
  if not private.die then

    --end jump
    if continue then
      ObjAnimate("obj_incapsule_hero", "pos_y", 0, 0, function () private.HeroEndJump(start_point+math.floor(jump_height/5)); end, { 0, 0, start_point,   0.1, 0, start_point+math.floor(jump_height/5) });
    else 
      ObjAnimate("obj_incapsule_hero", "pos_y", 0, 0, func_after, { 0, 0, cur_y,   0.1, 0, private.state[2][2] });
    end;
    
  end;

end;
-----------------------------------------------------------------------------------
--check if hit door
function private.CheckForDoor( param )
  
  local check = false;
  
  if param and ( ObjIntersect("obj_incapsule_hero", "obj_incapsule_door_1") or ObjIntersect("obj_incapsule_hero", "obj_incapsule_door_2") ) then
    check = true;
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
--check if hit any death obstacle
function private.HeroDie(fall)
  
  if not fall and not private.die then
    ObjSet("tmr_incapsule_timer_check",  { time = 0.1, playing = 1, endtrig = function () private.HeroDie(false); end });
    private.HeroFall();
  end;

  local hero_size = {50, 92};
  local ground = 402;
  local obst = 0;

  local game_over = function ()

    --SndStop("assets/levels/level4/mg_slotmachine/audio/aud_gameover_mus", 1);
    SndPlay( "assets/levels/level2/audio/sfx/aud_mmg_robotic_alarm_die", "sfx", 1, 0, 0.5 );

    private.die = false;
    private.in_air = false;

    local start_button = function ()

      --cmn.PlayAudio("mus", "assets/levels/level4/mg_slotmachine/audio/aud_gameover_mus", 1);

      ObjMultiSet( { {"obj_incapsule_button_6", { input = 1 }},
                     {"txt_incapsule_button_6_text", { text = StringGet("str_incapsule_restart") }},
                     {"obj_incapsule_game_restart", { input = 1 }},
                     {"obj_incapsule_buttons", { input = 0 }} } );
                     
      ObjAnimate("obj_incapsule_button_6", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 0,   0.5, 0, 1 });

    end;

    --for i = 1, #private.death_obstacles, 1 do
    --  SndStop("assets/levels/level4/mg_slotmachine/audio/"..private.obstacle_env[i], 0.5);
    --end;
  
    ObjAnimate("obj_incapsule_buttons", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });

    ObjAnimate("obj_incapsule_background", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("obj_incapsule_hero", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("obj_incapsule_lives", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("obj_incapsule_game_over", "alp", 0, 0, start_button, { 0, 0, 0,   0.5, 0, 1 });

  end;

  local set_hero = function ()

    private.die = false;
    private.in_air = false;

    local hero_new_pos = function ()

      private.DrawScene();

      ObjAnimate("obj_incapsule_hero", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 0,   0.5, 0, 1 });

    end;

    local move_back = function ()

      local old_x_back = private.state[1];
      private.state[1] = private.checkpoins[obst];
      
      if obst == 1 then
        private.state[2][1] = 240;
      end;
      
      private.state[2][2] = ground;
      ObjAnimate("obj_incapsule_background", "pos_x", 0, 0, hero_new_pos, { 0, 0, old_x_back,   0.5, 0, private.state[1] });

    end;

    ObjAnimate("obj_incapsule_hero", "alp", 0, 0, move_back, { 0, 0, 1,   0.5, 0, 0 });

  end;

  if private.CheckForDoor( private.doors_closing ) then
    
    obst = #private.death_obstacles+1;
    private.die = true;

    cmn.Lock(1);
    ObjStopAnimate("obj_incapsule_hero", "pos_x");
    ObjStopAnimate("obj_incapsule_hero", "pos_y");
    private.ChangeHeroState( private.state[3], 5 );

    private.state[2][2] = 402;
    private.state[3] = 1;
    private.state[2][3] = 1;
    private.state[4] = private.state[4] - 1;

    if private.state[4] == 0 then
      ObjMultiSet( { {"tmr_incapsule_timer", { playing = 0, endtrig = "" }},
                     {"tmr_incapsule_timer_check", { playing = 0, endtrig = "" }},
                     {"tmr_incapsule_timer_check_env", { playing = 0, endtrig = "" }},
                     {"tmr_incapsule_timer_jump", { playing = 0, endtrig = "" }} } );
      ObjAnimate("spr_incapsule_life_"..(private.state[4]+1), "alp", 0, 0, game_over, { 0, 0, 1,   0.1, 0, 0,    0.2, 0, 1,    0.3, 0, 0,  0.4, 0, 1,    0.5, 0, 0,    1, 0, 0 });
    else 
      ObjMultiSet( { {"tmr_incapsule_timer", { playing = 0, endtrig = "" }},
                     {"tmr_incapsule_timer_check", { playing = 0, endtrig = "" }},
                     {"tmr_incapsule_timer_jump", { playing = 0, endtrig = "" }} } );
      ObjAnimate("spr_incapsule_life_"..(private.state[4]+1), "alp", 0, 0, set_hero, { 0, 0, 1,   0.1, 0, 0,    0.2, 0, 1,    0.3, 0, 0,  0.4, 0, 1,    0.5, 0, 0 });
    end;
    
  else

    for i = 1, #private.death_obstacles, 1 do
    
      if ObjIntersect("obj_incapsule_hero", "obj_incapsule_"..private.death_obstacles[i]) then

        obst = i;
        private.die = true;

        cmn.Lock(1);
        ObjStopAnimate("obj_incapsule_hero", "pos_x");
        ObjStopAnimate("obj_incapsule_hero", "pos_y");
        private.ChangeHeroState( private.state[3], 5 );

        private.state[2][2] = 402;
        private.state[3] = 1;
        private.state[2][3] = 1;
        private.state[4] = private.state[4] - 1;
        
        --DbgTrace("die")

        if private.state[4] == 0 then
          ObjMultiSet( { {"tmr_incapsule_timer", { playing = 0, endtrig = "" }},
                         {"tmr_incapsule_timer_check", { playing = 0, endtrig = "" }},
                         {"tmr_incapsule_timer_check_env", { playing = 0, endtrig = "" }},
                         {"tmr_incapsule_timer_jump", { playing = 0, endtrig = "" }} } );
          ObjAnimate("spr_incapsule_life_"..(private.state[4]+1), "alp", 0, 0, game_over, { 0, 0, 1,   0.1, 0, 0,    0.2, 0, 1,    0.3, 0, 0,  0.4, 0, 1,    0.5, 0, 0,    1, 0, 0 });
        else 
          ObjMultiSet( { {"tmr_incapsule_timer", { playing = 0, endtrig = "" }},
                         {"tmr_incapsule_timer_check", { playing = 0, endtrig = "" }},
                         {"tmr_incapsule_timer_jump", { playing = 0, endtrig = "" }} } );
          ObjAnimate("spr_incapsule_life_"..(private.state[4]+1), "alp", 0, 0, set_hero, { 0, 0, 1,   0.1, 0, 0,    0.2, 0, 1,    0.3, 0, 0,  0.4, 0, 1,    0.5, 0, 0 });
        end;

        break;

      end;
      
    end;
    
  end;

end;
-----------------------------------------------------------------------------------
--sounds of animals and hydrants
function private.PlayObstacleEnv()

--  ObjSet("tmr_incapsule_timer_check_env",  { time = 0.1, playing = 1, endtrig = private.PlayObstacleEnv });
--
--  local cur_x;
--
--  for i = 1, #private.death_obstacles, 1 do
--
--    if private.death_obstacles[i] ~= "precipice" then
--
--      cur_x = ObjGet("obj_incapsule_"..private.death_obstacles[i]).pos_x;
--    
--      --we see obstacle on screen
--      if cur_x < 865-private.state[1]-private.obstacle_dif_inspace[i] and cur_x > math.abs(private.state[1])+184-private.obstacle_dif_inspace[i] and private.obstacle_env_playing[i] == 0 then
--        private.obstacle_env_playing[i] = 1;
--        SndPlay( "assets/levels/level4/mg_slotmachine/audio/"..private.obstacle_env[i], "env", 1, 0, 0.5 );
--      elseif private.obstacle_env_playing[i] == 1 and not( cur_x < 865-private.state[1] and cur_x > math.abs(private.state[1]) ) then
--        private.obstacle_env_playing[i] = 0;
--        SndStop("assets/levels/level4/mg_slotmachine/audio/"..private.obstacle_env[i], 0.5);
--      end;
--
--    end;
--    
--  end;

end;
-----------------------------------------------------------------------------------
--movement of doors
function private.MoveDoors( direction )
  
  local func_set_1 = function ()
    private.doors_closed = true;
    private.doors_closing = false;
  end;
  local func_set_2 = function ()
    private.doors_closed = false;
  end;
  
  if direction then
    ObjAnimate("obj_incapsule_door_1", "ang", 0, 0, func_set_2, { 0, 0, 0,   1, 0, -2.15 });
    ObjAnimate("obj_incapsule_door_2", "ang", 0, 0, "", { 0, 0, 0,   1, 0, 2.15 });
  else 
    private.doors_closing = true;
    ObjAnimate("obj_incapsule_door_1", "ang", 0, 0, func_set_1, { 0, 0, -2.15,   1, 0, 0 });
    ObjAnimate("obj_incapsule_door_2", "ang", 0, 0, "", { 0, 0, 2.15,   1, 0, 0 });
  end;
  
  ObjSet("tmr_incapsule_timer_doors",  { time = 5, playing = 1, endtrig = function() private.MoveDoors( not direction ) end });
  
end;
-----------------------------------------------------------------------------------
--movement of coral ball
function private.MoveBall()
  
  ObjAnimate("obj_incapsule_ball", "scale_xy", 1, 0, "", { 0, 0, 0, 0,   0.066, 0, 0, 0,   0.65, 0, 1, 1,   1.71, 0, 1, 1,   1.7167, 0, 0, 0 });
  ObjAnimate("obj_incapsule_ball", "pos_y", 1, 0, "", { 0, 0, 318,   0.95, 0, 318,  1.25, 0, 11,  1.7167, 0, 11 });
  
end;
-----------------------------------------------------------------------------------
--movement of animals
function private.MoveAnimal( direction, animal )

  local tme = private.animals_move[animal][3]*(private.animals_move[animal][2]-private.animals_move[animal][1]);

  local func_after = function ()
    private.MoveAnimal( not direction, animal );
  end;
  
  local inter = 0;
  
  if common.GetObjectPrefix( animal ) == "star" then
    if direction then
      inter = 1;
    else 
      inter = 2;
    end;
  end;
  
  if direction then
    ObjAnimate("obj_incapsule_"..animal, private.animals_move[animal][4], 0, 0, func_after, { 0, inter, private.animals_move[animal][1],   tme, inter, private.animals_move[animal][2] });
  else 
    ObjAnimate("obj_incapsule_"..animal, private.animals_move[animal][4], 0, 0, func_after, { 0, inter, private.animals_move[animal][2],   tme, inter, private.animals_move[animal][1] });
  end;

end; 
-----------------------------------------------------------------------------------
function private.CheckWin()

  if ObjIntersect("obj_incapsule_hero", "obj_incapsule_boss") or private.state[1] <= -5866 and private.state[2][1] >= 520 then
    
    ObjMultiSet( { {"tmr_incapsule_timer", { playing = 0, endtrig = "" }},
                   {"tmr_incapsule_timer_check", { playing = 0, endtrig = "" }},
                   {"tmr_incapsule_timer_check_env", { playing = 0, endtrig = "" }},
                   {"tmr_incapsule_timer_jump", { playing = 0, endtrig = "" }} } );

    private.state[3] = 6;
    private.state[5] = 1;
    local pos_x_h = private.state[2][1];
    local pos_y_h = private.state[2][2];
    private.state[2][1] = 240;
    private.state[2][2] = 402;
    
    ObjSet("obj_incapsule_hero",  { scale_x = 1 });
    ObjStopAnimate("obj_incapsule_hero", "pos_x");
    ObjStopAnimate("obj_incapsule_hero", "pos_y");

    cmn.Lock(1);
    
    local final_func = function ()
      
      SndStop("assets/levels/level2/audio/sfx/aud_mmg_robotic_loop_move", 0.5);
      
      ObjMultiSet( { {"obj_incapsule_button_6",  { event_mup = private.Win, input = 1 }},
                     {"obj_incapsule_buttons", { input = 0 }},
                     {"anm_incapsule_hero_stand", { alp = 1, playing = 1 }},
                     {"anm_incapsule_hero_runback", { alp = 0, playing = 0 }},
                     {"txt_incapsule_button_6_text", { text = StringGet("str_incapsule_attack") }} } );
      
      ObjAnimate("obj_incapsule_buttons", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_incapsule_button_6", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_walk = function ()
      
      SndPlay( "assets/levels/level2/audio/sfx/aud_mmg_robotic_loop_move", "sfx", 1, 0, 0.5 );
      
      for i = 1, 5, 1 do
      
        ObjSet("anm_incapsule_hero_"..private.hero_state[i],  { alp = 0, playing = 0, endtrig = "" });
        
      end;
      
      ObjSet("anm_incapsule_hero_runback",  { alp = 1, playing = 1 });
      ObjAnimate("obj_incapsule_hero", "pos_x", 0, 0, final_func, { 0, 0, pos_x_h,   2, 0, 240 });
      
    end;
    
    local anm_fall = function ()

      for i = 1, 5, 1 do
        if i ~= 4 then
          ObjSet("anm_incapsule_hero_"..private.hero_state[i],  { alp = 0, playing = 0, endtrig = "" });
        end;
      end;
      
      ObjSet("anm_incapsule_hero_land",  { alp = 1, playing = 1 });
      ObjAnimate("obj_incapsule_hero", "pos_y", 0, 0, anm_walk, { 0, 0, pos_y_h,   0.8, 0, 402 });
      
    end;
    
    if not private.in_air then
      anm_walk();
    else 
      anm_fall();
    end;

  else 

    

  end;
  
end;
-----------------------------------------------------------------------------------
function private.WinEnd()
  
  cmn.Lock( 0 );

  cmn.SetEventDone( "win_incapsule" );
  
  if ng_global.currentprogress == "std" then 
  
    cmn.CallEventHandler( "win_incapsule" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_incapsule" ].skip == 0 and not ng_global.noskipgames[ "win_incapsule" ] then

      ng_global.noskipgames[ "win_incapsule" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_incapsule" ] then
      ng_global.playedgames[ "win_incapsule" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    cmn.GotoRoom("rm_medicalsection");
    
  else 
    ObjSet("grm_incapsule_medicalsection",  { input = 0 });
    interface_impl.ShowStarsWindow();
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_robotic_win");
  
  if ng_global.currentprogress == "std" then 

    cmn.MiniGameHide();

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_incapsule" );
    
  else 
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
  end;
  
  ObjAnimate("obj_incapsule_button_6", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
  local anm_end_2 = function ()
    ObjMultiSet( { {"anm_incapsule_mg_win",  { playing = 1, endtrig = private.WinEnd }},
                   {"spr_incapsule_game_scan_back", { alp = 1 }} } );
  end;
  
  local anm_end = function ()
    ObjAnimate("anm_incapsule_mg_win", "alp", 0, 0, anm_end_2, { 0, 0, 0,   0.5, 0, 1 });
  end;

  ObjMultiSet( { {"obj_incapsule_hero", { alp = 0 }},
                 {"anm_incapsule_boss", { alp = 0, playing = 0 }},
                 {"anm_incapsule_final", { alp = 1, playing = 1, endtrig = anm_end }} } );

end;
--*********************************************************************************************************************
function private.CreateNewObjects()
  
  ObjMultiSet( { {"spr_incapsule_game_scan_back", { alp = 1 }},
                 {"obj_incapsule_buttons", { alp = 1, input = 1 }},
                 {"anm_incapsule_final", { alp = 0, frame = 0 }},
                 {"anm_incapsule_boss", { alp = 1, playing = 1 }} } );
  
  for j = 1, #private.start_actions, 1 do
      
    local nme = private.start_actions[j].name;
    
    if not ObjGet( nme ) then
      
      local typ = common.GetObjectPrefix( nme );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( nme, typ );
      ObjSet( nme, private.start_actions[j].prop );
      ObjAttach( nme, private.start_actions[j].parent );

    else 

      ObjSet( nme, private.start_actions[j].prop );
      ObjAttach( nme, private.start_actions[j].parent );

    end;
      
  end;
  
end;
--********************************************************************************************************************