-- name=mg_ventilation
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_ventilation";
  --------------------------------------------------------------------------------------------
  private.map_rooms = {
    {-297, -146, 0, 2}, {-84, -107, 3.14, 2}, {-122, -55, 1.57, 2}, {-247, 17, -1.57, 7}, {-124, 60, 1.57, 3},
    {-164, -62, -1.57, 1}, {-115, 19, 0, 2}, {-123, 145, -1.57, 2}, {-4, 18, -1.57, 4}, {34, 128, -1.57, 6},
    {75, -98, -1.57, 4}, {36, -16, 1.57, 1}, {156, -24, 1.57, 5}, {199, -63, -1.57, 1}, {158, -146, 1.57, 2},
    {160, -185, 0, 8}, {-247, 139, -1.57, 6}, {199, -152, -1.57, 1}, {241, 17, -1.57, 2}, {200, 59, 3.14, 2},
    {159, 19, 3.14, 1}, {159, 101, -1.57, 3}
  };
  private.map_connect = {
    { ["left"] = 2, ["right"] = 4, ["back"] = 1 }, { ["left"] = "trap_1", ["right"] = "trap_1", ["back"] = 1 },
    { ["left"] = "trap_1", ["right"] = "trap_1", ["back"] = 5 }, { ["left1"] = 5, ["left2"] = 8, ["front"] = 17, ["back"] = 1 },
    { ["left"] = 6, ["right"] = 7, ["front"] = 3, ["back"] = 4 }, { ["back"] = 5 },
    { ["left"] = 11, ["right"] = 9, ["back"] = 5 }, { ["left"] = "trap_7", ["right"] = "trap_7", ["back"] = 17 },
    { ["left"] = 10, ["front"] = "trap_3", ["back"] = 7 }, { ["left"] = "trap_5", ["back"] = 9 },
    { ["left"] = 13, ["front"] = 12, ["back"] = 7 }, { ["back"] = 11 },
    { ["right"] = 14, ["front"] = 15, ["back"] = 11 }, { ["back"] = 13 },
    { ["left"] = "trap_4", ["right"] = 16, ["back"] = 13 }, { ["right1"] = 18, ["right2"] = 19, ["back"] = 15 },
    { ["left"] = "trap_2", ["back"] = 4 }, { ["back"] = 16 },
    { ["left"] = 100, ["right"] = 20, ["back"] = 16 }, { ["left"] = 22, ["right"] = 21, ["back"] = 19 },
    { ["back"] = 20 }, { ["left"] = "trap_6", ["right"] = "trap_6", ["front"] = "trap_6", ["back"] = 20 }
  };
  
  private.room_anim = {
    {3, 5}, {10, 7}, {4, 6}, {10, 1, 7}, {10, 6},
    {1}, {2, 5, 10}, {1, 7}, {9, 4}, {10, 6},
    {10, 6}, {3, 10}, {8, 7}, {10}, {10, 3},
    {8, 2, 7}, {4, 6}, {10, 2}, {3, 5, 10}, {4, 6},
    {10, 7}, {3, 7}
  };
  
  private.trap_sounds = { "laser", "monster", "saw", "laser", "monster", "monster", "saw" };
  --------------------------------------------------------------------------------------------
  -- function win_ventilation () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_ventilation" ] = {
    type = "win",
    room = "rm_cargosection",
    zz = "mg_ventilation",
    zz_gate = "gmg_cargosection_ventilation"
  };
  --------------------------------------------------------------------------------------------
  local win_ventilation = function ()

    if cmn.IsEventDone( "win_ventilation" ) then
      
    end;

  end;
  local win_ventilation_loc = function ()

    if cmn.IsEventDone( "win_ventilation" ) then
      ObjSet("grm_cargosection_accomodations",  { alp = 1, input = 1 });
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_cargosection_accomodations_focus");
      end;
      ObjDelete("gmg_cargosection_ventilation");
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_ventilation", win_ventilation, "mg_ventilation" );
  cmn.AddSubscriber( "win_ventilation", win_ventilation_loc, "rm_cargosection" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_ventilation" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_ventilation" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/level2/audio/mus/aud_mg_ventilation_mus", 1);

  if ng_global.currentprogress == "std" and not private.CheckWin() and not(cmn.IsEventDone( "win_ventilation" )) then
    cmn.MiniGameShow();
  elseif ng_global.currentprogress == "secret" then
    rm_extra.MiniGameShow();
  end;
  
  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_ventilation" )) then
    cmn.StartTimePassing("mg_ventilation");
  end;
  
  if private.CheckWin() or cmn.IsEventDone( "win_ventilation" ) then
    private.Win();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv();

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_cargosection" );
  else 
    
    private.StartConditions();
    
    ObjSet("spr_ventilation_dark",  { alp = 0 });
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_ventilation" ].state;
    
    ObjSet("grm_ventilation_cargosection",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                         event_menter = function () rm_extra.GateMouseEnter( "ventilation_cargosection", CURSOR_DOWN, "extra" ); end, 
                                         event_mleave = function () common_impl.GateMouseLeave( "ventilation_cargosection" ); end });
                                     
  end;
    
  private.DrawScene();
  
  if private.CheckWin() or cmn.IsEventDone( "win_ventilation" ) then
    cmn.Lock( 1 );
    ObjMultiSet( { {"obj_ventilation_rooms", { input = 0 }},
                   {"obj_ventilation_map", { input = 0 }},
                   {"obj_ventilation_gates", { input = 0 }},
                   {"spr_ventilation_dark", { alp = 1 }},
                   {"obj_ventilation_exit", { alp = 0, input = 0 }} } );
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  cmn.HideNote( 0 );
  
  local old_room = private.state[1];
  if old_room == 100 then
    old_room = 19;
  end;
  
  if old_room < 100 then
  
    for i = 1, #private.room_anim[ old_room ], 1 do
      --DbgTrace("dett "..private.room_anim[ old_room ][i])
      ObjAttach("anm_ventilation_anim_"..private.room_anim[ old_room ][i], "obj_ventilation_anims_pull");
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_ventilation" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_ventilation" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  if private.state[1] > 1 then
    
    cmn.Lock( 1 );
    
    local old_room = private.state[1];
    
    ng_global.progress[ ng_global.currentprogress ][ "win_ventilation" ].state = { 1, {0, 0, 0, 0, 0, 0, 0} };
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_ventilation" ].state;
    
    local func_after = function ()
      
      cmn.StopAllEnv();
      
      for i = 1, #private.room_anim[ old_room ], 1 do
        --DbgTrace("dett "..private.room_anim[ old_room ][i])
        ObjAttach("anm_ventilation_anim_"..private.room_anim[ old_room ][i], "obj_ventilation_anims_pull");
      end;
      
      cmn.HideNote( 0 );
      private.DrawScene();
      ObjAnimate("spr_ventilation_dark", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
    ObjAnimate("spr_ventilation_dark", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock( 1 );
  cmn.StopAllEnv();
  cmn.MiniGameHide();
  
  ng_global.progress[ ng_global.currentprogress ][ "win_ventilation" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_ventilation" ].state = { 100, {0, 0, 0, 0, 0, 0, 0} };
  
  ObjAnimate("spr_ventilation_dark", "alp", 0, 0, private.Win, { 0, 0, 0,   0.5, 0, 1 });

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_ventilation" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_ventilation" ].state = { 1, {0, 0, 0, 0, 0, 0, 0} }; --[1] - current room, [2] - discovered traps

end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  ObjMultiSet( { {"spr_ventilation_map_small", { alp = 1, input = 1 }},
                 {"obj_ventilation_note", { alp = 0, input = 0 }} } );
                                                
  if private.state[1] ~= 100 then
    
    if private.map_rooms[ private.state[1] ][4] == 1 then
      cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_end");
    elseif private.map_rooms[ private.state[1] ][4] == 7 then
      cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_long");
    else 
      cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_middle");
    end;
    
    ObjSet("obj_ventilation_map_player", { pos_x = private.map_rooms[ private.state[1] ][1],
                                           pos_y = private.map_rooms[ private.state[1] ][2],
                                           ang = private.map_rooms[ private.state[1] ][3] });
                 
    for i = 1, 8, 1 do
      
      if private.map_rooms[ private.state[1] ][4] == i then
        ObjSet("obj_ventilation_room_"..i,  { alp = 1, input = 1 });
      else 
        ObjSet("obj_ventilation_room_"..i,  { alp = 0, input = 0 });
      end;
      
    end;
    
    for i = 1, #private.room_anim[ private.state[1] ], 1 do
      --DbgTrace("att "..private.room_anim[ private.state[1] ][i])
      ObjAttach("anm_ventilation_anim_"..private.room_anim[ private.state[1] ][i], "obj_ventilation_atmo");
    end;
    
    for i = 1, 7, 1 do
      
      if private.state[2][i] == 1 then
        ObjSet("spr_ventilation_map_trap_"..i,  { alp = 1 });
      else 
        ObjSet("spr_ventilation_map_trap_"..i,  { alp = 0 });
      end;
      
    end;
    
    if private.state[1] == 1 then
      ObjMultiSet( { {"grm_ventilation_cargosection", { input = 1 }},
                     {"grm_ventilation_room_back", { input = 0 }} } );
    else 
      ObjMultiSet( { {"grm_ventilation_cargosection", { input = 0 }},
                     {"grm_ventilation_room_back", { input = 1 }} } );
    end;
                   
  else 
    
  end;

end;
-----------------------------------------------------------------------------------
function public.FocusGate( name, inout, type_cursor )

  type_cursor = type_cursor or CURSOR_DEFAULT;
  SetCursor( type_cursor );

  local obj_focus = "spr_ventilation_room_"..name.."_focus";
  local alf = ObjGet( obj_focus ).alp;
  local tme = 0;
  
  if inout == 0 then
    tme = alf * 0.3;
  else 
    tme = ( 1 - alf ) * 0.3;
  end;
  
  ObjAnimate(obj_focus, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.ChooseGate( dir )
  
  cmn.Lock( 1 );
  
  local new = private.map_connect[ private.state[1] ][ dir ];
  local old = private.state[1];
  local trap = 0;
  
  --DbgTrace(new)
  
  if type( new ) ~= "string" then
    private.state[1] = new;
  else 
    trap = tonumber( cmn.GetObjectName( new ) );
    --DbgTrace(trap)
    new = 1;
    private.state[1] = 1;
    private.state[2][trap] = 1;
    --DbgTrace(trap)
    --DbgTrace(private.state[2][trap])
  end;
  
  local old_type = private.map_rooms[ old ][4];
  local new_type = 0;
  if new ~= 100 then
    new_type = private.map_rooms[ new ][4];
  end;
  
  if trap == 0 then
    
    if dir ~= "back" then
      private.MoveForward( old_type, new_type, old );
    else 
      private.MoveBack( old_type, new_type, old );
    end;
    
  else 
    private.PlayTrap( old_type, new_type, trap, old );
  end;
  
end;
-----------------------------------------------------------------------------------
function public.Exit()
  
  if ng_global.currentprogress == "std" then
    cmn.GotoRoom("rm_cargosection");
  else 
    rm_extra.GoToSecretroom();
  end;
  
end;
-----------------------------------------------------------------------------------
function public.FocusExit( inout )

  local obj_focus = "spr_ventilation_exit_focus";
  local alf = ObjGet( obj_focus ).alp;
  local tme = 0;
  
  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;
  
  ObjAnimate(obj_focus, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function private.MoveForward( old, new, old_room )
  
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_cage_go_"..math.random(1,3));
  
  local set_new_room = function ()
    
    cmn.StopAllEnv();
    
    if not private.CheckWin() then
      
      --if private.map_rooms[ private.state[1] ][4] == 1 then
      --  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_end");
      --elseif private.map_rooms[ private.state[1] ][4] == 7 then
      --  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_long");
      --else 
      --  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_middle");
      --end;
      
      for i = 1, #private.room_anim[ old_room ], 1 do
        --DbgTrace("dett "..private.room_anim[ old_room ][i])
        ObjAttach("anm_ventilation_anim_"..private.room_anim[ old_room ][i], "obj_ventilation_anims_pull");
      end;
      private.DrawScene();
      ObjAnimate("spr_ventilation_dark", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 1,   0.5, 0, 0 });
      ObjMultiSet( { {"obj_ventilation_room_"..old, { alp = 0, input = 0 }},
                     {"obj_ventilation_room_"..new, { alp = 1, input = 1 }},
                     {"obj_ventilation_rooms", { pos_y = 384, scale_x = 1, scale_y = 1 }},
                     {"obj_ventilation_front", { pos_y = 384, scale_x = 1, scale_y = 1 }} } );
                     
    else 
      
      if ng_global.currentprogress == "std" then               
        cmn.MiniGameHide();
      else 
        
        ObjMultiSet( { {"obj_ventilation_room_"..old, { alp = 0, input = 0 }},
                       {"obj_ventilation_rooms", { pos_y = 384, scale_x = 1, scale_y = 1 }},
                       {"obj_ventilation_front", { pos_y = 384, scale_x = 1, scale_y = 1 }} } );
                     
        rm_extra.MiniGameHide();
        int_dialog_secretroom.StopTimer();
        
      end;
      
      private.Win();
      
    end;
    
  end;
  
  ObjAnimate( "obj_ventilation_rooms", "scale_xy", 0, 0, "",
  {
    0.0, 3, 1, 1,
    1.6, 3, 1.3, 1.3
  } );
  
  ObjAnimate( "obj_ventilation_front", "scale_xy", 0, 0, "",
  {
    0.0, 3, 1, 1,
    1.6, 3, 1.3, 1.3
  } );

  ObjAnimate( "obj_ventilation_rooms", "pos_y", 0, 0, "",
  {
    0.0, 3, 384,
    0.4, 3, 374,
    0.8, 3, 394,
    1.2, 3, 374,
    1.6, 3, 394
  } );
  
  ObjAnimate( "obj_ventilation_front", "pos_y", 0, 0, "",
  {
    0.0, 3, 384,
    0.4, 3, 374,
    0.8, 3, 394,
    1.2, 3, 374,
    1.6, 3, 394
  } );
  
  ObjAnimate("spr_ventilation_dark", "alp", 0, 0, set_new_room, { 0, 0, 0,   1.4, 0, 0,   1.8, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function private.MoveBack( old, new, old_room )
  
  local set_new_room = function ()
    
    cmn.StopAllEnv();
    
    --if private.map_rooms[ private.state[1] ][4] == 1 then
    --  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_end");
    --elseif private.map_rooms[ private.state[1] ][4] == 7 then
    --  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_long");
    --else 
    --  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_middle");
    --end;
    
    for i = 1, #private.room_anim[ old_room ], 1 do
      --DbgTrace("dett "..private.room_anim[ old_room ][i])
      ObjAttach("anm_ventilation_anim_"..private.room_anim[ old_room ][i], "obj_ventilation_anims_pull");
    end;
    
    private.DrawScene();
    ObjAnimate("spr_ventilation_dark", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 1,   0.5, 0, 0 });
    ObjMultiSet( { {"obj_ventilation_room_"..old, { alp = 0, input = 0 }},
                   {"obj_ventilation_room_"..new, { alp = 1, input = 1 }} } );
    
  end;
  
  ObjAnimate("spr_ventilation_dark", "alp", 0, 0, set_new_room, { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function private.PlayTrap( old, new, trap, old_room )
  
  --cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_cage_go_"..math.random(1,3));
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_cage_wrong_"..private.trap_sounds[trap]);
  
  local set_new_room = function ()
    
    cmn.StopAllEnv();
    
    --if private.map_rooms[ private.state[1] ][4] == 1 then
    --  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_end");
    --elseif private.map_rooms[ private.state[1] ][4] == 7 then
    --  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_long");
    --else 
    --  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_mg_ventilation_middle");
    --end;
    
    for i = 1, #private.room_anim[ old_room ], 1 do
      --DbgTrace("dett "..private.room_anim[ old_room ][i])
      ObjAttach("anm_ventilation_anim_"..private.room_anim[ old_room ][i], "obj_ventilation_anims_pull");
    end;
    
    private.DrawScene();
    ObjAnimate("spr_ventilation_dark", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 1,   0.5, 0, 0 });
    ObjMultiSet( { {"obj_ventilation_room_"..old, { alp = 0, input = 0 }},
                   {"obj_ventilation_room_"..new, { alp = 1, input = 1 }},
                   {"anm_ventilation_trap_"..trap, { alp = 0, frame = 0 }},
                   {"obj_ventilation_rooms", { pos_y = 384, scale_x = 1, scale_y = 1 }},
                   {"obj_ventilation_front", { pos_y = 384, scale_x = 1, scale_y = 1 }} } );
    
  end;
                 
  local anm_dark = function ()
    
    ObjAnimate("spr_ventilation_dark", "alp", 0, 0, set_new_room, { 0, 0, 0,   0.5, 0, 1 });
    
  end;
  
  local anm_trap = function ()
    
    --cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_cage_wrong_"..private.trap_sounds[trap]);
    ObjSet("anm_ventilation_trap_"..trap,  { playing = 1, endtrig = anm_dark });
    
  end;
  
  ObjAnimate("anm_ventilation_trap_"..trap, "alp", 0, 0, anm_trap, { 0, 0, 0,   1.3, 0, 0,   1.6, 0, 1 });
  
  ObjAnimate( "obj_ventilation_rooms", "scale_xy", 0, 0, "",
  {
    0.0, 3, 1, 1,
    1.6, 3, 1.3, 1.3
  } );
  
  ObjAnimate( "obj_ventilation_front", "scale_xy", 0, 0, "",
  {
    0.0, 3, 1, 1,
    1.6, 3, 1.3, 1.3
  } );

  ObjAnimate( "obj_ventilation_rooms", "pos_y", 0, 0, "",
  {
    0.0, 3, 384,
    0.4, 3, 374,
    0.8, 3, 394,
    1.2, 3, 374,
    1.6, 3, 394
  } );
  
  ObjAnimate( "obj_ventilation_front", "pos_y", 0, 0, "",
  {
    0.0, 3, 384,
    0.4, 3, 374,
    0.8, 3, 394,
    1.2, 3, 374,
    1.6, 3, 394
  } );
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  if private.state[1] == 100 then
    return true;
  else 
    return false;
  end;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.SetEventDone( "win_ventilation" );
  cmn.CallEventHandler( "win_ventilation" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_ventilation" ].skip == 0 and not ng_global.noskipgames[ "win_ventilation" ] then

    ng_global.noskipgames[ "win_ventilation" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
    
  if ng_global.playedgames and not ng_global.playedgames[ "win_ventilation" ] then
    ng_global.playedgames[ "win_ventilation" ] = 1;
  end;

  common_impl.PauseAchiev( 0 );
  cmn.GotoRoom("rm_accomodations");
  
  ObjMultiSet( { {"obj_ventilation_rooms", { input = 0 }},
                 {"obj_ventilation_map", { input = 0 }},
                 {"obj_ventilation_gates", { input = 0 }},
                 {"spr_ventilation_dark", { alp = 1 }},
                 {"obj_ventilation_exit", { alp = 0, input = 0 }} } );

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  cmn.Lock( 0 );
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_ventilation" );

    cmn.PlayFullscreenVideo( "assets/levels/level2/mg_ventilation/vid_ventelation_out", private.WinEnd, "assets/levels/level2/audio/mus/aud_ventilation_out_mus" );
    
  else 
    
    ObjSet("grm_ventilation_cargosection",  { input = 0 });
    cmn.SetEventDone( "win_ventilation" );
    interface_impl.ShowStarsWindow();
    
  end;

end;
--******************************************************************************************************************