-- name=level2

function public.Start ( param )

  game.play_hint_aud = false;

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 10 );
  interface.WidgetAdd( InterfaceWidget_BtnGuide, 6 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 4  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 5 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 6 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 7 );

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 0 );

  interface.WidgetAdd( InterfaceWidget_TaskHeader, 1 );
  interface.WidgetAdd( InterfaceWidget_Inventory, 2 );
  --interface.WidgetAdd( InterfaceWidget_TaskPanel );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 3, "assets/interface/int_taskpanel");

  interface.WidgetAdd( InterfaceWidget_Effects, 50 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 4 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 260 );

  interface.ButtonLockAdd();

  interface.WidgetAdd( InterfaceWidget_ItemPanel, 3, "assets/interface/int_itempanel" );
  interface.WidgetAdd( InterfaceWidget_Popup, 250 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 300 );
  --interface.WidgetAdd( InterfaceWidget_DialogStory );
  --interface.WidgetAdd( InterfaceWidget_DialogCharacter, 900 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial, 310 );

  interface.WidgetAdd( InterfaceWidget_Map, 200 );

  interface.PanelNotificationAdd();
  interface.ComplexInvAdd();
  interface_impl.DialogHintAdd();
  
  interface_impl.GlobalTaskAdd();
  
  interface_impl.DiaryAdd();
  
  ------------------------------------------------------
  if IsCollectorsEdition() or IsSurveyEdition() then
  
    if IsCollectorsEdition() then
  
      ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
      rm_achievements.Init();
    
      ModLoad( "assets/levels/menu/rm_collectable/mod_collectable" );
      rm_collectable.Init();
      
      ModLoad( "assets/levels/menu/rm_secretroom/mod_secretroom" );
      rm_secretroom.Init();
      
      interface_impl.PopupAchievementAdd();
      
    end;

    interface_impl.AchievAdd();
    
    interface_impl.BonusAdd();
  
  end;
  ------------------------------------------------------
  if IsCollectorsEdition() then
  
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  
  end;
  ------------------------------------------------------
  
  --переменная для того, чтобы из титров не выкидывало в меню
  public.in_progress = true;
  --
  private.Init();
  --
  int_map_impl.CreateRooms( "level2" );

  ModLoad( "assets/levels/level2/mod_inventory2" );
  inventory2.Init();
  
  ModLoad( "assets/levels/menu/rm_endroom/mod_endroom" );
  rm_endroom.Init();
  
  ModLoad( "assets/levels/menu/rm_credits/mod_credits" );
  rm_credits.Init();

  common.LevelLoad( "level2", "std", "rm_cargosection", param );
  ng_global.progress[ "std" ].common.gamestart = true;
  
  common_impl.AddAvailibleMusic( 3 );
  common_impl.AddAvailibleMusic( 4 );
  common_impl.AddAvailibleMusic( 6 );
  common_impl.AddAvailibleMusic( 7 );
  common_impl.AddAvailibleMusic( 8 );
  common_impl.PlayBackgroundMusic();
  
  common_impl.StartCountGameTime(1);

  common_impl.DialogCustomUpdate();
  interface_impl.RemoveFlowersTotal();
  cmn.RemoveCollectable();
  
  int_button_diary.DiaryCheckNewMessage();
  
  int_button_map_impl.MapSetActive();

  game.play_hint_aud = true;

  common_impl.is_in_map = 0;

end;
    
function private.Init ()

  game.room_names =
  {
     "rm_cargosection"
    ,"rm_accomodations"
    ,"rm_corridor"
    ,"rm_medicalsection"
    ,"rm_maindeck"
    ,"rm_armory"
    ,"rm_hangar"
    
    ,"mg_ventilation"
    ,"mg_incapsule"
    ,"mg_breakthrough"
    
    ,"ho_stars"
    ,"ho_insiderescuecapsule"
    ,"ho_onarmortable"
    
  };
  
  --имена диалогов с подбором предмета (для удаления gfx в кастом моде)
  game.dlg_witems_names =
  {
    "obj_corridor_dialog_jean1",
    "obj_medicalsection_dialog_jean2",
    "obj_maindeck_dialog_jean4",
    "obj_maindeck_dialog_ai"
  };

-- 1 - открыта
-- 2 - таски выполнены
-- 3 - кол-во тасков
-- 4 блокирована
  game.map_rooms = {
    
    [ "rm_cargosection" ]    =  { 0, 0, 1, 0, 3 },
    [ "rm_accomodations" ]   =  { 0, 0, 2, 0, 3 },
    [ "rm_corridor" ]        =  { 0, 0, 2, 0, 3 },
    [ "rm_medicalsection" ]  =  { 0, 0, 3, 0, 2 },
    [ "rm_maindeck" ]        =  { 0, 0, 1, 0, 4 },
    [ "rm_armory" ] =  { 0, 0, 1, 0, 2 },
    [ "rm_hangar" ] =  { 0, 0, 99, 0, 1 }
  
  };
  
  --таблица с координатами открытия зз
  game.zz_end_pos = {
    
    [ "zz_grate" ] = {380, 320},
    [ "zz_controlpanel" ] = {380, 360},
    [ "zz_cargo" ] = {600, 370},
    [ "zz_junk" ] = {620, 330},
    
    [ "zz_pilotbed" ] = {580, 340},
    [ "zz_desk" ] = {600, 370},
    [ "zz_spaceship" ] = {530, 330},
    [ "zz_cabinet" ] = {330, 340},
    
    [ "zz_scanner" ] = {540, 340},
    [ "zz_armorydoor" ] = {340, 320},
    [ "zz_holeincovering" ] = {530, 370},
    [ "zz_robot" ] = {620, 350},
    
    [ "zz_laser" ] = {520, 320},
    [ "zz_lab" ] = {600, 340},
    [ "zz_capsule" ] = {400, 330},
    [ "zz_plant" ] = {380, 370},
    
    [ "zz_onboardcomputer" ] = {420, 320},
    [ "zz_pilotseat" ] = {540, 340},
    [ "zz_rescuecapsule" ] = {380, 370},
    [ "zz_repairmodule" ] = {630, 340},
    
    [ "zz_weaponcabinet" ] = {620, 340},
    [ "zz_weapontable" ] = {520, 370},
    [ "zz_armorcabinet" ] = {420, 330},
    
    [ "zz_turret" ] = {600, 330},
    [ "zz_connectingmodule" ] = {380, 360}
  
  };

  --таблицы для динамического хинта
  --таблица для юзов на предметы, получаемые в хо и мультиюзов
  game.progress_multyuse =
  {
    
     {"use_coordinates", "win_stars"},
     {"use_display", "win_insiderescuecapsule"},
     {"use_weapon", "win_onarmortable"},
   
     {"use_toolcargo", "get_tool"},
     {"use_toolrobot", "get_tool"},

     {"use_screwdriverrobot", "get_screwdriver"},
     {"use_screwdriverscanner", "get_screwdriver"},

     {"use_lvl2lense", "beg_level2"},
     {"use_lvl2badge1", "beg_level2"},
     {"use_shippart1", "beg_level2"},
     
     {"use_holvl2wrench", "win_onarmortable"},
     
     {"use_researcherwin", "get_researcher"}
    
  };

  --таблица на мультипредметы с количеством их частей
  game.progress_multyobj =
  {
    
    {"use_element", 3},
    {"use_bombpart", 3},

  };

  --таблица на юзы, разблокирующиеся другими юзами или кликами
  game.progress_blockeduse =
  {
    
    {"use_wrench","clk_activatejunk"},
    {"get_hacker","clk_activatejunk"},
    {"get_squarekey","clk_activatejunk"},

    {"get_cutterbase","win_tablet"},
    {"get_accesscard","win_tablet"},
    
    {"use_lvl2lense","use_triangularkey"},
    {"use_gas","use_triangularkey"},
    {"use_penicillin","use_doctorsnamebadge"},
    {"use_runoutenergyelement","use_toolcargo"},
    {"use_toolrobot","use_screwdriverrobot"},
    
    {"use_wires","use_screwdriverscanner"},
    {"use_adhesivetape","use_wires"},
    {"use_fixedhacker","use_adhesivetape"},
    
    {"use_accesstoshipcode","use_pressuresuit"},
    {"get_shipsymbol","use_pressuresuit"},
    {"get_defensesign","use_pressuresuit"},
    {"use_squarekey","use_pressuresuit"},
    
    {"use_turretmodule","use_squarekey"},
    {"use_turretmodule2","use_squarekey"}
    
  };

  game.progress_names =
  {
     "beg_level2"
    ,"clk_pressbutton"
    ,"get_tablet"
    ,"get_wrench"
    ,"get_code"
    ,"use_code"
    ,"win_controlpanel"
    ,"clk_activatejunk"
    ,"opn_cargosectionjunk"
    ,"get_hacker"
    ,"get_squarekey"
    ,"use_wrench"
    ,"get_tabletpart1"
    ,"get_tabletpart2"
    ,"use_tabletpart1"
    ,"use_tabletpart2"
    ,"win_tablet"
    ,"get_cutterbase"
    ,"get_accesscard"
    ,"use_accesscard"
    ,"clk_printventmap"
    ,"get_ventilationscheme"
    ,"use_cutterbase"
    ,"win_junk"
    ,"get_plasmaticcutter"
    ,"use_plasmaticcutter"
    ,"use_ventilationscheme"
    ,"win_ventilation"
    
    ,"opn_accomodations"
    ,"get_lvl2knife"
    ,"use_lvl2knife"
    ,"get_element2"
    ,"get_amuletcabinet1"
    ,"get_brokenmechanicparrot"
    ,"get_amuletcabinet2"
    ,"use_amuletcabinet1"
    ,"use_amuletcabinet2"
    ,"get_button"
    ,"get_communicationmodule"
    ,"use_button"
    ,"opn_accomodationswindow"
    ,"win_stars"
    ,"get_bombpart3"
    ,"use_coordinates"
    ,"use_communicationmodule"
    ,"opn_accomodationsdoor"
    
    ,"opn_corridor"
    ,"clk_corridorfirst"
    ,"get_screwdriver"
    ,"use_screwdriverrobot"
    ,"get_wires"
    ,"get_adhesivetape"
    ,"use_screwdriverscanner"
    ,"use_wires"
    ,"use_adhesivetape"
    ,"opn_corridordoor"
    ,"get_captainsign"
    ,"use_captainsign"
    ,"get_emptybottle"
    ,"use_emptybottle"
    ,"get_acid"
    ,"use_acid"
    ,"get_element1"
    ,"get_element3"
    ,"use_element"
    ,"get_fixedhacker"
    ,"use_fixedhacker"
    ,"win_scanner"
    
    ,"opn_medicalsection"
    ,"get_tongs"
    ,"use_tongs"
    ,"get_doctorsnamebadge"
    ,"use_doctorsnamebadge"
    ,"get_triangularkey"
    ,"use_triangularkey"
    ,"get_scalpel"
    ,"use_scalpel"
    ,"get_plantpart"
    ,"get_bombpart2"
    ,"use_plantpart"
    ,"get_penicillin"
    ,"clk_takeoldglassout"
    ,"use_penicillin"
    ,"opn_incapsule"
    ,"win_incapsule"
    ,"opn_medicalsectiondlg"
    ,"get_gun"
    ,"opn_gun"
    ,"get_runoutenergyelement"
    ,"get_fob"
    ,"use_fob"
    ,"get_mechanicparrot"
    ,"use_mechanicparrot"
    ,"get_tool"
    ,"use_toolcargo"
    ,"use_runoutenergyelement"
    ,"get_chargedenergyelement"
    ,"use_toolrobot"
    ,"get_crystal"
    ,"use_crystal"
    ,"use_chargedenergyelement"
    ,"get_blaster"
    ,"use_blaster"
    ,"get_gas"
    ,"use_gas"
    ,"use_lvl2lense"
    
    ,"opn_maindeck"
    ,"clk_mandeckfirst"
    ,"get_manipulatorbase"
    ,"get_manipulatorclaw"
    ,"get_manipulatormodule"
    ,"use_manipulatormodule"
    ,"use_manipulatorclaw"
    ,"get_manipulator"
    ,"use_manipulator"
    ,"get_shippart2"
    ,"use_shippart1"
    ,"use_shippart2"
    ,"get_codemodule"
    ,"use_codemodule"
    ,"win_pilotbed"
    ,"get_brain"
    ,"get_bomb"
    ,"get_bag"
    ,"use_brain"
    ,"win_repairmodule"
    ,"get_robot"
    ,"use_robot"
    ,"win_insiderescuecapsule"
    ,"use_display"
    ,"get_eye"
    ,"use_eye"
    ,"opn_maindeckdialog1"
    ,"get_researcher"
    --,"use_researcher"
    ,"use_researcherwin"
    ,"get_memorymodule"
    ,"use_memorymodule"
    ,"opn_maindeckdialog2"
    ,"get_bombpart1"
    ,"use_bombpart"
    ,"get_readybomb"
    ,"use_readybomb"
    
    ,"opn_armory"
    ,"get_list"
    ,"get_lvl2hammer"
    ,"use_list"
    ,"get_spareparts"
    ,"use_lvl2hammer"
    ,"get_bracelet"
    ,"use_bracelet"
    ,"get_accesstoweaponcodes"
    ,"use_accesstoweaponcodes"
    ,"win_weaponcabinet"
    ,"get_weaponbase"
    ,"use_spareparts"
    ,"use_weaponbase"
    ,"use_holvl2wrench"
    ,"clk_holvl2glove"
    ,"clk_holvl2disk"
    ,"win_onarmortable"
    ,"use_weapon"
    ,"clk_chooseweapon"
    ,"win_breakthrough"
    
    ,"opn_hangar"
    ,"get_lvl2badge2"
    ,"use_lvl2badge1"
    ,"use_lvl2badge2"
    ,"get_armorcabinetkey"
    ,"get_shipsymbol2"
    ,"get_turretmodule2"
    ,"opn_armoryafterhangar"
    ,"use_armorcabinetkey"
    ,"get_pressuresuit"
    
    ,"opn_hangarsuit"
    ,"use_pressuresuit"
    ,"get_shipsymbol"
    ,"get_defensesign"
    ,"use_shipsymbol"
    ,"use_shipsymbol2"
    ,"get_accesstoshipcode"
    ,"use_accesstoshipcode"
    ,"win_connectingmodule"
    ,"use_defensesign"
    ,"get_turretmodule"
    ,"use_squarekey"
    ,"use_turretmodule"
    ,"use_turretmodule2"
    ,"win_turret"
    
    ,"clk_openhelmet"
    
    ,"tutor_21"
    ,"tutor_22"
    ,"tutor_23" 
  
  };
  
  game.relations = {};

end;

function Test ()
    
  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;
