-- name=ho_apartment3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_apartment3" );
  game.relations[ "ho_apartment3" ].exitroom = "rm_office";
  private.win_inprogress = false;
  private.foam_inprogress = false;
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_apartment3" ] = 
  {
    type = "win",
    room = "rm_office",
    zz = "ho_apartment3",
    zz_gate = "gho_office_apartment3"
  };
  --------------------------------------------------------------------------------------------------
  local win_apartment3_func = function ()

    if ( cmn.IsEventDone( "win_apartment3" ) ) then

    end;

  end;
  cmn.AddSubscriber( "win_apartment3", win_apartment3_func );
  --------------------------------------------------------------------------------------------------
  local start_apartment3_func = function ()

    if ( cmn.IsEventStart( "win_apartment3" ) ) then

      common_impl.ProcessHoStart( "apartment3" );

    end;

  end;
  cmn.AddSubscriber( "win_apartment3", start_apartment3_func, "ho_apartment3" );
  
  --------------------------------------------------------------------------------------------
  -- function beg_level3 () end;
  --------------------------------------------------------------------------------------------
  local beg_level3 = function ()
  
    int_map_impl.OpenRoom( "rm_office" );
    int_diary.SetVisibleHands( 1 );
    interface_impl.SetCurrentGlobalTask( 12 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "beg_level3", beg_level3 );
  
  
  --for secretroom
  private.tasks =  {    
      { "headphones",   1, 0, { { "obj_apartment3_fly_headphones", "spr_apartment3_headphones", "fx_apartment3_fire_headphones" } } },
      { "fan",       1, 0, { { "obj_apartment3_fly_fan", "spr_apartment3_fan", "fx_apartment3_fire_fan" } } },
      { "cap",       1, 0, { { "obj_apartment3_fly_cap", "spr_apartment3_cap", "fx_apartment3_fire_cap" } } },
      { "coffee",    1, 0, { { "obj_apartment3_fly_coffee", "spr_apartment3_coffee", "fx_apartment3_fire_coffee" } } },

      { "lamp",      1, 0, { { "obj_apartment3_fly_lamp", "spr_apartment3_lamp", "fx_apartment3_fire_lamp" } } },
      { "table",     1, 0, { { "obj_apartment3_fly_table", "spr_apartment3_table", "fx_apartment3_fire_table" } } },
      { "vase",      1, 0, { { "obj_apartment3_fly_vase", "spr_apartment3_vase", "fx_apartment3_fire_vase" } } },
      { "pillow",    1, 0, { { "obj_apartment3_fly_pillow", "spr_apartment3_pillow", "fx_apartment3_fire_pillow" } } },

      { "iron",      1, 0, { { "obj_apartment3_fly_iron", "spr_apartment3_iron", "fx_apartment3_fire_iron" } } },
      { "umbrella",  1, 0, { { "obj_apartment3_fly_umbrella", "spr_apartment3_umbrella", "fx_apartment3_fire_umbrella" } } },
      { "chair",     1, 0, { { "obj_apartment3_fly_chair", "spr_apartment3_chair", "fx_apartment3_fire_chair" } } },
      { "drawer",    1, 0, { { "obj_apartment3_fly_drawer", "spr_apartment3_drawer", "fx_apartment3_fire_drawer" } } },
      
      { "fireextinguisher",    1, 0, { { "spr_apartment3_fireextinguisher", "spr_apartment3_fireextinguisher_shadow", "obj_apartment3_fireextinguisher_2", "fx_apartment3_foam" } } }
  };
    
  private.start = {};
  private.start_items = {};
  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
      
    if i < #private.tasks then
      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "itm_"..common.GetObjectName( private.tasks[ i ][ 4 ][ 1 ][ 1 ] );
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme ); 
    end; 
    
  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if not ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].stage or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].stage = { 1, 2 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].state = {};
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_ho_apartament3_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_ho_apartament3_env");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_office" );
    cmn.StartTimePassing("ho_apartment3");
  else 
    
    private.win_inprogress = false;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].stage = { 1, 2 }; 
    ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].state = {};
    
    private.CreateNewObjects();
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_apartment3_back",  { input = 1 });
    
  end;

  if not cmn.IsEventStart( "win_apartment3" ) then
    cmn.InitHo( "apartment3" );
  end;
  
  private.DrawScene();
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].stage;

  if not cmn.IsEventDone("win_apartment3") and ho_stage[1] <= ho_stage[2] then

    if ( ho_stage[1] == 1 ) then
      interface_impl.TaskPanelShow( private.stages_task() );
    elseif ( ho_stage[1] == 2 ) then
      interface_impl.ItemPanelShow( private.stages_task() );
    end;
  
  else
    --public.win();
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/level3/audio/mus/aud_fire_danger_mus", 1);
  
  if ng_global.currentprogress == "std" and not cmn.IsEventDone("beg_level3") then
    cmn.SetEventDone("beg_level3");
    cmn.CallEventHandler("beg_level3");
    cmn.ShowBbt( "apartment3_open" );
    interface_impl.ShowGlobalTask();
  end;
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].stage;
  if cmn.IsEventDone("win_apartment3") or ho_stage[1] > ho_stage[2] then
    public.win();
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  interface_impl.ItemPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_apartment3_back",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_apartment3");

    if ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_apartment3" ] then

      ng_global.nohintho[ "win_apartment3" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_apartment3" ] then
      ng_global.playedhops[ "win_apartment3" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_apartment3_back",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.win()
  
  if ng_global.currentprogress == "std" and not private.win_inprogress then
    
    private.win_inprogress = true;
    
    cmn.SetEventDone("win_apartment3");
    cmn.CallEventHandler("win_apartment3");
  
    cmn.StopAllEnv();
    
    local func_after = function ()
      ObjSet("ho_apartment3",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.CallEventHandler("win_apartment3");
      cmn.GotoRoom("rm_office");
    end;
    
    cmn.PlayFullscreenVideo( "assets/levels/level3/ho_apartment3/vid_flight", func_after, "assets/levels/level3/audio/mus/aud_vid_flight_mus", "assets/levels/level3/audio/voc/aud_lvl_3_stephen_2_voc");
    
  elseif ng_global.currentprogress == "secret" and not private.win_inprogress then
    
    private.win_inprogress = true;
    cmn.SetEventDone("win_apartment3");
    
    int_dialog_secretroom.ShowAnim();
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  if item_name ~= 1 then
    
    cmn.HoItemFind( "obj_apartment3_fly_"..item_name, 1 );
    table.insert( ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].state, item_name );
    ObjSet("spr_apartment3_"..item_name,  { input = 0 });
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_ho_apartament3_fire_1");
    ObjAnimate("fx_apartment3_fire_"..item_name, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
    local reset_foam = function ()
      
      private.foam_inprogress = false;
      ObjSet("fx_apartment3_foam",  { active = 0, visible = 0 });
      
    end;
    
    if not private.foam_inprogress then
      
      private.foam_inprogress = true;
    
      ObjMultiSet( { {"fx_apartment3_foam",  { active = 1, visible = 1 }},
                     {"tmr_apartment3_timer_2", { time = 2.1, playing = 1, endtrig = reset_foam }} } );
      PartSysRestart("fx_apartment3_foam");
      
    end;
    
  else 
    
    cmn.HoTaskFind("spr_apartment3_fireextinguisher", "fireextinguisher", 2);
    ObjDelete("spr_apartment3_fireextinguisher_shadow");
    private.FollowFire();
    
  end;
  
end;
--*********************************************************************************************************************
function private.DrawScene()

  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].stage[1];
  
  if ( ho_stage == 2 ) then
    
    ObjSet("obj_apartment3_fireextinguisher_2",  { alp = 1 });
    private.FollowFire();
    
    ObjDelete("spr_apartment3_fireextinguisher");
    ObjDelete("spr_apartment3_fireextinguisher_shadow");
    
    for i = 1, #ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].state, 1 do
      
      ObjDelete("fx_apartment3_fire_"..ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].state[i]);
      ObjSet("spr_apartment3_"..ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].state[i],  { input = 0 });
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.FollowFire()
  
  local curs = GetZoomCursorPos();
  curs[1] = math.floor( curs[1] );
  curs[2] = math.floor( curs[2] );
  
  ObjMultiSet( { {"obj_apartment3_fireextinguisher_2", { pos_x = curs[1], pos_y = curs[2] }},
                 {"tmr_apartment3_timer",  { alp = 0.01, playing = 1, endtrig = private.FollowFire }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.stages_task()

  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_apartment3" ].stage[1];
  local ho_tasks_items = {};

  if ( ho_stage == 1 ) then

    interface.TaskPanelTaskAdd( ho_tasks_items, "fireextinguisher", 1, 0, { { "spr_apartment3_fireextinguisher" } } );

  elseif ( ho_stage == 2 ) then

    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_chair",     0, "obj_apartment3_fly_chair" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_drawer",    0, "obj_apartment3_fly_drawer" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_umbrella",  0, "obj_apartment3_fly_umbrella" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_iron",      0, "obj_apartment3_fly_iron" );
    
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_vase",     0, "obj_apartment3_fly_vase" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_lamp",     0, "obj_apartment3_fly_lamp" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_pillow",   0, "obj_apartment3_fly_pillow" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_coffee",   0, "obj_apartment3_fly_coffee" );
    
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_table",       0, "obj_apartment3_fly_table" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_cap",         0, "obj_apartment3_fly_cap" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_headphones",  0, "obj_apartment3_fly_headphones" );
    interface_impl.ItemPanelItemAdd( ho_tasks_items, "fly_fan",         0, "obj_apartment3_fly_fan" );

    ObjSet("obj_apartment3_objects",  { input = 1 });

  end;

  return ho_tasks_items;
  
end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
function public.stage_2()

  interface_impl.ChangeTaskPanelToItemPanel( private.stages_task() );
  
  ObjAnimate("obj_apartment3_fireextinguisher_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });

end;
------------------------------------------------------------------------------

--*********************************************************************************************************************
function private.CreateNewObjects()
  
  local ho_obj = private.start;
  local ho_itm = private.start_items;
  
  for i = 1, #ho_obj, 1 do
    
    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      if typ == "fx" then
        typ = "partsys";
      end;
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_itm, 1 do
    
    if not ObjGet( ho_itm[i].name ) then
      
      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_apartment3_items" );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, "obj_apartment3_items" );

    end;
    
  end;
  
end;
--*********************************************************************************************************************