-- name=ho_destroyedrobot
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_destroyedrobot" );
  game.relations[ "ho_destroyedrobot" ].exitroom = "rm_debughall";
  
  public.change_stage_anim_type = "alp";
  public.task_count_show = 13;
  public.tasks_img = { "battery", "button", "cogwheel", "wire", "ruler", "cpu" };
  
  private.cur_progress = "std";
  --------------------------------------------------------------------------------------------------
  game.destroyedrobot = {};
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_destroyedrobot" ] = 
  {
    type = "win",
    room = "rm_debughall",
    zz = "ho_destroyedrobot",
    zz_gate = "gho_debughall_destroyedrobot"
  };
  --------------------------------------------------------------------------------------------------
  local win_destroyedrobot_func = function ()

    if ( cmn.IsEventDone( "win_destroyedrobot" ) ) then
      interface.InventoryItemAdd( "inv_magnet", "spr_destroyedrobot_win" );
      ObjDelete("gho_debughall_destroyedrobot");
      ObjDelete("spr_debughall_robot_ho");
      ObjSet("spr_debughall_robot_ho_win",  { alp = 1 });
    end;

  end;
  cmn.AddSubscriber( "win_destroyedrobot", win_destroyedrobot_func );
  --------------------------------------------------------------------------------------------------
  local start_destroyedrobot_func = function ()

    if ( cmn.IsEventStart( "win_destroyedrobot" ) ) then

      common_impl.ProcessHoStart( "destroyedrobot", true );

    end;

  end;
  cmn.AddSubscriber( "win_destroyedrobot", start_destroyedrobot_func, "ho_destroyedrobot" );
  
  --for secretroom
  private.tasks =  {    
  
      { "bulb",      1, 0, { { "spr_destroyedrobot_bulb" } } },
      { "battery",    1, 0, { { "spr_destroyedrobot_battery", "spr_destroyedrobot_battery_2", "spr_destroyedrobot_battery_2_shadow" } } },
      { "chip",      1, 0, { { "spr_destroyedrobot_chip" } } },
      { "button",     1, 0, { { "spr_destroyedrobot_button", "spr_destroyedrobot_button_2" } } },
      
      { "disk",      1, 0, { { "spr_destroyedrobot_disk" } } },
      { "cogwheel",     1, 0, { { "spr_destroyedrobot_cogwheel", "spr_destroyedrobot_cogwheel_2", "spr_destroyedrobot_cogwheel_2_shadow" } } },
      { "goggles",   1, 0, { { "spr_destroyedrobot_goggles" } } },
      { "wire",   1, 0, { { "spr_destroyedrobot_wire", "spr_destroyedrobot_wire_2", "spr_destroyedrobot_wire_2_shadow" } } },
      
      { "pen",  1, 0, { { "spr_destroyedrobot_pen" } } },
      { "ruler",    1, 0, { { "spr_destroyedrobot_ruler", "spr_destroyedrobot_ruler_2" } } },
      { "wrench", 1, 0, { { "spr_destroyedrobot_wrench" } } },
      { "cpu",    1, 0, { { "spr_destroyedrobot_cpu", "anm_destroyedrobot_final", "obj_destroyedrobot_cpu_fly" } } },
      
      { "safekey",    1, 0, { { "spr_destroyedrobot_safekey" } } }
      
  };
  
  private.tasks_sh =  { 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 1, 0, 0 };

  private.start = {};
  private.start_sh = {};
  private.start_items = {};
  local nme = "";

  for i = 1,  #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
    if i < 13 and i % 2 == 0 then

      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][1][1] ).."_task_img";
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      
      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][1][1] ).."_task_img_2";
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
    if private.tasks_sh[i] == 1 then
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][ 1 ][ 1 ] ).."_shadow";
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if ng_global.currentprogress == "std" and not ( ng_global.progress[ "std" ][ "win_destroyedrobot" ].stage ) then
    ng_global.progress[ "std" ][ "win_destroyedrobot" ].stage = { 1, 13 };   --[1] - номер стадии, [2] - количество стадий
  elseif ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_destroyedrobot" ].stage = { 1, 13 };
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_game_2_mus", 1);
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_laboratory_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_laboratory_env");
  
  if ng_global.currentprogress == "std" then

    private.cur_progress = "std";
    common.SetPreviousRoom( "rm_debughall" );
    cmn.StartTimePassing("ho_destroyedrobot");
    
  else 
    
    private.cur_progress = "secret";
    public.task_count_show = 13;
    private.CreateNewObjects();
    ng_global.progress[ ng_global.currentprogress ][ "win_destroyedrobot" ].stage = { 1, 13 };
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_destroyedrobot_debughall",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                        event_menter = function () rm_extra.GateMouseEnter( "destroyedrobot_debughall", CURSOR_DOWN, "extra" ); end, 
                                        event_mleave = function () common_impl.GateMouseLeave( "destroyedrobot_debughall" ); end });
    
  end;

  if not cmn.IsEventStart( "win_destroyedrobot" ) then
    cmn.InitHo( "destroyedrobot" );
  end;

  local ho_tasks = private.stages_task();
  
  if ng_global.progress[ ng_global.currentprogress ][ "win_destroyedrobot" ].stage[1] == 13 then
    ObjSet("anm_destroyedrobot_final",  { frame = 300, input = 1 });
  else 
    ObjSet("anm_destroyedrobot_final",  { frame = 0, input = 0 });             
  end; 

  if (not cmn.IsEventDone("win_destroyedrobot"))
  and ng_global.progress[ ng_global.currentprogress ][ "win_destroyedrobot" ].stage[1] <= ng_global.progress[ ng_global.currentprogress ][ "win_destroyedrobot" ].stage[2] then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
    
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_destroyedrobot_debughall",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()

  cmn.HideNote( 0 );
  
  if ng_global.progress[ private.cur_progress ][ "win_destroyedrobot" ].stage[1] < ng_global.progress[ private.cur_progress ][ "win_destroyedrobot" ].stage[2] and
     ng_global.progress[ private.cur_progress ][ "win_destroyedrobot" ].stage[1] % 2 == 0 then
    
    local st = ng_global.progress[ private.cur_progress ][ "win_destroyedrobot" ].stage[1]/2;
    
    ObjDetach("spr_destroyedrobot_"..public.tasks_img[st].."_task_img");
    
  end;
    
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_destroyedrobot");

    if ng_global.progress[ ng_global.currentprogress ][ "win_destroyedrobot" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_destroyedrobot" ] then

      ng_global.nohintho[ "win_destroyedrobot" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_destroyedrobot" ] then
      ng_global.playedhops[ "win_destroyedrobot" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_destroyedrobot_debughall",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemUse( task_name )
  
  --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
  
  if ( cmn.ApplyObj( "spr_destroyedrobot_"..task_name.."_task_img_2", "spr_destroyedrobot_"..task_name ) ) then
    
    local func_after = function ()

      cmn.Lock( 0 );

      public.ItemFound( task_name );
    
    end;

    cmn.Lock( 1, { room = 1 } );
    
    ObjSet( "spr_destroyedrobot_"..task_name.."_task_img",  { alp = 0, input = false } );
    
    ObjAnimate( "spr_destroyedrobot_"..task_name.."_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    
    if task_name ~= "button" and task_name ~= "ruler" then
      ObjAnimate( "spr_destroyedrobot_"..task_name.."_2_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.CPUUse()
  
  if ( cmn.ApplyObj( "spr_destroyedrobot_cpu_task_img_2", "spr_destroyedrobot_cpu" ) ) then
    
    local func_after = function ()

      cmn.Lock( 0 );

      cmn.HoTaskFind( "obj_destroyedrobot_cpu_fly", "cpu", 1 );
    
    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_ho_destroyedrobot_processor");
    
    ObjMultiSet( { {"spr_destroyedrobot_cpu_task_img",  { alp = 0, input = false }},
                   {"spr_destroyedrobot_cpu",  { input = false }},
                   {"anm_destroyedrobot_final",  { playing = 1, endtrig = func_after }} } );

  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  ObjDelete( "spr_destroyedrobot_"..item_name.."_shadow" );
  
  if task_name ~= "button" and task_name ~= "ruler" then
    ObjDelete( "spr_destroyedrobot_"..item_name.."_2_shadow" );
  end;
  
  if item_name == "safekey" then
    local pos = GetObjPosByObj( "spr_destroyedrobot_safekey" );
    ObjSet( "spr_destroyedrobot_safekey", { pos_x = pos[1] + 171, pos_y = pos[2] } );
  end;
  
  cmn.HoTaskFind( "spr_destroyedrobot_"..item_name, item_name, 1 );
  
end;
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
function private.stages_task()

  local ho_tasks = {};
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_destroyedrobot" ].stage[1];

  if ( ho_stage == 1 ) then

    game.destroyedrobot.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "bulb", 1, 0, { { "spr_destroyedrobot_bulb" } } );
    ObjSet( "spr_destroyedrobot_bulb", { input = 1 } );
    
  elseif ( ho_stage == 2 ) then
    
    game.destroyedrobot.double_hint = { { "spr_destroyedrobot_battery",  "spr_destroyedrobot_battery_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "battery", 1, 0, { { "spr_destroyedrobot_battery" } } );
    ObjSet( "spr_destroyedrobot_battery", { input = 1 } );

  elseif ( ho_stage == 3 ) then
    
    game.destroyedrobot.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "chip", 1, 0, { { "spr_destroyedrobot_chip" } } );
    ObjSet( "spr_destroyedrobot_chip", { input = 1 } );
    
  elseif ( ho_stage == 4 ) then
    
    game.destroyedrobot.double_hint = { { "spr_destroyedrobot_button",  "spr_destroyedrobot_button_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "button", 1, 0, { { "spr_destroyedrobot_button" } } );
    ObjSet( "spr_destroyedrobot_button", { input = 1 } );

  elseif ( ho_stage == 5 ) then
    
    game.destroyedrobot.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "disk", 1, 0, { { "spr_destroyedrobot_disk" } } );
    ObjSet( "spr_destroyedrobot_disk", { input = 1 } );
    
  elseif ( ho_stage == 6 ) then
    
    game.destroyedrobot.double_hint = { { "spr_destroyedrobot_cogwheel",  "spr_destroyedrobot_cogwheel_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "cogwheel", 1, 0, { { "spr_destroyedrobot_cogwheel" } } );
    ObjSet( "spr_destroyedrobot_cogwheel", { input = 1 } );

  elseif ( ho_stage == 7 ) then
    
    game.destroyedrobot.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "goggles", 1, 0, { { "spr_destroyedrobot_goggles" } } );
    ObjSet( "spr_destroyedrobot_goggles", { input = 1 } );
    
  elseif ( ho_stage == 8 ) then
    
    game.destroyedrobot.double_hint = { { "spr_destroyedrobot_wire",  "spr_destroyedrobot_wire_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "wire", 1, 0, { { "spr_destroyedrobot_wire" } } );
    ObjSet( "spr_destroyedrobot_wire", { input = 1 } );

  elseif ( ho_stage == 9 ) then
    
    game.destroyedrobot.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "pen", 1, 0, { { "spr_destroyedrobot_pen" } } );
    ObjSet( "spr_destroyedrobot_pen", { input = 1 } );
    
  elseif ( ho_stage == 10 ) then
    
    game.destroyedrobot.double_hint = { { "spr_destroyedrobot_ruler",  "spr_destroyedrobot_ruler_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "ruler", 1, 0, { { "spr_destroyedrobot_ruler" } } );
    ObjSet( "spr_destroyedrobot_ruler", { input = 1 } );

  elseif ( ho_stage == 11 ) then
    
    game.destroyedrobot.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "wrench", 1, 0, { { "spr_destroyedrobot_wrench" } } );
    ObjSet( "spr_destroyedrobot_wrench", { input = 1 } );
    
  elseif ( ho_stage == 12 ) then
    
    game.destroyedrobot.double_hint = { { "spr_destroyedrobot_cpu",  "spr_destroyedrobot_cpu_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "cpu", 1, 0, { { "spr_destroyedrobot_cpu" } } );
    ObjSet( "spr_destroyedrobot_cpu", { input = 1 } );
    
  elseif ( ho_stage == 13 ) then
    
    game.destroyedrobot.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "safekey", 1, 0, { { "spr_destroyedrobot_safekey" } } );
    ObjSet( "spr_destroyedrobot_safekey", { input = 1 } );
    
  end;

  return ho_tasks;

end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
function public.stage_1()
end;
------------------------------------------------------------------------------
function public.stage_2()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_3()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_4()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_5()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_6()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_7()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_8()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_9()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_10()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_11()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_12()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_13()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
  ObjSet("anm_destroyedrobot_final",  { input = 1 });
end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  local ho_itm = private.start_items;

  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #ho_itm, 1 do

    if not ObjGet( ho_itm[i].name ) then

      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );

    end;

  end;
  
end;
--*********************************************************************************************************************
