-- name=ho_installation
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_installation" );
  game.relations[ "ho_installation" ].exitroom = "rm_apocalypse3";
  public.change_stage_anim_type = "alp";
  public.hop_type = "voice";
  
  private.item_sfx = { "mask_build", "brain", "globe", "shield", "knight", "", "cube", "man_wings", "man_mask" };
  
  private.task_names = {"evil", "mind", "world", "protector", "attack", "machine", "reward", "god", "happy", "cry"};
  
  private.cur_progress = "std";
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_installation" ] = 
  {
    type = "win",
    room = "rm_apocalypse3",
    zz = "ho_installation",
    zz_gate = "gho_apocalypse3_installation"
  };
  --------------------------------------------------------------------------------------------------
  local win_installation_func = function ()

    if ( cmn.IsEventDone( "win_installation" ) ) then
      
      interface.InventoryItemAdd( "inv_fang", "spr_installation_win" );
      ObjDelete("gho_apocalypse3_installation");
      ObjDelete("spr_apocalypse3_showpiece_ho_fang_2");
      
      ObjSet("gzz_apocalypse3_showpiece",  { active = 0, input = 1, alp = 0 });

    end;

  end;
  cmn.AddSubscriber( "win_installation", win_installation_func );
  --------------------------------------------------------------------------------------------------
  local start_installation_func = function ()

    if ( cmn.IsEventStart( "win_installation" ) ) then

      common_impl.ProcessHoStart( "installation" );

    end;

  end;
  cmn.AddSubscriber( "win_installation", start_installation_func, "ho_installation" );
  
  --for secretroom
  private.tasks =  {    
  
      { "evil",      1, 0, { { "spr_installation_evil", "obj_installation_fly_evil", "obj_installation_use_evil", "spr_installation_use_evil" } } },
      { "fang",    1, 0, { { "spr_installation_fang", "anm_installation_final", "obj_installation_podium", "spr_installation_podium", "spr_installation_target_1", "spr_installation_target_2",
                             "spr_installation_slot_1", "spr_installation_slot_2", "spr_installation_podium_bl_1", "spr_installation_podium_bl_2" } } },
      { "mind",      1, 0, { { "spr_installation_mind", "obj_installation_fly_mind", "obj_installation_use_mind", "spr_installation_use_mind" } } },
      { "world",     1, 0, { { "spr_installation_world_1", "spr_installation_world_2", "obj_installation_fly_world_1", "obj_installation_fly_world_2",
                               "obj_installation_use_world_1", "spr_installation_use_world_1", "obj_installation_use_world_2", "spr_installation_use_world_2" } } },
      
      { "protector",      1, 0, { { "spr_installation_protector", "obj_installation_fly_protector", "obj_installation_use_protector", "spr_installation_use_protector" } } },
      { "attack",     1, 0, { { "spr_installation_attack", "obj_installation_fly_attack", "obj_installation_use_attack", "spr_installation_use_attack" } } },
      { "machine",   1, 0, { { "spr_installation_machine_1", "spr_installation_machine_2", "obj_installation_fly_machine_1", "obj_installation_fly_machine_2", "spr_installation_machine_1_sh",
                               "obj_installation_use_machine_1", "spr_installation_robot_1_sh", "spr_installation_robot_1", "anm_installation_robot_1",
                               "obj_installation_use_machine_2", "spr_installation_robot_2_sh", "spr_installation_robot_2", "anm_installation_robot_2" } } },
      { "reward",   1, 0, { { "spr_installation_reward_1", "spr_installation_reward_2", "obj_installation_fly_reward_1", "obj_installation_fly_reward_2", 
                              "obj_installation_use_reward_1", "spr_installation_use_reward_1_sh", "spr_installation_use_reward_1",
                              "obj_installation_use_reward_2", "spr_installation_use_reward_2_sh", "spr_installation_use_reward_2" } } },
      
      { "god",  1, 0, { { "spr_installation_god", "obj_installation_use_god", "spr_installation_use_god_sh", "spr_installation_use_god", "obj_installation_fly_god" } } },
      { "happy",    1, 0, { { "spr_installation_happy", "obj_installation_use_happy", "spr_installation_use_happy", "obj_installation_fly_happy" } } },
      { "cry", 1, 0, { { "spr_installation_cry", "obj_installation_fly_cry" } } }
      
  };
    
  private.start = {};
  private.start_items = {};
  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
      
    if i ~= 2 then
      
      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "obj_installation_"..private.tasks[ i ][ 1 ].."_portrait";
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme ); 
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      
      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "spr_installation_"..private.tasks[ i ][ 1 ].."_portrait";
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if not ( ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].stage ) or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].stage = { 1, 11 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].state = {};
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].state;

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ng_global.currentprogress == "std" then
    private.cur_progress = "std";
    common.SetPreviousRoom( "rm_apocalypse3" );
    cmn.StartTimePassing("ho_installation");
  else 
    
    private.cur_progress = "secret";
    
    private.CreateNewObjects();
    ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].stage = { 1, 11 };
    ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].state = {};
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].state;
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_installation_apocalypse3",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                        event_menter = function () rm_extra.GateMouseEnter( "installation_apocalypse3", CURSOR_DOWN, "extra" ); end, 
                                        event_mleave = function () common_impl.GateMouseLeave( "installation_apocalypse3" ); end });
    
  end;
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse3_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse3_env");

  if not cmn.IsEventStart( "win_installation" ) then
    cmn.InitHo( "installation" );
  end;

  local ho_tasks = private.stages_task();
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].stage;

  if not cmn.IsEventDone("win_installation") and ho_stage[1] <= ho_stage[2] then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;
  
  private.DrawScene();

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_game_2_mus", 1);
  
  local stage = ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].stage[1];
  
  if stage < 11 and ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played[stage] == 0 then
    ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played[stage] = 1;
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_"..(stage+6).."_voc");
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  SndStop( common_impl.audio.voc, 1 );
  
  if ng_global.currentprogress == "std" then

    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_installation_apocalypse3",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()
  
  if ng_global.progress[ private.cur_progress ][ "win_installation" ].stage[1] < ng_global.progress[ private.cur_progress ][ "win_installation" ].stage[2] then
  
    local name = private.task_names[ ng_global.progress[ private.cur_progress ][ "win_installation" ].stage[1] ];
    
    ObjDetach("obj_installation_"..name.."_portrait");
    
  end;
  
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "std" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_installation");

    if ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_installation" ] then

      ng_global.nohintho[ "win_installation" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_installation" ] then
      ng_global.playedhops[ "win_installation" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_installation_apocalypse3",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( task )
  
  local stage = ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].stage[1];
  
  local func_after = function ()
    
    ObjDelete("spr_installation_"..task);
    
    if stage ~= 6 and stage ~= 10 then
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_ho_installation_"..private.item_sfx[ stage ]);
      
      table.insert( private.state, task );
      
      if stage ~= 3 and stage ~= 7 then
        cmn.HoTaskFind( "obj_installation_fly_"..task, task, 1 );
      else 
        cmn.HoTaskFind( "obj_installation_fly_"..task, common.GetObjectPrefix(task), 1 );
      end;
      
      ObjAnimate("obj_installation_use_"..task, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    elseif stage == 6 then
      
      local anm_end = function ()
        
        cmn.Lock( 0 );
        table.insert( private.state, task );
        cmn.HoTaskFind( "obj_installation_fly_"..task, "machine", 1 );
        
        local num = 1;
        if task == "machine_2" then
          num = 2;
        end;
        
        ObjDelete("anm_installation_robot_"..num);
        ObjDelete("spr_installation_target_"..num);
        
        ObjMultiSet( { {"obj_installation_use_"..task, { alp = 1 }},
                       {"spr_installation_slot_"..num, { alp = 1 }} } );
        
      end;
      
      local anm_robot = function ()
        
        local num = 1;
        if task == "machine_2" then
          num = 2;
        end;
        
        ObjMultiSet( { {"obj_installation_use_"..task, { alp = 0 }},
                       {"anm_installation_robot_"..num, { alp = 1, playing = 1, endtrig = anm_end }},
                       {"spr_installation_target_"..num, { alp = 0 }} } );
        
      end;
                     
      if task == "machine_2" then
        cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_ho_installation_right_droid");
      else 
        cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_ho_installation_orange_droid");
      end;               
      
      ObjAnimate("obj_installation_use_"..task, "alp", 0, 0, anm_robot, { 0, 0, 0,   0.3, 0, 1 });
      
    elseif stage == 10 then
      table.insert( private.state, task );
      cmn.HoTaskFind( "obj_installation_fly_"..task, task, 1 );
    end;
    
  end;
  
  if stage < 11 then
    
    if stage == 6 then
      cmn.Lock( 1, { room = 1 } );
    end;
    
    ObjSet("spr_installation_"..task,  { input = 0 });
    ObjAnimate("spr_installation_"..task, "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
    
  else 
    
    local pos = GetObjPosByObj( "spr_installation_fang" );
    ObjSet( "spr_installation_fang", { pos_x = pos[1] + 171, pos_y = pos[2] } );
    
    cmn.HoTaskFind( "spr_installation_fang", "fang", 2 );
    
  end;
  
  if task == "machine_1" then
    ObjAnimate("spr_installation_machine_1_sh", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;

end;
--*********************************************************************************************************************
function private.DrawScene()
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].stage[1];

  for i = 1, #private.state, 1 do
    
    ObjDelete("spr_installation_"..private.state[i]);
    if private.state[i] == "machine_1" then
      ObjDelete("spr_installation_"..private.state[i].."_sh");
      ObjDelete("spr_installation_target_1");
      ObjDelete("anm_installation_robot_1");
      ObjSet("spr_installation_slot_1",  { alp = 1 });
    elseif private.state[i] == "machine_2" then
      ObjDelete("spr_installation_target_2");
      ObjDelete("anm_installation_robot_2");
      ObjSet("spr_installation_slot_2",  { alp = 1 });
    end;
    
    if private.state[i] ~= "cry" then
      ObjSet("obj_installation_use_"..private.state[i],  { alp = 1 });
    else 
      ObjDelete("obj_installation_podium");
      ObjSet("anm_installation_final",  { alp = 1, input = 1, frame = 400 });
    end;
    
  end;
  
end;
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
function private.stages_task()

  local ho_tasks = {};

  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].stage[1];

  if     ( ho_stage == 1 ) then

    interface.TaskPanelTaskAdd( ho_tasks, "evil", 1, 0, { { "spr_installation_evil" } } );
    ObjSet( "spr_installation_evil", { input = 1 } );
    
  elseif ( ho_stage == 2 ) then

    interface.TaskPanelTaskAdd( ho_tasks, "mind", 1, 0, { { "spr_installation_mind" } } );
    ObjSet( "spr_installation_mind", { input = 1 } );
    
  elseif ( ho_stage == 3 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "world", 2, 0, { { "spr_installation_world_1" }, { "spr_installation_world_2" } } );
    
    ObjMultiSet( { {"spr_installation_world_1", { input = 1 }},
                   {"spr_installation_world_2", { input = 1 }} } );

  elseif ( ho_stage == 4 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "protector", 1, 0, { { "spr_installation_protector" } } );
    ObjSet( "spr_installation_protector", { input = 1 } );

  elseif ( ho_stage == 5 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "attack", 1, 0, { { "spr_installation_attack" } } );
    ObjSet( "spr_installation_attack", { input = 1 } );
    
  elseif ( ho_stage == 6 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "machine", 2, 0, { { "spr_installation_machine_1" }, { "spr_installation_machine_2" } } );
    
    ObjMultiSet( { {"spr_installation_machine_1", { input = 1 }},
                   {"spr_installation_machine_2", { input = 1 }} } );
    
  elseif ( ho_stage == 7 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "reward", 2, 0, { { "spr_installation_reward_1" }, { "spr_installation_reward_2" } } );
    
    ObjMultiSet( { {"spr_installation_reward_1", { input = 1 }},
                   {"spr_installation_reward_2", { input = 1 }} } );

  elseif ( ho_stage == 8 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "god", 1, 0, { { "spr_installation_god" } } );
    ObjSet( "spr_installation_god", { input = 1 } );
    
  elseif ( ho_stage == 9 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "happy", 1, 0, { { "spr_installation_happy" } } );
    ObjSet( "spr_installation_happy", { input = 1 } );

  elseif ( ho_stage == 10 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "cry", 1, 0, { { "spr_installation_cry" } } );
    ObjSet( "spr_installation_cry", { input = 1 } );
    
  elseif ( ho_stage == 11 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "fang", 1, 0, { { "spr_installation_fang" } } );
    ObjSet( "spr_installation_fang", { input = 1 } );
    
  end;

  return ho_tasks;

end;
------------------------------------------------------------------------------
function public.stage_1()
 
end;
------------------------------------------------------------------------------
function public.stage_2()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );  
  
  ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played[2] = 1;
  
  SndStop("assets/levels/level3/audio/voc/aud_lvl_3_aion_7_voc", 0.5);
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_8_voc");
  
end;
------------------------------------------------------------------------------
function public.stage_3()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );  
  
  ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played[3] = 1;
  
  SndStop("assets/levels/level3/audio/voc/aud_lvl_3_aion_8_voc", 0.5);
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_9_voc");
  
end;
------------------------------------------------------------------------------
function public.stage_4()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );  
  
  ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played[4] = 1;
  
  SndStop("assets/levels/level3/audio/voc/aud_lvl_3_aion_9_voc", 0.5);
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_10_voc");
  
end;
------------------------------------------------------------------------------
function public.stage_5()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );  
  
  ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played[5] = 1;
  
  SndStop("assets/levels/level3/audio/voc/aud_lvl_3_aion_10_voc", 0.5);
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_11_voc");
  
end;
------------------------------------------------------------------------------
function public.stage_6()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );  
  
  ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played[6] = 1;
  
  SndStop("assets/levels/level3/audio/voc/aud_lvl_3_aion_11_voc", 0.5);
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_12_voc");
  
end;
------------------------------------------------------------------------------
function public.stage_7()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );  
  
  ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played[7] = 1;
  
  SndStop("assets/levels/level3/audio/voc/aud_lvl_3_aion_12_voc", 0.5);
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_13_voc");
  
end;
------------------------------------------------------------------------------
function public.stage_8()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );  
  
  ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played[8] = 1;
  
  SndStop("assets/levels/level3/audio/voc/aud_lvl_3_aion_13_voc", 0.5);
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_14_voc");
  
end;
------------------------------------------------------------------------------
function public.stage_9()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );  
  
  ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played[9] = 1;
  
  SndStop("assets/levels/level3/audio/voc/aud_lvl_3_aion_14_voc", 0.5);
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_15_voc");
  
end;
------------------------------------------------------------------------------
function public.stage_10()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );  
  
  ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].voice_played[10] = 1;
  
  SndStop("assets/levels/level3/audio/voc/aud_lvl_3_aion_15_voc", 0.5);
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_16_voc");
  
end;
------------------------------------------------------------------------------
function public.stage_11()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );  
  
  local func_after = function ()
    cmn.Lock( 0 );
    ObjSet("anm_installation_final",  { input = 1 });
  end;
  
  cmn.Lock( 1, { room = 1 } );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_ho_installation_under_water");
  
  ObjDelete("obj_installation_podium");
  ObjSet("anm_installation_final",  { alp = 1, playing = 1, endtrig = func_after });
  
end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_itm = private.start_items;
  
  for i = 1, #ho_obj, 1 do
    
    --DbgTrace(ho_obj[i].name)

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      if typ == "anm" then
        typ = "anim";
      end;
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_itm, 1 do
    
    if not ObjGet( ho_itm[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_itm[i].name );
      
      ObjCreate( ho_itm[i].name, typ );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );

    end;
    
  end;

end;
--*********************************************************************************************************************