-- name=mg_aion
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_aion";
  --------------------------------------------------------------------------------------------
  private.player_pos = {
    {206, 460}, {365, 410}, {227, 364}, {93, 325}, {115, 245}, {255, 208}, {137, 170}, {269, 139},
    {389, 172}, {516, 207}, {382, 243}, {528, 285}, {377, 325}, {513, 364}, {678, 410}, {672, 325},
    {806, 282}, {932, 243}, {792, 207}, {912, 171}, {780, 137}, {657, 172}, {529, 73}
  };
  private.board_challenges = {
    1, 3, 2, 3, 4, 1, 2, 4, 3, 2, 4, 3, 1, 1, 4, 2, 4, 2, 1, 4, 3, 4, 1
  };
  private.board_challenges_num = {
    1, 1, 1, 2, 1, 1, 2, 2, 3, 3, 3, 4, 1, 1, 4, 4, 5, 5, 1, 6, 5, 7, 1
  };
  
  private.right_answers = {4, 1, 2, 3, 2};
  
  private.right_symbolls = { {3, 1, 2}, {3, 4, 2, 1}, {2, 4, 3, 1}, {3, 1, 4, 5, 2}, {5, 3, 1, 4, 2} };
  private.symbolls_pos = {
    { {301, 306}, {497, 306}, {693, 306} },
    { {257, 306}, {407, 306}, {587, 306}, {733, 306} },
    { {232, 306}, {369, 306}, {497, 306}, {644, 306}, {782, 306} }
  };
  private.symbolls_pos_bott = {
    { {366, 525}, {497, 525}, {628, 525} },
    { {310, 525}, {441, 525}, {572, 525}, {703, 525} },
    { {235, 525}, {366, 525}, {497, 525}, {628, 525}, {759, 525} }
  };
  
  private.in_progress = false;
  private.board = false;
  private.hit_progress = false;
  private.attack_progress = false;
  
  private.alien_type = { "purple", "green" };
  private.alien_act = { "waiting", "jump", "atack" };
  private.alien_type_attack = { "func_damage_from_purpur", "func_damage_from_green" };
  private.current_alien = { 0, 0, 0, 0 };
  private.enemies = { 3, 4, 4, 5, 5, 6, 6 };
  private.enemy_next = 0;
  private.enemy_pause = { 1.4, 1.2, 1.2, 1, 1, 0.8, 0.6 };
  private.crows_pause = { 3, 2, 4, 3, 3, 4, 3 };
  private.crows = { 1, 1, 2, 2, 2, 3, 3 };
  private.crows_cur = {};
  
  private.gun = 1;
  
  private.progress = "std";
  private.secret_al = { 0, 0, 0, 0 };
  --------------------------------------------------------------------------------------------
  -- function win_aion () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_aion" ] = {
    type = "click",
    use_place = "obj_aion_clk_towin",
    room = "mg_aion"
  };
  --------------------------------------------------------------------------------------------
  local win_aion = function ()

    if cmn.IsEventDone( "win_aion" ) then
      ObjDelete("gmg_aion_board");
      ObjDelete("obj_aion_challenge_2");
      ObjDelete("obj_aion_challenge_3");
      ObjDelete("obj_aion_challenge_4");
      ObjDelete("obj_aion_challenge_4_2");
      ObjDelete("obj_aion_interface");
      ObjDelete("obj_aion_board");
      ObjAttach("obj_aion_dialog_aion2", "mg_aion");
      ObjMultiSet( { {"obj_aion_dialog_aion2", { alp = 1, input = 1 }},
                     {"obj_aion_dialog_aion2_choice", { alp = 1, input = 1 }} } );
    end;

  end;
--  local win_aion_loc = function ()
--
--  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_aion", win_aion, "mg_aion" );
--  cmn.AddSubscriber( "win_aion", win_aion_loc, "rm_debughall" );

  --------------------------------------------------------------------------------------------
  -- function clk_chooseending () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_chooseending" ] = {
    type = "click",
    use_place = "obj_aion_dialog_aion2_choice_1",
    room = "mg_aion"
  };
  --------------------------------------------------------------------------------------------
  local clk_chooseending_lvl = function ()
    level3.in_progress = false;
  end;
  local clk_chooseending_loc = function ()
  
    ObjDelete("obj_aion_dialog_aion2");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_chooseending", clk_chooseending_loc, "mg_aion" );
  cmn.AddSubscriber( "clk_chooseending", clk_chooseending_lvl );

  --------------------------------------------------------------------------------------------
  -- function opn_aion () end;
  --------------------------------------------------------------------------------------------
  local opn_aion_map = function ()
    int_map_impl.OpenRoom( "mg_aion" );
  end;
  local opn_aion = function ()

    ObjDelete("obj_aion_dialog_aion1");

    ObjMultiSet( { {"obj_aion_gameboard",  { alp = 1 }},
                   {"obj_aion_interface", { alp = 1 }} } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_aion", opn_aion, "mg_aion" );
  cmn.AddSubscriber( "opn_aion", opn_aion_map );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state;
  private.state_3 = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_3;
  private.state_4 = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_4;
  
  if ng_global.player_gun then
    private.gun = ng_global.player_gun;
  end;

end;
--*********************************************************************************************************************
function public.Open() 
  
  if ng_global.currentprogress == "std" and not cmn.IsEventDone("clk_chooseending") then
    cmn.PlayAudio("mus", "assets/levels/level3/audio/mus/aud_aion_choice_mus", 1);
  end;

  if ng_global.currentprogress == "std" and not cmn.IsEventDone("opn_aion") then
    cmn.SetEventDone("opn_aion");
    private.dialog_open(1);
  elseif ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_aion" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_aion");
  elseif ng_global.currentprogress == "std" and cmn.IsEventDone("clk_chooseending") then
    
    local func_after = function()
      cmn.GotoRoom( "rm_credits", 0, true );
    end;
    
    local vid = 1;
    if ng_global.ending then
      vid = ng_global.ending;
    end;
  
    local voc = "assets/levels/level3/audio/voc/";
    if vid == 1 then
      voc = voc.."aud_lvl_3_naya_6_voc";
    else 
      voc = voc.."aud_lvl_3_aion_6_voc";
    end;
    
    cmn.Lock( 0 );
    cmn.StopAllEnv();

    cmn.PlayFullscreenVideo( "assets/levels/level3/mg_aion/vid_lvl3outro"..vid,
                             func_after,
                             "assets/levels/level3/audio/mus/aud_vid_lvl3outro"..vid.."_mus",
                             voc );
                           
  end;
                           
  if ng_global.currentprogress == "secret" then
    rm_extra.MiniGameShow();
    cmn.PlayAudio("mus", "assets/levels/level3/audio/mus/aud_aion_choice_mus", 1);
  end;
                           
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_mg_aion_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_mg_aion_env");
  
  if ng_global.currentprogress == "std" and not cmn.IsEventDone("opn_aion") then
    cmn.Lock( 1 );
  end;

  if ng_global.currentprogress == "std" then
    private.progress = "std";
    common.SetPreviousRoom( "rm_debughall" );
  else
    
    private.progress = "secret";
    private.StartConditions();
    ObjDelete("obj_col_6");
    
    private.in_progress = false;
    private.board = false;
    private.hit_progress = false;
    private.attack_progress = false;
    
    ObjMultiSet( { {"gmg_aion_board", { alp = 1, input = 1, active = 1 }},
                   {"obj_aion_board", { alp = 0, input = 0 }},
                   {"obj_aion_interface", { alp = 1 }},
                   {"obj_aion_gameboard", { alp = 1 }},
                   {"anm_aion_aion_0", { alp = 1, playing = 1 }},
                   {"anm_aion_aion_cast", { alp = 0, playing = 0, frame = 0  }},
                   {"anm_alien_vent_1_1", { alp = 1, playing = 0, frame = 0 }},
                   {"anm_alien_vent_1_2", { alp = 0, playing = 0, frame = 0 }},
                   {"anm_alien_vent_2_1", { alp = 1, playing = 0, frame = 0 }},
                   {"anm_alien_vent_2_2", { alp = 0, playing = 0, frame = 0 }},
                   {"obj_aion_weapon", { alp = 0 }},
                   {"obj_aion_aim", { alp = 0 }} } );
     
    if private.board_challenges[ private.state[1] ] == 2 then              
      private.Challenge2Reset();
    elseif private.board_challenges[ private.state[1] ] == 3 then  
      private.Challenge3Reset();
    end;
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state;
    private.state_3 = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_3;
    private.state_4 = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_4;
    
    ObjSet("grm_aion_debughall",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                    event_menter = function () rm_extra.GateMouseEnter( "aion_debughall", CURSOR_DOWN, "extra" ); end, 
                                    event_mleave = function () common_impl.GateMouseLeave( "aion_debughall" ); end });
    
  end;
  
  private.DrawScene();
  
  if ng_global.currentprogress == "std" and cmn.IsEventDone("clk_chooseending") then
    
    ObjSet("mg_aion",  { color_r = 0, color_g = 0, color_b = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );
    interface.WidgetSetInput( InterfaceWidget_ButtonDiary,   false );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_ButtonDiary,   false, false );
    
    ng_global.progress[ "std" ].common.gamewin = true;
    
  end;
  
  --анимация морф-оъекта
  if ng_global.currentprogress == "std" and cmn.IsCollectableAvailible(6) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  SetCursor(CURSOR_DEFAULT);
  
  if private.progress == "secret" then
    
    local stage = private.board_challenges_num[ private.state[1] ];
    
    local al = private.secret_al[1];
    local way = private.secret_al[3];
    local con = private.secret_al[4];
    
    --private.StopAlien();
    private.enemy_next = 0;
    
    if al > 0 then
      private.ResetAlien( stage, way, con );
    end;
    
    for i = 1, 3, 1 do
      private.ResetCrow( i );
    end;
      
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;
  
  SndStop("assets/levels/level2/audio/sfx/aud_mmg_monsters_appears", 0.5);
  SndStop("assets/levels/level3/audio/sfx/aud_mg_aion_crows_appear", 0.5);

  if ng_global.currentprogress == "std" and cmn.IsEventDone("opn_aion") and not(cmn.IsEventDone( "win_aion" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_aion" )) then
    rm_extra.MiniGameHide();
  end;
  
  if private.progress == "secret" then
    private.secret_al = { 0, 0, 0, 0 };
    private.secret_al[1] = private.current_alien[1];
    private.secret_al[3] = private.current_alien[3];
    private.secret_al[4]= private.current_alien[4];
    private.StopAlien();
    for i = 1, 3, 1 do
      ObjSet("anm_aion_crow_"..i,  { endtrig = "" });
    end;
    ObjMultiSet( { {"tmr_aion_timer_aim", { playing = 0 }},
                   {"tmr_aion_timer_alien", { playing = 0 }},
                   {"tmr_aion_timer_crow", { playing = 0 }},
                   {"anm_aion_aion_cast", { endtrig = "" }} } );
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  if private.state[1] > 1 then
    
    if private.board then
      
      cmn.Lock( 1 );
      
      private.StartConditions();
      local hp = private.state[3];
      local tme = 0;
      
      if hp < 8 then
        
        for i = hp+1, 8, 1 do
          ObjAnimate("spr_aion_hp_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        end;
        
      end;
      
      local set_player = function ()
        
        for i = 2, 4, 1 do
          ObjSet("spr_aion_board_light_"..i,  { alp = 0 });
        end;
        
        ObjMultiSet( { {"spr_aion_board_light_1", { alp = 1 }},
                       {"obj_aion_player", { pos_x = private.player_pos[ private.state[1] ][1], pos_y = private.player_pos[ private.state[1] ][2] }} } );
                       
        ObjAnimate("obj_aion_player", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 0,   0.3, 0, 1 });
        
      end;
                     
      private.state = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state;
      private.state_3 = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_3;
      private.state_4 = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_4;
      
      ObjAnimate("obj_aion_player", "alp", 0, 0, set_player, { 0, 0, 1,   0.3, 0, 0 });
      
    elseif private.state[2] == 0 then
    
      cmn.Lock( 1 );
      
      if private.board_challenges[ private.state[1] ] == 4 then
        
        SndStop("assets/levels/level2/audio/sfx/aud_mmg_monsters_appears", 0.5);
        SndStop("assets/levels/level3/audio/sfx/aud_mg_aion_crows_appear", 0.5);
        
        local stage = private.board_challenges_num[ private.state[1] ];
        local al = private.current_alien[1];
        local way = private.current_alien[3];
        local con = private.current_alien[4];
        
        local anm_alien = function ()
          private.ResetAlien( stage, way, con );
        end;
        
        if private.current_alien[1] > 0 then
          private.StopAlien();
          ObjSet("tmr_aion_timer_alien",  { time = 0.5, playing = 1, endtrig = anm_alien });
        else 
          ObjSet("tmr_aion_timer_alien",  { playing = 0 });
        end;
        
        if #private.crows_cur > 0 then
          
          ObjSet("tmr_aion_timer_crow",  { playing = 0 });
          
          for i = 1, #private.crows_cur, 1 do
            ObjSet("anm_aion_crow_"..private.crows_cur[i],  { endtrig = "" });
            ObjAnimate("anm_aion_crow_"..private.crows_cur[i], "alp", 0, 0, function() private.ResetCrow( private.crows_cur[i] ); end, { 0, 0, 1,   0.3, 0, 0 });
          end;
          
        end;
        
      end;
      
      private.Death( true );
      
    else 
      
      local hp = private.state[3];
      
      private.StartConditions();
      private.state = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state;
      private.state_3 = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_3;
      private.state_4 = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_4;
      
      private.SetBoard();
      
      if hp < 8 then
        
        cmn.Lock( 1 );
        
        for i = hp+1, 8, 1 do
          ObjAnimate("spr_aion_hp_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        end;
        
        ObjSet("tmr_aion_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
        
      end;
      
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock( 1 );
  
  ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state = { 23, 1, 8 }; 
  ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state[3] = private.state[3];
  
  if private.state[2] == 1 then
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state;
    private.CheckWin( private.board );
  else 
    
    ObjSet("obj_aion_challenge_"..private.board_challenges[ private.state[1] ],  { input = 0 });
    ObjAnimate("obj_aion_challenge_"..private.board_challenges[ private.state[1] ], "alp", 0, 0, function() private.CheckWin(false); end, { 0, 0, 1,   0.5, 0, 0 });
    
    if private.board_challenges[ private.state[1] ] == 4 then
        
      SndStop("assets/levels/level2/audio/sfx/aud_mmg_monsters_appears", 0.5);
      
      local stage = private.board_challenges_num[ private.state[1] ];
      local al = private.current_alien[1];
      local way = private.current_alien[3];
      local con = private.current_alien[4];
      
      local anm_alien = function ()
        private.ResetAlien( stage, way, con );
      end;
      
      if private.current_alien[1] > 0 then
        private.StopAlien();
        ObjSet("tmr_aion_timer_alien",  { time = 0.5, playing = 1, endtrig = anm_alien });
      else 
        ObjSet("tmr_aion_timer_alien",  { playing = 0 });
      end;
      
      if #private.crows_cur > 0 then
          
        ObjSet("tmr_aion_timer_crow",  { playing = 0 });
        
        for i = 1, #private.crows_cur, 1 do
          ObjAnimate("anm_aion_crow_"..private.crows_cur[i], "alp", 0, 0, function() private.ResetCrow( private.crows_cur[i] ); end, { 0, 0, 1,   0.3, 0, 0 });
        end;
        
      end;
      
    end;
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state;
    
  end;

end;
--*********************************************************************************************************************
function public.BoardGameShow( inout )
  
  local func_after = function ()
    
    cmn.Lock(0);
    ObjSet("obj_aion_board",  { input = inout });
    
  end;

  cmn.Lock(1);
  
  local alf = 1;
  if inout == 1 then
    private.board = true;
    private.SetBoard();
    alf = 0;
  else 
    private.board = false;
  end;
  
  ObjAnimate("obj_aion_board", "alp", 0, 0, func_after, { 0, 2, alf,   0.5, 2, inout });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_6_1", { alp = 1 }},
                 {"spr_col_6_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_6_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_6_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_6_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_6_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_6_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_6_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_open( num )
  
  --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  local func_after = function() private.dialog_aion1_beg(); end;
  if num == 2 then
    func_after = function() private.dialog_aion2_beg(); end;
  end;
  
  ObjAttach("obj_aion_dialog_aion"..num, "mg_aion");
  ObjAnimate("obj_aion_dialog_aion"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_aion1_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "aion", "aion1", 2 );
  
  local dialog_end = function ()
    
    ObjMultiSet( { {"gmg_aion_board",  { active = 1, input = 1, alp = 1 }},
                   {"obj_aion_gameboard", { alp = 1 }},
                   {"obj_aion_interface", { alp = 1 }} } );
  
    cmn.CallEventHandler( "opn_aion" );
    common_impl.current_dialog = "";
    
    cmn.MiniGameShow();
    cmn.StartTimePassing("mg_aion");
    
    cmn.ShowBbt( "aion_after_dialog_1" );
    
  end;
  
  local anm_start = function ()
    
    interface.InterfaceSetInput( true );
    cmn.PlayFullscreenVideo( "assets/levels/level3/mg_aion/vid_game_start", dialog_end, "assets/levels/level3/audio/sfx/aud_aion_creates_table", "", 1, 20, false, true, true );
    
  end;
  
  local anm_hide = function ()
    
    private.dlg_lipsync = "";
    --ObjDelete("vid_laboratory_dialog_robot_lipsync1");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjSet("tmr_aion_dialog_aion1_timer",  { playing = 0 });
    
    ObjAnimate("obj_aion_dialog_aion1", "alp", 0, 0, anm_start, { 0, 0, 1,   0.6, 0, 0 });
    
  end;
  
  local aion_talks2 = function ()
  
    cmn.ShowDlgBbt( "dlg_aion1_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_2_voc");
    
    ObjMultiSet( { {"tmr_aion_dialog_aion1_timer", { endtrig = anm_hide, time = 6, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hide }},
                   {"obj_character_dialog_continue", { event_mup = anm_hide }} } );
  
  end;
                 
  cmn.ShowDlgBbt( "dlg_aion1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_1_voc");

  ObjMultiSet( { {"tmr_aion_dialog_aion1_timer", { time = 15, playing = 1, endtrig = aion_talks2 }},
                 {"spr_character_dialog_continue", { event_mup = aion_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = aion_talks2 }},
                 {"spr_character_dialog_skip", { event_mup = mg_aion.skip_dlg_aion1 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function private.dialog_aion2_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "aion", "aion2", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "win_aion" );
    cmn.ShowBbt( "aion_after_dialog_2" );
    
    common_impl.PauseAchiev( 0 );
    
  end;
  
  local anm_hand = function ()
    
    private.dlg_lipsync = "";
    --ObjDelete("vid_aion_dialog_aion2_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjSet("tmr_aion_dialog_aion2_timer",  { playing = 0 });
    
    ObjAnimate("obj_aion_dialog_aion2_choice", "alp", 0, 0, dialog_end, { 0, 0, 0,   0.5, 0, 1 });
    
  end;
  
  local aion_talks3 = function ()
  
    cmn.ShowDlgBbt( "dlg_aion2_phrase_3" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_5_voc");
    
    ObjMultiSet( { {"tmr_aion_dialog_aion2_timer", { endtrig = anm_hand, time = 14, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hand }},
                   {"obj_character_dialog_continue", { event_mup = anm_hand }} } );
  
  end;
  
  local aion_talks2 = function ()
  
    cmn.ShowDlgBbt( "dlg_aion2_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_4_voc");
    
    ObjMultiSet( { {"tmr_aion_dialog_aion2_timer", { endtrig = aion_talks3, time = 15, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = aion_talks3 }},
                   {"obj_character_dialog_continue", { event_mup = aion_talks3 }} } );
  
  end;

  cmn.ShowDlgBbt( "dlg_aion2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_aion_3_voc");

  ObjMultiSet( { {"tmr_aion_dialog_aion2_timer", { time = 9, playing = 1, endtrig = aion_talks2 }},
                 {"spr_character_dialog_continue", { event_mup = aion_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = aion_talks2 }},
                 {"spr_character_dialog_skip", { event_mup = mg_aion.skip_dlg_aion2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_aion1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";
  
  local func_after_dlg = function ()
    
    ObjMultiSet( { {"gmg_aion_board",  { active = 1, input = 1, alp = 1 }},
                   {"obj_aion_gameboard", { alp = 1 }},
                   {"obj_aion_interface", { alp = 1 }} } );

    cmn.CallEventHandler( "opn_aion" );
    
    cmn.MiniGameShow();
    cmn.StartTimePassing("mg_aion");
    
    cmn.ShowBbt( "aion_after_dialog_1" );
    
  end;
  
  local anm_start = function ()
    
    cmn.Lock(0);
    cmn.PlayFullscreenVideo( "assets/levels/level3/mg_aion/vid_game_start", func_after_dlg, "assets/levels/level3/audio/sfx/aud_aion_creates_table", "", 1, 20, false, true, true );
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    --ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  ObjSet("tmr_aion_dialog_aion1_timer",  { playing = 0 });
  
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_aion_dialog_aion1", "alp", 0, 0, anm_start, { 0, 0, 1,   0.6, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_aion2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    common_impl.PauseAchiev( 0 );
    
    cmn.CallEventHandler( "win_aion" );
    cmn.ShowBbt( "aion_after_dialog_2" );
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    --ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  ObjSet("tmr_aion_dialog_aion2_timer",  { playing = 0 });
  
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_aion_dialog_aion2_choice", "alp", 0, 0, func_after_dlg, { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function public.ChooseEnding( num )

  ng_global.ending = num;
  cmn.SetEventDone("clk_chooseending");
  
  local func_after = function ()
    
    cmn.CallEventHandler("clk_chooseending");
    ObjSet("mg_aion",  { color_r = 0, color_g = 0, color_b = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );
    interface.WidgetSetInput( InterfaceWidget_ButtonDiary,   false );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_ButtonDiary,   false, false );

    ng_global.progress[ "std" ].common.gamewin = true;
    
    iOS_RegisterGameplay("level_4"); 
    cmn.GotoRoom( "rm_credits", 0, true );
    
  end;
  
  local vid = 1;
  if ng_global.ending then
    vid = ng_global.ending;
  end;
  
  local voc = "assets/levels/level3/audio/voc/";
  if vid == 1 then
    voc = voc.."aud_lvl_3_naya_6_voc";
  else 
    voc = voc.."aud_lvl_3_aion_6_voc";
  end;
  
  cmn.Lock( 0 );
  cmn.StopAllEnv();

  cmn.PlayFullscreenVideo( "assets/levels/level3/mg_aion/vid_lvl3outro"..vid,
                           func_after,
                           "assets/levels/level3/audio/mus/aud_vid_lvl3outro"..vid.."_mus",
                           voc );
  
end;
-----------------------------------------------------------------------------------
function private.PlayOutro()
  
  local func_after = function ()
    
    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );
    interface.WidgetSetInput( InterfaceWidget_ButtonDiary,   false );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_ButtonDiary,   false, false );

    ng_global.progress[ "std" ].common.gamewin = true;
    cmn.GotoRoom( "rm_credits", 0, true );
    
  end;
  
  local vid = 1;
  if ng_global.ending then
    vid = ng_global.ending;
  end;
  
  local voc = "assets/levels/level3/audio/voc/";
  if vid == 1 then
    voc = voc.."aud_lvl_3_naya_6_voc";
  else 
    voc = voc.."aud_lvl_3_aion_6_voc";
  end;
  
  cmn.Lock( 0 );
  cmn.StopAllEnv();

  cmn.PlayFullscreenVideo( "assets/levels/level3/mg_aion/vid_lvl3outro"..vid,
                           func_after,
                           "assets/levels/level3/audio/mus/aud_vid_lvl3outro"..vid.."_mus",
                           voc );
  
end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state = { 1, 1, 8 }; 
  --[1] - current place, [2] - state of challenge: 0 - active, 1 - done, [3] - hp
  
  ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].stage = 1;
  
  ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_3 = { {0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0, 0}, {0, 0, 0, 0, 0} };

  ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_4 = { 0, 0, 0, 0, 0, 0, 0 };
  
end;
-----------------------------------------------------------------------------------
function private.DrawScene()

  private.SetBoard();
  
  for i = 1, 2, 1 do
    
    if i == private.gun then
      ObjSet("anm_aion_gunfire_"..i,  { alp = 1 });
    else 
      ObjSet("anm_aion_gunfire_"..i,  { alp = 0 });
    end;
    
  end;
  
  if private.board_challenges[ private.state[1] ] == 2 and private.state[2] == 0 and not private.in_progress then
    private.Challenge2Set();
  elseif private.board_challenges[ private.state[1] ] ~= 2 or private.state[2] == 1 then
    ObjSet("obj_aion_challenge_2",  { alp = 0, input = 0 });
  end;
  
  if private.board_challenges[ private.state[1] ] == 3 and private.state[2] == 0 and not private.in_progress then
    private.Challenge3Set();
    private.CheckSymbolls();
  --elseif private.board_challenges[ private.state[1] ] == 3 and private.state[2] == 0 and not private.in_progress then
  --  private.Challenge3Start();
  elseif private.board_challenges[ private.state[1] ] ~= 3 or private.state[2] == 1 then
    ObjSet("obj_aion_challenge_3",  { alp = 0, input = 0 });
  end;
  
  if private.board_challenges[ private.state[1] ] == 4 and private.state[2] == 0 and not private.in_progress then
    private.Challenge4Set();
    private.CheckWinShooter( false );
  elseif private.board_challenges[ private.state[1] ] ~= 4 or private.state[2] == 1 then
    ObjMultiSet( { {"obj_aion_challenge_4", { input = 0 }},
                   {"obj_aion_challenge_4_2", { input = 0 }} } );
  end;
  
  for i = 1, private.state[3], 1 do
    ObjSet("spr_aion_hp_"..i,  { alp = 1 });
  end;
  for i = private.state[3]+1, 8, 1 do
    ObjSet("spr_aion_hp_"..i,  { alp = 0 });
  end;
  
  if private.state[2] == 0 then
    ObjSet("gmg_aion_board",  { active = 0, input = 0, alp = 0 });
  elseif (ng_global.currentprogress == "std" and cmn.IsEventDone("opn_aion")) or ng_global.currentprogress == "secret" then
    ObjSet("gmg_aion_board",  { active = 1, input = 1, alp = 1 });
  end;
  
  private.in_progress = true;
  
end;
-----------------------------------------------------------------------------------
function private.SetBoard()
  
  ObjSet("obj_aion_player", { pos_x = private.player_pos[ private.state[1] ][1], pos_y = private.player_pos[ private.state[1] ][2] });
  
  for i = 1, 4, 1 do
    
    if i == private.board_challenges[ private.state[1] ] and private.state[1] < 23 then
      ObjSet("spr_aion_board_light_"..i,  { alp = 1 });
    else 
      ObjSet("spr_aion_board_light_"..i,  { alp = 0 });
    end;
      
  end;

  if private.state[2] == 1 then
    ObjMultiSet( { {"obj_aion_ball",  { input = 1 }},
                   {"spr_aion_ball_light", { alp = 1 }} } );
  else 
    ObjMultiSet( { {"obj_aion_ball",  { input = 0 }},
                   {"spr_aion_ball_light", { alp = 0 }} } );
  end;
  
end;
-----------------------------------------------------------------------------------
--private.click_terator = 0;
function public.ClickBall()

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_click_ball");
  
  cmn.ShowBbt( "aion_ball_"..math.random(1, 4) );
  
  private.board = false;
  
  local move = math.random(1, 100);
  if move <= 10 then
    move = 4;
  elseif move <= 30 then
    move = 3;
  elseif move <= 60 then
    move = 2;
  else
    move = 1;
  end;
  
  --if private.click_terator == 0 then
  --  move = 2;
  --elseif private.click_terator == 1 then
  --  move = 4;
  --elseif private.click_terator == 2 then
  --  move = 3;
  --elseif private.click_terator == 3 then
  --  move = 6;
  --elseif private.click_terator == 4 then
  --  move = 2;
  --end;  
  --private.click_terator = private.click_terator + 1;
  
  local place = private.state[1];
  private.state[1] = private.state[1] + move;
  if private.state[1] > 23 then
    private.state[1] = 23;
  end;
  
  local count = private.state[1] - place;
  
  if private.board_challenges[ private.state[1] ] > 1 then
    private.state[2] = 0;
    ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].stage = private.board_challenges[ private.state[1] ];
  end;
  
  local make_move = function ()
    
    ObjAnimate("spr_aion_board_light_"..private.board_challenges[ place ], "alp", 0, 0, function() private.MakeMoves( place, count, move ) end, { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    ObjAnimate("spr_aion_ball_number_"..move, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  local anm_ball = function ()
    ObjSet("anm_aion_ball", { playing = 1, endtrig = make_move });
  end;
  
  ObjAnimate("spr_aion_ball_light", "alp", 0, 0, anm_ball, { 0, 0, 1,   0.3, 0, 0 });
  
  --ObjSet("anm_aion_ball", { playing = 1, endtrig = make_move });
  
end;
-----------------------------------------------------------------------------------
function private.MakeMoveEnd( move )
  
  int_blackbartext.Hide();
  
  local func_after = function ()
    
    if private.state[2] == 1 then
      ObjAnimate("spr_aion_ball_light", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 0,   0.3, 0, 1 });
      ObjSet("obj_aion_ball",  { input = 1 });
    else 
      private.StartChallenge( private.board_challenges[ private.state[1] ] );
      ObjSet("obj_aion_ball",  { input = 0 });
    end;
    
  end;
  
  if private.state[2] == 1 then
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_lucky");
  else 
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_unlucky");
  end;
  
  ObjAnimate("spr_aion_ball_number_"..move, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
  if private.state[1] < 23 then
    ObjAnimate("spr_aion_board_light_"..private.board_challenges[ private.state[1] ], "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  else 
    private.CheckWin( true );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.MakeMoves( place, num, move )
  
  if num > 0 then
    
    cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mg_aion_atom_moves_"..math.random(1, 3) );
    
    ObjAnimate("obj_aion_player", "pos_xy", 0, 0, function() private.MakeMoves( place+1, num-1, move ) end, { 
        0, 0, private.player_pos[ place ][1], private.player_pos[ place ][2],   
      0.5, 0, private.player_pos[ place+1 ][1], private.player_pos[ place+1 ][2] ,   
      0.7, 0, private.player_pos[ place+1 ][1], private.player_pos[ place+1 ][2]
    });
    
  else
    private.MakeMoveEnd( move );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.StartChallenge( num )
  
  local func_after;
  if num == 2 then
    ObjSet("anm_aion_aion_0",  { alp = 0, playing = 0 });
    func_after = private.Challenge2Start;
  elseif num == 3 then
    ObjSet("anm_aion_aion_0",  { alp = 0, playing = 0 });
    func_after = private.Challenge3Start;
  elseif num == 4 then
    private.AimTarget();
    SetCursor(CURSOR_NULL);
    ObjMultiSet( { {"obj_aion_weapon", { alp = 1 }},
                   {"obj_aion_aim", { alp = 1 }} } );
    func_after = private.Challenge4Start;
  end;
  
  ObjMultiSet( { {"obj_aion_challenge_"..num,  { alp = 1, input = 1 }},
                 {"gmg_aion_board",  { active = 0, input = 0, alp = 0 }},
                 {"obj_aion_board",  { input = 0 }} } );
  
  ObjAnimate("obj_aion_board", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
  
end;
--*********************************************************************************************************************
-- function *** RIDDLES *** () end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------
function public.ChooseAnswer( num )
  
  cmn.Lock( 1 );
  ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].stage = 1;
  
  if private.right_answers[ private.board_challenges_num[ private.state[1] ] ] == num then
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_question_right");
    
    private.state[2] = 1;
    
    local func_after = function ()
      cmn.ShowBbt( "aion_win_"..math.random(1, 3) );
      private.Challenge2Pass();
    end;
    
    ObjAnimate("spr_aion_answer_"..num.."_right", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1,   1, 0, 1,   1.5, 0, 0 });
    
  else 
    
    private.state[2] = 1;
    private.state[3] = private.state[3] - 1;
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_question_wrong_fire_blast");
    
    ObjAnimate("spr_aion_answer_"..num.."_wrong", "alp", 0, 0, private.Challenge2Kill, { 0, 0, 0,   0.5, 0, 1,   1, 0, 1,   1.5, 0, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.FocusAnswer( num, inout )
  
  local obj = "spr_aion_answer_"..num.."_focus";
  
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mg_aion_question_arrow_"..math.random(1, 3) );
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function private.Challenge2Start()
  
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_shows_questions");
  
  local new = private.board_challenges_num[ private.state[1] ];
  
  local set_game = function ()
    
    ObjMultiSet( { {"anm_aion_challenge_2_start",  { alp = 0, frame = 0, endtrig = "" }},
                   {"anm_aion_challenge_2",  { alp = 1, playing = 1, input = 1 }},
                   {"txt_aion_question_text", { text = StringGet("str_aion_question_"..new) }} } );
                   
    ObjAnimate("txt_aion_question_text", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 0,   0.5, 0, 1 });
    
    for i = 1, 4, 1 do
      ObjSet("txt_aion_answer_"..i.."_text",  { text = StringGet("str_aion_answer_"..new.."_"..i) });
      ObjAnimate("txt_aion_answer_"..i.."_text", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  ObjMultiSet( { {"anm_aion_challenge_2_start",  { alp = 1, frame = 0, playing = 1, endtrig = set_game }},
                 {"txt_aion_question_text", { text = "", alp = 0 }} } );
  
  for i = 1, 4, 1 do
    ObjSet("txt_aion_answer_"..i.."_text",  { text = "", alp = 0 });
  end;
  
end;
-----------------------------------------------------------------------------------
function private.Challenge2Set()
  
  local new = private.board_challenges_num[ private.state[1] ];
  
  ObjMultiSet( { {"anm_aion_challenge_2_start",  { alp = 0, frame = 0, endtrig = "" }},
                 {"anm_aion_challenge_2",  { alp = 1, playing = 1, input = 1 }},
                 {"txt_aion_question_text", { text = StringGet("str_aion_question_"..new), alp = 1 }},
                 {"obj_aion_challenge_2",  { alp = 1, input = 1 }},
                 {"anm_aion_aion_0",  { alp = 0, playing = 0 }} } );
                   
  
  for i = 1, 4, 1 do
    ObjSet("txt_aion_answer_"..i.."_text",  { text = StringGet("str_aion_answer_"..new.."_"..i), alp = 1 });
  end;
  
end;
-----------------------------------------------------------------------------------
function private.Challenge2Reset()
  
  local new = private.board_challenges_num[ private.state[1] ];
  
  ObjMultiSet( { {"anm_aion_challenge_2_start",  { alp = 1, frame = 0, endtrig = "" }},
                 {"anm_aion_challenge_2",  { alp = 0, playing = 0, input = 0 }},
                 {"txt_aion_question_text", { text = "", alp = 0 }},
                 {"obj_aion_challenge_2",  { alp = 0, input = 0 }} } );
                   
  
  for i = 1, 4, 1 do
    ObjSet("txt_aion_answer_"..i.."_text",  { text = "", alp = 0 });
  end;
  
end;
-----------------------------------------------------------------------------------
function private.Challenge2Pass()
  
  local func_after = function ()
    
    --cmn.Lock( 0 );
    
    ObjMultiSet( { {"obj_aion_challenge_2", { input = 0 }},
                   {"anm_aion_challenge_2", { alp = 0, input = 0 }},
                   {"txt_aion_question_text", { alp = 0, text = "" }},
                   {"gmg_aion_board",  { active = 1, input = 1, alp = 1 }} } );
                   
    for i = 1, 4, 1 do
      ObjSet("txt_aion_answer_"..i.."_text",  { text = "", alp = 0 });
    end;
    
    public.BoardGameShow( 1 );
    
  end;
  
  ObjSet("anm_aion_aion_0",  { playing = 1 });
  
  ObjAnimate("obj_aion_challenge_2", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("gmg_aion_board", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("anm_aion_aion_0", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function private.Challenge2Kill()
  
  local set_hero = function ()
    
    if private.state[3] == 0 then
      private.Death( false );
    else 
      cmn.ShowBbt( "aion_lose_"..math.random(1, 3) );
      private.Challenge2Pass();
    end;
    
  end;
  
  local anm_damage = function ()
    
    ObjAnimate("spr_aion_hp_"..(private.state[3]+1), "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0,    0.2, 0, 1,    0.3, 0, 0,  0.4, 0, 1,    0.5, 0, 0 });
    
    ObjMultiSet( { {"anm_aion_aion_2", { alp = 1, playing = 1 }},
                   {"anm_aion_aion_2_kill", { alp = 0, frame = 0, playing = 0, endtrig = "" }},
                   {"anm_aion_damage", { alp = 1, frame = 0, playing = 1, endtrig = set_hero }} } );
    
  end;
  
  ObjMultiSet( { {"anm_aion_aion_2", { alp = 0, playing = 0, frame = 0 }},
                 {"anm_aion_aion_2_kill", { alp = 1, playing = 1, endtrig = anm_damage }} } );
  
end;
--*********************************************************************************************************************
-- function *** PUZZLE *** () end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------
function public.FocusSymboll( num, inout )
  
  local stage = private.board_challenges_num[ private.state[1] ];
  local obj = "spr_aion_symboll_"..stage.."_"..num;
  local scale = ObjGet( obj ).scale_x;
  local tme = 0;
  local max_scale = 1.05;  
  local max_tme = 0.3;
  local end_scale = 1;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );
  else 
    SetCursor(CURSOR_GET);
    end_scale = max_scale;
    tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
  end;

  ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale });
  
end;
-----------------------------------------------------------------------------------
function public.StartDrag( num )
  
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_stuffs_click");
  
  local stage = private.board_challenges_num[ private.state[1] ];
  
  ObjAttach("spr_aion_symboll_"..stage.."_"..num, "obj_aion_fly");
  
end;
-----------------------------------------------------------------------------------
function public.DropSymboll( num )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_stuffs_unclick");
  
  local stage = private.board_challenges_num[ private.state[1] ];
  local hard = #private.right_symbolls[ stage ];
  local place = 0;
  
  local pos = GetZoomCursorPos();
  if  tostring(GetPlatform()) == "android" then
    pos[2] = pos[2] - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      pos[2] = pos[2] - 75;
    else
      pos[2] = pos[2] - 50;
    end;
  end;
  
  local px = pos[1];
  local py = pos[2];
  
  for i = 1, #private.right_symbolls[ stage ], 1 do
    
    if private.CheckHit(hard-2, px, py, i) then
      place = i;
      break;
    end;
    
  end;
  
  local check_vac = true;
  
  if place > 0 and place ~= private.state_3[ stage ][ num ] then
    check_vac = private.CheckVacancy( stage, place );
  end;
  
  local hard = #private.right_symbolls[ stage ];
  
  --place not possible
  if place == 0 or not check_vac then
    place = private.state_3[ stage ][num];
  else 
    private.state_3[ stage ][ num ] = place;
  end;
  
  local point_a, point_b = {}, {};
  point_a[1] = px;
  point_a[2] = py;
  
  if place == 0 then
    point_b[1] = private.symbolls_pos_bott[ hard-2 ][ num ][1];
    point_b[2] = private.symbolls_pos_bott[ hard-2 ][ num ][2];
  else 
    point_b[1] = private.symbolls_pos[ hard-2 ][ place ][1];
    point_b[2] = private.symbolls_pos[ hard-2 ][ place ][2];
  end;
  
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.001 * len;
  
  if tme < 0.1 then
    tme = 0.1;
  elseif tme > 0.4 then
    tme = 0.4;
  end;
  
  local func_after = function () ObjAttach("spr_aion_symboll_"..stage.."_"..num,  "obj_aion_challenge_3_symbolls_"..stage); private.CheckSymbolls(); end;
    
  if place > 0 then
    ObjSet("spr_aion_symboll_"..stage.."_"..num,  { input = 0 });
  end;
  
  ObjAnimate("spr_aion_symboll_"..stage.."_"..num, "pos_xy", 0, 0, func_after, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
  
end;
-----------------------------------------------------------------------------------
function private.CheckHit(stage, px, py, num)
  
  local centr = {0, 0}; 
  local accuracy = 50;

  centr[1] = private.symbolls_pos[ stage ][num][1];
  centr[2] = private.symbolls_pos[ stage ][num][2];

  if ( (px - centr[1])^2 + (py - centr[2])^2 ) <= accuracy^2 then 

    return true;

  else

    return false;

  end; 
  
end;
-----------------------------------------------------------------------------------
function private.CheckVacancy( stage, place )
  
  local check = true;
  
  for i = 1, #private.state_3[ stage ], 1 do
    
    if private.state_3[ stage ][i] == place then
      check = false;
      break;
    end;
    
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
function private.CheckSymbolls()
  
  local win_flag = true;
  local stage = private.board_challenges_num[ private.state[1] ];
  
  for i = 1, #private.right_symbolls[ stage ], 1 do
    
    if private.state_3[ stage ][i] ~= private.right_symbolls[ stage ][i] then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_stuffs_win");
    
    ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].stage = 1;
    private.state[2] = 1;
    
    --local anm_win = function ()
    --  ObjSet("anm_aion_challenge_3_hard_"..#private.state_3[ stage ],  { frame = 0, animfunc = "func_win_lvl_"..(#private.state_3[ stage ]-2), playing = 1, endtrig = private.Challenge3Pass });
    --end;
  
    local func_after = function ()
      cmn.ShowBbt( "aion_win_"..math.random(1, 3) );
      private.Challenge3Pass();
    end;
    
    for i = 1, #private.state_3[ stage ], 1 do
      ObjAnimate("spr_aion_symboll_"..stage.."_"..i, "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.3, 0, 1.2, 1.2,   0.6, 0, 1, 1,   0.9, 0, 1.2, 1.2,   1.2, 0, 1, 1 });
      ObjAnimate("spr_aion_symboll_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.6, 0, 1,   0.9, 0, 0 });
    end;
    
    ObjAnimate("anm_aion_challenge_3_hard_"..#private.state_3[ stage ], "alp", 0, 0, func_after, { 0, 0, 1,   0.9, 0, 1,   1.2, 0, 0 });
    --ObjSet("tmr_aion_timer",  { time = 1, playing = 1, endtrig = anm_win });
    
  else 
    
    local wrong = 0;
    
    for i = 1, #private.right_symbolls[ stage ], 1 do
      
      if private.state_3[ stage ][i] ~= 0 and private.state_3[ stage ][i] ~= private.right_symbolls[ stage ][i] then
        wrong = i;
        break;
      end;
      
    end;
    
    if wrong == 0 then
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_stuffs_right");
      cmn.Lock( 0 );
    else 
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_stuffs_wrong");
      
      ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].stage = 1;
      private.state[2] = 1;
      private.state[3] = private.state[3] - 1;
      
      ObjAnimate("spr_aion_symboll_"..stage.."_"..wrong, "color_g", 0, 0, "", { 0, 0, 1,   0.2, 0, 0,    0.4, 0, 1,     0.6, 0, 0,    0.8, 0, 1 });
      ObjAnimate("spr_aion_symboll_"..stage.."_"..wrong, "color_b", 0, 0, "", { 0, 0, 1,   0.2, 0, 0,    0.4, 0, 1,     0.6, 0, 0,    0.8, 0, 1 });
      
      ObjAnimate("anm_aion_challenge_3_hard_"..#private.state_3[ stage ], "alp", 0, 0, private.Challenge3Kill, { 0, 0, 1,   0.9, 0, 1,   1.2, 0, 0 });
      ObjAnimate("obj_aion_challenge_3_symbolls_"..stage, "alp", 0, 0, "", { 0, 0, 1,   0.9, 0, 1,   1.2, 0, 0 });
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.Challenge3Start()
  
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_showes_3_4_stuffs");
  
  local stage = private.board_challenges_num[ private.state[1] ];
  local hard = #private.right_symbolls[ stage ];
  
  local func_set = function ()
    
    cmn.Lock(0);
    ObjSet("obj_aion_challenge_3",  { input = 1 });
    
  end;
  
  local anm_symbolls_3 = function ()
    
    for i = 1, hard, 1 do
      ObjSet("spr_aion_symboll_"..stage.."_"..i,  { input = 1, pos_x = private.symbolls_pos_bott[ hard-2 ][i][1], pos_y = private.symbolls_pos_bott[ hard-2 ][i][2] });
      ObjAnimate("spr_aion_symboll_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
    ObjSet("tmr_aion_timer",  { time = 0.3, playing = 1, endtrig = func_set });
    
  end;
  
  local anm_symbolls_2 = function ()
    
    for i = 1, hard, 1 do
      ObjAnimate("spr_aion_symboll_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
    ObjSet("tmr_aion_timer",  { time = 0.5, playing = 1, endtrig = anm_symbolls_3 });
    
  end;
  
  local anm_symbolls = function ()
    
    local tme = 0;
    
    local play_snd = function ()
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_3_4_stuffs_appear_"..math.random(1, 4));
    end;
    
    for i = 1, hard, 1 do
      tme = 0.3*i;
      --ObjSet("spr_aion_symboll_"..stage.."_"..i,  { pos_x = private.symbolls_pos[ hard-2 ][ private.right_symbolls[stage][i] ][1], pos_y = private.symbolls_pos[ hard-2 ][ private.right_symbolls[stage][i] ][2] });
      ObjMultiSet( { {"spr_aion_symboll_"..stage.."_"..i,  { pos_x = private.symbolls_pos[ hard-2 ][ private.right_symbolls[stage][i] ][1], pos_y = private.symbolls_pos[ hard-2 ][ private.right_symbolls[stage][i] ][2] }},
                     {"tmr_aion_timer_symbols_"..i, { time = tme-0.3, playing = 1, endtrig = play_snd }} } );
      ObjAnimate("spr_aion_symboll_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 0,   tme-0.3, 0, 0,   tme, 0, 1 });
    end;
    
    ObjSet("tmr_aion_timer",  { time = tme+2, playing = 1, endtrig = anm_symbolls_2 });
    
  end;
  
  local anm_start = function ()
    
    ObjMultiSet( { {"anm_aion_aion_3", { alp = 1, playing = 1 }},
                   {"anm_aion_challenge_3_light", { alp = 1, playing = 1 }},
                   {"anm_aion_challenge_3_start", { alp = 0, playing = 0, frame = 0, endtrig = "" }},
                   {"anm_aion_challenge_3_hard_"..hard, { alp = 1, playing = 1, endtrig = anm_symbolls }},
                   {"obj_aion_challenge_3_symbolls_"..stage, { alp = 1, input = 1 }} } );
    
  end;
  
  ObjSet("anm_aion_challenge_3_start",  { alp = 1, playing = 1, endtrig = anm_start });
  
end;
-----------------------------------------------------------------------------------
function private.Challenge3Set()
  
  local stage = private.board_challenges_num[ private.state[1] ];
  local hard = #private.right_symbolls[ stage ];
  
  ObjMultiSet( { {"obj_aion_challenge_3", { alp = 1, input = 1 }},
                 {"anm_aion_aion_3", { alp = 1, playing = 1 }},
                 {"anm_aion_challenge_3_light", { alp = 1, playing = 1 }},
                 {"anm_aion_challenge_3_start", { alp = 0, playing = 0, frame = 0, endtrig = "" }},
                 {"obj_aion_challenge_3_symbolls_"..stage, { alp = 1, input = 1 }},
                 {"anm_aion_challenge_3_hard_"..#private.right_symbolls[ stage ], { alp = 1, frame = 300 }},
                 {"anm_aion_aion_0",  { alp = 0, playing = 0 }} } );
                 
  for j = 1, #private.right_symbolls[ stage ], 1 do
    if private.state_3[ stage ][j] == 0 then
      ObjSet("spr_aion_symboll_"..stage.."_"..j,  { alp = 1, input = 1, pos_x = private.symbolls_pos_bott[ hard-2 ][j][1], pos_y = private.symbolls_pos_bott[ hard-2 ][j][2] });
    else 
      ObjSet("spr_aion_symboll_"..stage.."_"..j,  { alp = 1, input = 0, pos_x = private.symbolls_pos[ hard-2 ][ private.state_3[ stage ][j] ][1], pos_y = private.symbolls_pos[ hard-2 ][ private.state_3[ stage ][j] ][2] });
    end;
  end;
                 
end;
-----------------------------------------------------------------------------------
function private.Challenge3Reset()
  
  ObjMultiSet( { {"obj_aion_challenge_3", { alp = 0, input = 0 }},
                 {"anm_aion_aion_3", { alp = 0, playing = 0, frame = 0 }},
                 {"anm_aion_aion_3_kill", { alp = 0, playing = 0, frame = 0 }},
                 {"anm_aion_challenge_3_light", { alp = 0, playing = 0, frame = 0 }},
                 {"anm_aion_challenge_3_start", { alp = 1, frame = 0 }},
                 {"anm_aion_challenge_3_end", { alp = 0, frame = 0 }} } );
                 
  for i = 1, 5, 1 do
    
    ObjSet("obj_aion_challenge_3_symbolls_"..i,  { alp = 0, input = 0 });
    
    for j = 1, #private.right_symbolls[ i ], 1 do
      ObjSet("spr_aion_symboll_"..i.."_"..j,  { alp = 0, input = 0, pos_x = private.symbolls_pos[ #private.right_symbolls[ i ]-2 ][j][1], pos_y = private.symbolls_pos[ #private.right_symbolls[ i ]-2 ][j][2] });
    end;
    
  end;
  
  for i = 3, 5, 1 do
    ObjSet("anm_aion_challenge_3_hard_"..i,  { alp = 0, frame = 0 });
  end;
  
end;
-----------------------------------------------------------------------------------
function private.Challenge3Pass()
  
  local func_after = function ()
    
    private.Challenge3Reset();
    ObjSet("gmg_aion_board",  { active = 1, input = 1, alp = 1 });
    public.BoardGameShow( 1 );
    
  end;
  
  local level_end = function ()
    
    ObjAnimate("anm_aion_aion_0", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("gmg_aion_board", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("obj_aion_challenge_3", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      
  end;
  
  ObjMultiSet( { {"anm_aion_challenge_3_end", { alp = 1, playing = 1, endtrig = level_end }},
                 {"anm_aion_aion_3", { alp = 0, playing = 0 }},
                 {"anm_aion_challenge_3_light", { alp = 0, playing = 0 }},
                 {"anm_aion_aion_0", { playing = 1 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.Challenge3Kill()
  
  local set_hero = function ()
    
    if private.state[3] == 0 then
      private.Death( false );
    else 
      cmn.ShowBbt( "aion_lose_"..math.random(1, 3) );
      private.Challenge3Pass();
    end;
    
  end;
  
  local anm_damage = function ()
    
    ObjAnimate("spr_aion_hp_"..(private.state[3]+1), "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0,    0.2, 0, 1,    0.3, 0, 0,  0.4, 0, 1,    0.5, 0, 0 });
    
    ObjMultiSet( { {"anm_aion_aion_3_kill", { alp = 0, frame = 0, playing = 0, endtrig = "" }},
                   {"anm_aion_damage", { alp = 1, frame = 0, playing = 1, endtrig = set_hero }} } );
    
  end;
  
  --ObjSet("anm_aion_aion_3_kill", { alp = 1, playing = 1, endtrig = anm_damage });
  anm_damage();
  
end;
--*********************************************************************************************************************
-- function *** SHOOTER *** () end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------
function private.Challenge4Start()
  
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_scare_hands");
  
  local stage = private.board_challenges_num[ private.state[1] ];
  
  local func_after = function ()
    
    ObjMultiSet( { {"obj_aion_challenge_4", { input = 1 }},
                   {"obj_aion_challenge_4_2", { input = 1 }} } );
    
    cmn.Lock( 0 );
    private.SetAlien();
    
  end;
  
  local anm_vents = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_doors_opens");
    
    ObjMultiSet( { {"anm_aion_aion_cast", { alp = 0, endtrig = "" }},
                   {"anm_aion_aion_0", { alp = 1, playing = 1 }},
                   {"anm_alien_vent_1_1", { playing = 1 }},
                   {"anm_alien_vent_2_1", { playing = 1, endtrig = func_after }} } );
    
  end;
  
  ObjMultiSet( { {"anm_aion_aion_cast", { alp = 1, playing = 1, endtrig = anm_vents }},
                 {"anm_aion_aion_0", { alp = 0, playing = 0 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.Challenge4Set()
  
  private.AimTarget();
  
  ObjMultiSet( { {"anm_alien_vent_1_1", { alp = 1, frame = 300 }},
                 {"anm_alien_vent_2_1", { alp = 1, frame = 300}},
                 {"obj_aion_challenge_4", { input = 1 }},
                 {"obj_aion_challenge_4_2", { input = 1 }},
                 {"obj_aion_weapon", { alp = 1 }},
                 {"obj_aion_aim", { alp = 1 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.Challenge4Reset()
  
  ObjMultiSet( { {"tmr_aion_timer_aim", { playing = 0 }},
                 {"anm_alien_vent_1_1", { alp = 1, frame = 0, playing = 0 }},
                 {"anm_alien_vent_2_1", { alp = 1, frame = 0, playing = 0 }},
                 {"anm_alien_vent_1_2", { alp = 0, frame = 0, playing = 0 }},
                 {"anm_alien_vent_2_2", { alp = 0, frame = 0, playing = 0 }},
                 {"obj_aion_challenge_4", { input = 0 }},
                 {"obj_aion_challenge_4_2", { input = 0 }},
                 {"obj_aion_weapon", { alp = 0 }},
                 {"obj_aion_aim", { alp = 0 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.AimTarget()
  
  local curs = GetZoomCursorPos();
  curs[1] = math.floor(curs[1]);
  curs[2] = math.floor(curs[2]);
  
  local weap_pos = {0, 0};
  weap_pos[1] = curs[1];
  weap_pos[2] = curs[2]+220;
  
  if weap_pos[1] < 0 then
    weap_pos[1] = 0;
  elseif weap_pos[1] > 900 then
    weap_pos[1] = 900;
  end;
  
  if weap_pos[2] < 608 then
    weap_pos[2] = 608;
  elseif weap_pos[2] > 800 then
    weap_pos[2] = 800;
  end;
  
  ObjMultiSet( { {"obj_aion_aim", { pos_x = curs[1], pos_y = curs[2] }},
                 {"obj_aion_weapon", { pos_x = weap_pos[1], pos_y = weap_pos[2] }},
                 {"tmr_aion_timer_aim", { time = 0.01, playing = 1, endtrig = private.AimTarget }} } );
  
end;
-----------------------------------------------------------------------------------
function private.SetAlien()
  
  local stage = private.board_challenges_num[ private.state[1] ];
  
  --DbgTrace("SetAlien")
  local typ = math.random(1, 100);
  if typ <= 20 then
    typ = 2;
  else
    typ = 1;
  end;
  
  if typ == 1 then
  
    local anm_con = function ()
      
      local new_way = 2;
      
      --DbgTrace("pause "..private.current_alien[3])
      
      private.enemy_next = new_way;
    
      if private.current_alien[2] > 1 then
        private.current_alien[2] = 1;
        ObjSet("anm_aion_alien_"..private.current_alien[3].."_1_state",  { frame = 0, animfunc = "func_alien_"..private.alien_type[ private.current_alien[1] ].."_"..private.alien_act[ 1 ], playing = 1 });
      end;
      
      ObjMultiSet( { {"obj_aion_alien_"..private.current_alien[3].."_1",  { input = 1 }},
                     {"tmr_aion_timer_alien", { time = private.enemy_pause[ stage ], playing = 1, endtrig = function() private.AlienAttack( 1 ); end }} } );
          
    end;
    
    if private.current_alien[1] == 0 then
    
      private.current_alien[1] = math.random(1, 2);
      private.current_alien[2] = math.random(1, 2);
      private.current_alien[3] = math.random(1, 3);
      private.current_alien[4] = 1;
      
    end;
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_scare_string_monster_"..math.random(1,5));
    PlaySfx("assets/levels/level2/audio/sfx/aud_mmg_monsters_appears", 1, "", 1);
    
    ObjMultiSet( { {"anm_aion_alien_"..private.current_alien[3].."_1", { alp = 1, frame = 0, playing = 1, endtrig = anm_con }},
                   {"anm_aion_alien_"..private.current_alien[3].."_1_state", { alp = 1, frame = 0, animfunc = "func_alien_"..private.alien_type[ private.current_alien[1] ].."_"..private.alien_act[ private.current_alien[2] ], playing = 1 }},
                   {"obj_aion_alien_"..private.current_alien[3].."_1",  { input = 1 }} } );
                   
  else
                   
    local crows = {1, 2, 3};
    local enemies = {};
    local count = private.crows[ stage ];
    
    if private.state_4[ stage ] + count > private.enemies[ stage ] then
      count = private.enemies[ stage ] - private.state_4[ stage ];
    end;
    
    --count = 1;
    
    for i = 1, count, 1 do
      
      local num = math.random(1, #crows);
      table.insert( enemies, crows[num] );
      table.remove( crows, num );
      
    end;
    
    private.crows_cur = enemies;
    
    for i = 1, #enemies, 1 do
      ObjMultiSet( { {"anm_aion_crow_"..enemies[i],  { alp = 1, playing = 1 }},
                     {"anm_aion_crow_"..enemies[i].."_state",  { alp = 1, playing = 1, frame = (i-1)*10 }} } );
    end;
                   
    for i = 1, #enemies, 1 do
      ObjSet("obj_aion_crow_"..enemies[i],  { input = 1 });
    end;
    
    local set_crows = function ()
      
      --for i = 1, #enemies, 1 do
      --  ObjSet("obj_aion_crow_"..enemies[i],  { input = 1 });
      --end;
      
      ObjMultiSet( { {"anm_aion_aion_cast", { alp = 0, endtrig = "" }},
                     {"anm_aion_aion_0", { alp = 1, playing = 1 }},
                     {"tmr_aion_timer_crow", { time = private.crows_pause[ stage ], playing = 1, endtrig = private.CrowsAttack }} } );
      
    end;
                   
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_crows_appear");
    
    ObjMultiSet( { {"anm_aion_aion_cast", { alp = 1, playing = 1, endtrig = set_crows }},
                   {"anm_aion_aion_0", { alp = 0, playing = 0 }} } );
                   
  end;
    
end;
-----------------------------------------------------------------------------------
function private.CrowsAttack()
  
  local crows = private.crows_cur;
  
  if private.board_challenges[ private.state[1] ] == 4 and #private.crows_cur > 0 then
    
    private.attack_progress = true;
  
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_crows_hits_you");
    
    local stage = private.board_challenges_num[ private.state[1] ];
    --local damage = #crows;
    local damage = 1;
    local old_hp = private.state[3];
    
    private.state[3] = private.state[3]-damage;
    if private.state[3] < 0 then
      private.state[3] = 0;
    end;
    
    local func_after = function ()
      
      private.attack_progress = false;
      
      for i = 1, #crows, 1 do
        private.ResetCrow( crows[i] );
      end;
      
      if private.state[3] == 0 then
        SetCursor( CURSOR_DEFAULT );
        private.Death( false );
      else 
        cmn.ShowBbt( "aion_lose_"..math.random(1, 3) );
        --cmn.Lock( 0 );
        --ObjAnimate("anm_breakthrough_damage", "alp", 0, 0, function() private.CheckWin(true); end, { 0, 0, 1,   0.3, 0, 0 });
        private.CheckWinShooter(true);
      end;
      
    end;
    
    local anm_damage = function ()
      
      for i = old_hp, private.state[3]+1, -1 do
        
        ObjAnimate("spr_aion_hp_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0,    0.2, 0, 1,    0.3, 0, 0,  0.4, 0, 1,    0.5, 0, 0 });
        
      end;
      
      for i = 1, #crows, 1 do
        ObjAnimate("anm_aion_crow_"..crows[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
      ObjSet("tmr_aion_timer_crow",  { time = 0.3, playing = 1, endtrig = func_after });
      
    end;
    
    for i = 1, #crows, 1 do
    
      ObjMultiSet( { {"obj_aion_crow_"..crows[i],  { input = 0 }},
                     {"anm_aion_crow_"..crows[i].."_attack",  { alp = 1, playing = 1 }} } );
                     
    end;
                   
    ObjMultiSet( { {"anm_aion_damage_1", { alp = 1, playing = 1, endtrig = anm_damage }},
                   {"tmr_aion_timer_crow", { playing = 0 }} } );
                   
  end;
  
end;
-----------------------------------------------------------------------------------
function private.AlienAttack( num )
  
  if not private.hit_progress then
    
    private.attack_progress = true;
  
    cmn.Lock( 1 );
    SndStop("assets/levels/level2/audio/sfx/aud_mmg_monsters_appears", 0.5);
    
    local stage = private.board_challenges_num[ private.state[1] ];
    local way = private.current_alien[3];
    local damage = 1;
    local num2 = 0;
    local old_hp = private.state[3];
    
    --if private.current_alien[1] == 2 then
    --  damage = 2;
    --end;
    
    private.current_alien[2] = 3;
    private.state[3] = private.state[3]-damage;
    
    if private.state[3] < 0 then
      private.state[3] = 0;
    end;
    
    local alien = private.current_alien[1];
    
    local func_after = function ()
      
      private.attack_progress = false;
      
      ObjSet("anm_aion_damage_"..alien,  { alp = 0, frame = 0 });
      
      private.ResetAlien( stage, way, num );
      
      if num2 > 0 then
        private.ResetAlien( stage, way, num2 );
      end;
      
      if private.state[3] == 0 then
        SetCursor( CURSOR_DEFAULT );
        private.Death( false );
      else 
        cmn.ShowBbt( "aion_lose_"..math.random(1, 3) );
        --cmn.Lock( 0 );
        --ObjAnimate("anm_breakthrough_damage", "alp", 0, 0, function() private.CheckWin(true); end, { 0, 0, 1,   0.3, 0, 0 });
        private.CheckWinShooter(true);
      end;
      
    end;
    
    local anm_damage = function ()
      
      private.StopAlien();
      
      for i = old_hp, private.state[3]+1, -1 do
        
        ObjAnimate("spr_aion_hp_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0,    0.2, 0, 1,    0.3, 0, 0,  0.4, 0, 1,    0.5, 0, 0 });
        
      end;
    
      --num2 = private.enemy_next;
      num2 = 2;
      private.enemy_next = 0;
      
      ObjMultiSet( { {"anm_aion_alien_"..way.."_"..num2.."_state",  { frame = 0, animfunc = "func_alien_"..private.alien_type[ alien ].."_"..private.alien_act[ 1 ], playing = 1 }},
                     {"anm_aion_alien_"..way.."_"..num2, { alp = 1, frame = 0, playing = 1, endtrig = func_after }},
                     {"anm_aion_alien_"..way.."_"..num, { alp = 0 }} } );
                     
      
      --ObjSet("anm_breakthrough_damage_"..alien,  { alp = 1, playing = 1, endtrig = func_after });
      --ObjAnimate("anm_breakthrough_damage", "alp", 0, 0, func_after, { 0, 1, 0,   0.2, 1, 1,  0.4, 1, 0,   0.6, 1, 1,  0.8, 1, 0,    1, 1, 1,   1.2, 1, 0,   1.5, 1, 1 });
      
    end;
    
    if alien == 1 then
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_monsters_monster_hits");
    else 
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_monsters_spill_acid");
    end;
    
    ObjMultiSet( { {"obj_aion_alien_"..way.."_"..num,  { input = 0 }},
                   {"anm_aion_alien_"..way.."_"..num.."_state",  { frame = 0, animfunc = "func_alien_"..private.alien_type[ private.current_alien[1] ].."_"..private.alien_act[ private.current_alien[2] ].."_1", playing = 1, endtrig = anm_damage }},
                   {"anm_aion_damage_"..alien,  { alp = 1, playing = 1 }} } );
                   
  end;
  
end;
-----------------------------------------------------------------------------------
function private.ResetAlien( stage, way, con )
  
  ObjMultiSet( { {"anm_aion_alien_"..way.."_"..con, { alp = 0, frame = 0, playing = 0, endtrig = "" }},
                 {"anm_aion_alien_"..way.."_"..con.."_state", { alp = 1, frame = 0, playing = 0, endtrig = "" }},
                 {"obj_aion_alien_"..way.."_"..con, { input = 0 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.StopAlien()
  
  local stage = private.board_challenges_num[ private.state[1] ];
  local way = private.current_alien[3];
  local con = private.current_alien[4];
  
  private.current_alien = { 0, 0, 0, 0 };
  
  ObjMultiSet( { {"anm_aion_alien_"..way.."_"..con, { playing = 0, endtrig = "" }},
                 {"anm_aion_alien_"..way.."_"..con.."_state", { playing = 0, endtrig = "" }},
                 {"tmr_aion_timer_alien", { playing = 0 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.ResetCrow( num )
  
  ObjMultiSet( { {"anm_aion_crow_"..num, { alp = 0, frame = 0, playing = 0 }},
                 {"anm_aion_crow_"..num.."_state", { frame = 0, playing = 0 }},
                 {"anm_aion_crow_"..num.."_attack", { frame = 0, playing = 0 }},
                 {"obj_aion_crow_"..num, { input = 0 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.WeaponBlock( param, nolock )
  
  nolock = nolock or false;
  
  if not nolock then
    cmn.Lock( param );
  end;
  
  ObjSet("spr_aion_aim_2",  { alp = param });
  
end;
-----------------------------------------------------------------------------------
function public.MissHit()
  
  --DbgTrace("MissHit");
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_monsters_shot");
  
  private.WeaponBlock( 1 );
  
  ObjSet("anm_aion_gunfire_"..private.gun,  { playing = 1, endtrig = function() private.WeaponBlock(0); end });
  
end;
-----------------------------------------------------------------------------------
function public.HitTarget( num )
  
  if not private.attack_progress then
  
    private.hit_progress = true;
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_monsters_catch");
    SndStop("assets/levels/level2/audio/sfx/aud_mmg_monsters_appears", 0.5);
    
    local stage = private.board_challenges_num[ private.state[1] ];
    
    private.state_4[ stage ] = private.state_4[ stage ] + 1;
    
    local way = private.current_alien[3];
    local block = false;
    
    if private.state_4[ stage ] == private.enemies[ stage ] then
      block = true;
    end;
    
    --DbgTrace("hit target "..num);
    private.StopAlien();
    ObjSet("tmr_aion_timer_alien",  { playing = 0 });
    
    local func_after = function ()
      cmn.ShowBbt( "aion_win_"..math.random(1, 3) );
      ObjDetach("spr_aion_alien_dead");
      private.ResetAlien( stage, way, num );
      private.CheckWinShooter(true);
    end;
    
    private.WeaponBlock( 1 );
    
    ObjAttach("spr_aion_alien_dead", "obj_aion_alien_"..way.."_"..num);
    
    ObjAnimate("anm_aion_alien_"..way.."_"..num.."_state", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("spr_aion_alien_dead", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1,   1, 0, 0 });
    
    ObjSet("anm_aion_gunfire_"..private.gun,  { playing = 1, endtrig = function() private.WeaponBlock(0, block); end });
      
  end;
  
end;
-----------------------------------------------------------------------------------
function public.HitCrow( num )
  
  if not private.attack_progress then
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_crows_hits");
  
    local stage = private.board_challenges_num[ private.state[1] ];
    private.hit_progress = true;
    
    private.state_4[ stage ] = private.state_4[ stage ] + 1;
    
    local block = false;
    
    ObjMultiSet( { {"anm_aion_crow_"..num,  { playing = 0 }},
                   {"obj_aion_crow_"..num, { input = 0 }} } );
    
    if private.state_4[ stage ] == private.enemies[ stage ] then
      SndStop("assets/levels/level3/audio/sfx/aud_mg_aion_crows_appear", 0.5);
      block = true;
      ObjSet("tmr_aion_timer_crow",  { playing = 0 });
    end;
    
    local func_after = function ()
      
      ObjDetach("anm_aion_crow_dead_"..num);
      private.ResetCrow( num );
      
      if private.state_4[ stage ] == private.enemies[ stage ] and #private.crows_cur > 0 then
        
        for i = 1, #private.crows_cur, 1 do
          ObjAnimate("anm_aion_crow_"..private.crows_cur[i], "alp", 0, 0, function() private.ResetCrow( private.crows_cur[i] ); end, { 0, 0, 1,   0.5, 0, 0 });
        end;
        
        ObjSet("tmr_aion_timer_crow",  { time = 0.5, playing = 1, endtrig = function() cmn.ShowBbt( "aion_win_"..math.random(1, 3) ); private.CheckWinShooter(true); end });
          
      elseif #private.crows_cur == 0 then
        cmn.ShowBbt( "aion_win_"..math.random(1, 3) );
        private.CheckWinShooter(true);
      end;
      
    end;
    
    local ind = 0;
    
    for i = 1, #private.crows_cur, 1 do
      
      if private.crows_cur[i] == num then
        ind = i;
        break;
      end;
      
    end;
    
    table.remove(private.crows_cur, ind);
    if #private.crows_cur == 0 then
      SndStop("assets/levels/level3/audio/sfx/aud_mg_aion_crows_appear", 0.5);
      ObjSet("tmr_aion_timer_crow",  { playing = 0 });
    end;
    
    private.WeaponBlock( 1 );
    
    ObjAttach("anm_aion_crow_dead_"..num, "obj_aion_crow_"..num);
    
    ObjAnimate("anm_aion_crow_"..num.."_state", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("anm_aion_crow_dead_"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1,   1, 0, 0 });
    
    ObjSet("anm_aion_gunfire_"..private.gun,  { playing = 1, endtrig = function() private.WeaponBlock(0, block); end });
      
  end;
  
end;
-----------------------------------------------------------------------------------
function private.CheckWinShooter( ingame )
  
  ingame = ingame or false;
  
  local stage = private.board_challenges_num[ private.state[1] ];
  
  private.hit_progress = false;
  
  --end challenge
  if private.state_4[ stage ] == private.enemies[ stage ] then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_scare_hands");
    
    private.state[2] = 1;
    
    local func_after = function ()
      
      --cmn.Lock( 0 );
      private.Challenge4Reset();
      public.BoardGameShow( 1 );
      
    end;
    
    local anm_vents = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_doors_closes");
      
      ObjMultiSet( { {"anm_aion_aion_cast", { alp = 0, endtrig = "" }},
                     {"anm_aion_aion_0", { alp = 1, playing = 1 }},
                     {"anm_alien_vent_1_2", { alp = 1, playing = 1 }},
                     {"anm_alien_vent_2_2", { alp = 1, playing = 1, endtrig = func_after }},
                     {"gmg_aion_board",  { active = 1, input = 1, alp = 1 }} } );
      
    end;
                   
    SetCursor( CURSOR_DEFAULT );
                   
    ObjAnimate("obj_aion_weapon", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("obj_aion_aim", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
    ObjMultiSet( { {"anm_aion_aion_cast", { alp = 1, playing = 1, endtrig = anm_vents }},
                   {"anm_aion_aion_0", { alp = 0, playing = 0 }} } );
    
  elseif not ingame and private.state[3] == 0 then
    cmn.Lock( 1 );
    SetCursor( CURSOR_DEFAULT );
    private.Death( false );
  else 
    cmn.Lock( 0 );
    private.SetAlien();
  end;
  
end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------
function private.Death( reset_flag )
  
  reset_flag = reset_flag or false;
  
  local reset = function ()
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state;
    private.state_3 = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_3;
    private.state_4 = ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].state_4;
    
    private.DrawScene();
    private.Challenge2Reset();
    private.Challenge3Reset();
    private.Challenge4Reset();
    
    if private.current_alien[1] > 0 then
      local stage = private.board_challenges_num[ private.state[1] ];
      local al = private.current_alien[1];
      local way = private.current_alien[3];
      local con = private.current_alien[4];
      private.current_alien = { 0, 0, 0, 0 };
      private.ResetAlien( stage, way, con );
    end;
    
    private.board = false;
    ObjMultiSet( { {"obj_aion_board",  { alp = 0, input = 0 }},
                   {"anm_aion_aion_0", { alp = 1, playing = 1 }},
                   {"spr_aion_dark", { alp = 1 }},
                   {"anm_aion_hero_die", { alp = 0, frame = 0, playing = 0, endtrig = "" }} } );
    
    ObjAnimate("spr_aion_dark", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 1,   0.5, 0, 0 });
    
  end;
    
  local anm_dark = function ()
    ObjSet("tmr_aion_timer",  { time = 0.5, playing = 1, endtrig = reset });
  end;
      
  if reset_flag then
    ObjAnimate("spr_aion_dark", "alp", 0, 0, reset, { 0, 0, 0,   0.5, 0, 1 });
  else 
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_aion_we_die");
    ObjSet("anm_aion_hero_die",  { alp = 1, playing = 1, endtrig = anm_dark });
  end;
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin( ingame )
  
  ingame = ingame or false;
  
  if private.state[1] == 23 then
    
    cmn.Lock( 1 );
    
    if ng_global.currentprogress == "std" then 
    
      cmn.MiniGameHide();

      common_impl.PauseAchiev( 1 );
      cmn.EndTimePassing( "mg_aion" );
      
      ObjAnimate("obj_aion_interface", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
      if ingame then
        ObjAnimate("obj_aion_board", "alp", 0, 0, private.Win, { 0, 0, 1,   1, 0, 1,   1.5, 0, 0 });
      else
        ObjSet("tmr_aion_timer",  { time = 1, playing = 1, endtrig = private.Win });
      end;
    
    else 
      
      rm_extra.MiniGameHide();
      int_dialog_secretroom.StopTimer();
      
      ObjSet("tmr_aion_timer",  { time = 1, playing = 1, endtrig = private.Win });
      
    end;
    
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  local func_after = function ()
    
    cmn.SetEventDone( "win_aion" );
    ObjSet("obj_aion_gameboard",  { alp = 0 });
    
    if ng_global.currentprogress == "std" then 

      cmn.Lock( 1 );
      
      if ng_global.progress[ ng_global.currentprogress ][ "win_aion" ].skip == 0 and not ng_global.noskipgames[ "win_aion" ] then

        ng_global.noskipgames[ "win_aion" ] = 1;
        common_impl.CheckAchiev("mg");

      end;
    
      if ng_global.playedgames and not ng_global.playedgames[ "win_aion" ] then
        ng_global.playedgames[ "win_aion" ] = 1;
      end;
      
      private.dialog_open( 2 );
    
    else 
      ObjSet("grm_aion_debughall",  { input = 0 });
      interface_impl.ShowStarsWindow();
    end;
    
  end;
  
  cmn.Lock( 0 );
  
  if ng_global.currentprogress == "std" then 
    cmn.PlayFullscreenVideo( "assets/levels/level3/mg_aion/vid_game_end", func_after, "assets/levels/level3/audio/sfx/aud_mg_aion_win_end", "", 1, 20, false, true, true );
  else 
    ObjMultiSet( { {"grm_aion_debughall", { input = 0 }},
                   {"obj_aion_board", { input = 0 }} } );
    interface_impl.ShowStarsWindow();
  end;

end;
--******************************************************************************************************