-- name=mg_onmuseumdoors
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_onmuseumdoors";
  --------------------------------------------------------------------------------------------
  private.chosen = 0;
  private.start_ang = 0;
  private.ang_tmp = 0;
  private.ang_win = { {2, 0, 5}, {-6, -8, -3} };
  
  private.theme_pics = { {8, 5, 2}, {2, 8, 7}, {7, 3, 5}, {5, 6, 1}, {3, 1, 6} };
  --------------------------------------------------------------------------------------------
  -- function win_onmuseumdoors () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_onmuseumdoors" ] = {
    type = "win",
    room = "rm_apocalypse2",
    zz = "mg_onmuseumdoors",
    zz_gate = "gmg_apocalypse2_onmuseumdoors"
  };
  --------------------------------------------------------------------------------------------
  local win_onmuseumdoors = function ()

    if cmn.IsEventDone( "win_onmuseumdoors" ) then
      ObjDelete("obj_onmuseumdoors_buttons");
      ObjSet("obj_onmuseumdoors_game",  { input = 0 });
    end;

  end;
  local win_onmuseumdoors_loc = function ()

    if cmn.IsEventDone( "win_onmuseumdoors" ) then

      ObjDelete("gmg_apocalypse2_onmuseumdoors");
      ObjDelete( "spr_apocalypse2_museumdoors_circule" );

      ObjMultiSet( {
        { "grm_apocalypse2_apocalypse3", { alp = 1, input = 1 } },
        { "spr_apocalypse2_museumdoors_door_open", { alp = 1 } }
      } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_apocalypse2_apocalypse3_focus");
      end;
    
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_onmuseumdoors", win_onmuseumdoors, "mg_onmuseumdoors" );
  cmn.AddSubscriber( "win_onmuseumdoors", win_onmuseumdoors_loc, "rm_apocalypse2" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_onmuseumdoors" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onmuseumdoors" ].state;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse2_env");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_apocalypse2" );
  else 
    
    ObjSet("mg_onmuseumdoors",  { input = 1 });
    
    private.chosen = 0;
    private.start_ang = 0;
    private.ang_tmp = 0;
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onmuseumdoors" ].state;
    
    for i = 1, 4, 1 do
      ObjSet("spr_onmuseumdoors_button_"..i.."_on",  { alp = 0 });
    end;
    for i = 1, 5, 1 do
      ObjSet("spr_onmuseumdoors_type_"..i,  { alp = 0 });
    end;
    
    ObjSet("grm_onmuseumdoors_apocalypse2",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                         event_menter = function () rm_extra.GateMouseEnter( "onmuseumdoors_apocalypse2", CURSOR_DOWN, "extra" ); end, 
                                         event_mleave = function () common_impl.GateMouseLeave( "onmuseumdoors_apocalypse2" ); end });
                                     
  end;
    
  private.DrawScene();
  
  iOS_NeedDrag(0);
end;
--*********************************************************************************************************************
function public.Open()

  if ng_global.currentprogress == "secret" then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_game_2_mus", 1);
  end;
  
  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_onmuseumdoors" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_onmuseumdoors");
  elseif ng_global.currentprogress == "secret" then
    rm_extra.MiniGameShow();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  iOS_NeedDrag(1);
  
  if ng_global.currentprogress == "secret" then
    cmn.StopAllMus();
  end;

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_onmuseumdoors" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_onmuseumdoors" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  local need_r = false;
  local tme = 0;
  local locks = {};
  
  for i = 1, 3, 1 do
    
    if private.state[2][i] ~= 0 then
      
      if not need_r then
        need_r = true;
      end;
      
      local end_a = 0;
      
      if private.state[2][i] < -4 then
        end_a = -8*(math.pi/4);
      elseif private.state[2][i] > 4 then
        end_a = 8*(math.pi/4);
      end;
      
      local tme_c = private.state[2][i] * 0.1;
      if tme_c < 0 then
        tme_c = (8+private.state[2][i]) * 0.1;
      end;
      
      if tme < tme_c then
        tme = tme_c
      end;
      
      ObjAnimate("obj_onmuseumdoors_circle_"..i, "ang", 0, 0, "", { 0, 0, private.state[2][i]*(math.pi/4),   tme_c, 0, end_a });
      
      for j = 1, 8, 1 do
        ObjAnimate("spr_onmuseumdoors_circle_"..i.."_pic_"..j, "ang", 0, 0, "", { 0, 0, -private.state[2][i]*(math.pi/4),   0.2, 0, -end_a });
      end;
      
    end;
    
  end;
  
  if private.state[3] > 0 then
    
    local num = private.state[3];
    private.state[3] = 0;
    
    if not need_r then
      need_r = true;
    end;
    
    local tme_c = 0.3;
    if tme < tme_c then
      tme = tme_c
    end;
    
    ObjAnimate("spr_onmuseumdoors_button_"..num.."_on", "alp", 0, 0, "", { 0, 2, 1,   tme_c, 2, 0 });
    ObjAnimate("spr_onmuseumdoors_type_"..num, "alp", 0, 0, "", { 0, 2, 1,   tme_c, 2, 0 });
    
  end;
  
  for i = 1, 5, 1 do
    
    if private.state[1][i] ~= 0 then
      
      if not need_r then
        need_r = true;
      end;
      
      table.insert( locks, i );
      
      if tme < 0.6 then
        tme = 0.6;
      end;
      
      ObjAnimate("anm_onmuseumdoors_lock_"..i.."_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("anm_onmuseumdoors_lock_"..i.."_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  if #locks > 0 then
    
    local func_locks = function ()
      
      for i = 1, #locks, 1 do
        
        ObjMultiSet( { {"obj_onmuseumdoors_button_"..locks[i], { input = 1 }},
                       {"spr_onmuseumdoors_button_"..locks[i].."_on", { alp = 0 }},
                       {"anm_onmuseumdoors_lock_"..locks[i].."_1", { alp = 0, frame = 0 }},
                       {"anm_onmuseumdoors_lock_"..locks[i].."_2", { alp = 0, frame = 0 }} } );
        
        ObjAnimate("anm_onmuseumdoors_lock_"..locks[i].."_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        ObjAnimate("anm_onmuseumdoors_lock_"..locks[i].."_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        
        ObjAnimate("obj_onmuseumdoors_button_"..locks[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        
        for j = 1, 3, 1 do
          ObjSet("spr_onmuseumdoors_circle_"..j.."_pic_"..private.theme_pics[ locks[i] ][j],  { ang = 0 });
          ObjAnimate("spr_onmuseumdoors_circle_"..j.."_pic_"..private.theme_pics[ locks[i] ][j], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        end;
        
      end;
      
    end;
    
    ObjSet("tmr_onmuseumdoors_timer_2",  { time = 0.3, playing = 1, endtrig = func_locks });
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_stones_reset");
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onmuseumdoors" ].state;
    
    ObjSet("tmr_onmuseumdoors_timer",  { time = tme, playing = 1, endtrig = function() cmn.Lock( 0 ); end });
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_stones_skip_stones");
  
  local locks = {};
  local tme = 0.3;
  
  ng_global.progress[ ng_global.currentprogress ][ "win_onmuseumdoors" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_onmuseumdoors" ].state = { {1, 1, 1, 1, 1}, {2, 0, 5}, 5 };
  
  for i = 1, 3, 1 do
    
    if private.state[2][i] ~= private.ang_win[1][i] and private.state[2][i] ~= private.ang_win[2][i] then
      
      local tme_c = 0;
      if private.state[2][i] < 0 then
        tme_c = math.abs( (8+private.state[2][i])- private.ang_win[1][i] ) * 0.1;
      else 
        tme_c = math.abs( private.state[2][i] - private.ang_win[1][i] ) * 0.1;
      end;
      
      if tme < tme_c then
        tme = tme_c;
      end;
      
      ObjAnimate("obj_onmuseumdoors_circle_"..i, "ang", 0, 0, "", { 0, 0, private.state[2][i]*(math.pi/4),   tme_c, 0, private.ang_win[1][i]*(math.pi/4) });
      
      for j = 1, 8, 1 do
        ObjAnimate("spr_onmuseumdoors_circle_"..i.."_pic_"..j, "ang", 0, 0, "", { 0, 0, -private.state[2][i]*(math.pi/4),   0.2, 0, -private.ang_win[1][i]*(math.pi/4) });
      end;
      
    end;
    
  end;
  
  for i = 1, 4, 1 do
    
    if private.state[1][i] == 0 then
      
      table.insert( locks, i );
      
      ObjAnimate("obj_onmuseumdoors_button_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
      for j = 1, #private.theme_pics[ i ], 1 do
        ObjAnimate("spr_onmuseumdoors_circle_"..j.."_pic_"..private.theme_pics[ i ][j], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
    end;
    
  end;
  
  if private.state[3] > 0 then
    
    local num = private.state[3];
    private.state[3] = 5;
    
    ObjAnimate("spr_onmuseumdoors_button_"..num.."_on", "alp", 0, 0, "", { 0, 2, 1,   0.3, 2, 0 });
    ObjAnimate("spr_onmuseumdoors_type_"..num, "alp", 0, 0, "", { 0, 2, 1,   0.3, 2, 0 });
    
  end;
  
  ObjAnimate("spr_onmuseumdoors_button_5_on", "alp", 0, 0, "", { 0, 2, 0,   0.3, 2, 1 });
  ObjAnimate("spr_onmuseumdoors_type_5", "alp", 0, 0, "", { 0, 2, 0,   0.3, 2, 1 });
  
  local anm_locks = function ()
    
    if #locks > 0 then
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_stones_skip_chains");
      
      for i = 1, #locks-1, 1 do
        ObjMultiSet( { {"anm_onmuseumdoors_lock_"..locks[i].."_1", { playing = 1 }},
                       {"anm_onmuseumdoors_lock_"..locks[i].."_2", { playing = 1 }} } );
      end;
                     
      ObjMultiSet( { {"anm_onmuseumdoors_lock_"..locks[#locks].."_1", { playing = 1, endtrig = private.CheckWin }},
                     {"anm_onmuseumdoors_lock_"..locks[#locks].."_2", { playing = 1 }} } );
      
    else
      
      private.CheckWin();
      
    end;
    
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onmuseumdoors" ].state;
  ObjSet("tmr_onmuseumdoors_timer",  { time = tme, playing = 1, endtrig = anm_locks });

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_onmuseumdoors" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_onmuseumdoors" ].state = { {0, 0, 0, 0, 0}, {0, 0, 0}, 0 };
  --[1] - steps done, [2] - circles angs, [3] - selected theme

end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  if private.state[3] > 0 then
    ObjMultiSet( { {"spr_onmuseumdoors_button_"..private.state[3].."_on", { alp = 1 }},
                   {"spr_onmuseumdoors_type_"..private.state[3], { alp = 1 }} } );
  end;
                 
  for i = 1, 3, 1 do
    
    ObjSet("obj_onmuseumdoors_circle_"..i,  { ang = private.state[2][i]*(math.pi/4) });
    
    for j = 1, 8, 1 do
      ObjSet("spr_onmuseumdoors_circle_"..i.."_pic_"..j,  { ang = -private.state[2][i]*(math.pi/4) });
    end;
    
  end;
  
  for i = 1, #private.state[1], 1 do
    
    if private.state[1][i] == 1 then
      private.BlockTheme( i );
    else 
      private.UnlockTheme( i );
    end;
    
  end;

end;
-----------------------------------------------------------------------------------
function public.FocusButton( num, inout )

  local obj = "spr_onmuseumdoors_button_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.ChooseButton( num )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_stones_click");

  if private.state[3] == 0 then
    
    private.state[3] = num;
    private.SelectButton( num, 1, true );
    
  else 
    
    if private.state[3] == num then
      
      private.state[3] = 0;
      private.SelectButton( num, 0, true );
      
    else 
      
      local old = private.state[3];
      private.state[3] = num;
      private.SelectButton( num, 1, true );
      private.SelectButton( old, 0, false );
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.SelectButton( num, inout, after )
  
  after = after or false;
  if not after then
    after = "";
  else
    after = function() private.CheckWin(); end;
  end;

  local obj = "spr_onmuseumdoors_button_"..num.."_on";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    tme = alf * 0.3;
  else 
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, after, { 0, 2, alf,   tme, 2, inout });
  
  ObjAnimate("spr_onmuseumdoors_type_"..num, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function private.BlockTheme( num )
  
  ObjMultiSet( { {"obj_onmuseumdoors_button_"..num,  { input = 0, alp = 0 }},
                 {"anm_onmuseumdoors_lock_"..num.."_1", { frame = 400 }},
                 {"anm_onmuseumdoors_lock_"..num.."_2", { frame = 400 }} } );
  
  for i = 1, #private.theme_pics[ num ], 1 do
    
    ObjSet("spr_onmuseumdoors_circle_"..i.."_pic_"..private.theme_pics[ num ][i],  { alp = 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.UnlockTheme( num )
  
  ObjMultiSet( { {"obj_onmuseumdoors_button_"..num,  { input = 1, alp = 1 }},
                 {"anm_onmuseumdoors_lock_"..num.."_1", { frame = 0 }},
                 {"anm_onmuseumdoors_lock_"..num.."_2", { frame = 0 }} } );
  
  for i = 1, #private.theme_pics[ num ], 1 do
    
    ObjSet("spr_onmuseumdoors_circle_"..i.."_pic_"..private.theme_pics[ num ][i],  { alp = 1 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.FocusDisk( num, inout )

  local pref = "spr";
  if num == 3 then
    pref = "obj";
  end;
  local obj = pref.."_onmuseumdoors_circle_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_stones_arrow");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.ChooseDisk( num )

  private.chosen = num;
  
  ObjStartDrag("obj_onmuseumdoors_game_drag");
  public.FocusDisk( num, 0 );
  
end;
-----------------------------------------------------------------------------------
function public.OnStartDrag()

  local curspos = GetZoomCursorPos();
  
  curspos[1] = curspos[1] - 512;
  curspos[2] = curspos[2] - 384;

  local ang = -math.atan2(curspos[2], curspos[1]);
  local old = private.state[2][ private.chosen ]*(math.pi/4);

  private.start_ang = ang - old;
  
end;
-----------------------------------------------------------------------------------
function public.RotateDisk()

  local curspos = GetZoomCursorPos();
  
  curspos[1] = curspos[1] - 512;
  curspos[2] = curspos[2] - 384;
  
  if (private.chosen ~= 0) then
  
    local old = private.state[2][ private.chosen ]*(math.pi/4);
    local new_ang = - math.atan2(curspos[2], curspos[1]) - private.start_ang;
    
    local ang_step = math.floor((new_ang % 0.392625)*10)/10;
    local ang_floor = math.floor(new_ang / 0.392625 + 0.1) * 0.392625;
    
    if ang_step == 0 and private.ang_tmp ~= ang_floor then

      cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_stones_loop_"..math.random(1, 5) );
      private.ang_tmp = ang_floor;

    end;

    ObjSet("obj_onmuseumdoors_circle_"..private.chosen, { ang = new_ang } );
    
    for j = 1, 8, 1 do
      ObjSet("spr_onmuseumdoors_circle_"..private.chosen.."_pic_"..j,  { ang = -new_ang });
    end;

  end;
  
end;
-----------------------------------------------------------------------------------
function public.DropDisk()

  if (private.chosen ~= 0) then

    local num = private.chosen;
    local curspos = GetZoomCursorPos();
    
    curspos[1] = curspos[1] - 512;
    curspos[2] = curspos[2] - 384;

    local old = private.state[2][ private.chosen ];
    local new_ang = - math.atan2(curspos[2], curspos[1]) - private.start_ang;

    if ( new_ang <= -2*math.pi ) then
      new_ang = new_ang + 4*math.pi;
    elseif ( new_ang >= 2*math.pi ) then
      new_ang = new_ang - 2*math.pi;
    end;
    
    local part_1, part;
    part_1 = new_ang/(math.pi/4);
    
    if new_ang > 0 then
    
      part = math.floor( part_1 );
      
      if ( math.abs(part_1) - part)-0.5 > 0 then
        part = part + 1;
      end;
      
    else 
      
      part = math.ceil( part_1 );
      
      if ( math.abs(part_1) - math.abs(part) )-0.5 > 0 then
        part = part - 1;
      end;
      
    end;
    
    --if part == 8 or part == -8 then
    --  part = 0;
    --end;
    
    local ang2 = part*(math.pi/4);
    private.state[2][ num ] = part;

    --DbgTrace(part);

    --ObjSet("obj_onmuseumdoors_circle_"..num, { ang = private.state[2][ num ] } );
    
    cmn.Lock( 1 );
    ObjAnimate("obj_onmuseumdoors_circle_"..num, "ang", 0, 0, private.CheckWin, { 0, 0, new_ang,   0.2, 0, ang2 });
    
    for j = 1, 8, 1 do
      ObjAnimate("spr_onmuseumdoors_circle_"..num.."_pic_"..j, "ang", 0, 0, "", { 0, 0, -new_ang,   0.2, 0, -ang2 });
    end;

  end;

  private.chosen = 0;
  private.start_ang = 0;

  --private.CheckWin();
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  local win_flag = true;
  
  if private.state[3] == 0 then
    win_flag = false;
  else 
    
    for i = 1, #private.theme_pics[ private.state[3] ], 1 do
      
      --if (private.state[2][i]+1) ~= private.theme_pics[ private.state[3] ][i] then
      --  DbgTrace("1 "..i);
      --end;
      --if (8+private.state[2][i]+1) ~= private.theme_pics[ private.state[3] ][i] then
      --  DbgTrace("2 "..i);
      --end;
      --if not( private.state[2][i]== 8 and private.theme_pics[ private.state[3] ][i] == 1 ) then
      --  DbgTrace("3 "..i);
      --end;
      
      if (private.state[2][i]+1) ~= private.theme_pics[ private.state[3] ][i] 
      and (8+private.state[2][i]+1) ~= private.theme_pics[ private.state[3] ][i]
      and not( private.state[2][i]== 8 and private.theme_pics[ private.state[3] ][i] == 1 ) then
        win_flag = false;
        break;
      end;
      
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_stones_win");
    
    local theme = private.state[3];
    private.state[1][ theme ] = 1;
    
    local func_after = function () 
      
      if private.state[3] == 0 then
        cmn.Lock( 0 );
      else 
        ObjAnimate("spr_onmuseumdoors_type_5", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 0,   0.5, 0, 1 });
      end;
      
    end;
      
    local check = true;
    
    for i = 1, 4, 1 do
      
      if private.state[1][ i ] == 0 then
        check = false;
        break;
      end;
        
    end;
    
    if theme == 5 then
      
      if ng_global.currentprogress == "std" then 
      
        cmn.MiniGameHide();

        common_impl.PauseAchiev( 1 );
        cmn.EndTimePassing( "mg_onmuseumdoors" );
      
      else 
        
        rm_extra.MiniGameHide();
        int_dialog_secretroom.StopTimer();
        
      end;
      
      func_after = private.WinEnd;
      
    else 
      
      if check then
        private.state[3] = 5;
      else
        private.state[3] = 0;
      end;
      
    end;
    
    local anm_open = function ()
      
      private.BlockTheme( theme );
      
      ObjMultiSet( { {"anm_onmuseumdoors_lock_"..theme.."_1", { playing = 1, endtrig = func_after }},
                     {"anm_onmuseumdoors_lock_"..theme.."_2", { playing = 1 }} } );
                     
    end;
                   
    ObjAnimate("spr_onmuseumdoors_type_"..theme, "alp", 0, 0, anm_open, { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    
    if theme ~= 5 then
      ObjAnimate("obj_onmuseumdoors_button_"..theme, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    end;
    
    for i = 1, #private.theme_pics[ theme ], 1 do
      ObjAnimate("spr_onmuseumdoors_circle_"..i.."_pic_"..private.theme_pics[ theme ][i], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    end;
    
  else
    cmn.Lock( 0 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.Lock( 0 );
  
  cmn.SetEventDone( "win_onmuseumdoors" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_onmuseumdoors" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_onmuseumdoors" ].skip == 0 and not ng_global.noskipgames[ "win_onmuseumdoors" ] then

      ng_global.noskipgames[ "win_onmuseumdoors" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_onmuseumdoors" ] then
      ng_global.playedgames[ "win_onmuseumdoors" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    
    cmn.GotoRoom("rm_apocalypse2");
    
  else 
    
    ObjSet("mg_onmuseumdoors",  { input = 0 });
    
    interface_impl.ShowStarsWindow();
    
  end;

end;
--*******************************************************************************************************