-- name=mg_tosecuritypanel
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_tosecuritypanel";
  --------------------------------------------------------------------------------------------
  private.buttons_act = { 4, 12, 11, 1, 10, 8, 5, 9, 6, 3, 2, 7 };
  --------------------------------------------------------------------------------------------
  -- function get_coin2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_coin2" ] = {
    type = "get",
    get_obj = "spr_tosecuritypanel_coin2",
    room = "rm_office",
    zz = "mg_tosecuritypanel",
    zz_gate = "gmg_office_tosecuritypanel"
  };
  --------------------------------------------------------------------------------------------
  local get_coin2_inv = function ()
  
    interface.InventoryItemAdd( "inv_coin", "spr_tosecuritypanel_coin2", function () cmn.GetMultyObject( 'coin', 3 ); end );
  
  end;
  local get_coin2_end = function ()
  
    ObjDelete( "gfx_tosecuritypanel_coin2" );
    ObjDelete( "spr_tosecuritypanel_coin2_sh" );
    
  end;
  local get_coin2_loc = function ()

    ObjDelete( "spr_office_tosecuritypanel_coin_2" );

    if ( cmn.IsEventDone( "get_baton" ) and cmn.IsEventDone("get_sawblade") ) then
      ObjDelete( "gmg_office_tosecuritypanel" );
    end;

  end;
  
  cmn.AddSubscriber( "get_coin2", get_coin2_inv );
  cmn.AddSubscriber( "get_coin2", get_coin2_end, private.room_objname );
  cmn.AddSubscriber( "get_coin2", get_coin2_loc, "rm_office" );
  --------------------------------------------------------------------------------------------
  -- function get_sawblade () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_sawblade" ] = {
    type = "get",
    get_obj = "spr_tosecuritypanel_sawblade",
    room = "rm_office",
    zz = "mg_tosecuritypanel",
    zz_gate = "gmg_office_tosecuritypanel"
  };
  --------------------------------------------------------------------------------------------
  local get_sawblade_inv = function ()
  
    interface.InventoryItemAdd( "inv_sawblade", "spr_tosecuritypanel_sawblade" );
    ObjSet("inv_hacksaw_star_light",  { alp = 1 });
  
  end;
  local get_sawblade_end = function ()
  
    ObjDelete( "gfx_tosecuritypanel_sawblade" );
    ObjDelete( "spr_tosecuritypanel_sawblade_sh" );
  
  end;
  local get_sawblade_loc = function ()

    ObjDelete( "spr_office_tosecuritypanel_canvas" );

    if ( cmn.IsEventDone( "get_baton" ) and cmn.IsEventDone("get_coin2") ) then
      ObjDelete( "gmg_office_tosecuritypanel" );
    end;

  end;
  
  cmn.AddSubscriber( "get_sawblade", get_sawblade_inv );
  cmn.AddSubscriber( "get_sawblade", get_sawblade_end, private.room_objname );
  cmn.AddSubscriber( "get_sawblade", get_sawblade_loc, "rm_office" );
  --------------------------------------------------------------------------------------------
  -- function get_baton () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_baton" ] = {
    type = "get",
    get_obj = "spr_tosecuritypanel_baton",
    room = "rm_office",
    zz = "mg_tosecuritypanel",
    zz_gate = "gmg_office_tosecuritypanel"
  };
  --------------------------------------------------------------------------------------------
  local get_baton_inv = function ()
  
    interface.InventoryItemAdd( "inv_baton", "spr_tosecuritypanel_baton" );
  
  end;
  local get_baton_end = function ()
  
    ObjDelete( "gfx_tosecuritypanel_baton" );
    ObjDelete( "spr_tosecuritypanel_baton_sh" );
  
  end;
  local get_baton_loc = function ()
    
    ObjDelete( "spr_office_panel_baton" );

    if ( cmn.IsEventDone( "get_coin2" ) and cmn.IsEventDone("get_sawblade") ) then
      ObjDelete( "gmg_office_tosecuritypanel" );
    end;

  end;
  
  cmn.AddSubscriber( "get_baton", get_baton_inv );
  cmn.AddSubscriber( "get_baton", get_baton_end, private.room_objname );
  cmn.AddSubscriber( "get_baton", get_baton_loc, "rm_office" );

  --------------------------------------------------------------------------------------------
  -- function win_tosecuritypanel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_tosecuritypanel" ] = {
    type = "win",
    room = "rm_office",
    zz = "mg_tosecuritypanel",
    zz_gate = "gmg_office_tosecuritypanel"
  };
  --------------------------------------------------------------------------------------------
  local win_tosecuritypanel = function ()

    if cmn.IsEventDone( "win_tosecuritypanel" ) then
      ObjDelete("obj_tosecuritypanel_game");
      ObjMultiSet( { {"spr_tosecuritypanel_coin2", { input = 1 }},
                     {"spr_tosecuritypanel_baton", { input = 1 }} ,
                     {"spr_tosecuritypanel_sawblade", { input = 1 }}} );
    end;

  end;
  local win_tosecuritypanel_loc = function ()

    if cmn.IsEventDone( "win_tosecuritypanel" ) then
      ObjDelete("spr_office_panel_game");
      ObjDelete("obj_office_panel_explode");
      ObjDelete("fx_office_p_screen");
      ObjSet("spr_office_panel_open",  { alp = 1 });
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_tosecuritypanel", win_tosecuritypanel, "mg_tosecuritypanel" );
  cmn.AddSubscriber( "win_tosecuritypanel", win_tosecuritypanel_loc, "rm_office" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_tosecuritypanel" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_tosecuritypanel" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_game_2_mus", 1);

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_tosecuritypanel" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_tosecuritypanel");
  elseif ng_global.currentprogress == "secret" then
    rm_extra.MiniGameShow();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_office_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_office_env");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_office" );
  else 
    
    private.StartConditions();
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_tosecuritypanel" ].state;
    
    ObjMultiSet( { {"spr_tosecuritypanel_lamp_red", { alp = 1 }},
                   {"spr_tosecuritypanel_lamp_green", { alp = 0 }},
                   {"obj_tosecuritypanel_game", { input = 1 }} } );
    
    for i = 1, 12, 1 do
      
      ObjMultiSet( { {"obj_tosecuritypanel_lamp_"..i, { alp = 0 }},
                     {"spr_tosecuritypanel_lamp_"..i.."_1", { alp = 0 }},
                     {"spr_tosecuritypanel_lamp_"..i.."_2", { alp = 0 }},
                     {"spr_tosecuritypanel_chain_"..i, { alp = 0 }} } );
      
    end;
    
    ObjSet("grm_tosecuritypanel_office",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                         event_menter = function () rm_extra.GateMouseEnter( "tosecuritypanel_office", CURSOR_DOWN, "extra" ); end, 
                                         event_mleave = function () common_impl.GateMouseLeave( "tosecuritypanel_office" ); end });
                                     
  end;
  
  private.DrawScene();
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_tosecuritypanel" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_tosecuritypanel" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  local need_r = false;
  
  for i = 1, 12, 1 do
    
    if private.state[1][i] == 1 then
      
      if not need_r then
        need_r = true;
      end;
      
      ObjAnimate("spr_tosecuritypanel_button_"..i.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
  end;
  
  local chains = private.GetChains();
  
  for i = 4, 12, 1 do
    
    local lamp = private.CheckLight( i );
    
    if chains[i] == 1 then
      
      ObjAnimate("spr_tosecuritypanel_chain_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_tosecuritypanel_lamp_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
      if i > 6 and chains[i-3] == 0 then
        ObjAnimate("obj_tosecuritypanel_lamp_"..(i-3), "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      end;
      
    elseif lamp > 0 then
      ObjAnimate("obj_tosecuritypanel_lamp_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    end;
    
  end;
  
  for i = 1, 3, 1 do
    
    if chains[i] == 1 then
      ObjAnimate("spr_tosecuritypanel_chain_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_tosecuritypanel_lamp_"..i.."_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_tosecuritypanel_lamp_"..i.."_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_tosecuritypanel_click_reset");
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_tosecuritypanel" ].state;
    
    ObjSet("tmr_tosecuritypanel_timer",  { time = 0.5, playing = 1, endtrig = function() private.DrawScene(); cmn.Lock(0); end });
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_tosecuritypanel_click_stuff_"..math.random(1, 3));
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_tosecuritypanel_right");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_tosecuritypanel" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_tosecuritypanel" ].state = { 
    { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }, {0, 0, 0}
  };
  
  for i = 1, 12, 1 do
    
    if private.state[1][i] == 0 then
      
      ObjAnimate("spr_tosecuritypanel_button_"..i.."_on", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
  end;
  
  local chains = private.GetChains();
  
  for i = 1, 12, 1 do
    
    if chains[i] == 0 then
      
      ObjAnimate("spr_tosecuritypanel_chain_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local old_lamp = private.CheckLight( i );
      
    if old_lamp == 0 then
      ObjSet("spr_tosecuritypanel_lamp_"..i.."_1",  { alp = 1 });
      ObjAnimate("obj_tosecuritypanel_lamp_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    elseif old_lamp == 2 then
      ObjAnimate("spr_tosecuritypanel_lamp_"..i.."_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_tosecuritypanel_lamp_"..i.."_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_tosecuritypanel" ].state;
  ObjSet("tmr_tosecuritypanel_timer",  { time = 0.5, playing = 1, endtrig = private.CheckWin });

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_sawblade()

  cmn.SetEventDone( "get_sawblade" );
  cmn.CallEventHandler( "get_sawblade" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  if ( cmn.IsEventDone( "get_baton" ) and cmn.IsEventDone("get_coin2") ) then
    cmn.GotoRoom("rm_office");
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_baton()

  cmn.SetEventDone( "get_baton" );
  cmn.CallEventHandler( "get_baton" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  if ( cmn.IsEventDone( "get_sawblade" ) and cmn.IsEventDone("get_coin2") ) then
    cmn.GotoRoom("rm_office");
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_coin2()

  cmn.SetEventDone( "get_coin2" );
  cmn.CallEventHandler( "get_coin2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if ( cmn.IsEventDone( "get_sawblade" ) and cmn.IsEventDone("get_baton") ) then
    cmn.GotoRoom("rm_office");
  end;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.door_touch()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_mg_tosecuritypanel_right_handle");
  
  cmn.ShowBbt( "obj_tosecuritypanel_door_touch" );
  
  ObjSet( "anm_tosecuritypanel_handle", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_tosecuritypanel" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_tosecuritypanel" ].state = { 
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, {0, 0, 0}
  }; --[1] - buttons state, [2] - current set

end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  for i = 1, 12, 1 do
    
    if private.state[1][i] == 1 then
      ObjSet("spr_tosecuritypanel_button_"..i.."_on",  { alp = 1 });
    else 
      ObjSet("spr_tosecuritypanel_button_"..i.."_on",  { alp = 0 });
    end;
    
  end;
  
  local chains = private.GetChains();
  
  for i = 1, 12, 1 do
    
    local lamp = private.CheckLight( i );
    for j = 1, 2, 1 do
        
      if lamp == j then
        ObjSet("spr_tosecuritypanel_lamp_"..i.."_"..j,  { alp = 1 });
      else 
        ObjSet("spr_tosecuritypanel_lamp_"..i.."_"..j,  { alp = 0 });
      end;
      
    end;
    
    if chains[i] == 1 then
      
      ObjMultiSet( { {"spr_tosecuritypanel_chain_"..i,  { alp = 1 }},
                     {"obj_tosecuritypanel_lamp_"..i,  { alp = 1 }} } );
            
      if i > 3 and chains[i-3] == 0 then
        
        ObjSet("obj_tosecuritypanel_lamp_"..(i-3),  { alp = 1 });
        ObjSet("spr_tosecuritypanel_lamp_"..(i-3).."_2",  { alp = 1 });
        
      end;
      
    elseif lamp > 0 then
      ObjSet("obj_tosecuritypanel_lamp_"..i,  { alp = 1 });
    end;
    
  end;
  
  private.CheckInput();

end;
-----------------------------------------------------------------------------------
function private.GetChains()
  
  local chains = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
  
  for i = 1, 12, 1 do
    
    if private.state[1][i] == 1 then
      chains[ private.buttons_act[i] ] = 1;
    end;
    
  end;
  
  return chains;
  
end;
-----------------------------------------------------------------------------------
function private.CheckInput()
  
  for i = 1, 12, 1 do
    
    if private.state[1][i] == 1 then
      ObjSet("obj_tosecuritypanel_button_"..i,  { input = 0 });
    else 
      ObjSet("obj_tosecuritypanel_button_"..i,  { input = 1 });
    end;
    
  end;
  
  for i = 1, 3, 1 do
    
    if private.state[2][i] > 0 then
      ObjSet("obj_tosecuritypanel_button_"..private.state[2][i],  { input = 1 });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.FocusButton( num, inout )

  local obj = "spr_tosecuritypanel_button_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.ClickButton( num )

  cmn.Lock( 1 );
  
  local old_lamp = private.CheckLight( private.buttons_act[ num ] );
  local old_lamp_2 = 0;
  local chains = private.GetChains();
  
  if private.buttons_act[ num ] > 3 then
    old_lamp_2 = private.CheckLight( private.buttons_act[ num ]-3 );
  end;
  
  if private.state[1][ num ] == 0 then
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_tosecuritypanel_click_stuff_"..math.random(1, 3));
    
    private.state[1][ num ] = 1;
    
    for i = 1, 3, 1 do
      if private.state[2][ i ] == 0 then
        private.state[2][ i ] = num;
        break;
      end;
    end;
    
    local new_lamp = private.CheckLight( private.buttons_act[ num ] );
    
    ObjAnimate("spr_tosecuritypanel_button_"..num.."_on", "alp", 0, 0, private.CheckWin, { 0, 0, 0,   0.3, 0, 1 });
    
    ObjAnimate("spr_tosecuritypanel_chain_"..private.buttons_act[ num ], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
    if old_lamp == 0 and ( private.buttons_act[ num ] > 9 or chains[ private.buttons_act[ num ]+3 ] == 0 ) then
      ObjSet("spr_tosecuritypanel_lamp_"..private.buttons_act[ num ].."_"..new_lamp,  { alp = 1 });
      ObjAnimate("obj_tosecuritypanel_lamp_"..private.buttons_act[ num ], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    elseif old_lamp > 0 and new_lamp > 0 and new_lamp ~= old_lamp then
      ObjAnimate("spr_tosecuritypanel_lamp_"..private.buttons_act[ num ].."_"..new_lamp, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_tosecuritypanel_lamp_"..private.buttons_act[ num ].."_"..old_lamp, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
    if private.buttons_act[ num ] > 3 and chains[ private.buttons_act[ num ]-3 ] == 0 then
      
      local new_lamp_2 = private.CheckLight( private.buttons_act[ num ]-3 );
      
      if old_lamp_2 == 0 then
        ObjSet("spr_tosecuritypanel_lamp_"..(private.buttons_act[ num ]-3).."_2",  { alp = 1 });
        ObjAnimate("obj_tosecuritypanel_lamp_"..(private.buttons_act[ num ]-3), "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      --else 
      --  ObjAnimate("spr_tosecuritypanel_lamp_"..(private.buttons_act[ num ]-3).."_"..new_lamp_2, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      --  ObjAnimate("spr_tosecuritypanel_lamp_"..(private.buttons_act[ num ]-3).."_"..old_lamp_2, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
    end;
    
  else 
  
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_tosecuritypanel_unclick_stuff");
    
    private.state[1][ num ] = 0;
    
    for i = 1, 3, 1 do
      if private.state[2][ i ] == num then
        private.state[2][ i ] = 0;
        break;
      end;
    end;
    
    local new_lamp = private.CheckLight( private.buttons_act[ num ] );
    
    ObjAnimate("spr_tosecuritypanel_button_"..num.."_on", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 0 });
    
    ObjAnimate("spr_tosecuritypanel_chain_"..private.buttons_act[ num ], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0  });
    
    if new_lamp == 0 and ( private.buttons_act[ num ] > 9 or chains[ private.buttons_act[ num ]+3 ] == 0 ) then
      ObjAnimate("obj_tosecuritypanel_lamp_"..private.buttons_act[ num ], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    elseif old_lamp > 0 and new_lamp > 0 and new_lamp ~= old_lamp then
      ObjAnimate("spr_tosecuritypanel_lamp_"..private.buttons_act[ num ].."_"..new_lamp, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_tosecuritypanel_lamp_"..private.buttons_act[ num ].."_"..old_lamp, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
    if private.buttons_act[ num ] > 3 and chains[ private.buttons_act[ num ]-3 ] == 0 then
      
      local new_lamp_2 = private.CheckLight( private.buttons_act[ num ]-3 );
      
      if new_lamp_2 == 0 then
        ObjAnimate("obj_tosecuritypanel_lamp_"..(private.buttons_act[ num ]-3), "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      --else 
      --  ObjAnimate("spr_tosecuritypanel_lamp_"..(private.buttons_act[ num ]-3).."_"..new_lamp_2, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      --  ObjAnimate("spr_tosecuritypanel_lamp_"..(private.buttons_act[ num ]-3).."_"..old_lamp_2, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.CheckLight( lamp )
  
  local set = 0;
  local check = false;
  local chains = private.GetChains();
  
  for i = 1, 4, 1 do
    
    if lamp <= i*3 then
      set = i;
      break;
    end;
    
  end;
  
  if lamp < 4 then
    check = true;
  else 
    check = private.CheckSetOrder( set );
  end;
  
  if chains[ lamp ] == 1 and check then
    return 1;
  elseif check or chains[ lamp ] == 1 then
    return 2;
  else 
    return 0;
  end;
  
end;
-----------------------------------------------------------------------------------
function private.CheckSet()
  
  local count = 0;
  local sets = { 0, 0, 0 };
  local cur = private.FindCurrentSet();
  
  for i = 1, 3, 1 do
    
    if private.state[2][ i ] > 0 then
      count = count + 1;
      sets[i] = private.FindSet( private.state[2][ i ] );
    end;
    
  end;
  
  if count == 3 then
    
    local check_set = false;
    local check_order = false;
    
    if sets[1] == sets[2] and sets[2] == sets[3] then
      check_set = true;
      check_order = private.CheckSetOrder( sets[1] );
    end;
    
    if check_order and check_set then
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_tosecuritypanel_right");
      
      for i = 1, 3, 1 do
        private.state[2][ i ] = 0;
      end;
      
      private.CheckInput();
      --cmn.Lock(0);
      
      for i = sets[1]*3+1, sets[1]*3+3, 1 do
        ObjSet("spr_tosecuritypanel_lamp_"..i.."_2",  { alp = 1 });
        ObjAnimate("obj_tosecuritypanel_lamp_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      end;
      
      ObjSet("tmr_tosecuritypanel_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
      
    --wrong buttons - reset
    else 
    
      cmn.Lock(1);
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_tosecuritypanel_wrong");
      
      local butts = {0, 0, 0};
      local old_lamps = {0, 0, 0};
      local new_lamps = {0, 0, 0};
      
      for i = 1, 3, 1 do
        old_lamps[i] = private.CheckLight( private.buttons_act[ private.state[2][ i ] ] );
      end;
    
      for i = 1, 3, 1 do
        butts[i] = private.state[2][ i ];
        private.state[2][ i ] = 0;
        if butts[i] > 0 then
          private.state[1][ butts[i] ] = 0;
        end;
      end;
      
      local chains = private.GetChains();
      for i = 1, 3, 1 do
        new_lamps[i] = private.CheckLight( private.buttons_act[ butts[i] ] );
      end;
      
      for i = 1, 3, 1 do
        
        if butts[i] > 0 then
          
          if sets[i] ~= cur then
            ObjAnimate("spr_tosecuritypanel_button_"..butts[i].."_wrong", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1,   0.5, 0, 0,  0.7, 0, 1,
                                                                                     0.9, 0, 0,   1.1, 0, 1,   1.4, 0, 0 });
          end;
          
          ObjAnimate("spr_tosecuritypanel_button_"..butts[i].."_on", "alp", 0, 0, function() private.DrawScene(); cmn.Lock(0); end, 
            { 0, 0, 1,   1.1, 0, 1,   1.4, 0, 0 });
    
          ObjAnimate("spr_tosecuritypanel_chain_"..private.buttons_act[ butts[i] ], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 1,   0.5, 0, 0,  0.7, 0, 1,
                                                                                                     0.9, 0, 0,   1.1, 0, 1,   1.4, 0, 0 });
          
          if new_lamps[i] == 0 then
            ObjAnimate("obj_tosecuritypanel_lamp_"..private.buttons_act[ butts[i] ], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 1,   0.5, 0, 0,  0.7, 0, 1,
                                                                                                    0.9, 0, 0,   1.1, 0, 1,   1.4, 0, 0 });
          else
            ObjAnimate("spr_tosecuritypanel_lamp_"..private.buttons_act[ butts[i] ].."_"..old_lamps[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
            ObjAnimate("spr_tosecuritypanel_lamp_"..private.buttons_act[ butts[i] ].."_"..new_lamps[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1,   0.5, 0, 0,  0.7, 0, 1,
                                                                                                    0.9, 0, 0,   1.1, 0, 1 });
          end;
          
          if private.buttons_act[ butts[i] ] > 3 and chains[ private.buttons_act[ butts[i] ]-3 ] == 0 then
            local temp = private.CheckLight( private.buttons_act[ butts[i] ]-3 );
            if temp == 0 then
              ObjAnimate("obj_tosecuritypanel_lamp_"..(private.buttons_act[ butts[i] ]-3), "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 1,   0.5, 0, 0,  0.7, 0, 1,
                                                                                                          0.9, 0, 0,   1.1, 0, 1,   1.4, 0, 0 });
            else
              --ObjAnimate("spr_tosecuritypanel_lamp_"..(private.buttons_act[ butts[i] ]-3).."_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
              ObjAnimate("spr_tosecuritypanel_lamp_"..(private.buttons_act[ butts[i] ]-3).."_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 1,   0.5, 0, 0,  0.7, 0, 1,
                                                                                                    0.9, 0, 0,   1.1, 0, 1 });
            end;
          end;
          
        end;
        
      end;
      
    end;
    
  else
    cmn.Lock(0);
  end;
  
end;
-----------------------------------------------------------------------------------
function private.FindCurrentSet()
  
  local chains = private.GetChains();
  local set = 0;
  
  for i = 1, 4, 1 do
    
    for j = i*3-2, i*3, 1 do
      
      if chains[j] == 0 then
        set = i;
        break;
      end;
      
    end;
    
    if set > 0 then
      break;
    end;
    
  end;
  
  return set;
  
end;
-----------------------------------------------------------------------------------
function private.CheckSetOrder( set )
  
  local chains = private.GetChains();
  local check = false;
  
  if set == 1 then
    check = true;
  else 
    
    local check2 = true;
    
    for i = set*3-5, set*3-3, 1 do
      
      if chains[i] == 0 then
        --DbgTrace(i.." "..chains[i])
        check2 = false;
        break;
      end;
      
    end;
    
    if check2 then
      check = true;
    end;
    
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
function private.FindSet( butt )
  
  local chain = private.buttons_act[ butt ];
  local set = 0;
  
  for i = 1, 4, 1 do
    
    if chain <= i*3 then
      set = i;
      break;
    end;
    
  end;
  
  return set;
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 12, 1 do
    
    if private.state[1][i] == 0 then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_tosecuritypanel_win");
    
    if ng_global.currentprogress == "std" then  
    
      cmn.MiniGameHide();

      common_impl.PauseAchiev( 1 );
      cmn.EndTimePassing( "mg_tosecuritypanel" );
      
    else 
      
      rm_extra.MiniGameHide();
      int_dialog_secretroom.StopTimer();
      
    end;
    
    local anm_open = function ()
      
      if ng_global.currentprogress == "std" then 
        ObjAnimate("obj_tosecuritypanel_game", "alp", 0, 0, private.Win, { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
      else 
        private.Win();
      end;
      
    end;
    
    ObjAnimate("spr_tosecuritypanel_lamp_green", "alp", 0, 0, anm_open, { 0, 0, 0,   0.5, 0, 0,   1, 0, 1 });
    ObjAnimate("spr_tosecuritypanel_lamp_red", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    
  else 
    private.CheckSet();
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()

  cmn.Lock( 0 );
  cmn.SetEventDone( "win_tosecuritypanel" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_tosecuritypanel" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_tosecuritypanel" ].skip == 0 and not ng_global.noskipgames[ "win_tosecuritypanel" ] then

      ng_global.noskipgames[ "win_tosecuritypanel" ] = 1;
      common_impl.CheckAchiev("mg");

    end;

    common_impl.PauseAchiev( 0 );
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_tosecuritypanel" ] then
      ng_global.playedgames[ "win_tosecuritypanel" ] = 1;
    end;
    
  else 
    
    ObjMultiSet( { {"grm_tosecuritypanel_office", { input = 0 }},
                   {"obj_tosecuritypanel_game", { input = 0 }} } );
    
    interface_impl.ShowStarsWindow();
    
  end;

end;
--*****************************************************************************************************