-- name=ho_hiddenroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hiddenroom" );
  game.relations[ "ho_hiddenroom" ].exitroom = "rm_nearchapel";
  
  private.first_acts = {"use_holvl4crystal", "use_holvl4candle", "use_holvl4cup", "use_holvl4feather"};
  private.cur_progress = "ext";
  --------------------------------------------------------------------------------------------------
  private.InitMarked();
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_hiddenroom" ] = 
  {
    type = "win",
    room = "rm_nearchapel",
    zz = "ho_hiddenroom",
    zz_gate = "gho_nearchapel_hiddenroom"
  };
  --------------------------------------------------------------------------------------------------
  local win_hiddenroom_func = function ()

    if ( cmn.IsEventDone( "win_hiddenroom" ) ) then
      interface.InventoryItemAdd( "inv_pincers", "spr_hiddenroom_win" );
      ObjDelete("gho_nearchapel_hiddenroom");
    end;

  end;
  cmn.AddSubscriber( "win_hiddenroom", win_hiddenroom_func );
  --------------------------------------------------------------------------------------------------
  local start_hiddenroom_func = function ()

    if ( cmn.IsEventStart( "win_hiddenroom" ) ) then

      common_impl.ProcessHoStart( "hiddenroom" );

    end;

  end;
  cmn.AddSubscriber( "win_hiddenroom", start_hiddenroom_func, "ho_hiddenroom" );
  
  --for secretroom
  private.tasks =  {    
  
      { "ring",     1, 0, { { "spr_hiddenroom_ring" } } },
      { "sun",      1, 0, { { "spr_hiddenroom_sun" } } },
      { "ship",     1, 0, { { "spr_hiddenroom_ship", } } },
      { "ink",      1, 0, { { "spr_hiddenroom_ink" } } },
      
      { "lion",     1, 0, { { "spr_hiddenroom_lion" } } },
      { "torch",    1, 0, { { "spr_hiddenroom_torch", } } },
      { "net",      1, 0, { { "spr_hiddenroom_net", "obj_hiddenroom_net_1", "obj_hiddenroom_net_2" } } },
      { "scroll",   1, 0, { { "spr_hiddenroom_scroll" } } },
      
      { "pickaxe",  1, 0, { { "spr_hiddenroom_pickaxe", "obj_hiddenroom_pickaxe_1", "obj_hiddenroom_pickaxe_2" } } },
      { "bellows",  1, 0, { { "spr_hiddenroom_bellows" } } },
      { "flask",    1, 0, { { "spr_hiddenroom_flask" } } },
      { "mask",     1, 0, { { "spr_hiddenroom_mask" } } },
      
      { "pincers",     1, 0, { { "spr_hiddenroom_pincers" } } }
      
  };
    
  private.actions = {
  
    { "use_holvl4crystal", { "spr_hiddenroom_crystal", "spr_hiddenroom_crystal_sh", "spr_hiddenroom_panel_doors_sil_1", "spr_hiddenroom_panel_doors_sil_1_done" } },
    { "use_holvl4candle", { "spr_hiddenroom_candle", "spr_hiddenroom_candle_sh", "spr_hiddenroom_panel_doors_sil_2", "spr_hiddenroom_panel_doors_sil_2_done" } },
    { "use_holvl4cup", { "spr_hiddenroom_cup", "spr_hiddenroom_panel_doors_sil_3", "spr_hiddenroom_panel_doors_sil_3_done" } },
    { "use_holvl4feather", { "spr_hiddenroom_feather", "spr_hiddenroom_panel_doors_sil_4", "spr_hiddenroom_panel_doors_sil_4_done" } },
    
    { "use_holvl4amulet1", { "spr_hiddenroom_panel_doors_itm_1", "obj_hiddenroom_use_amulet_1", "spr_hiddenroom_amulet_1", "anm_hiddenroom_use_amulet_1" } },
    { "use_holvl4amulet2", { "spr_hiddenroom_panel_doors_itm_2", "obj_hiddenroom_use_amulet_2", "spr_hiddenroom_amulet_2", "anm_hiddenroom_use_amulet_2" } },
    { "use_holvl4amulet3", { "spr_hiddenroom_panel_doors_itm_3", "obj_hiddenroom_use_amulet_3", "spr_hiddenroom_amulet_3", "anm_hiddenroom_use_amulet_3" } },
    { "use_holvl4amulet4", { "spr_hiddenroom_panel_doors_itm_4", "obj_hiddenroom_use_amulet_4", "spr_hiddenroom_amulet_4", "anm_hiddenroom_use_amulet_4" } }
  
  };
  
  private.start_actions = {};
  
  for i = 1, #private.actions, 1 do
    
    private.start_actions[i] = {};
    
    for j = 1, #private.actions[i][2], 1 do
    
      private.start_actions[i][j] = {};
      private.start_actions[i][j].name = private.actions[i][2][j];
      local nme = private.start_actions[i][j].name;
      private.start_actions[i][j].prop = ObjGet( nme );
      private.start_actions[i][j].parent = ObjGetRelations( nme ).parent;
    
    end;
    
  end;
  
  private.tasks_sh =  { 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 0, 0 };

  private.start = {};
  private.start_sh = {};

  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][ 1 ][j];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
    
    if private.tasks_sh[i] == 1 then
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = "spr_"..common.GetObjectName(private.tasks[ i ][ 4 ][1][1].."_shadow");
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if not ng_global.progress[ ng_global.currentprogress ][ "win_hiddenroom" ].stage or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_hiddenroom" ].stage = { 1, 2 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_hiddenroom" ].panel_doors = { 0, 0, 0, 0 };
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if ng_global.currentprogress == "ext" then
    
    private.cur_progress = "ext";

    common.SetPreviousRoom( "rm_nearchapel" );
    cmn.StartTimePassing("ho_hiddenroom");
    
  else 
    
    private.cur_progress = "secret";
    
    private.CreateNewObjects();
    
    ng_global.progress[ ng_global.currentprogress ][ "win_hiddenroom" ].stage = { 1, 2 };   
    ng_global.progress[ ng_global.currentprogress ][ "win_hiddenroom" ].panel_doors = { 0, 0, 0, 0 };
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_hiddenroom_nearchapel",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                        event_menter = function () rm_extra.GateMouseEnter( "hiddenroom_nearchapel", CURSOR_DOWN, "extra" ); end, 
                                        event_mleave = function () common_impl.GateMouseLeave( "hiddenroom_nearchapel" ); end });
    
  end;

  if not cmn.IsEventStart( "win_hiddenroom" ) then
    cmn.InitHo( "hiddenroom" );
  end;

  local ho_tasks = private.stages_task();
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_hiddenroom" ].stage;

  if (not cmn.IsEventDone("win_hiddenroom")) and ho_stage[1] <= ho_stage[2] then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;
  
  if ( ho_stage[1] == 2 ) then

    ObjMultiSet( { {"anm_hiddenroom_door_open", { frame = 300, input = 1 }},
                   {"obj_hiddenroom_use_amulets", { input = 0 }} } );
    
  else 
    
    ObjMultiSet( { {"anm_hiddenroom_door_open", { frame = 0, input = 0 }},
                   {"obj_hiddenroom_use_amulets", { input = 1 }} } );

  end;
                 
  if ng_global.currentprogress == "secret" then      

    for i = 1, 4, 1 do
      
      ObjMultiSet( { {"spr_int_taskpanel_panel_doors_1"..i, { pos_y = 89 }},
                     {"spr_int_taskpanel_panel_doors_2"..i, { pos_y = 89 }} } );
      
    end;

  end; 

end;
--*********************************************************************************************************************
function public.Open()    

  cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_bells_mus", 1);

end;  
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "ext" then
    
    common_impl.PlayBackgroundMusic();
    
    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else
    
    ObjSet("grm_hiddenroom_nearchapel",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()
    
  for i = 1, 4, 1 do
    
    if ng_global.progress[ private.cur_progress ][ private.first_acts[i] ].done == 0 then
      ObjDetach("spr_hiddenroom_panel_doors_sil_"..i);
    end;
    if ng_global.progress[ private.cur_progress ][ "use_holvl4amulet"..i ].done == 0 then
      ObjDetach("spr_hiddenroom_panel_doors_itm_"..i);
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "ext" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_hiddenroom");

    if ng_global.progress[ ng_global.currentprogress ][ "win_hiddenroom" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_hiddenroom" ] then

      ng_global.nohintho[ "win_hiddenroom" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_hiddenroom" ] then
      ng_global.playedhops[ "win_hiddenroom" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_hiddenroom_nearchapel",  { input = 0 });
    
  end;
    
end;
--*********************************************************************************************************************
function public.ItemFound( item_name, task_name )
  
  if task_name == "pincers" then
    
    ObjSet(item_name,  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });
    local pos = GetObjPosByObj( item_name );
    ObjSet( item_name, { pos_x = pos[1] + 171, pos_y = pos[2] } );
    
  else 
    
    ObjDelete( item_name.."_shadow" );
    
  end;
  
  cmn.HoTaskFind( item_name, task_name, 1 );

end;
--*********************************************************************************************************************
-- function *** MARKED *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.InitMarked()

  public.ho_hint_progress_names = { "use_holvl4crystal", "use_holvl4candle", "use_holvl4cup", "use_holvl4feather",
                                    "use_holvl4amulet1", "use_holvl4amulet2", "use_holvl4amulet3", "use_holvl4amulet4" };
  
  --------------------------------------------------------------------------------------------
  -- function use_holvl4crystal () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4crystal" ] = {
      type = "use",
      inv_obj = "spr_hiddenroom_crystal",
      use_place = "spr_hiddenroom_panel_doors_sil_1",
      room = "rm_nearchapel",
      zz = "ho_hiddenroom",
      zz_gate = "gho_nearchapel_hiddenroom"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4crystal_beg = function ()
  
    ObjDelete( "spr_hiddenroom_crystal" );
    ObjDelete( "spr_hiddenroom_crystal_sh" );
  
  end;
  local use_holvl4crystal_end = function ()
  
    ObjDelete( "spr_hiddenroom_panel_doors_sil_1" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4crystal", use_holvl4crystal_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4crystal", use_holvl4crystal_end, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4crystal_beg", use_holvl4crystal_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4crystal_end", use_holvl4crystal_end, "ho_hiddenroom" );
  --------------------------------------------------------------------------------------------
  -- function use_holvl4candle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4candle" ] = {
      type = "use",
      inv_obj = "spr_hiddenroom_candle",
      use_place = "spr_hiddenroom_panel_doors_sil_2",
      room = "rm_nearchapel",
      zz = "ho_hiddenroom",
      zz_gate = "gho_nearchapel_hiddenroom"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4candle_beg = function ()
  
    ObjDelete( "spr_hiddenroom_candle" );
    ObjDelete( "spr_hiddenroom_candle_sh" );
  
  end;
  local use_holvl4candle_end = function ()
  
    ObjDelete( "spr_hiddenroom_panel_doors_sil_2" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4candle", use_holvl4candle_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4candle", use_holvl4candle_end, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4candle_beg", use_holvl4candle_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4candle_end", use_holvl4candle_end, "ho_hiddenroom" );
  --------------------------------------------------------------------------------------------
  -- function use_holvl4cup () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4cup" ] = {
      type = "use",
      inv_obj = "spr_hiddenroom_cup",
      use_place = "spr_hiddenroom_panel_doors_sil_3",
      room = "rm_nearchapel",
      zz = "ho_hiddenroom",
      zz_gate = "gho_nearchapel_hiddenroom"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4cup_beg = function ()
  
    ObjDelete( "spr_hiddenroom_cup" );
  
  end;
  local use_holvl4cup_end = function ()
  
    ObjDelete( "spr_hiddenroom_panel_doors_sil_3" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4cup", use_holvl4cup_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4cup", use_holvl4cup_end, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4cup_beg", use_holvl4cup_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4cup_end", use_holvl4cup_end, "ho_hiddenroom" );
  --------------------------------------------------------------------------------------------
  -- function use_holvl4feather () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4feather" ] = {
      type = "use",
      inv_obj = "spr_hiddenroom_feather",
      use_place = "spr_hiddenroom_panel_doors_sil_4",
      room = "rm_nearchapel",
      zz = "ho_hiddenroom",
      zz_gate = "gho_nearchapel_hiddenroom"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4feather_beg = function ()
  
    ObjDelete( "spr_hiddenroom_feather" );
  
  end;
  local use_holvl4feather_end = function ()
  
    ObjDelete( "spr_hiddenroom_panel_doors_sil_4" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4feather", use_holvl4feather_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4feather", use_holvl4feather_end, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4feather_beg", use_holvl4feather_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4feather_end", use_holvl4feather_end, "ho_hiddenroom" );
  
  --------------------------------------------------------------------------------------------
  -- function use_holvl4amulet1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4amulet1" ] = {
      type = "use",
      inv_obj = "spr_hiddenroom_panel_doors_itm_1",
      use_place = "obj_hiddenroom_use_amulet_1",
      room = "rm_nearchapel",
      zz = "ho_hiddenroom",
      zz_gate = "gho_nearchapel_hiddenroom"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4amulet1_beg = function ()
  
    ObjDelete( "spr_hiddenroom_panel_doors_itm_1" );
    ObjDelete( "obj_hiddenroom_use_amulet_1" );
  
  end;
  local use_holvl4amulet1_end = function ()
  
    ObjDelete( "anm_hiddenroom_use_amulet_1" );
    ObjSet( "spr_hiddenroom_amulet_1", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4amulet1", use_holvl4amulet1_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet1", use_holvl4amulet1_end, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet1_beg", use_holvl4amulet1_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet1_end", use_holvl4amulet1_end, "ho_hiddenroom" );
  --------------------------------------------------------------------------------------------
  -- function use_holvl4amulet2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4amulet2" ] = {
      type = "use",
      inv_obj = "spr_hiddenroom_panel_doors_itm_2",
      use_place = "obj_hiddenroom_use_amulet_2",
      room = "rm_nearchapel",
      zz = "ho_hiddenroom",
      zz_gate = "gho_nearchapel_hiddenroom"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4amulet2_beg = function ()
  
    ObjDelete( "spr_hiddenroom_panel_doors_itm_2" );
    ObjDelete( "obj_hiddenroom_use_amulet_2" );
  
  end;
  local use_holvl4amulet2_end = function ()
  
    ObjDelete( "anm_hiddenroom_use_amulet_2" );
    ObjSet( "spr_hiddenroom_amulet_2", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4amulet2", use_holvl4amulet2_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet2", use_holvl4amulet2_end, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet2_beg", use_holvl4amulet2_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet2_end", use_holvl4amulet2_end, "ho_hiddenroom" );
  --------------------------------------------------------------------------------------------
  -- function use_holvl4amulet3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4amulet3" ] = {
      type = "use",
      inv_obj = "spr_hiddenroom_panel_doors_itm_3",
      use_place = "obj_hiddenroom_use_amulet_3",
      room = "rm_nearchapel",
      zz = "ho_hiddenroom",
      zz_gate = "gho_nearchapel_hiddenroom"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4amulet3_beg = function ()
  
    ObjDelete( "spr_hiddenroom_panel_doors_itm_3" );
    ObjDelete( "obj_hiddenroom_use_amulet_3" );
  
  end;
  local use_holvl4amulet3_end = function ()
  
    ObjDelete( "anm_hiddenroom_use_amulet_3" );
    ObjSet( "spr_hiddenroom_amulet_3", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4amulet3", use_holvl4amulet3_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet3", use_holvl4amulet3_end, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet3_beg", use_holvl4amulet3_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet3_end", use_holvl4amulet3_end, "ho_hiddenroom" );
  --------------------------------------------------------------------------------------------
  -- function use_holvl4amulet4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4amulet4" ] = {
      type = "use",
      inv_obj = "spr_hiddenroom_panel_doors_itm_4",
      use_place = "obj_hiddenroom_use_amulet_4",
      room = "rm_nearchapel",
      zz = "ho_hiddenroom",
      zz_gate = "gho_nearchapel_hiddenroom"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4amulet4_beg = function ()
  
    ObjDelete( "spr_hiddenroom_panel_doors_itm_4" );
    ObjDelete( "obj_hiddenroom_use_amulet_4" );
  
  end;
  local use_holvl4amulet4_end = function ()
  
    ObjDelete( "anm_hiddenroom_use_amulet_4" );
    ObjSet( "spr_hiddenroom_amulet_4", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4amulet4", use_holvl4amulet4_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet4", use_holvl4amulet4_end, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet4_beg", use_holvl4amulet4_beg, "ho_hiddenroom" );
  cmn.AddSubscriber( "use_holvl4amulet4_end", use_holvl4amulet4_end, "ho_hiddenroom" );
  
end;
------------------------------------------------------------------------------
function public.start_drag( name )
  
  int_taskpanel_impl.PanelDoorsObjStartDrag( name );
  
  if name == "spr_hiddenroom_crystal" or name == "spr_hiddenroom_candle" then
    ObjAnimate(name.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0 });
  end;
  
  if name == "spr_hiddenroom_cup" then
    ObjSet(name,  { ang = -1.98 });
  elseif name == "spr_hiddenroom_feather" then
    ObjSet(name,  { ang = -2.19 });
  end;
  
end;
------------------------------------------------------------------------------
function public.use_holvl4crystal()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_hiddenroom_crystal";

  if ( ObjIntersect( item, "spr_hiddenroom_panel_doors_sil_1" ) ) then

    cmn.SetEventDone( "use_holvl4crystal" );
    cmn.CallEventHandler( "use_holvl4crystal_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_holvl4crystal_end" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_insert_slide");

    int_taskpanel.OpenPanelDoor( 1, func_after );

  else

    cmn.WrongApply();  
    ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
------------------------------------------------------------------------------
function public.use_holvl4candle()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_hiddenroom_candle";

  if ( ObjIntersect( item, "spr_hiddenroom_panel_doors_sil_2" ) ) then

    cmn.SetEventDone( "use_holvl4candle" );
    cmn.CallEventHandler( "use_holvl4candle_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_holvl4candle_end" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_insert_slide");

    int_taskpanel.OpenPanelDoor( 2, func_after );

  else

    cmn.WrongApply();  
    ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
------------------------------------------------------------------------------
function public.use_holvl4cup()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_hiddenroom_cup";

  if ( ObjIntersect( item, "spr_hiddenroom_panel_doors_sil_3" ) ) then

    cmn.SetEventDone( "use_holvl4cup" );
    cmn.CallEventHandler( "use_holvl4cup_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_holvl4cup_end" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_insert_slide");

    int_taskpanel.OpenPanelDoor( 3, func_after );

  else

    cmn.WrongApply();
    ObjSet(item,  { ang = 0 });

  end;

end;
------------------------------------------------------------------------------
function public.use_holvl4feather()

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_hiddenroom_feather";

  if ( ObjIntersect( item, "spr_hiddenroom_panel_doors_sil_4" ) ) then

    cmn.SetEventDone( "use_holvl4feather" );
    cmn.CallEventHandler( "use_holvl4feather_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_holvl4feather_end" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_insert_slide");

    int_taskpanel.OpenPanelDoor( 4, func_after );

  else

    cmn.WrongApply();
    ObjSet(item,  { ang = 0 });

  end;

end;
------------------------------------------------------------------------------
function public.use_holvl4amulet( num )

  int_taskpanel_impl.PanelDoorsObjDragDrop();

  local item = "spr_hiddenroom_panel_doors_itm_"..num;

  if ( cmn.ApplyObj( item, "obj_hiddenroom_use_amulets" ) ) then

    cmn.CallEventHandler( "use_holvl4amulet"..num.."_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_holvl4amulet"..num);
      cmn.CallEventHandler( "use_holvl4amulet"..num.."_end" );
      
      int_taskpanel.OpenPanelDoor( num );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_insert_cupboard");

    ObjSet("anm_hiddenroom_use_amulet_"..num,  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();

  end;

end;
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.stages_task()

  local ho_tasks = {};

  if ( ng_global.progress[ ng_global.currentprogress ][ "win_hiddenroom" ].stage[1] == 1 ) then

    interface.TaskPanelTaskAdd( ho_tasks, "ring",    1, 0, { { "spr_hiddenroom_ring" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "sun",     1, 0, { { "spr_hiddenroom_sun" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "ship",    1, 0, { { "spr_hiddenroom_ship" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "ink",     1, 0, { { "spr_hiddenroom_ink" } } );
    
    interface.TaskPanelTaskAdd( ho_tasks, "lion",    1, 0, { { "spr_hiddenroom_lion" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "torch",   1, 0, { { "spr_hiddenroom_torch" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "net",     1, 0, { { "spr_hiddenroom_net" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "scroll",  1, 0, { { "spr_hiddenroom_scroll" } } );
    
    interface.TaskPanelTaskAdd( ho_tasks, "pickaxe", 1, 0, { { "spr_hiddenroom_pickaxe" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "bellows", 1, 0, { { "spr_hiddenroom_bellows" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "flask",   1, 0, { { "spr_hiddenroom_flask" } } );
    interface.TaskPanelTaskAdd( ho_tasks, "mask",    1, 0, { { "spr_hiddenroom_mask" } } );

  elseif ( ng_global.progress[ ng_global.currentprogress ][ "win_hiddenroom" ].stage[1] == 2 ) then

    interface.TaskPanelTaskAdd( ho_tasks, "pincers",  1, 0, { { "spr_hiddenroom_pincers" } } );

  end;

  return ho_tasks;

end;
------------------------------------------------------------------------------
function public.stage_1()

end;
------------------------------------------------------------------------------
function public.stage_2()

  interface_impl.TaskPanelSetNewTask( private.stages_task() );

  local func_after = function ()
    ObjSet( "anm_hiddenroom_door_open", { input = 1 } );
    cmn.Lock( 0 );
  end;

  cmn.Lock( 1, { room = 1 } );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_cupboard_opens");

  ObjMultiSet( { {"anm_hiddenroom_door_open",  { playing = 1, endtrig = func_after }},
                 {"obj_hiddenroom_use_amulets", { input = 0 }} } );

end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;

  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #private.actions, 1 do
    
    if cmn.IsEventDone( private.actions[i][1] ) then
      
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].done = 0;
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].start = 0;
      
      for j = 1, #private.actions[i][2], 1 do
      
        local nme = private.start_actions[i][j].name;
        
        if not ObjGet( nme ) then
          
          local typ = common.GetObjectPrefix( nme );
          
          if typ == "anm" then
            typ = "anim";
          end;
          
          ObjCreate( nme, typ );
          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        else 

          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        end;
          
      end;
      
    end;
    
  end;

end;
--*********************************************************************************************************************
