-- name=ho_inmirror
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_inmirror" );
  game.relations[ "ho_inmirror" ].exitroom = "rm_oldchapel";
  
  private.diff_types = {
    { 2, 2, 1, 2, 1, 1 },
    { 2, 2, 1, 2, 2, 2, 1, 1 },
    { 2, 2, 1, 2, 2, 2, 2, 2 }
  };
  --------------------------------------------------------------------------------------------
  -- function win_inmirror () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_inmirror" ] = {
    type = "win",
    room = "rm_oldchapel",
    zz = "mg_inmirror",
    zz_gate = "gho_oldchapel_inmirror"
  };
  --------------------------------------------------------------------------------------------
  local win_inmirror_func = function ()

    if ( cmn.IsEventDone( "win_inmirror" ) ) then
      interface.InventoryItemAdd( "inv_statueface", "spr_inmirror_win" );
      ObjDelete("gho_oldchapel_inmirror");
    end;

  end;
  cmn.AddSubscriber( "win_inmirror", win_inmirror_func );
  --------------------------------------------------------------------------------------------------
  local start_inmirror_func = function ()

    if ( cmn.IsEventStart( "win_inmirror" ) ) then

      common_impl.ProcessHoStart( "inmirror" );

    end;

  end;
  cmn.AddSubscriber( "win_inmirror", start_inmirror_func, "ho_inmirror" );
  
  --for secretroom
  private.tasks =  {    
      { "difference1",   1, 0, { { "obj_inmirror_stage_1_task_1" } } },
      { "difference1",   1, 0, { { "obj_inmirror_stage_1_task_2" } } },
      { "difference1",   1, 0, { { "obj_inmirror_stage_1_task_3" } } },
      { "difference1",   1, 0, { { "obj_inmirror_stage_1_task_4" } } },
      { "difference1",   1, 0, { { "obj_inmirror_stage_1_task_5" } } },
      { "difference1",   1, 0, { { "obj_inmirror_stage_1_task_6" } } },

      { "difference2",   1, 0, { { "obj_inmirror_stage_2_task_1" } } },
      { "difference2",   1, 0, { { "obj_inmirror_stage_2_task_2" } } },
      { "difference2",   1, 0, { { "obj_inmirror_stage_2_task_3" } } },
      { "difference2",   1, 0, { { "obj_inmirror_stage_2_task_4", "obj_inmirror_stage_2_task_4_2", "obj_inmirror_stage_2_task_4_3", "obj_inmirror_stage_2_task_4_4" } } },
      { "difference2",   1, 0, { { "obj_inmirror_stage_2_task_5" } } },
      { "difference2",   1, 0, { { "obj_inmirror_stage_2_task_6" } } },
      { "difference2",   1, 0, { { "obj_inmirror_stage_2_task_7" } } },
      { "difference2",   1, 0, { { "obj_inmirror_stage_2_task_8" } } },

      { "difference3",   1, 0, { { "obj_inmirror_stage_3_task_1" } } },
      { "difference3",   1, 0, { { "obj_inmirror_stage_3_task_2", "obj_inmirror_stage_3_task_2_2" } } },
      { "difference3",   1, 0, { { "obj_inmirror_stage_3_task_3" } } },
      { "difference3",   1, 0, { { "obj_inmirror_stage_3_task_4", "obj_inmirror_stage_3_task_4_2", "obj_inmirror_stage_3_task_4_3" } } },
      { "difference3",   1, 0, { { "obj_inmirror_stage_3_task_5" } } },
      { "difference3",   1, 0, { { "obj_inmirror_stage_3_task_6" } } },
      { "difference3",   1, 0, { { "obj_inmirror_stage_3_task_7" } } },
      { "difference3",   1, 0, { { "obj_inmirror_stage_3_task_8" } } },
      
      { "face",   1, 0, { { "obj_inmirror_ball", "spr_inmirror_face", "obj_inmirror_main_candle", "spr_inmirror_main_stage_1", "spr_inmirror_main_stage_2", "spr_inmirror_main_stage_3",
                            "anm_inmirror_main_candle", "spr_inmirror_ball_1", "spr_inmirror_ball_2" } } }
  };
  
  private.start = {};

  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;

  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if ng_global.currentprogress == "ext" and not ( ng_global.progress[ "ext" ][ "win_inmirror" ].stage ) then
    ng_global.progress[ "ext" ][ "win_inmirror" ].stage = { 1, 4 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].state = { {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0} };
  elseif ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].stage = { 1, 4 };
    ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].state = { {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0} };
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].state;

end;
--*********************************************************************************************************************
function public.Open() 

  cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_bells_mus", 1);
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_oldchapel_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_oldchapel_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_ho_inmirror_env");

  if ng_global.currentprogress == "ext" then
    common.SetPreviousRoom( "rm_oldchapel" );
    cmn.StartTimePassing("ho_inmirror");
  else 
    
    ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].stage = { 1, 4 };
    ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].state = { {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0} };
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].state;
    
    private.CreateNewObjects();

    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_inmirror_oldchapel",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                 event_menter = function () rm_extra.GateMouseEnter( "inmirror_oldchapel", CURSOR_DOWN, "extra" ); end, 
                                 event_mleave = function () common_impl.GateMouseLeave( "inmirror_oldchapel" ); end });
    
  end;

  if not cmn.IsEventStart( "win_inmirror" ) then
    cmn.InitHo( "inmirror" );
  end;
  
  private.DrawScene();

  local ho_tasks = private.stages_task();
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].stage;

  if (not cmn.IsEventDone("win_inmirror")) and ho_stage[1] <= ho_stage[2] then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "ext" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_inmirror_oldchapel",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;
  
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "ext" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_inmirror");

    if ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_inmirror" ] then

      ng_global.nohintho[ "win_inmirror" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_inmirror" ] then
      ng_global.playedhops[ "win_inmirror" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_inmirror_oldchapel",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_num, typ )
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].stage[1];
  private.state[ ho_stage ][ item_num ] = 1;
  
  cmn.HoTaskFind( "obj_inmirror_stage_"..ho_stage.."_task_"..item_num, "difference"..ho_stage );
  
  ObjAnimate("spr_inmirror_stage_"..ho_stage.."_difference_"..item_num.."_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  if private.diff_types[ ho_stage ][ item_num ] == 2 then
    ObjAnimate("spr_inmirror_stage_"..ho_stage.."_difference_"..item_num.."_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
  end;
  
end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].stage[1];
  
  for i = 1, 3, 1 do
    
    if i <= ho_stage then
      ObjSet("spr_inmirror_main_stage_"..i,  { alp = 1 });
    end;
    
    if i == ho_stage then
      ObjSet("obj_inmirror_stage_"..i,  { alp = 1, input = 1 });
    else 
      ObjSet("obj_inmirror_stage_"..i,  { alp = 0, input = 0 });
    end;
    
  end;
  
  if ho_stage < 4 then
    
    for s = 1, 3, 1 do
  
      for i = 1, #private.state[ s ], 1 do
        
        if private.state[ s ][i] == 1 then
          
          ObjSet("spr_inmirror_stage_"..s.."_difference_"..i.."_1",  { alp = 0 });
          
          if private.diff_types[ s ][i] == 2 then
            ObjSet("spr_inmirror_stage_"..s.."_difference_"..i.."_2",  { alp = 1 });
          end;
          
        else 
          
          ObjSet("spr_inmirror_stage_"..s.."_difference_"..i.."_1",  { alp = 1 });
          
          if private.diff_types[ s ][i] == 2 then
            ObjSet("spr_inmirror_stage_"..s.."_difference_"..i.."_2",  { alp = 0 });
          end;
          
        end;
        
      end;
      
    end;
      
  else
    
    ObjMultiSet( { {"spr_inmirror_face", { input = 1 }},
                   {"obj_inmirror_ball", { input = 1 }},
                   {"obj_inmirror_main_candle", { alp = 0 }},
                   {"spr_inmirror_ball_1", { ang = 0.52 }},
                   {"spr_inmirror_ball_2", { ang = -0.52 }} } );
    
  end;

end;
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
function private.stages_task()

  local ho_tasks = {};
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_inmirror" ].stage[1];
  
  if ( ho_stage == 1 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "difference1", 6, 0, { { "obj_inmirror_stage_1_task_1" },
                                                                { "obj_inmirror_stage_1_task_2" },
                                                                { "obj_inmirror_stage_1_task_3" },
                                                                { "obj_inmirror_stage_1_task_4" },
                                                                { "obj_inmirror_stage_1_task_5" },
                                                                { "obj_inmirror_stage_1_task_6" } } );
    
  elseif ( ho_stage == 2 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "difference2", 8, 0, { { "obj_inmirror_stage_2_task_1" },
                                                                { "obj_inmirror_stage_2_task_2" },
                                                                { "obj_inmirror_stage_2_task_3" },
                                                                { "obj_inmirror_stage_2_task_4" },
                                                                { "obj_inmirror_stage_2_task_5" },
                                                                { "obj_inmirror_stage_2_task_6" },
                                                                { "obj_inmirror_stage_2_task_7" },
                                                                { "obj_inmirror_stage_2_task_8" } } );
                                                                
  elseif ( ho_stage == 3 ) then
    
    interface.TaskPanelTaskAdd( ho_tasks, "difference3", 8, 0, { { "obj_inmirror_stage_3_task_1" },
                                                                { "obj_inmirror_stage_3_task_2" },
                                                                { "obj_inmirror_stage_3_task_3" },
                                                                { "obj_inmirror_stage_3_task_4" },
                                                                { "obj_inmirror_stage_3_task_5" },
                                                                { "obj_inmirror_stage_3_task_6" },
                                                                { "obj_inmirror_stage_3_task_7" },
                                                                { "obj_inmirror_stage_3_task_8" } } );
                                                                
  elseif ( ho_stage == 4 ) then
    interface.TaskPanelTaskAdd( ho_tasks, "face", 1, 0, { { "spr_inmirror_face" } } );
  end;
    
  return ho_tasks;
  
end;
------------------------------------------------------------------------------
function public.stage_1()
end;
------------------------------------------------------------------------------
function public.stage_2()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
  
  local func_after = function ()
    ObjMultiSet( { {"obj_inmirror_stage_1", { input = 0 }},
                   {"obj_inmirror_stage_2", { input = 1 }} } );
  end;
                 
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_inmirror_anim_change");               
  
  ObjAnimate("obj_inmirror_stage_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("obj_inmirror_stage_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 0,   1, 0, 1 });
  ObjAnimate("spr_inmirror_main_stage_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,   1, 0, 1 });
  
end;
------------------------------------------------------------------------------
function public.stage_3()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
  
  local func_after = function ()
    ObjMultiSet( { {"obj_inmirror_stage_2", { input = 0 }},
                   {"obj_inmirror_stage_3", { input = 1 }} } );
  end;
                 
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_inmirror_anim_change");  
  
  ObjAnimate("obj_inmirror_stage_2", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("obj_inmirror_stage_3", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 0,   1, 0, 1 });
  ObjAnimate("spr_inmirror_main_stage_3", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,   1, 0, 1 });
  
end;
------------------------------------------------------------------------------
function public.stage_4()
  
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
  
  local func_after = function ()
    ObjMultiSet( { {"obj_inmirror_stage_3", { input = 0 }},
                   {"obj_inmirror_ball", { input = 1 }},
                   {"spr_inmirror_face", { input = 1 }} } );
  end;
                 
  local ball_open = function ()

    ObjAnimate("spr_inmirror_ball_1", "ang", 0, 0, func_after, { 0, 0, 0,   1, 0, 0.52 });
    ObjAnimate("spr_inmirror_ball_2", "ang", 0, 0, "", { 0, 0, 0,   1, 0, -0.52 });    
    
  end;
                 
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_inmirror_open_ball");  
  
  ObjAnimate("obj_inmirror_stage_3", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("obj_inmirror_main_candle", "alp", 0, 0, ball_open, { 0, 0, 1,   0.5, 0, 0 });
  
end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  
  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

end;
--********************************************************************************************************************