-- name=ho_intent
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_intent" );
  game.relations[ "ho_intent" ].exitroom = "rm_forest";
  
  private.task_names = {
    "rope", "hat", "binoculars", "headphones", "tin", "teddybear", "mug", "shoe", "flask", "matchbox", "scoopnet", "kettle"
  };
  
  private.fin_pos = {
    {732, 480, 0}, {270, 611, 0}, {738, 166, 0}, {109, 512, 0}, 0, {1010, 234, 0.16},
    {322, 363, 0}, {886, 438, -0.4}, {994, 366, -0.97}, {458, 644, 0}, {471, 54, 0.13}, {839, 239, 0.21}
  };
  private.fin_pos_sh = {
    {738, 522, 0}, 0, 0, {96, 523, 0}, 0, {1019, 243, 0.16},
    {318, 368, 0}, {882, 442, -0.4}, {1001, 381, -0.97}, {457, 660, 0}, {469, 84, 0.13}, {872, 249, 0.23}
  };
  
  private.start_pos = {
    {714, 443}, {325, 586}, {697, 166}, {155, 524}, 0, {972, 184},
    {357, 469}, {869, 401}, {963, 339}, {480, 604}, {317, 53}, {786, 245}
  };
  private.start_pos_sh = {
    {720, 485}, 0, 0, {143, 538}, 0, {980, 184},
    {345, 474}, {864, 413}, {979, 358}, {479, 621}, {315, 83}, {818, 262}
  };
  
  private.light_pos = {
    {733, 425}, {368, 566}, {672, 164}, {181, 526}, {623, 409}, {966, 149},
    {360, 461}, {857, 347}, {953, 320}, {470, 612}, {347, 61}, {776, 260}
  };
  
  private.big_light_param = { 0.4, 0.05 };
  
  private.InitMarked();
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_intent" ] = 
  {
    type = "win",
    room = "rm_forest",
    zz = "ho_intent",
    zz_gate = "gho_forest_intent"
  };
  --------------------------------------------------------------------------------------------------
  local win_intent_func = function ()

    if ( cmn.IsEventDone( "win_intent" ) ) then
      interface.InventoryItemAdd( "inv_littlefire", "spr_intent_win" );
      ObjSet("inv_torch_star_light",  { alp = 1 });
      ObjDelete("gho_forest_intent");
    end;

  end;
  cmn.AddSubscriber( "win_intent", win_intent_func );
  --------------------------------------------------------------------------------------------------
  local start_intent_func = function ()

    if ( cmn.IsEventStart( "win_intent" ) ) then

      common_impl.ProcessHoStart( "intent" );

    end;

  end;
  cmn.AddSubscriber( "win_intent", start_intent_func, "ho_intent" );
  
  --for secretroom
  private.tasks =  {    
  
    { "rope",      1, 0, { { "spr_intent_rope", "anm_intent_light_1", "obj_intent_fly_rope" } } },
    { "hat",    1, 0, { { "spr_intent_hat", "anm_intent_light_2", "obj_intent_fly_hat" } } },
    { "binoculars",      1, 0, { { "spr_intent_binoculars", "anm_intent_light_3", "obj_intent_fly_binoculars" } } },
    { "headphones",     1, 0, { { "spr_intent_headphones", "anm_intent_light_4", "obj_intent_fly_headphones" } } },
      
    { "tin",      1, 1, { { "obj_intent_fly_tin", "anm_intent_light_5", "anm_intent_tin" } } },
    { "teddybear",     1, 0, { { "spr_intent_teddybear", "anm_intent_light_6", "obj_intent_fly_teddybear" } } },
    { "mug",   1, 0, { { "spr_intent_mug", "anm_intent_light_7", "obj_intent_fly_mug" } } },
    { "shoe",   1, 1, { { "spr_intent_shoe", "anm_intent_light_8", "obj_intent_fly_shoe" } } },
      
    { "flask",  1, 0, { { "spr_intent_flask", "anm_intent_light_9", "obj_intent_fly_flask" } } },
    { "matchbox",    1, 1, { { "spr_intent_matchbox", "anm_intent_light_10", "obj_intent_fly_matchbox" } } },
    { "scoopnet", 1, 1, { { "spr_intent_scoopnet", "anm_intent_light_11", "obj_intent_fly_scoopnet" } } },
    { "kettle",    1, 0, { { "spr_intent_kettle", "anm_intent_light_12", "obj_intent_fly_kettle" } } }
      
  };
  
  private.actions = {
  
    { "use_holvl4opener", { "obj_intent_use_opener", "spr_intent_opener_sh", "spr_intent_opener" } },
    { "use_holvl4laces", { "obj_intent_use_laces", "spr_intent_laces_sh", "spr_intent_laces", "spr_intent_shoe_2" } },
    { "use_holvl4matches", { "obj_intent_use_matches", "spr_intent_matches", "spr_intent_matchbox_sh_2", "spr_intent_matchbox_2" } },
    { "use_holvl4net", { "obj_intent_use_net", "spr_intent_net", "spr_intent_scoop_2", "spr_intent_scoop_sh_2" } }

  };
  
  private.start_actions = {};
  
  for i = 1, #private.actions, 1 do
    
    private.start_actions[i] = {};
    
    for j = 1, #private.actions[i][2], 1 do
    
      private.start_actions[i][j] = {};
      private.start_actions[i][j].name = private.actions[i][2][j];
      local nme = private.start_actions[i][j].name;
      private.start_actions[i][j].prop = ObjGet( nme );
      private.start_actions[i][j].parent = ObjGetRelations( nme ).parent;
    
    end;
  end;
  
  private.tasks_sh =  { 1, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1 };

  private.start = {};
  private.start_sh = {};

  local nme = "";

  for i = 1, #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;

    end;
    
    if private.tasks_sh[i] == 1 then
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = "spr_"..common.GetObjectName(private.tasks[ i ][ 4 ][1][1].."_sh");
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if not( ng_global.progress[ ng_global.currentprogress ][ "win_intent" ].state) or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_intent" ].state = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_intent" ].state;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_forest_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_forest_env");

  if ng_global.currentprogress == "ext" then
    common.SetPreviousRoom( "rm_forest" );
    cmn.StartTimePassing("ho_intent");
  else 
    
    ng_global.progress[ ng_global.currentprogress ][ "win_intent" ].stage = { 1, 1 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_intent" ].state = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_intent" ].state;
    
    private.CreateNewObjects();

    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_intent_forest",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                 event_menter = function () rm_extra.GateMouseEnter( "intent_forest", CURSOR_DOWN, "extra" ); end, 
                                 event_mleave = function () common_impl.GateMouseLeave( "intent_forest" ); end });
    
  end;

  if not cmn.IsEventStart( "win_intent" ) then
    
    cmn.InitHo( "intent" );
    
    if ng_global.currentprogress == "ext" then
      
      cmn.SetMarkedTask( "intent", "tin" );
      cmn.SetMarkedTask( "intent", "shoe" );
      cmn.SetMarkedTask( "intent", "matchbox" );
      cmn.SetMarkedTask( "intent", "scoopnet" );
      
    else 
      
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "tin" ] = {};
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "tin" ].done = 0;
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "tin" ].start = 0;
      
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "shoe" ] = {};
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "shoe" ].done = 0;
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "shoe" ].start = 0;
      
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "matchbox" ] = {};
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "matchbox" ].done = 0;
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "matchbox" ].start = 0;
      
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "scoopnet" ] = {};
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "scoopnet" ].done = 0;
      ng_global.progress[ "secret" ][ "win_intent" ].unmark[ "scoopnet" ].start = 0;
      
    end;
    
  end;
  
  private.DrawScene();

  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "rope", 1, 0, { { "spr_intent_rope" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "hat", 1, 0, { { "spr_intent_hat" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "binoculars", 1, 0, { { "spr_intent_binoculars" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "headphones", 1, 0, { { "spr_intent_headphones" } } );
  
  interface.TaskPanelTaskAdd( ho_tasks, "tin", 1, 1, { { "obj_intent_fly_tin" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "teddybear", 1, 0, { { "spr_intent_teddybear" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "mug", 1, 0, { { "spr_intent_mug" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "shoe", 1, 1, { { "spr_intent_shoe" } } );
  
  interface.TaskPanelTaskAdd( ho_tasks, "flask", 1, 0, { { "spr_intent_flask" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "matchbox", 1, 1, { { "spr_intent_matchbox" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "scoopnet", 1, 1, { { "spr_intent_scoopnet" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "kettle", 1, 0, { { "spr_intent_kettle" } } );

  if (not cmn.IsEventDone("win_intent")) then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  else
    common_impl.DialogHo_Show();
  end;

end;
--*********************************************************************************************************************
function public.Open()    

  cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_bells_mus", 1);

end; 
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "ext" then
  
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_intent_forest",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "ext" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_intent");

    if ng_global.progress[ ng_global.currentprogress ][ "win_intent" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_intent" ] then

      ng_global.nohintho[ "win_intent" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_intent" ] then
      ng_global.playedhops[ "win_intent" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_intent_forest",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.ItemFind( item_num )
  
  private.state[ item_num ] = 1;
  local lights = private.CountLights();
  cmn.HoTaskFind( "obj_intent_fly_"..private.task_names[ item_num ], private.task_names[ item_num ], 1 );
  
  local anm_light = function ()
    private.SetLightFly( item_num, lights );
  end;
  
  if item_num ~= 5 then
    
    ObjSet("spr_intent_"..private.task_names[ item_num ],  { input = 0 });
  
    ObjAnimate("spr_intent_"..private.task_names[ item_num ], "pos_xy", 0, 0, anm_light, { 
      0, 0, private.start_pos[ item_num ][1], private.start_pos[ item_num ][2],   
    0.5, 0, private.fin_pos[ item_num ][1], private.fin_pos[ item_num ][2] });
    
    ObjAnimate("spr_intent_"..private.task_names[ item_num ], "ang", 0, 0, anm_light, { 0, 0, 0,    0.5, 0, private.fin_pos[ item_num ][3] });
    
    if private.start_pos_sh[ item_num ] ~= 0 then
      
      ObjAnimate("spr_intent_"..private.task_names[ item_num ].."_sh", "pos_xy", 0, 0, anm_light, { 
        0, 0, private.start_pos_sh[ item_num ][1], private.start_pos_sh[ item_num ][2],   
      0.5, 0, private.fin_pos_sh[ item_num ][1], private.fin_pos_sh[ item_num ][2] });
      
      ObjAnimate("spr_intent_"..private.task_names[ item_num ].."_sh", "ang", 0, 0, anm_light, { 0, 0, 0,    0.5, 0, private.fin_pos_sh[ item_num ][3] });
      
    end;
    
  else 
    private.SetLightFly( item_num, lights );
  end;

end;
--------------------------------------------------------------------------------
function private.SetLightFly( num, lights )
  
  local scale_1 = private.big_light_param[1] + private.big_light_param[2]*(lights-1);
  local scale_2 = private.big_light_param[1] + private.big_light_param[2]*lights;
  
  local point_a, point_b = {}, {};
  point_a[1] = private.light_pos[num][1];
  point_a[2] = private.light_pos[num][2];
  point_b[1] = 890;
  point_b[2] = 532;
  
  ObjAttach("anm_intent_light_"..num, "obj_intent_fly");
  
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.003 * len;
  
  if tme > 0.5 then
    tme = 0.5;
  elseif tme < 0.1 then
    tme = 0.1;
  end;
  
  local func_after = function ( num2 )
    ObjAnimate("spr_intent_biglight", "scale_xy", 0, 0, "", { 0, 0, scale_1, scale_1,   0.3, 0, scale_2, scale_2 });
    ObjAnimate("anm_intent_light_"..num2, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;
  
  ObjAnimate("anm_intent_light_"..num, "pos_xy", 0, 0, function() func_after(num); end, { 0, 0, private.light_pos[num][1], private.light_pos[num][2],    tme, 0, 890, 532 });
  
end;
-----------------------------------------------------------------------------------
function private.CountLights()
  
  local count = 0;
  
  for i = 1, 12, 1 do
    
    if private.state[i] == 1 then
      count = count + 1;
    end;
    
  end;
  
  return count;
  
end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  local lights = private.CountLights();
  local scale = private.big_light_param[1] + private.big_light_param[2]*lights;
  
  for i = 1, 12, 1 do
    
    if i ~= 5 then
    
      if private.state[i] == 0 then
        
        ObjSet("spr_intent_"..private.task_names[i],  { pos_x = private.start_pos[i][1], pos_y = private.start_pos[i][2], ang = 0 });
        
        if i ~= 8 and i ~= 10 and i ~= 11 then
          ObjSet("spr_intent_"..private.task_names[i],  { input = 1 });
        end;
        
        if private.start_pos_sh[i] ~= 0 then
          ObjSet("spr_intent_"..private.task_names[i].."_sh",  { pos_x = private.start_pos_sh[i][1], pos_y = private.start_pos_sh[i][2], ang = 0 });
        end;
        
      else 
        
        ObjDelete("anm_intent_light_"..i);
        
        ObjSet("spr_intent_"..private.task_names[i],  { input = 0, pos_x = private.fin_pos[i][1], pos_y = private.fin_pos[i][2], ang = private.fin_pos[i][3] });
        
        if private.fin_pos_sh[i] ~= 0 then
          ObjSet("spr_intent_"..private.task_names[i].."_sh",  { pos_x = private.fin_pos_sh[i][1], pos_y = private.fin_pos_sh[i][2], ang = private.fin_pos_sh[i][3] });
        end;
        
      end;
      
    else
      
      if private.state[i] == 1 then
        ObjDelete("anm_intent_light_"..i);
      end;
      
    end;
    
  end;
  
  ObjSet("spr_intent_biglight",  { scale_x = scale, scale_y = scale });
  
end;
--*********************************************************************************************************************
-- function *** MARKED *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function private.InitMarked()

  public.ho_hint_progress_names = { "use_holvl4opener", "use_holvl4laces", "use_holvl4matches", "use_holvl4net" };
  
  --------------------------------------------------------------------------------------------
  -- function use_holvl4opener () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4opener" ] = {
    type = "use",
    inv_obj = "spr_intent_opener",
    use_place = "obj_intent_use_opener",
    room = "rm_forest",
    zz = "ho_intent",
    zz_gate = "gho_forest_intent"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4opener_beg = function ()
  
    ObjDelete( "obj_intent_use_opener" );
    ObjDelete( "spr_intent_opener_sh" );
    ObjDelete( "spr_intent_opener" );
  
  end;
  local use_holvl4opener_end = function ()
    
    ObjMultiSet( { {"anm_intent_tin", { alp = 1, frame = 300 }},
                   {"anm_intent_light_5", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4opener", use_holvl4opener_beg, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4opener", use_holvl4opener_end, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4opener_beg", use_holvl4opener_beg, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4opener_end", use_holvl4opener_end, "ho_intent" );
  
  --------------------------------------------------------------------------------------------
  -- function use_holvl4laces () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4laces" ] = {
    type = "use",
    inv_obj = "spr_intent_laces",
    use_place = "obj_intent_use_laces",
    room = "rm_forest",
    zz = "ho_intent",
    zz_gate = "gho_forest_intent"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4laces_beg = function ()
  
    ObjDelete( "obj_intent_use_laces" );
    ObjDelete( "spr_intent_laces_sh" );
    ObjDelete( "spr_intent_laces" );
  
  end;
  local use_holvl4laces_end = function ()
    
    ObjMultiSet( { {"spr_intent_shoe_2", { alp = 1 }},
                   {"spr_intent_shoe", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4laces", use_holvl4laces_beg, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4laces", use_holvl4laces_end, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4laces_beg", use_holvl4laces_beg, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4laces_end", use_holvl4laces_end, "ho_intent" );
  
  --------------------------------------------------------------------------------------------
  -- function use_holvl4matches () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4matches" ] = {
    type = "use",
    inv_obj = "spr_intent_matches",
    use_place = "obj_intent_use_matches",
    room = "rm_forest",
    zz = "ho_intent",
    zz_gate = "gho_forest_intent"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4matches_beg = function ()
  
    ObjDelete( "obj_intent_use_matches" );
    ObjDelete( "spr_intent_matches" );
  
  end;
  local use_holvl4matches_end = function ()
    
    ObjDelete( "spr_intent_matchbox_sh_2" );
    ObjDelete( "spr_intent_matchbox_2" );
    
    ObjMultiSet( { {"spr_intent_matchbox_sh", { alp = 1 }},
                   {"spr_intent_matchbox", { alp = 1, input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4matches", use_holvl4matches_beg, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4matches", use_holvl4matches_end, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4matches_beg", use_holvl4matches_beg, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4matches_end", use_holvl4matches_end, "ho_intent" );
  
  --------------------------------------------------------------------------------------------
  -- function use_holvl4net () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_holvl4net" ] = {
    type = "use",
    inv_obj = "spr_intent_net",
    use_place = "obj_intent_use_net",
    room = "rm_forest",
    zz = "ho_intent",
    zz_gate = "gho_forest_intent"
  };
  --------------------------------------------------------------------------------------------
  local use_holvl4net_beg = function ()
  
    ObjDelete( "obj_intent_use_net" );
    ObjDelete( "spr_intent_net" );
  
  end;
  local use_holvl4net_end = function ()
    
    ObjDelete( "spr_intent_scoop_sh_2" );
    ObjDelete( "spr_intent_scoop_2" );
    
    ObjMultiSet( { {"spr_intent_scoopnet_sh", { alp = 1 }},
                   {"spr_intent_scoopnet", { alp = 1, input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_holvl4net", use_holvl4net_beg, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4net", use_holvl4net_end, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4net_beg", use_holvl4net_beg, "ho_intent" );
  cmn.AddSubscriber( "use_holvl4net_end", use_holvl4net_end, "ho_intent" );
  
end;
--*********************************************************************************************************************
------------------------------------------------------------------------------
function public.StartDrag( name )

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_from_inventory" );
  ObjAttach("spr_intent_"..name, "obj_intent_fly");

  if name == "opener" or name == "laces" then
    ObjAnimate("spr_intent_"..name.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0 });
  end;

end;
------------------------------------------------------------------------------
function public.use_opener()

  item = "spr_intent_opener";

  if ( cmn.ApplyObj( item, "obj_intent_use_opener" ) ) then

    cmn.CallEventHandler( "use_holvl4opener_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_holvl4opener" );
      cmn.CallEventHandler( "use_holvl4opener_end" );

      cmn.UnmarkTask( "intent", "tin" );
      
      public.ItemFind( 5 );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_intent_bank");
    
    ObjSet("anm_intent_tin",  { alp = 1, playing = 1, endtrig = func_after });
    ObjAnimate("anm_intent_light_5", "alp", 0, 0, "", { 0, 0, 0,   1.35, 0, 0,  1.56, 0, 1 });
    
  else 

    cmn.WrongApply();
    ObjAttach(item, "ho_intent");
    ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
------------------------------------------------------------------------------
function public.use_laces()

  item = "spr_intent_laces";

  if ( cmn.ApplyObj( item, "obj_intent_use_laces" ) ) then

    cmn.CallEventHandler( "use_holvl4laces_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_holvl4laces" );
      cmn.CallEventHandler( "use_holvl4laces_end" );

      cmn.UnmarkTask( "intent", "shoe" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_intent_boot");
    
    ObjAnimate("spr_intent_shoe_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    
  else 

    cmn.WrongApply();
    ObjAttach(item, "ho_intent");
    ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;

end;
------------------------------------------------------------------------------
function public.use_matches()

  item = "spr_intent_matches";

  if ( cmn.ApplyObj( item, "obj_intent_use_matches" ) ) then

    cmn.CallEventHandler( "use_holvl4matches_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_holvl4matches" );
      cmn.CallEventHandler( "use_holvl4matches_end" );

      cmn.UnmarkTask( "intent", "matchbox" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_intent_matches");
    
    local anm_2 = function ()
      
      ObjAnimate("spr_intent_matchbox_sh", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_intent_matchbox", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
      ObjAnimate("spr_intent_matchbox_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_intent_matchbox_sh_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
    ObjAnimate("spr_intent_matchbox_3", "alp", 0, 0, anm_2, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    
  else 

    cmn.WrongApply();
    ObjAttach(item, "ho_intent");

  end;

end;
------------------------------------------------------------------------------
function public.use_net()

  item = "spr_intent_net";

  if ( cmn.ApplyObj( item, "obj_intent_use_net" ) ) then

    cmn.CallEventHandler( "use_holvl4net_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_holvl4net" );
      cmn.CallEventHandler( "use_holvl4net_end" );

      cmn.UnmarkTask( "intent", "scoopnet" );

    end;

    cmn.Lock( 1, { room = 1 } );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_ho_intent_rocket");
    
    ObjAnimate("spr_intent_scoopnet_sh", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("spr_intent_scoopnet", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
    ObjAnimate("spr_intent_scoop_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_intent_scoop_sh_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
  else 

    cmn.WrongApply();
    ObjAttach(item, "ho_intent");

  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_racoon()
  
  ObjSet("obj_intent_racoon_touch",  { input = 0 });
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_raccoon");
  
  local func_after = function ()
    
    ObjMultiSet( { {"obj_intent_racoon_touch",  { input = 1 }},
                   {"anm_intent_raccoon", { frame = 0, animfunc = "anm_raccoon", playing = 1, endtrig = "" }} } );
    
  end;

  ObjSet( "anm_intent_raccoon", { frame = 0, animfunc = "anm_raccoon_click", playing = 1, endtrig = func_after } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_lizard()
  
  ObjSet("obj_intent_lizard_touch",  { input = 0 });
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_lizard");
  
  local func_after = function ()
    
    ObjMultiSet( { {"obj_intent_lizard_touch",  { input = 1 }},
                   {"anm_intent_lizard", { frame = 0, animfunc = "anm_lizard", playing = 1, endtrig = "" }} } );
    
  end;

  ObjSet( "anm_intent_lizard", { frame = 0, animfunc = "anm_lizard_click", playing = 1, endtrig = func_after } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_cricket()
  
  ObjSet("obj_intent_cricket_touch",  { input = 0 });
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_cricket");
  
  local func_after = function ()
    
    ObjMultiSet( { {"obj_intent_cricket_touch",  { input = 1 }},
                   {"anm_intent_cricket", { frame = 0, animfunc = "anm_cricket", playing = 1, endtrig = "" }} } );
    
  end;

  ObjSet( "anm_intent_cricket", { frame = 0, animfunc = "anm_cricket_click", playing = 1, endtrig = func_after } );
  
end;
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  
  for i = 1, #private.actions, 1 do
    
    if cmn.IsEventDone( private.actions[i][1] ) then
      
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].done = 0;
      ng_global.progress[ ng_global.currentprogress ][ private.actions[i][1] ].start = 0;
      
      for j = 1, #private.actions[i][2], 1 do
      
        local nme = private.start_actions[i][j].name;
        
        if not ObjGet( nme ) then
          
          local typ = common.GetObjectPrefix( nme );
          
          if typ == "gfx" then
            typ = "partsys_gm";
          elseif typ == "anm" then
            typ = "anim";
          end;
          
          ObjCreate( nme, typ );
          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        else 

          ObjSet( nme, private.start_actions[i][j].prop );
          ObjAttach( nme, private.start_actions[i][j].parent );

        end;
          
      end;
      
    end;
    
  end;

  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;

end;
--********************************************************************************************************************