-- name=ho_ontvset
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_ontvset" );
  game.relations[ "ho_ontvset" ].exitroom = "rm_inhouse";
  private.win_inprogress = false;
  
  public.change_stage_anim_type = "alp";
  public.task_count_show = 12;
  public.tasks_img = { "angel", "candle", "lolipop", "sliper", "cookie", "mitten" };
  
  private.cur_progress = "ext";
  --------------------------------------------------------------------------------------------------
  game.ontvset = {};
  --------------------------------------------------------------------------------------------------
  game.hint[ "win_ontvset" ] = 
  {
    type = "win",
    room = "rm_inhouse",
    zz = "ho_ontvset",
    zz_gate = "gho_inhouse_ontvset"
  };
  --------------------------------------------------------------------------------------------------
  local win_ontvset_func = function ()

    if ( cmn.IsEventDone( "win_ontvset" ) ) then

      ObjMultiSet( {
        { "grm_inhouse_nayasroom",  { alp = 1, input = 1 } },
        { "spr_inhouse_door_open", { alp = 1 } },
        { "spr_inhouse_tvset_3", { alp = 1 } }
      } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_inhouse_nayasroom_focus");
      end;
    
      ObjDelete("gho_inhouse_ontvset");
      ObjDelete("anm_inhouse_tvset_2");
      ObjDelete( "obj_inhouse_door" );

    end;

  end;
  cmn.AddSubscriber( "win_ontvset", win_ontvset_func );
  --------------------------------------------------------------------------------------------------
  local start_ontvset_func = function ()

    if ( cmn.IsEventStart( "win_ontvset" ) ) then

      common_impl.ProcessHoStart( "ontvset", true );

    end;

  end;
  cmn.AddSubscriber( "win_ontvset", start_ontvset_func, "ho_ontvset" );
  
  --for secretroom
  private.tasks =  {    
  
      { "sleigh",    1, 0, { { "spr_ontvset_sleigh" } } },
      { "angel",     1, 0, { { "spr_ontvset_angel", "spr_ontvset_angel_2" } } },
      { "mistletoe", 1, 0, { { "spr_ontvset_mistletoe" } } },
      { "candle",    1, 0, { { "spr_ontvset_candle", "spr_ontvset_candle_2", "spr_ontvset_candle_2_bl" } } },
      
      { "snowglobe", 1, 0, { { "spr_ontvset_snowglobe" } } },
      { "lolipop",   1, 0, { { "spr_ontvset_lolipop", "spr_ontvset_lolipop_2", "spr_ontvset_lolipop_2_shadow" } } },
      { "santahat",  1, 0, { { "spr_ontvset_santahat" } } },
      { "sliper",    1, 0, { { "spr_ontvset_sliper", "spr_ontvset_sliper_2", "spr_ontvset_sliper_2_shadow" } } },
      
      { "star",      1, 0, { { "spr_ontvset_star" } } },
      { "cookie",    1, 0, { { "spr_ontvset_cookie", "spr_ontvset_cookie_2" } } },
      { "bow",       1, 0, { { "spr_ontvset_bow" } } },
      { "mitten",    1, 0, { { "spr_ontvset_mitten", "spr_ontvset_mitten_2", "spr_ontvset_mitten_2_shadow" } } }
      
  };
  
  private.tasks_sh =  { 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1 };

  private.start = {};
  private.start_sh = {};
  private.start_items = {};
  local nme = "";

  for i = 1,  #private.tasks, 1 do

    for j = 1, #private.tasks[i][4][1], 1 do

      table.insert( private.start, {} );
      private.start[ #private.start ].name = private.tasks[ i ][ 4 ][1][ j ];
      nme = private.start[ #private.start ].name;
      private.start[ #private.start ].prop = ObjGet( nme );
      private.start[ #private.start ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
    if i < 13 and i % 2 == 0 then

      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][1][1] ).."_task_img";
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      
      table.insert( private.start_items, {} );
      private.start_items[ #private.start_items ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][1][1] ).."_task_img_2";
      nme = private.start_items[ #private.start_items ].name;
      private.start_items[ #private.start_items ].prop = ObjGet( nme );
      private.start_items[ #private.start_items ].parent = ObjGetRelations( nme ).parent;
      
    end;
    
    if private.tasks_sh[i] == 1 then
      table.insert( private.start_sh, {} );
      private.start_sh[ #private.start_sh ].name = "spr_"..common.GetObjectName( private.tasks[ i ][ 4 ][ 1 ][ 1 ] ).."_shadow";
      nme = private.start_sh[ #private.start_sh ].name;
      private.start_sh[ #private.start_sh ].prop = ObjGet( nme );
      private.start_sh[ #private.start_sh ].parent = ObjGetRelations( nme ).parent;
    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_ontvset" ].stage or ng_global.currentprogress == "secret" then
    ng_global.progress[ ng_global.currentprogress ][ "win_ontvset" ].stage = { 1, 12 };   --[1] - номер стадии, [2] - количество стадий
    ng_global.progress[ ng_global.currentprogress ][ "win_ontvset" ].state = {};
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_inhouse_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_inhouse_env");

  if ng_global.currentprogress == "ext" then
    
    private.cur_progress = "ext";
    
    common.SetPreviousRoom( "rm_inhouse" );
    cmn.StartTimePassing("ho_ontvset");
    
  else 
    
    private.win_inprogress = false;
    
    ObjSet("obj_ontvset_naya_and_victor",  { alp = 0 });
    
    private.cur_progress = "secret";
    public.task_count_show = 12;
    private.CreateNewObjects();
    ng_global.progress[ ng_global.currentprogress ][ "win_ontvset" ].stage = { 1, 12 };
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    
    ObjSet("grm_ontvset_inhouse",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                     event_menter = function () rm_extra.GateMouseEnter( "ontvset_inhouse", CURSOR_DOWN, "extra" ); end, 
                                     event_mleave = function () common_impl.GateMouseLeave( "ontvset_inhouse" ); end });
    
  end;
                                     
  private.DrawScene();

  if not cmn.IsEventStart( "win_ontvset" ) then
    cmn.InitHo( "ontvset" );
  end;

  local ho_tasks = private.stages_task();
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_ontvset" ].stage;

  if not cmn.IsEventDone("win_ontvset")  and ho_stage[1] <= ho_stage[2] then
  
    interface_impl.TaskPanelShow( ho_tasks );
  
  elseif ng_global.currentprogress == "ext" then
    cmn.Lock( 1, { room = 1 } );
  end;

end;
--*********************************************************************************************************************
function public.Open()
  
  cmn.PlayAudio("mus", "assets/levels/level4/audio/mus/aud_christmas_loop_mus", 1);
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_ontvset" ].stage;
  if ng_global.currentprogress == "ext" and cmn.IsEventDone("win_ontvset") or ho_stage[1] > ho_stage[2] then
    public.win();
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  interface_impl.TaskPanelHide();
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "ext" then
    
    common_impl.PlayBackgroundMusic();

    common_impl.StopwatchHoClose();
    common_impl.achiev.stopwatch = {};

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );

    common_impl.PauseAchiev(0);
    
  else 
    
    ObjSet("grm_ontvset_inhouse",  { input = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    
  end;

end;
--*********************************************************************************************************************
function public.Close()

  if ng_global.progress[ private.cur_progress ][ "win_ontvset" ].stage[1] < ng_global.progress[ private.cur_progress ][ "win_ontvset" ].stage[2] and
     ng_global.progress[ private.cur_progress ][ "win_ontvset" ].stage[1] % 2 == 0 then
    
    local st = ng_global.progress[ private.cur_progress ][ "win_ontvset" ].stage[1]/2;
    
    ObjDetach("spr_ontvset_"..public.tasks_img[st].."_task_img");
    
  end;
    
end;
--*********************************************************************************************************************
function public.HoComplete()
  
  if ng_global.currentprogress == "ext" then

    common_impl.PauseAchiev(1);

    cmn.EndTimePassing("ho_ontvset");

    if ng_global.progress[ ng_global.currentprogress ][ "win_ontvset" ].is_hint ~= 1
    and not ng_global.nohintho[ "win_ontvset" ] then

      ng_global.nohintho[ "win_ontvset" ] = 1;
      common_impl.CheckAchiev( "ho" );

    end;
    
    if ng_global.playedhops and not ng_global.playedhops[ "win_ontvset" ] then
      ng_global.playedhops[ "win_ontvset" ] = 1;
    end;
    
  else 
    
    ObjSet("grm_ontvset_inhouse",  { input = 0 });
    
  end;
  
end;
--*********************************************************************************************************************
function public.win()
  
  if not private.win_inprogress then
    
    ObjSet("grm_ontvset_inhouse",  { input = 0 });
    
    private.win_inprogress = true;
    
    cmn.SetEventDone("win_ontvset");
    
    local play_video = function ()
  
      cmn.StopAllEnv();

      local func_after = function ()
        ObjSet("ho_ontvset",  { color_r = 0, color_g = 0, color_b = 0 });
        cmn.ShowBbt( "inhouse_after_ho" );
        cmn.CallEventHandler("win_ontvset");
        cmn.GotoRoom("rm_inhouse");
      end;
      
      cmn.Lock(0);
      cmn.PlayFullscreenVideo( "assets/levels/level4/ho_ontvset/vid_ontvset", func_after, "assets/levels/level4/audio/mus/aud_vid_ontvset_mus", "assets/levels/level4/audio/voc/aud_4_lvl_victor_1_voc");
      
    end;
    
    if private.cur_progress == "secret" then
      ObjAnimate("obj_ontvset_naya_and_victor", "alp", 0, 0, int_dialog_secretroom.ShowAnim, { 0, 0, 0,   1, 0, 1 });
    else 
      ObjAnimate("obj_ontvset_naya_and_victor", "alp", 0, 0, play_video, { 0, 0, 0,   1, 0, 1,   2, 0, 1 });
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.DrawScene()
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_ontvset" ].stage[1];
  
  for i = 1, ho_stage-1, 1 do
    ObjSet("obj_ontvset_color_"..i,  { alp = 1 });
  end;
  
  for i = ho_stage, 12, 1 do
    ObjSet("obj_ontvset_color_"..i,  { alp = 0 });
  end;
  
end;
--*********************************************************************************************************************
function public.ItemUse( task_name )
  
  --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
  
  if ( cmn.ApplyObj( "spr_ontvset_"..task_name.."_task_img_2", "spr_ontvset_"..task_name ) ) then
    
    local func_after = function ()

      cmn.Lock( 0 );

      public.ItemFound( task_name );
    
    end;

    cmn.Lock( 1, { room = 1 } );
    
    ObjSet( "spr_ontvset_"..task_name.."_task_img",  { alp = 0, input = false } );
    
    ObjAnimate( "spr_ontvset_"..task_name.."_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    
    if task_name ~= "angel" and task_name ~= "candle" and task_name ~= "cookie" then
      ObjAnimate( "spr_ontvset_"..task_name.."_2_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_ontvset" ].stage[1];
  
  ObjAnimate("obj_ontvset_color_"..ho_stage, "alp", 0, 0, "", { 0, 0, 0,   1, 0, 1 });

  ObjDelete( "spr_ontvset_"..item_name.."_shadow" );
  
  if task_name ~= "angel" and task_name ~= "candle" and task_name ~= "cookie" then
    ObjDelete( "spr_ontvset_"..item_name.."_2_shadow" );
  end;
  
  cmn.HoTaskFind( "spr_ontvset_"..item_name, item_name, 1 );
  
end;
--*********************************************************************************************************************
-- function *** STAGES *** () end;
--*********************************************************************************************************************
function private.stages_task()

  local ho_tasks = {};
  local ho_stage = ng_global.progress[ ng_global.currentprogress ][ "win_ontvset" ].stage[1];

  if ( ho_stage == 1 ) then

    game.ontvset.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "sleigh", 1, 0, { { "spr_ontvset_sleigh" } } );
    ObjSet( "spr_ontvset_sleigh", { input = 1 } );
    
  elseif ( ho_stage == 2 ) then
    
    game.ontvset.double_hint = { { "spr_ontvset_angel",  "spr_ontvset_angel_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "angel", 1, 0, { { "spr_ontvset_angel" } } );
    ObjSet( "spr_ontvset_angel", { input = 1 } );

  elseif ( ho_stage == 3 ) then
    
    game.ontvset.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "mistletoe", 1, 0, { { "spr_ontvset_mistletoe" } } );
    ObjSet( "spr_ontvset_mistletoe", { input = 1 } );
    
  elseif ( ho_stage == 4 ) then
    
    game.ontvset.double_hint = { { "spr_ontvset_candle",  "spr_ontvset_candle_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "candle", 1, 0, { { "spr_ontvset_candle" } } );
    ObjSet( "spr_ontvset_candle", { input = 1 } );

  elseif ( ho_stage == 5 ) then
    
    game.ontvset.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "snowglobe", 1, 0, { { "spr_ontvset_snowglobe" } } );
    ObjSet( "spr_ontvset_snowglobe", { input = 1 } );
    
  elseif ( ho_stage == 6 ) then
    
    game.ontvset.double_hint = { { "spr_ontvset_lolipop",  "spr_ontvset_lolipop_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "lolipop", 1, 0, { { "spr_ontvset_lolipop" } } );
    ObjSet( "spr_ontvset_lolipop", { input = 1 } );

  elseif ( ho_stage == 7 ) then
    
    game.ontvset.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "santahat", 1, 0, { { "spr_ontvset_santahat" } } );
    ObjSet( "spr_ontvset_santahat", { input = 1 } );
    
  elseif ( ho_stage == 8 ) then
    
    game.ontvset.double_hint = { { "spr_ontvset_sliper",  "spr_ontvset_sliper_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "sliper", 1, 0, { { "spr_ontvset_sliper" } } );
    ObjSet( "spr_ontvset_sliper", { input = 1 } );

  elseif ( ho_stage == 9 ) then
    
    game.ontvset.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "star", 1, 0, { { "spr_ontvset_star" } } );
    ObjSet( "spr_ontvset_star", { input = 1 } );
    
  elseif ( ho_stage == 10 ) then
    
    game.ontvset.double_hint = { { "spr_ontvset_cookie",  "spr_ontvset_cookie_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "cookie", 1, 0, { { "spr_ontvset_cookie" } } );
    ObjSet( "spr_ontvset_cookie", { input = 1 } );

  elseif ( ho_stage == 11 ) then
    
    game.ontvset.double_hint = nil;
    interface.TaskPanelTaskAdd( ho_tasks, "bow", 1, 0, { { "spr_ontvset_bow" } } );
    ObjSet( "spr_ontvset_bow", { input = 1 } );
    
  elseif ( ho_stage == 12 ) then
    
    game.ontvset.double_hint = { { "spr_ontvset_mitten",  "spr_ontvset_mitten_task_img_2" } };

    interface.TaskPanelTaskAdd( ho_tasks, "mitten", 1, 0, { { "spr_ontvset_mitten" } } );
    ObjSet( "spr_ontvset_mitten", { input = 1 } );
    
  end;

  return ho_tasks;

end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
function public.stage_1()
end;
------------------------------------------------------------------------------
function public.stage_2()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_3()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_4()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_5()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_6()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_7()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_8()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_9()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_10()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_11()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
function public.stage_12()
  local ho_tasks = private.stages_task();
  interface_impl.TaskPanelSetNewTask( ho_tasks );
end;
------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.CreateNewObjects()

  local ho_obj = private.start;
  local ho_sh  = private.start_sh;
  local ho_itm = private.start_items;

  for i = 1, #ho_obj, 1 do

    if not ObjGet( ho_obj[i].name ) then
      
      local typ = common.GetObjectPrefix( ho_obj[i].name );
      
      ObjCreate( ho_obj[i].name, typ );
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    else 
      
      ObjSet( ho_obj[i].name, ho_obj[i].prop );
      ObjAttach( ho_obj[i].name, ho_obj[i].parent );

    end;

  end;

  for i = 1, #ho_sh, 1 do

    if not ObjGet( ho_sh[i].name ) then

      ObjCreate( ho_sh[i].name, "spr" );
      ObjSet( ho_sh[i].name, ho_sh[i].prop );
      ObjAttach( ho_sh[i].name, ho_sh[i].parent );

    end;

  end;
  
  for i = 1, #ho_itm, 1 do

    if not ObjGet( ho_itm[i].name ) then

      ObjCreate( ho_itm[i].name, "spr" );
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );
      
    else 
      
      ObjSet( ho_itm[i].name, ho_itm[i].prop );
      ObjAttach( ho_itm[i].name, ho_itm[i].parent );

    end;

  end;
  
end;
--*********************************************************************************************************************