-- name=mg_memories
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_memories";
  --------------------------------------------------------------------------------------------
  private.right_choice = { 1, 3, 3, 2, 1, 2, 1 };
  
  private.anims = {
    {"func_page_1_use_capsule", "", ""}, {"", "", "func_page_2_use_aion"}, 
    {"", "", "func_page_3_use_wheel"}, {"", "func_page_4_use_door", ""},
    {"func_page_5_use_lamp", "", ""}, {"", "func_page_6_use_rope", ""}, {"func_page_7_use_heart", "", ""}
  };
  
  private.game_start = false;
  private.cur_progress = "ext";
  
  private.choce_sound = {
    "capsule", "scarecrow", "open_castle", "door", "light", "rope", "chest"
  };
  private.stage_sound = {
    "first_appear", "scarecrow_appear", "castle_appear", "door_appear", "light_appear", "rope_appear", "chest_appear"
  };
  private.choice_anims = {
    {"capsule", "flower", "car"}, {"bucket", "hammer", "aion"},
    {"bird", "saw", "wheel"}, {"umbrella", "door", "glasses"},
    {"lamp", "star", "match"}, {"spyglass", "rope", "stairs"},
    {"heart", "book", "bow"}
  };
  
  private.choice_sound = {
    {"capsule", "flower", "machine"}, {"bucket", "hammer", "scarecrow"},
    {"bird", "saw", "open_castle"}, {"umbrella", "door", "glasses"},
    {"light", "star", "match"}, {"tube", "rope", "stair"},
    {"chest", "book", "bow"}
  };
  
  private.leave_naya = {
    {1, 1, 0}, {0, 0, 1}, {1, 0, 1}, {1, 1, 0}, {1, 1, 1}, {0, 1, 1}, {1, 1, 0}
  };
  
  private.skip_inprogress = false;
  --------------------------------------------------------------------------------------------
  -- function win_memories () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_memories" ] = {
    type = "win",
    room = "rm_nayasroom",
    zz = "mg_memories",
    zz_gate = "gmg_nayasroom_memories"
  };
  --------------------------------------------------------------------------------------------
  local win_memories_lvl = function ()
    level4.in_progress = false;
  end;
  local win_memories = function ()

    if cmn.IsEventDone( "win_memories" ) then
      
    end;

  end;
  local win_memories_loc = function ()

    if cmn.IsEventDone( "win_memories" ) then
      ObjDelete("gmg_nayasroom_memories");
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_memories", win_memories, "mg_memories" );
  cmn.AddSubscriber( "win_memories", win_memories_lvl );
  cmn.AddSubscriber( "win_memories", win_memories_loc, "rm_nayasroom" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  if not cmn.IsEventDone("win_memories") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_mg_memories_loop_mus", 1);
  end;
  
  if ng_global.currentprogress == "ext" and cmn.IsEventDone("win_memories") then
    
    local func_after = function()
      ObjSet("mg_memories",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.GotoRoom( "rm_credits", 0, true );
    end;
    
    cmn.Lock( 0 );
    cmn.StopAllEnv();

    cmn.PlayFullscreenVideo( "assets/levels/level4/mg_memories/vid_lvl4outro",
                             func_after,
                             "assets/levels/level4/audio/mus/aud_vid_lvl4outro_mus",
                             "assets/levels/level4/audio/voc/aud_4_lvl_victor_2_voc" );
    
  end;

  if ng_global.currentprogress == "ext" and not(cmn.IsEventDone( "win_memories" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_memories");
  elseif ng_global.currentprogress == "secret" then
    rm_extra.MiniGameShow();
    private.CheckWin();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_nayaroom_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_nayaroom_env");

  if ng_global.currentprogress == "ext" then
    private.cur_progress = "ext";
    common.SetPreviousRoom( "rm_nayasroom" );
  else 
    
    private.cur_progress = "secret";
    
    ObjSet("mg_memories",  { input = 1 });
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state;
    
    private.ResetActions();
    private.ResetNaya();
    
    ObjSet("grm_memories_nayasroom",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                        event_menter = function () rm_extra.GateMouseEnter( "memories_nayasroom", CURSOR_DOWN, "extra" ); end, 
                                        event_mleave = function () common_impl.GateMouseLeave( "memories_nayasroom" ); end });
    
  end;
  
  private.DrawScene();
  
  if ng_global.currentprogress == "ext" and cmn.IsEventDone("win_memories") then
    
    cmn.Lock(1);
    ObjSet("mg_memories",  { color_r = 0, color_g = 0, color_b = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );
    interface.WidgetSetInput( InterfaceWidget_ButtonDiary,   false );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_ButtonDiary,   false, false );

    ng_global.progress[ "ext" ].common.gamewin = true;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  if private.cur_progress == "secret" then
    
    private.ResetChoice( ng_global.progress[ "secret" ][ "win_memories" ].state[1] );
    
    if ng_global.progress[ "secret" ][ "win_memories" ].state[1] < 8 then
      ObjDetach("obj_memories_page_"..ng_global.progress[ "secret" ][ "win_memories" ].state[1]);
    else 
      ObjDetach("obj_memories_page_7");
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "ext" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "ext" and not(cmn.IsEventDone( "win_memories" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_memories" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  if private.state[1] > 1 then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mg_memories_reset");
    
    local page = private.state[1];
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state;
    
    local func_after = function ()
      
      ObjDetach("obj_memories_page_"..page);
      private.ResetChoice( page );
      private.ResetNaya();
      private.ResetActions();
      private.BeginStage( 1 );
      
    end;
    
    ObjAnimate("obj_memories_page_"..page, "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("anm_memories_page_choice", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("anm_memories_page_naya", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  if not private.skip_inprogress then
    
    private.skip_inprogress = true;
  
    cmn.Lock(1);
    
    local page = private.state[1];
    
    ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].skip = 1;
    ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state = { 8, 0, 0 };
    
    local func_after = function ()
      private.state = ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state;
      private.CheckWin();
    end;
    
    public.MakeChoice( private.right_choice[ page ], func_after );
    
  end;

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].state = { 1, 0, 0 }; --[1] - stage, [2] - started, [3] - choice

end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  if private.state[2] > 0 and private.state[1] <= 7 then
    
    ObjSet("anm_memories_page_7_box_1",  { alp = 1 });
    
    ObjAttach("obj_memories_page_"..private.state[1], "mg_memories");
    ObjSet("anm_memories_page_naya", { animfunc = "func_page_"..private.state[1].."_naya_come", frame = 300, alp = 1 });
    
  elseif private.state[1] > 7 then
    
    ObjAttach("obj_memories_page_7", "mg_memories");
    ObjMultiSet( { {"anm_memories_page_7_use", { alp = 0 }},
                   {"anm_memories_page_7_box_close", { alp = 1, frame = 300 }} } );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.FocusChoice( num, inout )

  local obj = "obj_memories_page_choice_"..num;
  local scale = ObjGet( obj ).scale_x;
  local tme = 0;
  local max_scale = 1.1;  
  local max_tme = 0.3;
  local end_scale = 1;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );
  else 
    SetCursor(CURSOR_HAND);
    end_scale = max_scale;
    tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/");
    end;
  end;

  ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale });
  
end;
-----------------------------------------------------------------------------------
function public.MakeChoice( num, func )

  func = func or false;
  
  cmn.Lock(1);
  
  --private.state[3] = num;
  local stage = private.state[1];
  
  --if num == private.right_choice[ private.state[1] ] then
    
    --cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mg_memories_click_right");
    
    local func_after = function ()
      
      private.ResetChoice( stage );
      private.AnimChoice( stage, num, func );
      
    end;
    
    if num == private.right_choice[ private.state[1] ] then
      private.state[1] = private.state[1] + 1;
      private.state[2] = 0;
      --private.state[3] = 0;
    end;
    
    ObjAnimate("anm_memories_page_choice", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
    
  --else 
  --  
  --  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mg_memories_click_wrong");
  --  
  --  local func_after = function ()
  --    ObjAnimate("anm_memories_choice_wrong", "alp", 0, 0, function() cmn.Lock(0); ObjAttach("anm_memories_choice_wrong", "obj_memories_choices"); end, { 0, 0, 1,   0.3, 0, 0 });
  --  end;
  --  
  --  local anm_2 = function ()
  --    ObjSet("anm_memories_choice_wrong",  { alp = 1, playing = 1, endtrig = func_after });
  --  end;
  --  
  --  ObjAttach("anm_memories_choice_wrong", "obj_memories_page_choice_"..num);
  --  ObjAnimate("anm_memories_choice_wrong", "alp", 0, 0, anm_2, { 0, 0, 0,   0.2, 0, 1 });
  --  
  --end;
  
end;
-----------------------------------------------------------------------------------
function private.AnimChoice( stage, num, func )
  
  func = func or false;
  
  local anm_end = function ()
    
    if private.state[1] <= 7 then
      
      local func_end = function ()
        private.ResetNaya();
        ObjDetach("obj_memories_page_"..stage);
        if func then
          func();
        else 
          private.CheckWin();
        end;
      end;
    
      ObjAnimate("obj_memories_page_"..stage, "alp", 0, 0, func_end, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("anm_memories_page_naya", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    else 
      
      if func then
        func();
      else 
        private.CheckWin();
      end;
      
    end;
    
  end;
  
  local func_after = function ()
    
    if num == private.right_choice[ stage ] then
    
      if stage == 1 or stage == 4 or stage == 6 then
        
        ObjSet("anm_memories_page_naya", { frame = 0, animfunc = "func_page_"..stage.."_naya_out", playing = 1, endtrig = anm_end });
        
        if stage ~= 4 then
          ObjSet("anm_memories_page_"..stage.."_use", { alp = 0, frame = 0 });
        else 
          ObjAnimate("anm_memories_page_4_use", "alp", 0, 0, "", { 0, 0, 1,   1.3667, 0, 1,   1.65, 0, 0 });
        end;
                       
      else
              
        private.AnimActions( stage, anm_end );
                       
      end;
      
    else
      ObjMultiSet( { {"anm_memories_page_"..stage.."_use",  { alp = 0, endtrig = "" }},
                     {"anm_memories_page_naya", { alp = 1 }} } );
      private.ActivateChoice( stage );
    end;
    
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mg_memories_"..private.choice_sound[ stage ][ num ]);
  
  if num == private.right_choice[ stage ] then
    --cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mg_memories_"..private.choce_sound[ stage ]);
    ObjSet("anm_memories_page_"..stage.."_use",  { alp = 1, frame = 0, animfunc = "func_page_"..stage.."_use_"..private.choice_anims[stage][num], playing = 1, endtrig = func_after });
    if stage == 7 then
      ObjSet("anm_memories_page_7_box_1",  { alp = 0 });
    end;
  else 
    ObjMultiSet( { {"anm_memories_page_"..stage.."_use",  { alp = 1, frame = 0, animfunc = "func_page_"..stage.."_use_"..private.choice_anims[stage][num], playing = 1, endtrig = func_after }},
                   {"anm_memories_page_naya", { alp = private.leave_naya[stage][num] }} } );
  end;
  
  
end;
-----------------------------------------------------------------------------------
function private.AnimActions( stage, func )
  
  local func_after = function ()
      
    ObjMultiSet( { {"anm_memories_page_"..stage.."_use", { alp = 0, frame = 0 }},
                   {"anm_memories_page_naya", { frame = 0, animfunc = "func_page_"..stage.."_naya_out", playing = 1, endtrig = func }} } );
    
  end;
  
  if stage == 2 then
    
    ObjAnimate("anm_memories_page_2_trees", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
    ObjMultiSet( { {"anm_memories_page_2_explode_1", { playing = 1, endtrig = func_after }},
                   {"anm_memories_page_2_explode_2", { playing = 1 }} } );
    
  elseif stage == 3 then
                   
    local func_3 = function ()
      ObjSet("anm_memories_page_naya", { frame = 0, animfunc = "func_page_"..stage.."_naya_out", playing = 1, endtrig = func });
    end;
    
    ObjSet("anm_memories_page_3_door",  { playing = 1, endtrig = func_3 });
    
  elseif stage == 5 then
    
    local func_5 = function ()
      ObjSet("anm_memories_page_naya", { frame = 0, animfunc = "func_page_"..stage.."_naya_out", playing = 1, endtrig = func });
    end;
    
    local anm_5 = function ()
      ObjAnimate("anm_memories_page_5_use", "alp", 0, 0, func_5, { 0, 0, 1,   0.3, 0, 0 });
    end;
    
    ObjAnimate("anm_memories_page_5_monsters", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
    ObjMultiSet( { {"anm_memories_page_5_explode_1", { playing = 1, endtrig = anm_5 }},
                   {"anm_memories_page_5_explode_2", { playing = 1 }} } );
    
  elseif stage == 7 then
                   
    local func_2 = function ()
      
      ObjMultiSet( { {"anm_memories_page_7_use", { alp = 0 }},
                     {"anm_memories_page_7_box_close", { alp = 1, playing = 1, endtrig = func }} } );
      
    end;
                   
    ObjSet("anm_memories_page_naya", { frame = 0, animfunc = "func_page_"..stage.."_naya_out", playing = 1, endtrig = func_2 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.BeginStage( stage )
  
  private.state[2] = 1;
  
  local anm_choice = function ()
    
    private.ActivateChoice( stage );
    
  end;
  
  local anm_naya = function ()
    
    ObjAttach("obj_memories_page_"..stage, "mg_memories");
    
    ObjMultiSet( { {"anm_memories_page_naya", { frame = 0, animfunc = "func_page_"..stage.."_naya_come", alp = 1, playing = 1, endtrig = anm_choice }},
                   {"anm_memories_page_start", { alp = 0, frame = 0 }} } );
    
  end;
                 
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mg_memories_"..private.stage_sound[ stage ]);
  
  ObjSet("anm_memories_page_start",  { frame = 0, animfunc = "func_page_"..stage.."_start", alp = 1, playing = 1, endtrig = anm_naya });
  
end;
-----------------------------------------------------------------------------------
function private.ActivateChoice( stage )
  
  local func_after = function ()
    
    cmn.Lock(0);
    ObjSet("anm_memories_page_choice",  { input = 1 });
    
  end;
  
  for i = 1, 3, 1 do
    ObjAttach("spr_memories_choice_"..stage.."_"..i, "obj_memories_page_choice_"..i);
  end;
  
  ObjAnimate("anm_memories_page_choice", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function private.ResetActions()
  
  for i = 1, 7, 1 do
    
    ObjMultiSet( { {"obj_memories_page_"..i,  { alp = 1 }},
                   {"anm_memories_page_"..i.."_use", { alp = 0, frame = 0 }} } );
    
  end;
  
  ObjMultiSet( { {"anm_memories_page_2_trees", { alp = 1 }},
                 {"anm_memories_page_3_door", { alp = 1, frame = 0 }},
                 {"anm_memories_page_5_monsters", { alp = 1 }},
                 {"anm_memories_page_7_use", { alp = 1 }},
                 {"anm_memories_page_7_box_close", { alp = 0, frame = 0 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.ResetNaya()
  
  ObjSet("anm_memories_page_naya",  { alp = 0, playing = 0, endtrig = "", frame = 0 });
  
end;
-----------------------------------------------------------------------------------
function private.ResetChoice( stage )
  
  for i = 1, 3, 1 do
    ObjAttach("spr_memories_choice_"..stage.."_"..i, "obj_memories_choices");
  end;
  
  ObjSet("anm_memories_page_choice",  { alp = 0, input = 0 });
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  if private.state[1] > 7 then
      
    private.Win();
  
  elseif private.state[3] > 0 then
    
    if private.state[3] == private.right_choice[ private.state[1] ] then
      
      cmn.Lock(1);
      
      private.state[3] = 0;
      
      if private.state[1] < 7 then
        private.BeginStage( private.state[1] );
      else 
        
        private.Win();
        
      end;
      
    end;
    
  elseif private.state[2] == 0 then
    
    cmn.Lock(1);
    private.BeginStage( private.state[1] );
    
  elseif not private.game_start then
    
    cmn.Lock(1);
    private.ActivateChoice( private.state[1] );
    
  end;
  
  private.game_start = true;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()
  
  cmn.Lock( 0 );

  if ng_global.currentprogress == "ext" then
  
    cmn.CallEventHandler( "win_memories" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_memories" ].skip == 0 and not ng_global.noskipgames[ "win_memories" ] then

      ng_global.noskipgames[ "win_memories" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_memories" ] then
      ng_global.playedgames[ "win_memories" ] = 1;
    end;

    --common_impl.PauseAchiev( 0 );
    private.PlayOutro();
    
  else 
    
    ObjSet("mg_memories",  { input = 0 });
    
    interface_impl.ShowStarsWindow();
    
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  if ng_global.currentprogress == "ext" then

    cmn.MiniGameHide();

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_memories" );
    
  else 
    
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
    
  end;
  
  cmn.SetEventDone( "win_memories" );

  ObjSet("tmr_memories_timer",  { time = 1, playing = 1, endtrig = private.WinEnd });

end;
-----------------------------------------------------------------------------------
function private.PlayOutro()
  
  local func_after = function ()
    
    common_impl.PauseAchiev( 0 );
    
    ObjSet("mg_memories",  { color_r = 0, color_g = 0, color_b = 0 });
    
    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );
    interface.WidgetSetInput( InterfaceWidget_ButtonDiary,   false );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, false );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, false );
    interface.WidgetSetVisible( InterfaceWidget_ButtonDiary,   false, false );

    ng_global.progress[ "ext" ].common.gamewin = true;
    cmn.GotoRoom( "rm_credits", 0, true );
    
  end;
  
  cmn.Lock( 0 );
  cmn.StopAllEnv();

  cmn.PlayFullscreenVideo( "assets/levels/level4/mg_memories/vid_lvl4outro",
                           func_after,
                           "assets/levels/level4/audio/mus/aud_vid_lvl4outro_mus",
                           "assets/levels/level4/audio/voc/aud_4_lvl_victor_2_voc" );
  
end;
--*******************************************************************************************************************