-- name=mg_nightmare
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_nightmare";
  --------------------------------------------------------------------------------------------
  private.is_on_symbol = false;

  private.light = {
    { false,false,false,false,false,false,false,false,false,false,
      false,false,false,false,false,false,false,false,false,false,
      false,false,false,false,false,false,false,false,false,false,
      false,false,false,false,false,false,false,false,false,false
    },
    { false,false,false,false,false,false,false,false,false,false,
      false,false,false,false,false,false,false,false,false,false,
      false,false,false,false,false,false,false,false,false,false
    },
    { false,false,false,false,false,false,false,false,false,false,
      false,false,false,false,false,false,false,false,false,false,
      false,false,false,false,false,false,false,false,false,false,
      false,false
    }
  };

  private.umbrella_anim_tme = { 1.1167, 0.98 };
  --------------------------------------------------------------------------------------------
  -- function win_nightmare () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_nightmare" ] = {
    type = "win",
    room = "rm_attic",
    zz = "mg_nightmare",
    zz_gate = "gmg_attic_nightmare"
  };
  --------------------------------------------------------------------------------------------
  local win_nightmare_map = function ()

    if cmn.IsEventDone( "win_nightmare" ) then
      interface_impl.SetCurrentGlobalTask( 25 );
      int_map_impl.OpenRoom( "rm_nearchapel" );
      int_map_impl.OpenRoom( "rm_oldcemetery" );
      int_map_impl.OpenRoom( "rm_oldchapel" );
      int_map_impl.OpenRoom( "rm_forest" );
      int_map_impl.OpenRoom( "rm_nearhouse" );
      int_map_impl.OpenRoom( "rm_inhouse" );
      int_map_impl.OpenRoom( "rm_nayasroom" );
      int_map_impl.OpenRoom( "rm_cellar" );
    end;

  end;
  local win_nightmare = function ()

    if cmn.IsEventDone( "win_nightmare" ) then

    end;

  end;
  local win_nightmare_loc = function ()

    if cmn.IsEventDone( "win_nightmare" ) then
      ObjDelete("anm_attic_use_sword");
      ObjDelete("obj_attic_monster");
      ObjMultiSet( {
        { "gzz_attic_boxes", { alp = 1, input = true, active = true } },
        { "gzz_attic_shelf", { alp = 1, input = true, active = true } },
        { "gzz_attic_dollhouse", { alp = 1, input = true, active = true } },
        { "gzz_attic_lvl4window", { alp = 1, input = true, active = true } },
        { "spr_attic_letter9", { input = 1, pos_z = 92 } }
      } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_nightmare", win_nightmare, "mg_nightmare" );
  cmn.AddSubscriber( "win_nightmare", win_nightmare_loc, "rm_attic" );
  cmn.AddSubscriber( "win_nightmare", win_nightmare_map );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_nightmare" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_nightmare" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/level4/audio/mus/aud_mg_nightmare_mus", 1);

  if ng_global.currentprogress == "ext" and not(cmn.IsEventDone( "win_nightmare" )) then
    cmn.MiniGameShow();
    cmn.StartTimePassing("mg_nightmare");
  elseif ng_global.currentprogress == "secret" then
    rm_extra.MiniGameShow();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_attic_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_attic_env");

  if ng_global.currentprogress == "ext" then
    common.SetPreviousRoom( "rm_attic" );
  else 

    for i = 1, private.state.stage - 1, 1 do
      for j = 1, #private.light[i], 1 do
        ObjMultiSet( {
          { "obj_nightmare_way_"..i.."_"..j, { input = true } },
          { "spr_nightmare_light_"..i.."_"..j, { alp = 0 } }
        } );
      end;
    end;

    if private.state.stage == 4 then
      ObjMultiSet( {
        { "anm_nightmare_right_hand", { alp = 1, frame = 0, playing = true } },
        { "anm_nightmare_head", { alp = 1, frame = 0, playing = true } },
        { "anm_nightmare_body", { alp = 1, frame = 0, playing = true } },
        { "anm_nightmare_man_out", { alp = 0, frame = 0, playing = false } },
        { "anm_nightmare_umbrella_1", { alp = 1 } },
        { "anm_nightmare_umbrella_2", { alp = 1 } },
        { "spr_nightmare_umbrella_stick", { alp = 1 } }
      } );
    end;

    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_nightmare" ].state;
    
    private.is_on_symbol = false;

    private.light = {
      { false,false,false,false,false,false,false,false,false,false,
        false,false,false,false,false,false,false,false,false,false,
        false,false,false,false,false,false,false,false,false,false,
        false,false,false,false,false,false,false,false,false,false
      },
      { false,false,false,false,false,false,false,false,false,false,
        false,false,false,false,false,false,false,false,false,false,
        false,false,false,false,false,false,false,false,false,false
      },
      { false,false,false,false,false,false,false,false,false,false,
        false,false,false,false,false,false,false,false,false,false,
        false,false,false,false,false,false,false,false,false,false,
        false,false
      }
    };
      
    ObjSet("grm_nightmare_back",  { input = 1 });
    
  end;
  
  private.DrawScene();
  
  iOS_NeedDrag(0);
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  iOS_NeedDrag(1);
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "ext" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "ext" and not(cmn.IsEventDone( "win_nightmare" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_nightmare" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()

  if private.state.stage == 1 then
    return;
  end;

  --DbgTrace( "***Reset" );

  cmn.Lock( 1 );

  local func_after = function ()
    ObjAnimate( "spr_nightmare_symbol_1", "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 0,    0.3, 0, 1 } );
  end;

  ObjMultiSet( {
    { "spr_nightmare_umbrella_hit_miss_part_1", { alp = 1 } },
    { "spr_nightmare_umbrella_hit_miss_part_2", { alp = 1 } },
    { "spr_nightmare_symbol_1", { input = true } },
    { "spr_nightmare_symbol_"..private.state.stage, { input = false } }
  } );

  for i = 1, #private.light[1], 1 do
    private.light[1][i] = false;
    ObjMultiSet( {
      { "obj_nightmare_way_1_"..i, { input = true } },
      { "spr_nightmare_light_1_"..i, { alp = 0 } }
    } );
  end;

  ObjAnimate( "spr_nightmare_symbol_"..private.state.stage, "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

  if private.state.stage == 3 then
    for i = 1, #private.light[2], 1 do
      private.light[2][i] = false;
      ObjMultiSet( {
        { "obj_nightmare_way_2_"..i, { input = true } },
        { "spr_nightmare_light_2_"..i, { alp = 0 } }
      } );
    end;
    ObjAnimate( "spr_nightmare_umbrella_part_2", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
  end;

  private.state.stage = 1;

  ObjAnimate( "spr_nightmare_umbrella_part_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

end;
--*********************************************************************************************************************
function public.Skip()

  --DbgTrace( "***Skip" );

  cmn.Lock( 1 );

  ng_global.progress[ ng_global.currentprogress ][ "win_nightmare" ].skip = 1;

  local func_after = function ()
    ObjSet( "anm_nightmare_man_out", { endtrig = private.WinEnd, playing = true } );
  end;

  ObjSet( "spr_nightmare_symbol_"..private.state.stage, { input = false } );
  ObjAnimate( "spr_nightmare_symbol_"..private.state.stage, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );

  ObjAnimate( "anm_nightmare_umbrella_1", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
  ObjAnimate( "anm_nightmare_umbrella_2", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
  ObjAnimate( "spr_nightmare_umbrella_stick", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );

  ObjMultiSet( {
    { "anm_nightmare_sword", { alp = 0, playing = false } },
    { "anm_nightmare_sword_hit", { animfunc = "func_sword_hit_3", alp = 1, frame = 0, playing = true, endtrig =
      function ()
        ObjMultiSet( {
          { "anm_nightmare_sword", { alp = 1, frame = 0, playing = true } },
          { "anm_nightmare_sword_hit", { alp = 0 } }
        } );
      end
    } },
    {"anm_nightmare_umbrella_hit",{animfunc = "func_umbrella_hit_3", endtrig = func_after, alp = 1, frame = 0, playing = true}}
  } );

  private.state.stage = 4;

  private.Win();

  ObjSet( "tmr_nightmare_anim", { time = 2, playing = true,
    endtrig = function ()
      --DbgTrace( "поменяли чувака" );
      ObjMultiSet( {
        { "anm_nightmare_right_hand", { alp = 0, playing = false } },
        { "anm_nightmare_head", { alp = 0, playing = false } },
        { "anm_nightmare_body", { alp = 0, playing = false } },
        { "anm_nightmare_man_out", { alp = 1 } }
      } );
    end
  } );

  cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_nightmare_hit_last" );

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_nightmare" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_nightmare" ].state = {
    stage = 1
  };

end;
-----------------------------------------------------------------------------------
function private.DrawScene()

  --DbgTrace( "***DrawScene" );

  if private.state.stage == 4 then  --форс квит при аним выйгриша
    private.state.stage = 3;
    cmn.Lock( 1 );
    ObjSet( "tmr_nightmare_anim", { time = 0.5, endtrig = function () private.CheckWin( true ); end, playing = true } );
  end;

  for i = 1, 3, 1 do
    if i == private.state.stage then
      ObjSet( "spr_nightmare_symbol_"..i, { alp = 1, input = true } );
    else
      ObjSet( "spr_nightmare_symbol_"..i, { alp = 0, input = false } );
    end;
  end;

  if private.state.stage >= 2 then
    ObjMultiSet( {
      { "spr_nightmare_umbrella_hit_miss_part_1", { alp = 0 } },
      { "spr_nightmare_umbrella_part_1", { alp = 0 } }
    } );
    if private.state.stage >= 3 then
      ObjMultiSet( {
        { "spr_nightmare_umbrella_hit_miss_part_2", { alp = 0 } },
        { "spr_nightmare_umbrella_part_2", { alp = 0 } }
      } );
    else
      ObjMultiSet( {
        { "spr_nightmare_umbrella_hit_miss_part_2", { alp = 1 } },
        { "spr_nightmare_umbrella_part_2", { alp = 1 } }
      } );
    end;
  else
    ObjMultiSet( {
      { "spr_nightmare_umbrella_hit_miss_part_2", { alp = 1 } },
      { "spr_nightmare_umbrella_part_2", { alp = 1 } },
      { "spr_nightmare_umbrella_hit_miss_part_1", { alp = 1 } },
      { "spr_nightmare_umbrella_part_1", { alp = 1 } }
    } );
  end;

end;
-----------------------------------------------------------------------------------
function private.CheckWin( is_win )

  --DbgTrace( "***CheckWin" );
  local all_light = #private.light[private.state.stage];
  local light_on = 0;
  if not is_win then
    --for i = 1, #private.light[private.state.stage], 1 do
    --  if not private.light[private.state.stage][i] then
    --    return;
    --  end;
    --end;
    for i = 1, #private.light[private.state.stage], 1 do
      if private.light[private.state.stage][i] then
        light_on = light_on + 1;
      end;
    end;
    if (light_on<all_light-all_light*0.075) then
      return;
    end;
  end;

  cmn.Lock( 1 );

  local old_stage = private.state.stage;

  private.state.stage = private.state.stage + 1;
  --DbgTrace( "stage = "..private.state.stage );

  local man_anim = function ()

    local func_after = function ()
      if private.state.stage < 4 then
        --DbgTrace( "***func_after" );
        ObjMultiSet( {
          { "spr_nightmare_umbrella_hit_miss_part_"..old_stage, { alp = 0 } },
          { "anm_nightmare_umbrella_hit", { alp = 0 } },
          { "spr_nightmare_symbol_"..private.state.stage, { input = true } }
        } );
        ObjAnimate( "spr_nightmare_symbol_"..private.state.stage, "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 0,    0.3, 0, 1 } );
      else
        --DbgTrace( "***func_after2" );
        ObjSet( "anm_nightmare_man_out", { endtrig = private.WinEnd, playing = true } );
      end;
    end;

    ObjAnimate( "anm_nightmare_umbrella_1", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
    ObjAnimate( "anm_nightmare_umbrella_2", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
    ObjAnimate( "spr_nightmare_umbrella_stick", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );

    ObjMultiSet( {
      { "anm_nightmare_sword", { alp = 0, playing = false } },
      { "anm_nightmare_sword_hit", { animfunc = "func_sword_hit_"..old_stage, alp = 1, frame = 0, playing = true, endtrig =
        function ()
          ObjMultiSet( {
            { "anm_nightmare_sword", { alp = 1, frame = 0, playing = true } },
            { "anm_nightmare_sword_hit", { alp = 0 } }
          } );
        end
      } },
      {"anm_nightmare_umbrella_hit",{animfunc = "func_umbrella_hit_"..old_stage, endtrig = func_after, alp = 1, frame = 0, playing = true}}
    } );

    if private.state.stage == 4 then

      --DbgTrace( "WWWWWWIIIIIIIINNNNNNNNNN" );

      private.Win();

      ObjSet( "tmr_nightmare_anim", { time = 2, playing = true,
        endtrig = function ()
          --DbgTrace( "поменяли чувака" );
          ObjMultiSet( {
            { "anm_nightmare_right_hand", { alp = 0, playing = false } },
            { "anm_nightmare_head", { alp = 0, playing = false } },
            { "anm_nightmare_body", { alp = 0, playing = false } },
            { "anm_nightmare_man_out", { alp = 1 } }
          } );
        end
      } );

      cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_nightmare_hit_last" );

    else

      ObjSet( "tmr_nightmare_anim", { time = private.umbrella_anim_tme[old_stage], playing = true,
        endtrig = function ()
          --DbgTrace( "umbrella показалась" );
          ObjSet( "spr_nightmare_umbrella_part_"..old_stage, { alp = 0 } );
          ObjAnimate( "anm_nightmare_umbrella_1", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
          ObjAnimate( "anm_nightmare_umbrella_2", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
          ObjAnimate( "spr_nightmare_umbrella_stick", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
        end
      } );

      cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_nightmare_hit" );

    end;

  end;

  ObjMultiSet( {
    { "spr_nightmare_symbol_"..old_stage, { input = false } },
    { "anm_nightmare_win_stage_"..old_stage, {
      frame = 0,
      playing = true,
      endtrig = function ()
        ObjAnimate( "spr_nightmare_symbol_"..old_stage, "alp", 0, 0, man_anim, { 0, 0, 1,    0.3, 0, 0 } );--0.5, 0, 0
      end
    } }
  } );

  private.is_on_symbol = false;
  ObjStopDrag();

  cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_nightmare_right" );

end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.Lock( 0 );

  cmn.SetEventDone( "win_nightmare" );
  
  if ng_global.currentprogress == "ext" then
  
    cmn.CallEventHandler( "win_nightmare" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_nightmare" ].skip == 0 and not ng_global.noskipgames[ "win_nightmare" ] then
      ng_global.noskipgames[ "win_nightmare" ] = 1;
      common_impl.CheckAchiev("mg");
    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_nightmare" ] then
      ng_global.playedgames[ "win_nightmare" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );

    cmn.GotoRoom("rm_attic");
    int_diary.AddDiarypage( 28 );
    interface_impl.ShowGlobalTask();
    
  else 
    
    ObjSet("grm_nightmare_back",  { input = 0 });
    
    interface_impl.ShowStarsWindow();
    
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  if ng_global.currentprogress == "ext" then

    cmn.MiniGameHide();

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_nightmare" );
    
  else 
    
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
    
  end;

end;
--*********************************************************************************************************************
function public.PointMEnterDrag( num )

  if not private.is_on_symbol or private.light[private.state.stage][num] then
    return;
  end;

  --DbgTrace( "***PointMEnterDrag "..private.state.stage.." "..num );

  private.light[private.state.stage][num] = true;

  ObjSet( "obj_nightmare_way_"..private.state.stage.."_"..num, { input = false } );

  ObjAnimate( "spr_nightmare_light_"..private.state.stage.."_"..num, "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );

  private.CheckWin();

  cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_nightmare_arrow_"..math.random( 1, 5 ) );

end;
--*********************************************************************************************************************
function public.PointMDown( num )

  --DbgTrace( "***PointMDown" );

  public.SymbolMDown();

  public.PointMEnterDrag( num );

end;
--*********************************************************************************************************************
function public.SymbolMDown()

  --DbgTrace( "***SymbolMDown" );

  private.is_on_symbol = true;

  ObjStartDrag( "obj_nightmare_drag" );

end;
--*********************************************************************************************************************
--function public.SymbolMLeaveDrag()
--
--  if not private.is_on_symbol then
--    return;
--  end;
--
--  for i = 1, #private.light[private.state.stage], 1 do
--    if not private.light[private.state.stage][i]
--    --and ApplyObj( "obj_nightmare_drag", "obj_nightmare_way_"..private.state.stage.."_"..i )
--    and ApplyObj( "obj_nightmare_drag", "obj_nightmare_way_"..private.state.stage.."_"..i ) then
--      return;
--    end;
--  end;
--
--  --DbgTrace( "***SymbolMLeaveDrag" );
--
--  ObjStopDrag();
--
--end;
--*********************************************************************************************************************
function public.DropDrag()

  if not private.is_on_symbol then
    return;
  end;

  --DbgTrace( "***DropDrag" );

  private.is_on_symbol = false;

  local go_reset = false;

  for i = 1, #private.light[private.state.stage], 1 do
    if private.light[private.state.stage][i] then
      go_reset = true;
      private.light[private.state.stage][i] = false;
      ObjSet( "obj_nightmare_way_"..private.state.stage.."_"..i, { input = true } );
      ObjAnimate( "spr_nightmare_light_"..private.state.stage.."_"..i, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
    end;
  end;

  if not go_reset then
    return;
  end;

  cmn.Lock( 1 );

  SetCursor( CURSOR_DEFAULT );

  local man_anim = function ()

    local func_after = function ()

      ObjMultiSet( {
        { "anm_nightmare_sword", { alp = 1, frame = 0, playing = true } },
        { "anm_nightmare_sword_hit_miss", { alp = 0 } },
        { "anm_nightmare_umbrella_hit_miss", { alp = 0 } }
      } );

      ObjAnimate( "spr_nightmare_symbol_"..private.state.stage, "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 0,    0.3, 0, 1 } );

    end;

    ObjAnimate( "anm_nightmare_umbrella_1", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
    ObjAnimate( "anm_nightmare_umbrella_2", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
    ObjAnimate( "spr_nightmare_umbrella_stick", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );

    ObjSet( "tmr_nightmare_anim", { time = 1.8, playing = true,--1.6833
      endtrig = function ()
        ObjAnimate( "anm_nightmare_umbrella_1", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
        ObjAnimate( "anm_nightmare_umbrella_2", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
        ObjAnimate( "spr_nightmare_umbrella_stick", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
      end
    } );

    ObjMultiSet( {
      { "anm_nightmare_sword", { alp = 0, playing = false } },
      { "anm_nightmare_sword_hit_miss", { alp = 1, frame = 0, playing = true } },
      { "anm_nightmare_umbrella_hit_miss", { alp = 1, frame = 0, endtrig = func_after, playing = true } }
    } );

  end;

  ObjAnimate( "spr_nightmare_symbol_"..private.state.stage, "alp", 0, 0, man_anim, { 0, 0, 1,    0.2, 0, 1,    0.5, 0, 0 } );

  cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_nightmare_wrong" );

end;
--*********************************************************************************************************************
function public.BackMEnterDrag()

  if not private.is_on_symbol then
    return;
  end;

  --DbgTrace( "***BackMEnterDrag" );

  SetCursor( CURSOR_DEFAULT );

  ObjStopDrag();

end;
--*********************************************************************************************************************