-- name=level4

function public.Start ( param )

  game.play_hint_aud = false;

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 10 );
  interface.WidgetAdd( InterfaceWidget_BtnGuide, 6 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 4  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 5 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 6 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 7 );

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 0 );

  interface.WidgetAdd( InterfaceWidget_TaskHeader, 1 );
  interface.WidgetAdd( InterfaceWidget_Inventory, 2 );
  --interface.WidgetAdd( InterfaceWidget_TaskPanel );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 3, "assets/interface/int_taskpanel");

  interface.WidgetAdd( InterfaceWidget_Effects, 50 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 4 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 260 );

  interface.ButtonLockAdd();

  interface.WidgetAdd( InterfaceWidget_ItemPanel, 3, "assets/interface/int_itempanel" );
  interface.WidgetAdd( InterfaceWidget_Popup, 250 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 300 );
  --interface.WidgetAdd( InterfaceWidget_DialogStory );
  --interface.WidgetAdd( InterfaceWidget_DialogCharacter, 900 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial, 310 );

  interface.WidgetAdd( InterfaceWidget_Map, 200 );

  interface.PanelNotificationAdd();
  interface.ComplexInvAdd();
  interface_impl.DialogHintAdd();
  
  interface_impl.GlobalTaskAdd();
  
  interface_impl.DiaryAdd();
  
  ------------------------------------------------------
  if IsCollectorsEdition() or IsSurveyEdition() then
  
    if IsCollectorsEdition() then
  
      ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
      rm_achievements.Init();
    
      ModLoad( "assets/levels/menu/rm_collectable/mod_collectable" );
      rm_collectable.Init();
      
      ModLoad( "assets/levels/menu/rm_secretroom/mod_secretroom" );
      rm_secretroom.Init();
      
      interface_impl.PopupAchievementAdd();
      
    end;

    interface_impl.AchievAdd();
    
    interface_impl.BonusAdd();
  
  end;
  ------------------------------------------------------
  if IsCollectorsEdition() then
  
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  
  end;
  ------------------------------------------------------
  
  --переменная для того, чтобы из титров не выкидывало в меню
  public.in_progress = true;
  --
  private.Init();
  --
  int_map_impl.CreateRooms( "level4" );

  ModLoad( "assets/levels/level4/mod_inventory4" );
  inventory4.Init();
  
  ModLoad( "assets/levels/menu/rm_endroom/mod_endroom" );
  rm_endroom.Init();
  
  ModLoad( "assets/levels/menu/rm_credits/mod_credits" );
  rm_credits.Init();

  common.LevelLoad( "level4", "ext", "rm_nearchapel", param );
  ng_global.progress[ "ext" ].common.gamestart = true;
  
  common_impl.AddAvailibleMusic( 3 );
  common_impl.AddAvailibleMusic( 4 );
  common_impl.AddAvailibleMusic( 8 );
  common_impl.PlayBackgroundMusic();
  
  common_impl.StartCountGameTime(2);

  common_impl.DialogCustomUpdate();
  interface_impl.RemoveFlowersTotal();
  cmn.RemoveCollectable();

  int_button_diary.DiaryCheckNewMessage();
  
  int_button_map_impl.MapSetActive();
  
  game.play_hint_aud = true;

  common_impl.is_in_map = 0;

end;
    
function private.Init ()

  game.room_names =
  {
     "rm_nearchapel"
    ,"rm_oldchapel"
    ,"rm_oldcemetery"
    ,"rm_forest"
    ,"rm_nearhouse"
    ,"rm_inhouse"
    ,"rm_cellar"
    ,"rm_nayasroom"
    ,"rm_attic"
    
    ,"ho_hiddenroom"
    ,"ho_intent"
    ,"ho_ontvset"
    ,"ho_inboxes"
    ,"ho_inmirror"
    
    ,"mg_ingamingmachine"
    ,"mg_nightmare"
    ,"mg_memories"
  };
  
  --имена диалогов с подбором предмета (для удаления gfx в кастом моде)
  game.dlg_witems_names =
  {
    "obj_nearchapel_dialog_jean",
    "obj_oldchapel_dialog_faceless",
    "obj_oldchapel_dialog_queen",
    "obj_forest_dialog_stephen",
    "obj_inhouse_dialog_victor1",
    "obj_nayasroom_dialog_victor2"
  };

-- 1 - открыта
-- 2 - таски выполнены
-- 3 - кол-во тасков
-- 4 блокирована
  game.map_rooms = {
      
    [ "rm_nearchapel" ]   =  { 0, 0, 2, 0, 1 },
    [ "rm_oldcemetery" ]  =  { 0, 0, 6, 0, 0 },
    [ "rm_oldchapel" ]    =  { 0, 0, 2, 0, 2 },
    [ "rm_forest" ]       =  { 0, 0, 3, 0, 3 },
    [ "rm_nearhouse" ]    =  { 0, 0, 2, 0, 1 },
    [ "rm_inhouse" ]      =  { 0, 0, 2, 0, 3 },
    [ "rm_nayasroom" ]    =  { 0, 0, 99, 0, 3 },
    [ "rm_attic" ]        =  { 0, 0, 5, 0, 2 },
    [ "rm_cellar" ]       =  { 0, 0, 2, 0, 2 }
    
  };
  
  --таблица с координатами открытия зз
  game.zz_end_pos = {
    
    [ "zz_fissure" ] = {400, 370},
    [ "zz_hellishoven" ] = {650, 350},
    [ "zz_brokenwall" ] = {580, 340},
    
    [ "zz_tree" ] = {340, 320},
    [ "zz_ruins" ] = {550, 330},
    [ "zz_tomb" ] = {660, 355},
    
    [ "zz_statue" ] = {350, 360},
    [ "zz_mirror" ] = {660, 360},
    [ "zz_basrelief" ] = {550, 340},
    
    [ "zz_stump" ] = {350, 350},
    [ "zz_burrow" ] = {640, 370},
    [ "zz_bonfire" ] = {540, 360},
    [ "zz_tent" ] = {640, 340},
    
    [ "zz_housedoor" ] = {500, 340},
    [ "zz_nearcellar" ] = {640, 340},
    [ "zz_doghouse" ] = {380, 360},
    [ "zz_flowerbed" ] = {580, 360},
    
    [ "zz_lvl4firtree" ] = {540, 350},
    [ "zz_hearth" ] = {360, 340},
    [ "zz_table" ] = {520, 360},
    [ "zz_tvset" ] = {360, 320},
    
    [ "zz_littlebox" ] = {600, 370},
    [ "zz_nayasbed" ] = {380, 350},
    [ "zz_highmirror" ] = {430, 320},
    [ "zz_piano" ] = {620, 340},
    
    [ "zz_boxes" ] = {560, 340},
    [ "zz_shelf" ] = {660, 340},
    [ "zz_lvl4window" ] = {380, 320},
    [ "zz_dollhouse" ] = {380, 360},
    
    [ "zz_electricbox" ] = {360, 320},
    [ "zz_gamingmachine" ] = {660, 330},
    [ "zz_nayasdesk" ] = {560, 330},
    [ "zz_chest" ] = {380, 370}
  
  };

  --таблицы для динамического хинта
  --таблица для юзов на предметы, получаемые в хо и мультиюзов
  game.progress_multyuse =
  {
    {"use_pincers", "win_hiddenroom"},
    {"use_littlefire", "win_intent"},
    {"use_amethyst", "win_inboxes"},
    {"use_statueface", "win_inmirror"},
    
    {"use_holvl4crystal", "use_lvl4pickaxewall"},
    {"use_holvl4candle", "use_lvl4pickaxewall"},
    {"use_holvl4cup", "use_lvl4pickaxewall"},
    {"use_holvl4feather", "use_lvl4pickaxewall"},
    {"use_holvl4amulet1", "use_lvl4pickaxewall"},
    {"use_holvl4amulet2", "use_lvl4pickaxewall"},
    {"use_holvl4amulet3", "use_lvl4pickaxewall"},
    {"use_holvl4amulet4", "use_lvl4pickaxewall"},
    
    {"use_holvl4opener", "use_zipper"},
    {"use_holvl4laces", "use_zipper"},
    {"use_holvl4matches", "use_zipper"},
    {"use_holvl4net", "use_zipper"},
    
    {"use_lvl4pickaxefissure", "get_lvl4pickaxe"},
    {"use_lvl4pickaxewall", "get_lvl4pickaxe"},
    
    {"use_potionstump", "get_potion"},
    {"use_potionflowerbed", "get_potion"},
    
    {"use_recipe1", "get_recipe"},
    {"use_recipe2", "get_recipe"},
    {"use_recipe3", "get_recipe"},
    {"use_recipe4", "get_recipe"}
  };

  --таблица на мультипредметы с количеством их частей
  game.progress_multyobj =
  {
    {"use_clothbutton", 2},
    {"use_letter", 9}
  };

  --таблица на юзы, разблокирующиеся другими юзами или кликами
  game.progress_blockeduse =
  {
    {"use_feather1", "use_floweramulets"},
    {"use_feather2", "use_floweramulets"},
    {"use_potionstump", "use_gloves"},
    {"use_recipe4", "use_gloves"},
    {"use_lvl4wire", "use_fixedflashlight"},
    {"use_crown", "use_shield"},
    {"use_potionflowerbed", "use_seeds"},
    {"use_letter", "use_chestkey"},
    {"use_polish", "use_letter"},
    {"get_broom", "win_nightmare"},
    {"get_letter9", "win_nightmare"},
    {"use_deer1", "win_nightmare"}
  };
  
  --исключения для параллельных действий (необязательная таблица)
  game.progress_exeptions =
  {
    {"win_inboxes", "use_lvl4knife"},
    {"get_notesheet", "use_spinner"},
    {"get_polish", "use_spinner"}
  };

  game.progress_names =
  {
     "beg_level4"
    ,"get_floweramulet1"
    ,"get_letter1"
    
    ,"opn_oldchapel"
    ,"get_letter4"
    ,"get_stick"
    ,"get_emerald"
    
    ,"opn_oldcemetery"
    ,"get_letter2"
    ,"use_stick"
    ,"get_lvl4pickaxe"
    ,"get_feather1"
    ,"use_lvl4pickaxefissure"
    ,"get_floweramulet2"
    ,"get_floweramulet3"
    ,"get_deer1"
    ,"use_floweramulet1"
    ,"use_floweramulet2"
    ,"use_floweramulet3"
    ,"use_floweramulets"
    ,"get_basreliefpart1"
    ,"get_frozenpart"
    ,"get_fireamulet1"
    ,"use_frozenpart"
    ,"get_basreliefpart2"
    ,"use_basreliefpart1"
    ,"use_basreliefpart2"
    ,"get_statuering1"
    ,"get_lvl4hook"
    ,"get_lvl4rope"
    ,"use_lvl4hook"
    ,"get_ropehook"
    ,"use_ropehook"
    ,"get_shield"
    ,"get_musicnote1"
    ,"use_shield"
    ,"get_statuering2"
    ,"use_lvl4pickaxewall"
    ,"use_holvl4crystal"
    ,"use_holvl4candle"
    ,"use_holvl4cup"
    ,"use_holvl4feather"
    ,"use_holvl4amulet1"
    ,"use_holvl4amulet2"
    ,"use_holvl4amulet3"
    ,"use_holvl4amulet4"
    ,"win_hiddenroom"
    ,"use_pincers"
    ,"get_statuering3"
    ,"use_statuering1"
    ,"use_statuering2"
    ,"use_statuering3"
    ,"win_statue"
    ,"get_mirrorshard1"
    ,"opn_oldchapeldialog1"
    ,"get_necklace"
    ,"use_necklace"
    ,"get_lvl4firenecklace"
    ,"use_lvl4firenecklace"
    ,"get_egg"
    ,"get_feather2"
    ,"use_feather1"
    ,"use_feather2"
    ,"win_tree"
    ,"get_ravenfigurine"
    ,"get_mirrorshard2"
    ,"use_ravenfigurine"
    ,"get_phoenix"
    ,"use_phoenix"
    ,"get_crown"
    ,"get_mirrorshard4"
    ,"use_crown"
    ,"get_sword"
    ,"use_sword"
    ,"get_mirrorshard3"
    ,"use_mirrorshard1"
    ,"use_mirrorshard2"
    ,"use_mirrorshard3"
    ,"use_mirrorshard4"
    ,"win_inmirror"
    ,"use_statueface"
    ,"opn_oldchapeldialog2"
    ,"get_guidingline"
    ,"use_guidingline"
    
    ,"opn_forest"
    ,"clk_forestfirst"
    ,"get_littlemirror"
    ,"get_gloves"
    ,"get_battery1"
    ,"get_letter3"
    ,"use_gloves"
    ,"win_stump"
    ,"get_angel2"
    ,"get_torch"
    ,"get_shovelhandle"
    ,"get_diary"
    ,"use_shovelhandle"
    ,"get_spade"
    ,"use_spade"
    ,"get_zipper"
    ,"use_zipper"
    ,"use_holvl4opener"
    ,"use_holvl4laces"
    ,"use_holvl4matches"
    ,"use_holvl4net"
    ,"win_intent"
    ,"clk_opentorch"
    ,"clk_littlemirror"
    ,"use_littlemirror"
    ,"use_littlefire"
    ,"get_guidingtorch"
    ,"use_guidingtorch"
    
    ,"opn_nearhouse"
    ,"get_letter5"
    ,"get_wateringcan"
    ,"use_wateringcan"
    ,"get_fullwateringcan"
    ,"get_handkerchief"
    ,"use_fullwateringcan"
    ,"get_doorfigurine1"
    ,"get_apple"
    ,"use_apple"
    ,"get_needdle"
    ,"get_dogpaw"
    ,"use_handkerchief"
    ,"get_glassshard"
    ,"use_glassshard"
    ,"get_clothbutton1"
    ,"get_clothbutton2"
    ,"use_needdle"
    ,"use_clothbutton"
    ,"use_dogpaw"
    ,"get_doorfigurine2"
    ,"use_doorfigurine1"
    ,"use_doorfigurine2"
    ,"win_housedoor"
    
    ,"opn_inhouse"   ----
    ,"clk_inhousefirst"
    ,"get_soldier"
    ,"get_letter6"
    ,"get_scissors"
    ,"use_scissors"
    ,"get_toyfishingpole"
    ,"use_toyfishingpole"
    ,"get_codewheel"
    ,"use_codewheel"
    ,"get_fireamulet2"
    ,"get_fireamulet3"
    ,"get_ruby"
    ,"use_fireamulet1"
    ,"use_fireamulet2"
    ,"use_fireamulet3"
    ,"win_hearth"
    ,"get_cellarkey"
    ,"use_cellarkey"
    
    ,"opn_cellar"
    ,"get_lvl4screwdriver"
    ,"use_lvl4screwdriver"
    ,"get_lvl4button"
    ,"get_fuse1"
    ,"use_lvl4button"
    ,"get_fuse2"
    ,"clk_oldfuses"
    ,"use_fuse1"
    ,"use_fuse2"
    ,"win_electricbox"
    ,"get_letter7"
    ,"opn_cellarlight"
    ,"get_bone"
    ,"use_bone"
    ,"get_machinepart1"
    ,"get_machinepart2"
    ,"use_machinepart1"
    ,"use_machinepart2"
    ,"win_ingamingmachine"
    ,"get_vhstape"
    
    ,"use_vhstape"
    ,"win_ontvset"
    
    ,"opn_nayasroom"
    ,"clk_nayasroomfirst"
    ,"get_lvl4bulb"
    ,"get_letter8"
    ,"get_lvl4flashlight"
    ,"get_developer"
    ,"use_developer"
    ,"win_table"
    ,"get_musicnote2"
    ,"get_musicnote3"
    ,"use_musicnote1"
    ,"get_sapphire"
    ,"use_musicnote2"
    ,"use_musicnote3"
    ,"get_battery2"
    ,"get_battery3"
    ,"clk_lvl4bulb"
    ,"use_battery1"
    ,"use_battery2"
    ,"use_battery3"
    ,"use_lvl4bulb"
    ,"get_fixedflashlight"
    ,"use_fixedflashlight"
    ,"get_angel1"
    ,"use_angel1"
    ,"use_angel2"
    ,"get_drawerhandle"
    ,"use_drawerhandle"
    ,"get_recipe"
    ,"use_recipe1"
    ,"get_ingredients1"
    ,"use_recipe2"
    ,"get_ingredients2"
    ,"use_recipe3"
    ,"get_ingredients3"
    ,"use_recipe4"
    ,"get_ingredients4"
    ,"use_ingredients1"
    ,"use_ingredients2"
    ,"use_ingredients3"
    ,"use_ingredients4"
    ,"get_potion"
    ,"use_potionstump"
    ,"get_mushroom"
    ,"use_mushroom"
    ,"get_chestkey"
    ,"use_chestkey"
    ,"get_seeds"
    ,"get_lvl4wire"
    ,"use_lvl4wire"
    ,"get_toysword"
    ,"use_seeds"
    ,"use_potionflowerbed"
    
    ,"opn_attic"   ----
    ,"use_toysword"
    ,"win_nightmare"
    ,"get_letter9"
    ,"get_broom"
    ,"use_broom"
    ,"get_ruler"
    ,"use_ruler"
    ,"get_hearthamulet"
    ,"use_hearthamulet"
    ,"get_giftamulet"
    ,"get_windupkey"
    ,"use_windupkey"
    ,"get_ballerina"
    ,"use_giftamulet"
    ,"get_soldierpart"
    ,"get_deer2"
    ,"use_soldierpart"
    ,"get_toysoldier"
    ,"use_ballerina"
    ,"use_toysoldier"
    ,"win_dollhouse"
    ,"get_heartpart1"
    ,"use_deer1"
    ,"use_deer2"
    ,"get_lvl4knife"
    ,"get_medallion"
    ,"use_medallion"
    ,"get_whistle"
    ,"use_whistle"
    ,"get_spinner"
    ,"use_spinner"
    ,"get_notesheet"
    ,"use_notesheet"
    ,"win_piano"
    ,"get_heartpart2"
    ,"use_letter"
    ,"get_polish"
    ,"use_polish"
    ,"get_heartpart3"
    ,"use_lvl4knife"
    ,"win_inboxes"
    ,"use_emerald"
    ,"use_ruby"
    ,"use_sapphire"
    ,"use_amethyst"
    ,"get_snowflake"
    ,"use_snowflake"
    ,"get_heartpart4"
    ,"use_heartpart1"
    ,"use_heartpart2"
    ,"use_heartpart3"
    ,"use_heartpart4"
    ,"win_memories"
    
    ,"tutor_27"
    ,"tutor_28"
    ,"tutor_29"
    ,"tutor_30"
  
  };
  
  game.relations = {};

end;

function Test ()
    
  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;
