-- name=rm_attic
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_attic";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Dollhouse();
  --------------------------------------------------------------------------------------------
  -- function get_ruler () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_ruler" ] = {
    type = "get",
    get_obj = "spr_boxes_ruler",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_attic_boxes"
  };
  --------------------------------------------------------------------------------------------
  local get_ruler_inv = function ()
  
    interface.InventoryItemAdd( "inv_ruler", "spr_boxes_ruler" );
  
  end;
  local get_ruler_end = function ()
  
    ObjDelete( "gfx_boxes_ruler" );
    ObjDelete( "spr_boxes_ruler_sh" );
    ObjDelete( "spr_attic_boxes_ruler" );
  
  end;
  
  cmn.AddSubscriber( "get_ruler", get_ruler_inv );
  cmn.AddSubscriber( "get_ruler", get_ruler_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_medallion () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_medallion" ] = {
    type = "get",
    get_obj = "spr_shelf_medallion",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_attic_shelf"
  };
  --------------------------------------------------------------------------------------------
  local get_medallion_inv = function ()
  
    interface.InventoryItemAdd( "inv_medallion", "spr_shelf_medallion" );
  
  end;
  local get_medallion_end = function ()
  
    ObjDelete( "gfx_shelf_medallion" );
    ObjDelete( "spr_shelf_medallion_sh" );
    ObjDelete( "spr_attic_shelf_collar" );

    if cmn.IsEventDone( "get_lvl4knife" ) and cmn.IsEventDone( "get_medallion" )
    and cmn.IsEventDone( "get_notesheet" ) and cmn.IsEventDone( "get_polish" ) then
      ObjDelete( "gzz_attic_shelf" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_medallion", get_medallion_inv );
  cmn.AddSubscriber( "get_medallion", get_medallion_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_notesheet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_notesheet" ] = {
    type = "get",
    get_obj = "spr_shelf_notesheet",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_attic_shelf"
  };
  --------------------------------------------------------------------------------------------
  local get_notesheet_inv = function ()
  
    interface.InventoryItemAdd( "inv_notesheet", "spr_shelf_notesheet" );
    int_map_impl.DecreaseRoomTasks("rm_attic");
  
  end;
  local get_notesheet_end = function ()
  
    ObjDelete( "gfx_shelf_notesheet" );
    ObjDelete( "spr_shelf_notesheet_sh" );
    ObjDelete( "spr_attic_shelf_sheet" );

    if cmn.IsEventDone( "get_lvl4knife" ) and cmn.IsEventDone( "get_medallion" )
    and cmn.IsEventDone( "get_notesheet" ) and cmn.IsEventDone( "get_polish" ) then
      ObjDelete( "gzz_attic_shelf" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_notesheet", get_notesheet_inv );
  cmn.AddSubscriber( "get_notesheet", get_notesheet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_broom () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_broom" ] = {
    type = "get",
    get_obj = "spr_shelf_broom",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_attic_shelf"
  };
  --------------------------------------------------------------------------------------------
  local get_broom_inv = function ()
  
    interface.InventoryItemAdd( "inv_broom", "spr_shelf_broom" );
  
  end;
  local get_broom_end = function ()
  
    ObjDelete( "gfx_shelf_broom" );
    ObjDelete( "spr_shelf_broom_sh" );
    ObjDelete( "spr_attic_shelf_broom" );
  
  end;
  
  cmn.AddSubscriber( "get_broom", get_broom_inv );
  cmn.AddSubscriber( "get_broom", get_broom_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4knife () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4knife" ] = {
    type = "get",
    get_obj = "spr_shelf_lvl4knife",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_attic_shelf"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4knife_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4knife", "spr_shelf_lvl4knife" );
  
  end;
  local get_lvl4knife_end = function ()
  
    ObjDelete( "gfx_shelf_lvl4knife" );
    ObjDelete( "spr_shelf_lvl4knife_sh" );
    ObjDelete( "spr_attic_shelf_knife" );

    if cmn.IsEventDone( "get_lvl4knife" ) and cmn.IsEventDone( "get_medallion" )
    and cmn.IsEventDone( "get_notesheet" ) and cmn.IsEventDone( "get_polish" ) then
      ObjDelete( "gzz_attic_shelf" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lvl4knife", get_lvl4knife_inv );
  cmn.AddSubscriber( "get_lvl4knife", get_lvl4knife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_polish () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_polish" ] = {
    type = "get",
    get_obj = "spr_shelf_polish",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_attic_shelf"
  };
  --------------------------------------------------------------------------------------------
  local get_polish_inv = function ()
  
    interface.InventoryItemAdd( "inv_polish", "spr_shelf_polish" );
    int_map_impl.DecreaseRoomTasks("rm_attic");
  
  end;
  local get_polish_end = function ()
  
    ObjDelete( "gfx_shelf_polish" );
    ObjDelete( "spr_shelf_polish_sh" );
    ObjDelete( "spr_attic_shelf_polish" );

    if cmn.IsEventDone( "get_lvl4knife" ) and cmn.IsEventDone( "get_medallion" )
    and cmn.IsEventDone( "get_notesheet" ) and cmn.IsEventDone( "get_polish" ) then
      ObjDelete( "gzz_attic_shelf" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_polish", get_polish_inv );
  cmn.AddSubscriber( "get_polish", get_polish_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hearthamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_hearthamulet" ] = {
    type = "get",
    get_obj = "spr_lvl4window_hearthamulet",
    room = private.room_objname,
    zz = "zz_lvl4window",
    zz_gate = "gzz_attic_lvl4window"
  };
  --------------------------------------------------------------------------------------------
  local get_hearthamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_hearthamulet", "spr_lvl4window_hearthamulet" );
  
  end;
  local get_hearthamulet_end = function ()
  
    ObjDelete( "gfx_lvl4window_hearthamulet" );
    ObjDelete( "spr_attic_window_amulet" );
  
  end;
  
  cmn.AddSubscriber( "get_hearthamulet", get_hearthamulet_inv );
  cmn.AddSubscriber( "get_hearthamulet", get_hearthamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spinner () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_spinner" ] = {
    type = "get",
    get_obj = "spr_lvl4window_spinner",
    room = private.room_objname,
    zz = "zz_lvl4window",
    zz_gate = "gzz_attic_lvl4window"
  };
  --------------------------------------------------------------------------------------------
  local get_spinner_inv = function ()
  
    interface.InventoryItemAdd( "inv_spinner", "spr_lvl4window_spinner" );
  
  end;
  local get_spinner_end = function ()
  
    ObjDelete( "gfx_lvl4window_spinner" );
    ObjDelete( "anm_lvl4window_use_whistle" );
    ObjDelete( "spr_attic_window_spinner" );
    
    ObjSet("anm_lvl4window_bird",  { alp = 1, pos_z = 10, animfunc = "func_bird_big_anm", frame = 0 });
    ObjDelete( "gzz_attic_lvl4window" );
  
  end;
  
  cmn.AddSubscriber( "get_spinner", get_spinner_inv );
  cmn.AddSubscriber( "get_spinner", get_spinner_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_heartpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_heartpart1" ] = {
    type = "get",
    get_obj = "spr_dollhouse_heartpart1",
    room = private.room_objname,
    zz = "zz_dollhouse",
    zz_gate = "gzz_attic_dollhouse"
  };
  --------------------------------------------------------------------------------------------
  local get_heartpart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_heartpart1", "spr_dollhouse_heartpart1" );
    int_map_impl.DecreaseRoomTasks("rm_attic");
  
  end;
  local get_heartpart1_end = function ()
  
    ObjDelete( "gfx_dollhouse_heartpart1" );
    ObjDelete( "gzz_attic_dollhouse" );
    ObjDelete( "spr_attic_house_heart" );
  
  end;
  
  cmn.AddSubscriber( "get_heartpart1", get_heartpart1_inv );
  cmn.AddSubscriber( "get_heartpart1", get_heartpart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter9 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_letter9" ] = {
    type = "get",
    get_obj = "spr_attic_letter9",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_letter9_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter", "spr_attic_letter9", function () cmn.GetMultyObject( 'letter', 9 ); end );
    int_map_impl.DecreaseRoomTasks("rm_attic");
  
  end;
  local get_letter9_end = function ()
  
    ObjDelete( "gfx_attic_letter9" );
    ObjDelete( "spr_attic_letter9_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_letter9", get_letter9_inv );
  cmn.AddSubscriber( "get_letter9", get_letter9_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_broom () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_broom" ] = {
    type = "use",
    inv_obj = "inv_broom",
    use_place = "obj_boxes_use_broom",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_attic_boxes"
  };
  --------------------------------------------------------------------------------------------
  local use_broom_inv = function ()
  
    interface.InventoryItemRemove( "inv_broom" );
  
  end;
  local use_broom_beg = function ()
  
    ObjDelete( "obj_boxes_use_broom" );
    ObjDelete( "anm_boxes_web_touch" );
  
  end;
  local use_broom_end = function ()
    
    ObjDelete( "anm_boxes_web_clean" );
    ObjDelete( "spr_attic_boxes_dust" );

    ObjMultiSet( {
      { "anm_boxes_touch", { input = true } },
      { "obj_boxes_use_lvl4knife", { input = true } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_broom", use_broom_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom", use_broom_inv );
  cmn.AddSubscriber( "use_broom", use_broom_end, private.room_objname );
  cmn.AddSubscriber( "use_broom_inv", use_broom_inv, private.room_objname );
  cmn.AddSubscriber( "use_broom_beg", use_broom_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom_end", use_broom_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4knife () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl4knife" ] = {
    type = "use",
    inv_obj = "inv_lvl4knife",
    use_place = "obj_boxes_use_lvl4knife",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_attic_boxes"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl4knife_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4knife" );
  
  end;
  local use_lvl4knife_beg = function ()
  
    ObjDelete( "obj_boxes_use_lvl4knife" );
    ObjDelete( "anm_boxes_touch" );
  
  end;
  local use_lvl4knife_end = function ()
  
    ObjDelete( "gzz_attic_boxes" );
    ObjDelete( "spr_attic_boxes" );

    ObjSet( "gho_attic_inboxes", { alp = 1, input = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4knife", use_lvl4knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4knife", use_lvl4knife_inv );
  cmn.AddSubscriber( "use_lvl4knife", use_lvl4knife_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4knife_inv", use_lvl4knife_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4knife_beg", use_lvl4knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4knife_end", use_lvl4knife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_deer2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_deer2" ] = {
    type = "use",
    inv_obj = "inv_deer2",
    use_place = "obj_shelf_use_deer2",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_attic_shelf"
  };
  --------------------------------------------------------------------------------------------
  local use_deer2_inv = function ()
  
    interface.InventoryItemRemove( "inv_deer2" );
  
  end;
  local use_deer2_beg = function ()
  
    ObjDelete( "obj_shelf_use_deer2" );
  
  end;
  local use_deer2_end = function ()
    
    ObjMultiSet( { {"anm_shelf_use_deer_2",  { alp = 1, frame = 300 }},
                   {"spr_attic_shelf_deer_2", { alp = 1 }} } );

    if ( cmn.IsEventDone( "use_deer1" ) ) then
      ObjDelete( "anm_shelf_deer_box_touch" );
      ObjDelete( "spr_attic_shelf_deer_closed" );
      ObjMultiSet( { {"anm_shelf_deer_box_open",  { alp = 1, input = 1, frame = 300 }},
                     {"spr_attic_shelf_deer_open", { alp = 1 }} } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_deer2", use_deer2_beg, private.room_objname );
  cmn.AddSubscriber( "use_deer2", use_deer2_inv );
  cmn.AddSubscriber( "use_deer2", use_deer2_end, private.room_objname );
  cmn.AddSubscriber( "use_deer2_inv", use_deer2_inv, private.room_objname );
  cmn.AddSubscriber( "use_deer2_beg", use_deer2_beg, private.room_objname );
  cmn.AddSubscriber( "use_deer2_end", use_deer2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_deer1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_deer1" ] = {
    type = "use",
    inv_obj = "inv_deer1",
    use_place = "obj_shelf_use_deer1",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_attic_shelf"
  };
  --------------------------------------------------------------------------------------------
  local use_deer1_inv = function ()
  
    interface.InventoryItemRemove( "inv_deer1" );
  
  end;
  local use_deer1_beg = function ()
  
    ObjDelete( "obj_shelf_use_deer1" );
  
  end;
  local use_deer1_end = function ()
    
    ObjMultiSet( { {"anm_shelf_use_deer_1",  { alp = 1, frame = 300 }},
                   {"spr_attic_shelf_deer_1", { alp = 1 }} } );

    if ( cmn.IsEventDone( "use_deer2" ) ) then
      ObjDelete( "anm_shelf_deer_box_touch" );
      ObjDelete( "spr_attic_shelf_deer_closed" );
      ObjMultiSet( { {"anm_shelf_deer_box_open",  { alp = 1, input = 1, frame = 300 }},
                     {"spr_attic_shelf_deer_open", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_deer1", use_deer1_beg, private.room_objname );
  cmn.AddSubscriber( "use_deer1", use_deer1_inv );
  cmn.AddSubscriber( "use_deer1", use_deer1_end, private.room_objname );
  cmn.AddSubscriber( "use_deer1_inv", use_deer1_inv, private.room_objname );
  cmn.AddSubscriber( "use_deer1_beg", use_deer1_beg, private.room_objname );
  cmn.AddSubscriber( "use_deer1_end", use_deer1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spinner () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_spinner" ] = {
    type = "use",
    inv_obj = "inv_spinner",
    use_place = "obj_shelf_use_spinner",
    room = private.room_objname,
    zz = "zz_shelf",
    zz_gate = "gzz_attic_shelf"
  };
  --------------------------------------------------------------------------------------------
  local use_spinner_inv = function ()
  
    interface.InventoryItemRemove( "inv_spinner" );
  
  end;
  local use_spinner_beg = function ()
  
    ObjDelete( "obj_shelf_use_spinner" );
    ObjDelete( "anm_shelf_music_box_touch" );
  
  end;
  local use_spinner_end = function ()
    
    ObjDelete( "spr_attic_shelf_music_closed" );

    ObjMultiSet( { {"anm_shelf_use_spinner",  { alp = 1, input = 1, frame = 300 , pos_z = 2}},
                   {"spr_attic_shelf_music_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spinner", use_spinner_beg, private.room_objname );
  cmn.AddSubscriber( "use_spinner", use_spinner_inv );
  cmn.AddSubscriber( "use_spinner", use_spinner_end, private.room_objname );
  cmn.AddSubscriber( "use_spinner_inv", use_spinner_inv, private.room_objname );
  cmn.AddSubscriber( "use_spinner_beg", use_spinner_beg, private.room_objname );
  cmn.AddSubscriber( "use_spinner_end", use_spinner_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_whistle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_whistle" ] = {
    type = "use",
    inv_obj = "inv_whistle",
    use_place = "obj_lvl4window_use_whistle",
    room = private.room_objname,
    zz = "zz_lvl4window",
    zz_gate = "gzz_attic_lvl4window"
  };
  --------------------------------------------------------------------------------------------
  local use_whistle_inv = function ()
  
    interface.InventoryItemRemove( "inv_whistle" );
  
  end;
  local use_whistle_beg = function ()
  
    ObjDelete( "obj_lvl4window_use_whistle" );
    ObjDelete( "anm_lvl4window_bird_touch" );
    ObjSet("anm_lvl4window_bird",  { alp = 0 });
  
  end;
  local use_whistle_end = function ()
  
    ObjDelete( "spr_attic_window_bird_1" );
    ObjSet( "spr_attic_window_bird_2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_whistle", use_whistle_beg, private.room_objname );
  cmn.AddSubscriber( "use_whistle", use_whistle_inv );
  cmn.AddSubscriber( "use_whistle", use_whistle_end, private.room_objname );
  cmn.AddSubscriber( "use_whistle_inv", use_whistle_inv, private.room_objname );
  cmn.AddSubscriber( "use_whistle_beg", use_whistle_beg, private.room_objname );
  cmn.AddSubscriber( "use_whistle_end", use_whistle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ruler () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_ruler" ] = {
    type = "use",
    inv_obj = "inv_ruler",
    use_place = "obj_lvl4window_use_ruler",
    room = private.room_objname,
    zz = "zz_lvl4window",
    zz_gate = "gzz_attic_lvl4window"
  };
  --------------------------------------------------------------------------------------------
  local use_ruler_inv = function ()
  
    interface.InventoryItemRemove( "inv_ruler" );
  
  end;
  local use_ruler_beg = function ()
  
    ObjDelete( "obj_lvl4window_use_ruler" );
    ObjDelete( "anm_lvl4window_window_touch" );
  
  end;
  local use_ruler_end = function ()
    
    ObjDelete( "spr_attic_window_1" );
  
    ObjMultiSet( { {"anm_lvl4window_window_open", { alp = 1, frame = 300 }},
                   {"obj_lvl4window_use_whistle", { input = 1 }},
                   {"anm_lvl4window_hearthamulet", { input = 1 }},
                   {"spr_attic_window_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ruler", use_ruler_beg, private.room_objname );
  cmn.AddSubscriber( "use_ruler", use_ruler_inv );
  cmn.AddSubscriber( "use_ruler", use_ruler_end, private.room_objname );
  cmn.AddSubscriber( "use_ruler_inv", use_ruler_inv, private.room_objname );
  cmn.AddSubscriber( "use_ruler_beg", use_ruler_beg, private.room_objname );
  cmn.AddSubscriber( "use_ruler_end", use_ruler_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toysoldier () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_toysoldier" ] = {
    type = "use",
    inv_obj = "inv_toysoldier",
    use_place = "obj_dollhouse_use_toysoldier",
    room = private.room_objname,
    zz = "zz_dollhouse",
    zz_gate = "gzz_attic_dollhouse"
  };
  --------------------------------------------------------------------------------------------
  local use_toysoldier_inv = function ()
  
    interface.InventoryItemRemove( "inv_toysoldier" );
  
  end;
  local use_toysoldier_beg = function ()
  
    ObjDelete( "obj_dollhouse_use_toysoldier" );
  
  end;
  local use_toysoldier_end = function ()
    
    ObjMultiSet( { {"anm_dollhouse_enemy_1", { alp = 1 }},
                   {"spr_attic_house_soldier", { alp = 1 }} } );
  
    if ( cmn.IsEventDone( "use_ballerina" ) ) then
      ObjDelete( "obj_dollhouse_door" );
      ObjDelete( "anm_dollhouse_game_start" );
      ObjDelete( "spr_attic_house_closed" );
      ObjMultiSet( { {"obj_dollhouse_game", { input = 1, alp = 1 }},
                     {"anm_dollhouse_plate_1", { alp = 1 }},
                     {"anm_dollhouse_plate_2", { alp = 1 }},
                     {"anm_dollhouse_plate_3", { alp = 1 }},
                     {"spr_attic_house_plates", { alp = 1 }} } );
    else 
      ObjSet("anm_dollhouse_locker_1",  { animfunc = "func_touch_openlocker_1", frame = 0 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_toysoldier", use_toysoldier_beg, private.room_objname );
  cmn.AddSubscriber( "use_toysoldier", use_toysoldier_inv );
  cmn.AddSubscriber( "use_toysoldier", use_toysoldier_end, private.room_objname );
  cmn.AddSubscriber( "use_toysoldier_inv", use_toysoldier_inv, private.room_objname );
  cmn.AddSubscriber( "use_toysoldier_beg", use_toysoldier_beg, private.room_objname );
  cmn.AddSubscriber( "use_toysoldier_end", use_toysoldier_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ballerina () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_ballerina" ] = {
    type = "use",
    inv_obj = "inv_ballerina",
    use_place = "obj_dollhouse_use_ballerina",
    room = private.room_objname,
    zz = "zz_dollhouse",
    zz_gate = "gzz_attic_dollhouse"
  };
  --------------------------------------------------------------------------------------------
  local use_ballerina_inv = function ()
  
    interface.InventoryItemRemove( "inv_ballerina" );
  
  end;
  local use_ballerina_beg = function ()
  
    ObjDelete( "obj_dollhouse_use_ballerina" );
  
  end;
  local use_ballerina_end = function ()

    ObjMultiSet( { {"anm_dollhouse_enemy_3", { alp = 1 }},
                   {"spr_attic_house_ballerina", { alp = 1 }} } );

    if ( cmn.IsEventDone( "use_toysoldier" ) ) then
      ObjDelete( "obj_dollhouse_door" );
      ObjDelete( "anm_dollhouse_game_start" );
      ObjDelete( "spr_attic_house_closed" );
      ObjMultiSet( { {"obj_dollhouse_game", { input = 1, alp = 1 }},
                     {"anm_dollhouse_plate_1", { alp = 1 }},
                     {"anm_dollhouse_plate_2", { alp = 1 }},
                     {"anm_dollhouse_plate_3", { alp = 1 }},
                     {"spr_attic_house_plates", { alp = 1 }} } );
    else 
      ObjSet("anm_dollhouse_locker_1",  { animfunc = "func_touch_openlocker_1", frame = 0 });
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ballerina", use_ballerina_beg, private.room_objname );
  cmn.AddSubscriber( "use_ballerina", use_ballerina_inv );
  cmn.AddSubscriber( "use_ballerina", use_ballerina_end, private.room_objname );
  cmn.AddSubscriber( "use_ballerina_inv", use_ballerina_inv, private.room_objname );
  cmn.AddSubscriber( "use_ballerina_beg", use_ballerina_beg, private.room_objname );
  cmn.AddSubscriber( "use_ballerina_end", use_ballerina_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toysword () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_toysword" ] = {
    type = "use",
    inv_obj = "inv_toysword",
    use_place = "obj_attic_use_toysword",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_toysword_inv = function ()
  
    interface.InventoryItemRemove( "inv_toysword" );
    
    int_map_impl.BlockRoom( "rm_nearchapel" );
    int_map_impl.BlockRoom( "rm_oldcemetery" );
    int_map_impl.BlockRoom( "rm_oldchapel" );
    int_map_impl.BlockRoom( "rm_forest" );
    int_map_impl.BlockRoom( "rm_nearhouse" );
    int_map_impl.BlockRoom( "rm_inhouse" );
    int_map_impl.BlockRoom( "rm_nayasroom" );
    int_map_impl.BlockRoom( "rm_cellar" );
  
  end;
  local use_toysword_beg = function ()
  
    ObjDelete( "obj_attic_use_toysword" );
  
  end;
  local use_toysword_end = function ()
  
    --ObjSet( "spr_attic_letter9", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_toysword", use_toysword_beg, private.room_objname );
  cmn.AddSubscriber( "use_toysword", use_toysword_inv );
  cmn.AddSubscriber( "use_toysword", use_toysword_end, private.room_objname );
  cmn.AddSubscriber( "use_toysword_inv", use_toysword_inv, private.room_objname );
  cmn.AddSubscriber( "use_toysword_beg", use_toysword_beg, private.room_objname );
  cmn.AddSubscriber( "use_toysword_end", use_toysword_end, private.room_objname );


  --------------------------------------------------------------------------------------------
  -- function opn_attic () end;
  --------------------------------------------------------------------------------------------
  local opn_attic = function ()
  
    int_map_impl.OpenRoom( "rm_attic" );
    --interface_impl.SetCurrentGlobalTask( 24 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_attic", opn_attic );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_dollhouse" );
  
  function zz_dollhouse.PreOpen()
    
    private.zz_dollhouse.DrawScene();
    
    if not(cmn.IsEventDone( "win_dollhouse" )) then
      if private.zz_dollhouse.state[ 4 ] == 1 then
        cmn.Lock(1);
      end;
    end;

  end;
  
  function zz_dollhouse.Open()
    
    if cmn.IsEventDone( "use_toysoldier" ) and cmn.IsEventDone("use_ballerina") and not(cmn.IsEventDone( "win_dollhouse" )) then
      cmn.MiniGameShow();
      if private.zz_dollhouse.state[ 4 ] == 1 then
        public.zz_dollhouse.PlayScene();
      end;
    end;

  end;
  
  function zz_dollhouse.PreClose()
    
    if cmn.IsEventDone( "use_toysoldier" ) and cmn.IsEventDone("use_ballerina") and not cmn.IsEventDone("win_dollhouse") then
      cmn.MiniGameHide("dollhouse");
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_dollhouse" ].state) then 
    private.zz_dollhouse.StartConditions();
  end;
  
  private.zz_dollhouse.state = ng_global.progress[ ng_global.currentprogress ][ "win_dollhouse" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_attic();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if not ( cmn.IsEventDone( "opn_attic" ) ) then
    cmn.Lock( 1 );
    cmn.StopAllEnv();
    ObjSet("rm_attic",  { color_r = 0, color_g = 0, color_b = 0 });
  else
    cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_attic_env");
    cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_attic_env"); 
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(11) then
    private.AnimMorphObject();
  end;

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_broom()

  local item = "inv_broom";

  if cmn.ApplyObj( item, "gzz_attic_boxes" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_boxes" );

  elseif ( cmn.ApplyObj( item, "obj_boxes_use_broom" ) ) then

    cmn.CallEventHandler( "use_broom_inv" );
    cmn.CallEventHandler( "use_broom_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_broom" );
      cmn.CallEventHandler( "use_broom_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_clean_web");

    ObjSet("anm_boxes_web_clean",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4knife()

  local item = "inv_lvl4knife";

  if cmn.ApplyObj( item, "gzz_attic_boxes" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_boxes" );

  elseif ( cmn.ApplyObj( item, "obj_boxes_use_lvl4knife" ) and cmn.IsEventDone( "use_broom" ) ) then

    cmn.CallEventHandler( "use_lvl4knife_inv" );
    cmn.CallEventHandler( "use_lvl4knife_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4knife" );
      cmn.CallEventHandler( "use_lvl4knife_end" );

      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_zz_boxes_cut_box");

    ObjSet("anm_boxes_use_knife",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_deer2()

  local item = "inv_deer2";

  if cmn.ApplyObj( item, "gzz_attic_shelf" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_shelf" );

  elseif ( cmn.ApplyObj( item, "obj_shelf_use_deer2" ) ) then

    cmn.CallEventHandler( "use_deer2_inv" );
    cmn.CallEventHandler( "use_deer2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_deer2" );
      cmn.CallEventHandler( "use_deer2_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjDelete("anm_shelf_deer_box_touch");
      ObjSet("anm_shelf_deer_box_open",  { alp = 1, playing = 1, endtrig = func_after });

      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_open_upper_box_zz_shelf");
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_deer_1");

    if cmn.IsEventDone("use_deer1") then
      ObjSet("anm_shelf_use_deer_2",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_shelf_use_deer_2",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_deer1()

  local item = "inv_deer1";

  if cmn.ApplyObj( item, "gzz_attic_shelf" ) and cmn.IsEventDone("win_nightmare") then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_shelf" );

  elseif ( cmn.ApplyObj( item, "obj_shelf_use_deer1" ) ) then

    cmn.CallEventHandler( "use_deer1_inv" );
    cmn.CallEventHandler( "use_deer1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_deer1" );
      cmn.CallEventHandler( "use_deer1_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjDelete("anm_shelf_deer_box_touch");
      ObjSet("anm_shelf_deer_box_open",  { alp = 1, playing = 1, endtrig = func_after });

      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_open_upper_box_zz_shelf");
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_deer_1");

    if cmn.IsEventDone("use_deer2") then
      ObjSet("anm_shelf_use_deer_1",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_shelf_use_deer_1",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spinner()

  local item = "inv_spinner";

  if cmn.ApplyObj( item, "gzz_attic_shelf" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_shelf" );

  elseif ( cmn.ApplyObj( item, "obj_shelf_use_spinner" ) ) then

    cmn.CallEventHandler( "use_spinner_inv" );
    cmn.CallEventHandler( "use_spinner_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_spinner" );
      cmn.CallEventHandler( "use_spinner_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_shelf_box_down");

    ObjSet("anm_shelf_use_spinner",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_whistle()

  local item = "inv_whistle";

  if cmn.ApplyObj( item, "gzz_attic_lvl4window" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4window" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4window_use_whistle" ) and cmn.IsEventDone("use_ruler") ) then

    cmn.CallEventHandler( "use_whistle_inv" );
    cmn.CallEventHandler( "use_whistle_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_whistle" );
      cmn.CallEventHandler( "use_whistle_end" );
      
      public.get_spinner();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_whistle_bird");

    ObjSet("anm_lvl4window_use_whistle",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ruler()

  local item = "inv_ruler";

  if cmn.ApplyObj( item, "gzz_attic_lvl4window" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4window" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4window_use_ruler" ) ) then

    cmn.CallEventHandler( "use_ruler_inv" );
    cmn.CallEventHandler( "use_ruler_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ruler" );
      cmn.CallEventHandler( "use_ruler_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_open_ruler");

    ObjSet("anm_lvl4window_window_open",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_toysoldier()

  local item = "inv_toysoldier";

  if cmn.ApplyObj( item, "gzz_attic_dollhouse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_dollhouse" );

  elseif ( cmn.ApplyObj( item, "obj_dollhouse_use_toysoldier" ) ) then

    cmn.CallEventHandler( "use_toysoldier_inv" );
    cmn.CallEventHandler( "use_toysoldier_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_toysoldier" );
      cmn.CallEventHandler( "use_toysoldier_end" );
      
      if cmn.IsEventDone("use_ballerina") then
        cmn.MiniGameShow();
      end;
    
    end;
    
    local anm_game = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_begin_stuffs");
      ObjSet("anm_dollhouse_game_start",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud__zz_dollhouse_opens_for_mmg");
      
      ObjSet("obj_dollhouse_game",  { alp = 1 });
      ObjAnimate("obj_dollhouse_door", "alp", 0, 0, anm_game, { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
    local anm_lock = function ()
      
      if cmn.IsEventDone("use_ballerina") then
        ObjSet("anm_dollhouse_locker_2",  { frame = 0, animfunc = "func_open_locker_2", playing = 1, endtrig = anm_open });
      else 
        ObjSet("anm_dollhouse_locker_1",  { frame = 0, animfunc = "func_open_locker_1", playing = 1, endtrig = func_after });
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_solider_mmg");

    ObjAnimate( "anm_dollhouse_enemy_1", "alp", 0, 0, anm_lock, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ballerina()

  local item = "inv_ballerina";

  if cmn.ApplyObj( item, "gzz_attic_dollhouse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_dollhouse" );

  elseif ( cmn.ApplyObj( item, "obj_dollhouse_use_ballerina" ) ) then

    cmn.CallEventHandler( "use_ballerina_inv" );
    cmn.CallEventHandler( "use_ballerina_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ballerina" );
      cmn.CallEventHandler( "use_ballerina_end" );
      
      if cmn.IsEventDone("use_toysoldier") then
        cmn.MiniGameShow();
      end;
    
    end;

    local anm_game = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_begin_stuffs");
      ObjSet("anm_dollhouse_game_start",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud__zz_dollhouse_opens_for_mmg");
      
      ObjSet("obj_dollhouse_game",  { alp = 1 });
      ObjAnimate("obj_dollhouse_door", "alp", 0, 0, anm_game, { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
    local anm_lock = function ()
      
      if cmn.IsEventDone("use_toysoldier") then
        ObjSet("anm_dollhouse_locker_2",  { frame = 0, animfunc = "func_open_locker_2", playing = 1, endtrig = anm_open });
      else 
        ObjSet("anm_dollhouse_locker_1",  { frame = 0, animfunc = "func_open_locker_1", playing = 1, endtrig = func_after });
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_girl_mmg");

    ObjAnimate( "anm_dollhouse_enemy_3", "alp", 0, 0, anm_lock, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_toysword()

  local item = "inv_toysword";

  if ( cmn.ApplyObj( item, "obj_attic_use_toysword" ) ) then

    cmn.CallEventHandler( "use_toysword_inv" );
    cmn.CallEventHandler( "use_toysword_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_toysword" );
      cmn.CallEventHandler( "use_toysword_end" );
      
      cmn.GotoRoom("mg_nightmare");
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_take_sword");

    ObjSet("anm_attic_use_sword",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_ruler()

  cmn.SetEventDone( "get_ruler" );
  cmn.CallEventHandler( "get_ruler" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_medallion()

  cmn.SetEventDone( "get_medallion" );
  cmn.CallEventHandler( "get_medallion" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  if cmn.IsEventDone( "get_lvl4knife" ) and cmn.IsEventDone( "get_medallion" )
  and cmn.IsEventDone( "get_notesheet" ) and cmn.IsEventDone( "get_polish" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_notesheet()

  cmn.SetEventDone( "get_notesheet" );
  cmn.CallEventHandler( "get_notesheet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  if cmn.IsEventDone( "get_lvl4knife" ) and cmn.IsEventDone( "get_medallion" )
  and cmn.IsEventDone( "get_notesheet" ) and cmn.IsEventDone( "get_polish" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_broom()

  cmn.SetEventDone( "get_broom" );
  cmn.CallEventHandler( "get_broom" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4knife()

  cmn.SetEventDone( "get_lvl4knife" );
  cmn.CallEventHandler( "get_lvl4knife" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  if cmn.IsEventDone( "get_lvl4knife" ) and cmn.IsEventDone( "get_medallion" )
  and cmn.IsEventDone( "get_notesheet" ) and cmn.IsEventDone( "get_polish" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_polish()

  cmn.SetEventDone( "get_polish" );
  cmn.CallEventHandler( "get_polish" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  if cmn.IsEventDone( "get_lvl4knife" ) and cmn.IsEventDone( "get_medallion" )
  and cmn.IsEventDone( "get_notesheet" ) and cmn.IsEventDone( "get_polish" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_hearthamulet()

  cmn.SetEventDone( "get_hearthamulet" );
  cmn.CallEventHandler( "get_hearthamulet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_spinner()

  cmn.SetEventDone( "get_spinner" );
  cmn.CallEventHandler( "get_spinner" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_heartpart1()

  cmn.SetEventDone( "get_heartpart1" );
  cmn.CallEventHandler( "get_heartpart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_letter9()

  cmn.SetEventDone( "get_letter9" );
  cmn.CallEventHandler( "get_letter9" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_attic()

  if not ( cmn.IsEventDone( "opn_attic" ) ) then
    
    local func_after = function ()

      ObjSet("rm_attic",  { color_r = 1, color_g = 1, color_b = 1 });
      cmn.CallEventHandler("opn_attic");
      cmn.ShowBbt( "attic_open" );
      interface_impl.ShowGlobalTask();
      cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_attic_env"); 
      
    end;
    
    cmn.SetEventDone( "opn_attic" );
    
    cmn.Lock( 0 );

    cmn.PlayFullscreenVideo( "assets/levels/level4/rm_attic/vid_lvl4monster", func_after, "assets/levels/level4/audio/mus/aud_vid_lvl4monster_mus" );

  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_11_1", { alp = 1 }},
                 {"spr_col_11_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_11_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_11_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_11_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_11_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_11_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_11_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_boxes()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_boxes");

  cmn.ShowBbt( "obj_boxes_use_lvl4knife" );
  
  ObjSet( "anm_boxes_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_boxes_web()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_web_zz_boxes");

  cmn.ShowBbt( "obj_boxes_use_broom" );
  
  ObjSet( "anm_boxes_web_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_shelf_deerbox()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_shelf_up");

  cmn.ShowBbt( "obj_shelf_use_deer" );
  
  ObjSet( "anm_shelf_deer_box_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_shelf_musicbox()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_shelf_down");

  cmn.ShowBbt( "obj_shelf_use_spinner" );
  
  ObjSet( "anm_shelf_music_box_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_window()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_window_1");

  cmn.ShowBbt( "obj_lvl4window_use_ruler" );
  
  ObjSet( "anm_lvl4window_window_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_window_bird()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_bird_window");

  cmn.ShowBbt( "obj_lvl4window_use_whistle" );
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    ObjMultiSet( { {"anm_lvl4window_bird", { alp = 1, playing = 1 }},
                   {"anm_lvl4window_bird_touch", { alp = 0 }} } );
    
  end;
  
  ObjMultiSet( { {"anm_lvl4window_bird", { alp = 0, playing = 0 }},
                 {"anm_lvl4window_bird_touch", { alp = 1, playing = 1, endtrig = func_after }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_dollhouse()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_closed_chest_zz_dollhouse");

  cmn.ShowBbt( "obj_dollhouse_use_toys" );
  
  ObjMultiSet( { {"anm_dollhouse_door_touch", { playing = 1, endtrig = function() cmn.Lock(0); end }},
                 {"anm_dollhouse_locker_1", { playing = 1 }},
                 {"anm_dollhouse_locker_2", { playing = 1 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_monster()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_creature_umbrella");

  cmn.ShowBbt( "obj_attic_use_toysword" );
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    ObjMultiSet( { {"anm_attic_monster_umbrella", { alp = 1 }},
                   {"anm_attic_monster_umbrella_2", { alp = 1 }},
                   {"anm_attic_monster_touch", { alp = 0 }} } );
    
  end;
  
  ObjMultiSet( { {"anm_attic_monster_umbrella", { alp = 0 }},
                 {"anm_attic_monster_umbrella_2", { alp = 0 }},
                 {"anm_attic_monster_touch", { alp = 1, playing = 1, endtrig = func_after }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Dollhouse *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_dollhouse = {};
public.zz_dollhouse = {};

function private.Init_Dollhouse()
  
  private.zz_dollhouse.current = 0;
  private.zz_dollhouse.place = 0;
  
  private.zz_dollhouse.old_lever = false;
  private.zz_dollhouse.no_plate_anim = false;
  
  private.zz_dollhouse.plate_pos = { {23, -205}, {113, -205}, {203, -205} };
  private.zz_dollhouse.item_pos = { {-209, 215}, {-120, 207}, {-41, 218}, {36, 210}, {118, 196}, {219, 206} };
  
  private.zz_dollhouse.win_state = {4, 6, 3};
  
  private.zz_dollhouse.item_names = { "crown", "sword", "flower", "axe", "gun", "shield" };
  private.zz_dollhouse.anim_names = {
    { {"func_soldier_move_1"}, "func_soldier_attack", "func_soldier_move_2", {"func_soldier_move_3", "func_soldier_move_4"} },
    { {"func_robot_move_1", "func_robot_move_2"}, "func_robot_attack", "func_robot_move_3", {"func_robot_move_4", "func_robot_move_5", "func_robot_move_6"} },
    { {"func_doll_move_1", "func_doll_move_2", "func_doll_move_3"}, "func_doll_dancing", "func_doll_move_4", {"func_doll_move_5", "func_doll_move_6", "func_doll_move_7"} }
  };
  
  private.zz_dollhouse.outcomes = {
    {0, "func_soldier_die", 0, 1, "func_soldier_die", 1},
    {0, 0, 0, 0, "func_robot_die", 1},
    {"func_doll_angree", "func_doll_die", 1, 0, "func_doll_die", 0}
  };
  
  private.zz_dollhouse.snd_action = { "enemy_solider_shot", "enemy_robot_shot", "girl_happy" };
  -----------------------------------------------------------------------------------
  game.hint[ "win_dollhouse" ] = {
    type = "win",
    room = "rm_attic",
    zz = "zz_dollhouse",
    zz_gate = "gzz_attic_dollhouse"
  };
  -----------------------------------------------------------------------------------
  local win_dollhouse = function ()

    if cmn.IsEventDone( "win_dollhouse" ) then
      ObjDelete("anm_dollhouse_mechanism");
      ObjDelete("obj_dollhouse_scene");
      ObjDelete("anm_dollhouse_plate_1");
      ObjDelete("anm_dollhouse_plate_2");
      ObjDelete("anm_dollhouse_plate_3");
      ObjDelete("obj_attic_house_game");
      ObjMultiSet( { {"anm_dollhouse_heart_get", { alp = 1, input = 1, frame = 300 }},
                     {"obj_dollhouse_game", { input = 0 }},
                     {"anm_dollhouse_plates_next", { alp = 1, frame = 0, animfunc = "func_plate_4_out" }},
                     {"spr_attic_house_heart", { alp = 1 }} } );
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_dollhouse", win_dollhouse, "rm_attic" );
  
end;
--*********************************************************************************************************************
function private.zz_dollhouse.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_dollhouse" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_dollhouse" ].state = { 0, 0, 0, 0 }; --[1-3] - chosen items, [4] - win flag
  
end;
-----------------------------------------------------------------------------------
function public.zz_dollhouse.Reset()
  
  local need_r = false;
  local table_r = {};
  local table_r2 = {};
  
  for i = 1, 3, 1 do
    
    if private.zz_dollhouse.state[ i ] > 0 then
      
      need_r = true;
      table.insert( table_r, private.zz_dollhouse.state[ i ] );
      table.insert( table_r2, i );
      ObjAnimate("spr_dollhouse_game_item_"..private.zz_dollhouse.state[ i ], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local anm_end = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_unclick");
    
    for i = 1, #table_r, 1 do
      
      ObjAttach("spr_dollhouse_game_item_"..table_r[ i ], "obj_dollhouse_game_item_"..table_r[ i ]);
      ObjAnimate("spr_dollhouse_game_item_"..table_r[ i ], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_dollhouse_game_item_"..table_r[ i ].."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_arrow_stuff_"..math.random(1, 3));
    
    for i = 1, #table_r2, 1 do
      ObjSet("anm_dollhouse_plate_"..table_r2[i],  { animfunc = "func_plate_"..table_r2[i].."_up", frame = 0, playing = 1 });
    end;
    
    if #table_r2 == 3 then
      ObjMultiSet( { {"anm_dollhouse_lever",  { frame = 0, animfunc = "func_lever_on", playing = 1, endtrig = function() cmn.Lock(0); end }},
                     {"obj_dollhouse_game_play", { input = 0 }} } );
    else
      ObjSet("tmr_dollhouse_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
    end;
    
  end;
  
  if need_r then
    
    private.zz_dollhouse.current = 0;
    private.zz_dollhouse.place = 0;
    
    private.zz_dollhouse.old_lever = false;
    private.zz_dollhouse.no_plate_anim = false;
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_click");
    
    private.zz_dollhouse.StartConditions();
    private.zz_dollhouse.state = ng_global.progress[ ng_global.currentprogress ][ "win_dollhouse" ].state;
    
    ObjSet("tmr_dollhouse_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_dollhouse.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_click");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_dollhouse" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_dollhouse" ].state = { 4, 6, 3, 1 };
  
  local table_r = {};
  local table_r2 = {};
  local table_r3 = {};
  local check = private.zz_dollhouse.CheckLever();
  
  for i = 1, 3, 1 do
    
    if private.zz_dollhouse.state[ i ] == 0 then
      
      local func_after = function ( num )
        ObjSet("anm_dollhouse_plate_"..num,  { frame = 0, animfunc = "func_plate_"..num, endtrig = "" });
      end;
      
      ObjSet("anm_dollhouse_plate_"..i,  { animfunc = "func_plate_"..i.."_down", frame = 0, playing = 1, endtrig = function() func_after(i); end });
      
    elseif private.zz_dollhouse.state[ i ] ~= private.zz_dollhouse.win_state[ i ] then
      
      table.insert( table_r, private.zz_dollhouse.state[ i ] );
      table.insert( table_r2, i );
      ObjAnimate("spr_dollhouse_game_item_"..private.zz_dollhouse.state[ i ], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  for i = 1, 3, 1 do
    
    if private.zz_dollhouse.FindPlace( private.zz_dollhouse.win_state[ i ] ) == 0 then
      table.insert( table_r3, i );
      ObjAnimate("spr_dollhouse_game_item_"..private.zz_dollhouse.win_state[ i ], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_dollhouse_game_item_"..private.zz_dollhouse.win_state[ i ].."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
  end;
  
  local anm_end = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_unclick");
    
    for i = 1, #table_r, 1 do
      
      ObjAttach("spr_dollhouse_game_item_"..table_r[ i ], "obj_dollhouse_game_item_"..table_r[ i ]);
      ObjAnimate("spr_dollhouse_game_item_"..table_r[ i ], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_dollhouse_game_item_"..table_r[ i ].."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    for i = 1, #table_r2, 1 do
      ObjAttach("spr_dollhouse_game_item_"..private.zz_dollhouse.win_state[ table_r2[i] ], "obj_dollhouse_item_"..table_r2[ i ]);
      ObjAnimate("spr_dollhouse_game_item_"..private.zz_dollhouse.win_state[ table_r2[i] ], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
    for i = 1, #table_r3, 1 do
      ObjAttach("spr_dollhouse_game_item_"..private.zz_dollhouse.win_state[ table_r3[i] ], "obj_dollhouse_item_"..table_r3[ i ]);
      ObjAnimate("spr_dollhouse_game_item_"..private.zz_dollhouse.win_state[ table_r3[i] ], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
    if not check then
      ObjMultiSet( { {"anm_dollhouse_lever",  { frame = 0, animfunc = "func_lever_start", playing = 1, endtrig = public.zz_dollhouse.PlayScene }},
                     {"obj_dollhouse_game_play", { input = 0 }} } );
    else
      ObjSet("tmr_dollhouse_timer",  { time = 0.3, playing = 1, endtrig = public.zz_dollhouse.PlayScene });
    end;
    
  end;
  
  private.zz_dollhouse.state = ng_global.progress[ ng_global.currentprogress ][ "win_dollhouse" ].state;
  
  ObjSet("tmr_dollhouse_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
    
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.DrawScene()
  
  if not cmn.IsEventDone("win_dollhouse") then
  
    for i = 1, 3, 1 do
      
      if private.zz_dollhouse.state[ i ] > 0 then
        ObjMultiSet( { {"anm_dollhouse_plate_"..i,  { frame = 0, animfunc = "func_plate_"..i }},
                       {"spr_dollhouse_game_item_"..private.zz_dollhouse.state[ i ].."_sh", { alp = 0 }} } );
        ObjAttach("spr_dollhouse_game_item_"..private.zz_dollhouse.state[ i ], "obj_dollhouse_item_"..i);
      end;
      
    end;
    
    if private.zz_dollhouse.CheckLever() then
      private.zz_dollhouse.old_lever = true;
      ObjMultiSet( { {"anm_dollhouse_lever",  { frame = 0, animfunc = "func_lever_on" }},
                     {"obj_dollhouse_game_play", { input = 1 }} } );
    end;
                   
  else
    
    for i = 1, 3, 1 do
      
      if private.zz_dollhouse.state[ i ] > 0 then
        ObjDelete("spr_dollhouse_game_item_"..private.zz_dollhouse.state[ i ]);
        ObjDelete("spr_dollhouse_game_item_"..private.zz_dollhouse.state[ i ].."_sh");
      end;
      
    end;
                   
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_dollhouse.FocusPlate( num, inout )
  
  local obj = "anm_dollhouse_plate_"..num;
  local frame = ObjGet( obj ).frame;
  local tme = 0;
  
  if frame == 15 then
    frame = 0;
  elseif frame > 0 then
    frame = 15 - frame;
  end;
  
  if frame < 6 then
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_arrow_stuff_"..math.random(1, 3));
  end;

  if inout == 0 then
    private.zz_dollhouse.place = 0;
    if private.zz_dollhouse.state[ num ] == 0 and not private.zz_dollhouse.no_plate_anim then
      ObjSet("anm_dollhouse_plate_"..num,  { animfunc = "func_plate_"..num.."_up", frame = frame, playing = 1 });
    end;
  else 
    private.zz_dollhouse.place = num;
    if private.zz_dollhouse.state[ num ] == 0 and not private.zz_dollhouse.no_plate_anim then
      ObjSet("anm_dollhouse_plate_"..num,  { animfunc = "func_plate_"..num.."_down", frame = frame, playing = 1 });
    end;
  end;
  
  private.zz_dollhouse.no_plate_anim = false;
  
end;
-----------------------------------------------------------------------------------
function public.zz_dollhouse.FocusLever( inout )
  
  local obj = "spr_dollhouse_lever_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_dollhouse.FocusItem( num, inout, act )
  
  local obj = "spr_dollhouse_game_item_"..num;
  local scale = ObjGet( obj ).scale_x;
  local tme = 0;
  local max_scale = 1.1;  
  local max_tme = 0.3;
  local end_scale = 1;

  if inout == 0 then
    
    SetCursor(CURSOR_DEFAULT);
    
    tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );
    
  else 
    
    SetCursor(CURSOR_GET);
    
    end_scale = max_scale;
    tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/");
    end;
    
  end;

  ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale });
  
end;
-----------------------------------------------------------------------------------
function public.zz_dollhouse.StartDrag( num, flag )
  
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_click");
  
  flag = flag or false;
  
  for i = 1, 3, 1 do
    ObjSet("anm_dollhouse_plate_"..i,  { input = 0 });
  end;
  
  local curspos = GetZoomCursorPos();
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_dollhouse").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_dollhouse").pos_y);
  
  private.zz_dollhouse.current = num;
  local plate = private.zz_dollhouse.FindPlace( num );
  --private.zz_dollhouse.old_lever = private.zz_dollhouse.CheckLever();
  
  if plate == 0 and not flag then
    ObjAnimate("spr_dollhouse_game_item_"..num.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0 });
  elseif not flag then
    private.zz_dollhouse.no_plate_anim = true;
    private.zz_dollhouse.state[ plate ] = 0;
    ObjSet("anm_dollhouse_plate_"..plate,  { animfunc = "func_plate_"..plate.."_down", frame = 15 });
  end;
  
  ObjSet("spr_dollhouse_game_item_"..num,  { pos_x = curspos[1], pos_y = curspos[2] });
  ObjAttach("spr_dollhouse_game_item_"..num, "obj_dollhouse_fly");
  ObjStartDrag("obj_dollhouse_game_drag");
  
  public.zz_dollhouse.FocusItem( num, 0 );
  
end;
-----------------------------------------------------------------------------------
function public.zz_dollhouse.DragItem()
  
  local num = private.zz_dollhouse.current;
  
  local curspos = GetZoomCursorPos();
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_dollhouse").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_dollhouse").pos_y);
  
  if curspos[1] > 230 then
    curspos[1] = 230;
  elseif curspos[1] < -230 then
    curspos[1] = -230;
  end;
  
  if curspos[2] > 230 then
    curspos[2] = 230;
  elseif curspos[2] < -230 then
    curspos[2] = -230;
  end;
  
  ObjSet("spr_dollhouse_game_item_"..num,  { pos_x = curspos[1], pos_y = curspos[2] });
  
end;
-----------------------------------------------------------------------------------
function public.zz_dollhouse.DropItem()
  
  local curspos = GetZoomCursorPos();
  if  tostring(GetPlatform()) == "android" then
      curspos[2] = curspos[2] - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        curspos[2] = curspos[2] - 75;
      else
        curspos[2] = curspos[2] - 50;
      end;
    end;
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_dollhouse").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_dollhouse").pos_y);
  
  if curspos[1] > 230 then
    curspos[1] = 230;
  elseif curspos[1] < -230 then
    curspos[1] = -230;
  end;
  
  if curspos[2] > 230 then
    curspos[2] = 230;
  elseif curspos[2] < -230 then
    curspos[2] = -230;
  end;
  
  local num = private.zz_dollhouse.current;
  local place = private.zz_dollhouse.place;
  local old = 0;
  local plate = private.zz_dollhouse.FindPlace( num );
  
  if place > 0 and private.zz_dollhouse.state[ place ] > 0 then
    old = private.zz_dollhouse.state[ place ];
  end;
  if place > 0 then
    private.zz_dollhouse.state[ place ] = num;
  end;
  
  private.zz_dollhouse.current = 0;
  private.zz_dollhouse.place = 0;
  
  local point_a, point_b = {}, {};
  point_a[1] = curspos[1];
  point_a[2] = curspos[2];
  
  if place > 0 then
    point_b[1] = private.zz_dollhouse.plate_pos[place][1];
    point_b[2] = private.zz_dollhouse.plate_pos[place][2];
  else 
    point_b[1] = private.zz_dollhouse.item_pos[num][1];
    point_b[2] = private.zz_dollhouse.item_pos[num][2];
  end;
  
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.001 * len;
  
  if tme < 0.1 then
    tme = 0.1;
  elseif tme > 0.4 then
    tme = 0.4;
  end;
  
  cmn.Lock(1);
  
  local func_after = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_unclick");
    
    ObjSet("spr_dollhouse_game_item_"..num,  { pos_x = 0, pos_y = 0 });
    
    if place > 0 then
      ObjSet("anm_dollhouse_plate_"..place,  { frame = 0, animfunc = "func_plate_"..place });
      ObjAttach("spr_dollhouse_game_item_"..num, "obj_dollhouse_item_"..place);
    else 
      ObjAttach("spr_dollhouse_game_item_"..num, "obj_dollhouse_game_item_"..num);
      ObjAnimate("spr_dollhouse_game_item_"..num.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });
    end;
    
    if old > 0 and old ~= num then
      cmn.Lock(0);
      public.zz_dollhouse.StartDrag( old, true );
    else
      for i = 1, 3, 1 do
        ObjSet("anm_dollhouse_plate_"..i,  { input = 1 });
      end;
    end;
    
    private.zz_dollhouse.AnimLever();
    
  end;
  
  ObjAnimate("spr_dollhouse_game_item_"..num, "pos_xy", 0, 0, func_after, 
  { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
    
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.AnimLever()
  
  local old_state = private.zz_dollhouse.old_lever;
  local new_state = private.zz_dollhouse.CheckLever();
  private.zz_dollhouse.old_lever = private.zz_dollhouse.CheckLever();
  
  if old_state ~= new_state then
    
    if old_state then
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_lever_goes_down");
      
      ObjMultiSet( { {"anm_dollhouse_lever",  { frame = 0, animfunc = "func_lever_on", playing = 1, endtrig = function() cmn.Lock(0); end }},
                     {"obj_dollhouse_game_play", { input = 0 }} } );
        
    else 
                     
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_lever_down");               
        
      ObjMultiSet( { {"anm_dollhouse_lever",  { frame = 0, animfunc = "func_lever_start", playing = 1, endtrig = function() cmn.Lock(0); end }},
                     {"obj_dollhouse_game_play", { input = 1 }} } );
        
    end;
      
  else 
    cmn.Lock(0);
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.CheckLever()
  
  local check = true;
  
  for i = 1, 3, 1 do
    
    if private.zz_dollhouse.state[ i ] == 0 then
      check = false;
      break;
    end;
    
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.FindPlace( item )
  
  local ind = 0;
  
  for i = 1, 3, 1 do
    
    if private.zz_dollhouse.state[ i ] == item then
      ind = i;
      break;
    end;
    
  end;
  
  return ind;
  
end;
-----------------------------------------------------------------------------------
function public.zz_dollhouse.PlayScene()
  
  cmn.Lock(1);
  
  if private.zz_dollhouse.CheckWin() then
    private.zz_dollhouse.state[ 4 ] = 1;
  end;
  
  local anm_lever = function ()
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_lever_click");
    ObjMultiSet( { {"anm_dollhouse_lever",  { frame = 0, animfunc = "func_lever_on", playing = 1, endtrig = function() private.zz_dollhouse.SceneStart(1); end }},
                   {"obj_dollhouse_game_play", { input = 0 }} } );
  end;
  
  ObjSet("tmr_dollhouse_timer",  { time = 0.3, playing = 1, endtrig = anm_lever });
  
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.SceneStart( num )
  
  local item = private.zz_dollhouse.state[ num ];
  
  local anim_end = function ()
    
    if num < 3 then
      private.zz_dollhouse.SceneStart(num+1);
    else 
      private.zz_dollhouse.WinAnim();
    end;
    
  end;
  
  local win_stage = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_stuff_3_goes_step");
    
    for i = 1, 3, 1 do
      ObjSet("anm_dollhouse_plate_"..i,  { alp = 0 });
    end;
    
    for i = num+1, 3, 1 do
      ObjAttach("spr_dollhouse_game_item_"..private.zz_dollhouse.state[ i ], "obj_dollhouse_plates_next_"..num.."_"..i);
    end;
    
    ObjSet("anm_dollhouse_plates_next",  { alp = 1, frame = 0, animfunc = "func_plate_"..num.."_out", playing = 1, endtrig = anim_end });
    
  end;
  
  local win_soldier = function ()
    
    ObjSet("anm_dollhouse_hero", { frame = 0, animfunc = "func_player_out", endtrig = "" });
    win_stage();
    
  end;
  
  local anm_flower = function ()
    ObjSet("anm_dollhouse_hero", { frame = 0, animfunc = "func_player_object_out", playing = 1, endtrig = new_anim });
  end;
  
  local outcome = function ()
    
    if private.zz_dollhouse.outcomes[num][item] == 1 then
      
      if num < 3 then
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_figure_goes");
        ObjSet("anm_dollhouse_enemy_"..num,  { frame = 0, animfunc = private.zz_dollhouse.anim_names[num][3], playing = 1, endtrig = win_stage });
      else
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_girl_takes_flower");
        ObjMultiSet( { {"anm_dollhouse_enemy_"..num,  { frame = 0, animfunc = private.zz_dollhouse.anim_names[num][3], playing = 1, endtrig = win_soldier }},
                       {"tmr_dollhouse_timer", { time = 1.35, playing = 1, endtrig = anm_flower }} } );
      end;
                     
    elseif private.zz_dollhouse.outcomes[num][item] == 0 then
                     
      if num < 3 then
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_die_figure");
        ObjSet("anm_dollhouse_hero", { frame = 0, animfunc = "func_player_die", playing = 1, endtrig = function() private.zz_dollhouse.SceneRset(num); end });
      else 
        private.zz_dollhouse.SceneRset(num);
      end;
      
    else 
      
      if num < 3 then
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_die_figure");
        ObjSet("anm_dollhouse_hero", { frame = 0, animfunc = "func_player_die", playing = 1, endtrig = "" });
      elseif private.zz_dollhouse.outcomes[num][item] == "func_doll_die" then
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_die_figure");
      end;
      
      if private.zz_dollhouse.outcomes[num][item] == "func_doll_angree" then
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_girl_ugly");
      end;
      
      ObjSet("anm_dollhouse_enemy_"..num,  { frame = 0, animfunc = private.zz_dollhouse.outcomes[num][item], playing = 1, endtrig = function() private.zz_dollhouse.SceneRset(num); end });
      
    end;
    
  end;
                 
  local anm_hands = function ()
    
    if num == 3 and private.zz_dollhouse.state[ 4 ] == 1 then
      outcome();
    else
      ObjSet("anm_dollhouse_hero", { frame = 0, animfunc = "func_player_object_out", playing = 1, endtrig = outcome });
    end;
    
  end;
  
  local action = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_"..private.zz_dollhouse.snd_action[ num ]);
    
    if private.zz_dollhouse.item_names[item] == "gun" then
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_we_shot");
    elseif private.zz_dollhouse.item_names[item] == "axe" then
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_we_down");
    end;
    
    ObjMultiSet( { {"anm_dollhouse_enemy_"..num,  { frame = 0, animfunc = private.zz_dollhouse.anim_names[num][2], playing = 1, endtrig = anm_hands }},
                   {"anm_dollhouse_hero", { frame = 0, animfunc = "func_player_use_"..private.zz_dollhouse.item_names[item], playing = 1, endtrig = "" }},
                   {"anm_dollhouse_hero_item", { alp = 0 }} } );
    
  end;
                 
  local get_item_2 = function ()
    
    ObjSet("anm_dollhouse_hero", { frame = 0, animfunc = "func_player_get_object", playing = 1, endtrig = action });
    
    local name = private.zz_dollhouse.item_names[item];
    if name == "axe" then
      name = "pickaxe";
    end;
    ObjSet("anm_dollhouse_hero_item",  { animfunc = "func_player_get_"..name });
    
    ObjAnimate("spr_dollhouse_game_item_"..item, "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 1,   0.5, 0, 0 });
    ObjAnimate("anm_dollhouse_hero_item", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 0,   0.5, 0, 1 });
    
  end;
  
  local get_item = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_mechanism_takes_stuff");
    
    ObjAttach("spr_dollhouse_game_item_"..item, "obj_dollhouse_item");
    --ObjSet("anm_dollhouse_mechanism",  { playing = 1, endtrig = get_item_2 });
    ObjMultiSet( { {"anm_dollhouse_mechanism",  { playing = 1 }},
                   {"tmr_dollhouse_timer", { time = 1.5, playing = 1, endtrig = get_item_2 }} } );
    
  end;
                 
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_figure_goes");
 
  for i = num, 3, 1 do
   
    if i == num then
      ObjSet("anm_dollhouse_enemy_"..i,  { frame = 0, animfunc = private.zz_dollhouse.anim_names[i][1][num], playing = 1, endtrig = get_item });
    else 
      ObjSet("anm_dollhouse_enemy_"..i,  { frame = 0, animfunc = private.zz_dollhouse.anim_names[i][1][num], playing = 1, endtrig = "" });
    end;
   
  end; 
  
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.SceneRset( num )
  
  if num > 1 then
  
    local anm_2 = function ()
    
      for i = 1, 3, 1 do
        
        if private.zz_dollhouse.state[ i ] > 0 then
          ObjMultiSet( { {"anm_dollhouse_plate_"..i,  { frame = 0, animfunc = "func_plate_"..i }},
                         {"spr_dollhouse_game_item_"..private.zz_dollhouse.state[ i ].."_sh", { alp = 0 }},
                         {"spr_dollhouse_game_item_"..private.zz_dollhouse.state[ i ], { alp = 1 }} } );
          ObjAttach("spr_dollhouse_game_item_"..private.zz_dollhouse.state[ i ], "obj_dollhouse_item_"..i);
        end;
        
        ObjAnimate("anm_dollhouse_plate_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        
      end;
      
    end;
    
    ObjAnimate("anm_dollhouse_plates_next", "alp", 0, 0, anm_2, { 0, 0, 1,   0.3, 0, 0 });
    
  else 
    
    ObjAttach("spr_dollhouse_game_item_"..private.zz_dollhouse.state[ 1 ], "obj_dollhouse_item_1");
    ObjAnimate("spr_dollhouse_game_item_"..private.zz_dollhouse.state[ 1 ], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  private.zz_dollhouse.SceneRsetEnd( num );
  
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.SceneRsetEnd( stage )
  
  if stage == 3 then
    private.zz_dollhouse.SceneReset_3();
  elseif stage == 2 then
    private.zz_dollhouse.SceneReset_2();
  else 
    private.zz_dollhouse.SceneReset_1();
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.SceneReset_1()
  
  private.zz_dollhouse.old_lever = false;
  local count = 0;
  
  local anm_2 = function ()
    
    count = count + 1;
    if count == 3 then
      
      count = 0;
      private.zz_dollhouse.AnimLever();
      
    end;
    
  end;
 
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_figure_goes");
  
  ObjMultiSet( { {"anm_dollhouse_enemy_1",  { frame = 0, animfunc = "func_soldier_move_4", playing = 1, endtrig = anm_2 }},
                 {"anm_dollhouse_enemy_2",  { frame = 0, animfunc = "func_robot_move_6", playing = 1, endtrig = anm_2 }},
                 {"anm_dollhouse_enemy_3",  { frame = 0, animfunc = "func_doll_move_7", playing = 1, endtrig = anm_2 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.SceneReset_2()
  
  private.zz_dollhouse.old_lever = false;
  local count = 0;
  
  local anm_3 = function ()
    
    count = count + 1;
    if count == 3 then
      
      count = 0;
      private.zz_dollhouse.AnimLever();
      
    end;
    
  end;
  
  local anm_2 = function ()
    
    count = count + 1;
    if count == 3 then
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_figure_goes");
      count = 0;
      
      ObjMultiSet( { {"anm_dollhouse_enemy_1",  { frame = 0, animfunc = "func_soldier_move_4", playing = 1, endtrig = anm_3 }},
                     {"anm_dollhouse_enemy_2",  { frame = 0, animfunc = "func_robot_move_6", playing = 1, endtrig = anm_3 }},
                     {"anm_dollhouse_enemy_3",  { frame = 0, animfunc = "func_doll_move_7", playing = 1, endtrig = anm_3 }} } );
      
    end;
    
  end;
                 
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_figure_goes");
  
  ObjMultiSet( { {"anm_dollhouse_enemy_1",  { frame = 0, animfunc = "func_soldier_move_3", playing = 1, endtrig = anm_2 }},
                 {"anm_dollhouse_enemy_2",  { frame = 0, animfunc = "func_robot_move_5", playing = 1, endtrig = anm_2 }},
                 {"anm_dollhouse_enemy_3",  { frame = 0, animfunc = "func_doll_move_6", playing = 1, endtrig = anm_2 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.SceneReset_3()
  
  private.zz_dollhouse.old_lever = false;
  local count = 0;
  
  local anm_4 = function ()
    
    count = count + 1;
    if count == 3 then
      
      count = 0;
      private.zz_dollhouse.AnimLever();
      
    end;
    
  end;
  
  local anm_3 = function ()
    
    count = count + 1;
    if count == 3 then
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_figure_goes");
      
      count = 0;
      
      ObjMultiSet( { {"anm_dollhouse_enemy_1",  { frame = 0, animfunc = "func_soldier_move_4", playing = 1, endtrig = anm_4 }},
                     {"anm_dollhouse_enemy_2",  { frame = 0, animfunc = "func_robot_move_6", playing = 1, endtrig = anm_4 }},
                     {"anm_dollhouse_enemy_3",  { frame = 0, animfunc = "func_doll_move_7", playing = 1, endtrig = anm_4 }} } );
      
    end;
    
  end;
  
  local anm_2 = function ()
    
    count = count + 1;
    if count == 2 then
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_figure_goes");
      
      count = 0;
      
      ObjMultiSet( { {"anm_dollhouse_enemy_1",  { frame = 0, animfunc = "func_soldier_move_3", playing = 1, endtrig = anm_3 }},
                     {"anm_dollhouse_enemy_2",  { frame = 0, animfunc = "func_robot_move_5", playing = 1, endtrig = anm_3 }},
                     {"anm_dollhouse_enemy_3",  { frame = 0, animfunc = "func_doll_move_6", playing = 1, endtrig = anm_3 }} } );
      
    end;
    
  end;
  
  ObjMultiSet( { {"anm_dollhouse_enemy_3",  { frame = 0, animfunc = "func_doll_move_5", playing = 1, endtrig = anm_2 }},
                 {"anm_dollhouse_enemy_2",  { frame = 0, animfunc = "func_robot_move_4", playing = 1, endtrig = anm_2 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 3, 1 do
    
    if private.zz_dollhouse.state[ i ] ~= private.zz_dollhouse.win_state[ i ] then
      win_flag = false;
      break;
    end;
    
  end;
  
  return win_flag;
  
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.WinAnim()
  
  if private.zz_dollhouse.state[ 4 ] == 1 then
    
    cmn.Lock( 1 );
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_figure_goes");
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("dollhouse");
    
    local anm_win = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_dolls_shield_drops");
      
      ObjDelete("anm_dollhouse_mechanism");

      ObjMultiSet( { {"anm_dollhouse_heart_get",  { alp = 1, playing = 1, endtrig = private.zz_dollhouse.Win }},
                     {"anm_dollhouse_plates_next",  { frame = 0, animfunc = "func_plate_4_out", playing = 0, endtrig = "" }} } );
      
    end;
    
    cmn.Lock( 1 );

    ObjSet("anm_dollhouse_hero",  { frame = 0, animfunc = "func_player_out", playing = 1, endtrig = anm_win });
    --ObjMultiSet( { {"anm_dollhouse_hero",  { frame = 0, animfunc = "func_player_out", playing = 1, endtrig = anm_win }},
    --               {"anm_dollhouse_plates_next",  { frame = 0, animfunc = "func_plate_4_out", playing = 0, endtrig = "" }} } );
    
    
  else
    cmn.Lock(0);
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_dollhouse.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_dollhouse" );
  cmn.CallEventHandler( "win_dollhouse" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_dollhouse" ].skip == 0 and ng_global.noskipgames[ "win_dollhouse" ] == nil then

    ng_global.noskipgames[ "win_dollhouse" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
--**************************************************************************************************************