-- name=menu
--*********************************************************************************************************************
function public.Start( param )

  interface.WidgetAdd( InterfaceWidget_Window );
  interface.WidgetAdd( InterfaceWidget_Pause, 666 );
  interface.WidgetAdd( InterfaceWidget_DialogVideo );
  interface.WidgetAdd( InterfaceWidget_Effects );
  
  if IsCollectorsEdition() or IsSurveyEdition() then
  
    interface.WidgetAdd( InterfaceWidget_BtnHint, 4  );
    interface.WidgetAdd( InterfaceWidget_BtnInfo, 6 );
    interface.WidgetAdd( InterfaceWidget_BtnReset, 7 );
    
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, false );
    
    interface.WidgetAdd( InterfaceWidget_TaskHeader, 1 );
    interface.WidgetAdd( InterfaceWidget_TaskPanel, 3, "assets/interface/int_taskpanel");
    
    interface.WidgetAdd( InterfaceWidget_ItemPanel, 3, "assets/interface/int_itempanel" );
    interface.WidgetAdd( InterfaceWidget_Popup, 250 );
    
    interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
    interface.WidgetAdd( InterfaceWidget_Dialog );
    
    
    interface.WidgetAdd( InterfaceWidget_BtnGuide, 6 );
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,   false );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,   false, false );
    
    interface_impl.SecretroomAdd();
    
    interface_impl.BonusAdd();
    
  end;

  local modules = 
  {
    "rm_intro"
    ,"rm_obb"
    ,"rm_menu"
    ,"rm_extra"
    ,"rm_achievements"
    ,"rm_collectable"
    ,"rm_secretroom"
    ,"rm_credits"
    ,"rm_moregames"
    ,"rm_sequel"
    ,"rm_unlock"
  };
  
  if IsCollectorsEdition() then
    
    game.progress_names =
    {
      
      "win_balcony"
      ,"clk_hosymbol1"
      ,"clk_hosymbol2"
      ,"clk_hosymbol3"
      ,"clk_hosymbol4"
      ,"win_crypt"
      ,"use_holvl1scissors"
      ,"use_holvl1snowflake"
      ,"win_toys"
      
      ,"opn_returning"
      ,"win_returning"
      ,"win_cobweb"
      ,"opn_mind"
      ,"win_mind"
      
      ,"win_stars"
      ,"win_insiderescuecapsule"
      ,"use_holvl2wrench"
      ,"clk_holvl2glove"
      ,"clk_holvl2disk"
      ,"win_onarmortable"
      
      ,"win_ventilation"
      ,"opn_incapsule"
      ,"win_incapsule"
      ,"win_breakthrough"
      
      ,"win_apartment3"
      ,"win_destroyedrobot"
      ,"win_installation"
      
      ,"win_tosecuritypanel"
      ,"win_onmuseumdoors"
      ,"win_device"
      ,"win_aion"
      
      ,"use_holvl4crystal"
      ,"use_holvl4candle"
      ,"use_holvl4cup"
      ,"use_holvl4feather"
      ,"use_holvl4amulet1"
      ,"use_holvl4amulet2"
      ,"use_holvl4amulet3"
      ,"use_holvl4amulet4"
      ,"win_hiddenroom"
      ,"win_inmirror"
      ,"use_holvl4opener"
      ,"use_holvl4laces"
      ,"use_holvl4matches"
      ,"use_holvl4net"
      ,"win_intent"
      ,"win_ontvset"
      ,"win_inboxes"
      
      ,"win_ingamingmachine"
      ,"win_nightmare"
      ,"win_memories"
      
      ,"win_secretroom"
      
    };

    game.relations = {};
    
  end;
  
  if IsDemoEdition() and IsCollectorsEdition() then

    game.progress_names =
    {
       
      "win_balcony"
      ,"clk_hosymbol1"
      ,"clk_hosymbol2"
      ,"clk_hosymbol3"
      ,"clk_hosymbol4"
      ,"win_crypt"
      ,"use_holvl1scissors"
      ,"use_holvl1snowflake"
      ,"win_toys"
      
      ,"opn_returning"
      ,"win_returning"
      ,"win_cobweb"
      ,"opn_mind"
      ,"win_mind"
      
      ,"win_secretroom"
      
    };

  end;

  if  not IsCollectorsEdition() and not IsSurveyEdition() then

    modules = 
    {
      "rm_intro"
      ,"rm_obb"
      ,"rm_menu"
      ,"rm_credits"
      ,"rm_moregames"
    };

  else 

    interface_impl.PopupAchievementAdd();

    if IsSurveyEdition() then

      modules = 
      {
        "rm_intro"
        ,"rm_obb"
        ,"rm_menu"
        --,"rm_achievements"
        --,"rm_collectable"
        ,"rm_credits"
        ,"rm_moregames"
      };

    end;

  end;

  common.MenuLoad( param, modules );
  common.ProjectSet();

end;
--*********************************************************************************************************************