-- name=rm_collectable
--******************************************************************************************
function public.Init()

  public.rm_collectable_state = {
    0, 0, 0,
    0, 0, 0,
    0, 0, 0,
    0, 0, 0
  };

end;
--******************************************************************************************
function public.PreOpen()
  
  interface_impl.DialogHintHide();

  cmn.StopAllEnv();
  cmn.PlayAudio( "env", "assets/levels/common/audio/aud_rm_collectibles_env" );
  --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_surf8_17_mus", 1);
  -------------------------------------------------------------------------
  if  ( not cmn.is_inmenunow ) then

    interface.WidgetSetInput( InterfaceWidget_Achiev, false );

    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );
    interface.WidgetSetInput( InterfaceWidget_ButtonDiary,   false );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, true );
    interface.WidgetSetVisible( InterfaceWidget_ButtonDiary,   false, true );

    ObjSet( "int_inventory_impl",        { input = 0 } );
    --ObjSet( "int_button_hint",      { input = 0, alp = 0 } );
    --ObjSet( "obj_int_button_guide", { input = 0, alp = 0 } );
    --ObjSet( "int_button_map",       { input = 0, alp = 0 } );
    --ObjSet( "int_button_menu",      { input = 0, alp = 0 } );

  end;
  -------------------------------------------------------------------------
  public.rm_collectable_state = {
    0, 0, 0,
    0, 0, 0,
    0, 0, 0,
    0, 0, 0
  };
  
  local sfx_flag = false;

  for i = 1, #ng_global.collectable, 1 do

    public.rm_collectable_state[ ng_global.collectable[i].num ] = 1;

    if ng_global.collectable[i].first_appearance then

      ng_global.collectable[i].first_appearance = false;
      
      sfx_flag = true;

      ObjSet("fx_collectable_"..ng_global.collectable[i].num, { playing = true, active = true });

    end;

  end;
  
  if sfx_flag then
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_collectibles_appear_character" );
  end;

  for i = 1, #public.rm_collectable_state, 1 do
    
    ObjStopAnimate("spr_collectable_"..i, "pos_y");
    ObjSet("spr_collectable_"..i,  { pos_y = 0 });
    
    if ( public.rm_collectable_state[i] == 0 ) then
      ObjMultiSet( { {"fx_collectable_"..i.."_light", { active = 0, visible = 0 }},
                     {"spr_collectable_"..i, { alp = 0 }} } );
    else 
      private.AnimatePicFly( i );
      ObjMultiSet( { {"fx_collectable_"..i.."_light", { active = 1, visible = 1 }},
                     {"spr_collectable_"..i, { alp = 1 }} } );
    end;
                   
  end;

end;
--******************************************************************************************
function public.Open()
  
  common_impl.go_acievements = false;

end;
--******************************************************************************************
function public.PreClose()

  interface_impl.PopupAchievementHide();

  cmn.StopAllEnv();
  --cmn.StopAllMus();

  if  ( not cmn.is_inmenunow ) then

    interface.WidgetSetVisible( InterfaceWidget_Inventory, true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   true, true );
    interface.WidgetSetVisible( InterfaceWidget_ButtonDiary,   true, true );

  end;

end;
--******************************************************************************************
function public.Close()
  
  common_impl.go_acievements = false;

  --костыль - чтобы снимался блок в комнате из который мы вошли при открытом сложном предмете
  if  ( not cmn.is_inmenunow ) then

    cmn.Lock( 0 );
    
    interface.WidgetSetInput( InterfaceWidget_Achiev,    true );
    interface.WidgetSetInput( InterfaceWidget_Bonus,     true );

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  true );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    true );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   true );
    interface.WidgetSetInput( InterfaceWidget_ButtonDiary,  true );

    ObjSet("int_inventory_impl", {input = 1});

  end;

end;
--******************************************************************************************
--port.
function public.Hide()
  public.Exit(); --  public. or private.
end;
--******************************************************************************************
--выход из комнаты
function public.Exit()

  if cmn.is_inmenunow then
    room.Switch("rm_extra");
    --room.Switch("rm_menu");
  else
    room.Switch(common.GetCurrentRoom());
  end;

end;
--******************************************************************************************
function public.MouseEnterBack()

  local alp = ObjGet( "spr_collectable_exit_focus" ).alp;
  ObjAnimate( "spr_collectable_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,1});
  SetCursor(CURSOR_HAND);

end;

function public.MouseLeaveBack()

  local alp = ObjGet( "spr_collectable_exit_focus" ).alp;
  ObjAnimate( "spr_collectable_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,0});
  SetCursor(CURSOR_DEFAULT);

end;
--******************************************************************************************
--вывод попапа и подсветка
function public.AreaEnter( num, curs )   --num - номер collectable, curs - состояние курсора мыши (1-в области, 0-вне области)

  if curs == 1 then

    SetCursor(CURSOR_QUESTION);
    
    local loc_table = { {
      str_1 = "ce_col_"..num, str_2 = "",
      color_r_1 = 1, color_g_1 = 1, color_b_1 = 1,
      color_r_2 = 1, color_g_2 = 1, color_b_2 = 1
    } };
  
    if public.rm_collectable_state[num] == 1 then

      loc_table = { {
        str_1 = "ce_col_"..num, str_2 = "ce_col_"..num.."_text",
        color_r_1 = 1, color_g_1 = 1, color_b_1 = 1,
        color_r_2 = 1, color_g_2 = 1, color_b_2 = 1
      } };
      
    end;

    interface_impl.PopupAchievementShow( loc_table );

  else
    
    interface_impl.PopupAchievementHide();
    SetCursor(CURSOR_DEFAULT);

  end;

  if public.rm_collectable_state[num] == 0 then

    ObjAnimate("spr_collectable_"..num.."_glow", "alp", 0, 0, "", {0, 0, ObjGet("spr_collectable_"..num.."_glow").alp,   1.2, 0, curs * 0.5});

  end;

end;
-----------------------------------------------------------------------------------
function private.AnimatePicFly( num )
  
  local range_y = math.random(4, 8);
  local dir_y = math.random(1, 2);
  if dir_y == 2 then
    dir_y = -1;
  end;
  
  ObjAnimate("spr_collectable_"..num, "pos_y", 1, 0, "", { 
    0, 2, 0,     
    1.5, 2, range_y*dir_y,    
    4.5, 3, -range_y*dir_y,    
    6, 1, 0 
  });
  
end;
--******************************************************************************************