-- name=rm_menu
--******************************************************************************************
function public.Init()

  ObjSet("menu_but_play", 
  {
    event_mdown = private.PlayDown
  });
 
  private.but_play_pos = { 790, 672 };
  private.but_play_shown = false;
  public.playing_main_theme = false;
  
  private.last_virus = 1;
  
  ObjSet("menu_but_options", { event_mdown = private.OptionsDown });
  ObjSet("menu_but_credits", { event_mdown = private.CreditsDown } );
  ObjSet("menu_but_profile", { event_mdown = private.ProfileDown } );
  ObjSet("menu_but_moregames", { event_mdown = private.MoreGamesDown } );
  ObjSet("menu_but_forum", { event_mdown = private.ForumDown } );
  ObjSet("menu_but_sequel", { event_mdown = private.SneakPeakDown });
  ObjSet("menu_but_save50", { event_mdown = private.Save50Down });
  ObjSet("menu_but_support", { event_mdown = function() common.dialog.options.SupportDown(); end });
  ObjSet("menu_but_terms", { event_mdown = function() common.dialog.options.TermsDown(); end });
  ObjSet("menu_but_privacy", { event_mdown = function() common.dialog.options.PolicyDown() end});
  ObjSet("menu_but_credits", { event_mdown = function() common.MenuCredits("credits"); end});
  ObjSet("menu_but_unlock", { event_mdown = private.UnlockDown });
  ObjSet("spr_menu_but_back_button", { event_mdown = function() public.closeGearSubMenu(); end });
  ObjSet("menu_but_gear", { event_mdown = function() public.openGearSubMenu(); end });
  ObjSet("menu_but_extra", { event_mdown = private.ExtraDown } );
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  
  if GetPlatform() == "android" then
    ObjSet("menu_but_forum",{ alp = 0, input = false, visible = false });  
    ObjSet("menu_but_credits",{ pos_x = 512 });  
  end;
  
end;
--******************************************************************************************
function private.ButMouseEnter(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1.1, scale_y = 1.1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1.1, scale_y = 1.1 }); 
  end;
end;
--******************************************************************************************
function private.ButMouseLeave(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1, scale_y = 1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1, scale_y = 1 }); 
  end;
end;
--******************************************************************************************
local wait_gear;
public.sub_menu_active = false;
--******************************************************************************************
function public.closeGearSubMenu()
  common.button_click_sound();
  private.ButMouseEnter("close_gear");
  port.TapDownTimer(0.5,
    function() 
    public.sub_menu_active = false;
    ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
    private.ButMouseLeave("close_gear");
    end
  );
end;
--******************************************************************************************
function public.openGearSubMenu()
  common.button_click_sound();
  private.ButMouseEnter("gear");
  port.TapDownTimer(0.5,
    function() 
      public.sub_menu_active = true;
      ObjSet("menu_port_hub_sub_menu", { active = true, visible = true, input = true, alp = true });
      private.ButMouseLeave("gear");
    end
  );
  
end;
--******************************************************************************************
function public.gearOverAngle()
  
  local current_ang = ObjGet("spr_menu_but_gear").ang;
  
  if (wait_gear) then
    
    ObjSet( "tmr_gear", { time = 0.5, playing = 1, endtrig = function() wait_gear = false; public.gearOverAngle(); end  } );
  else
    wait_gear = true;
    local end_ang = current_ang + ((360/8)*3.14)/180;
    ObjAnimate( "spr_menu_but_gear", "ang", 0, 0, function() public.gearOverAngle(); end , {0,0,current_ang, 1,0,end_ang} ); 
  end;
  
  
end;
--******************************************************************************************
function public.PreOpen()
  
  if IsCollectorsEdition() then
    ObjMultiSet( { {"menu_but_extra", { active = true, visible = true, input = true }},
                   {"spr_menu_logo_ce", { alp = 1 }} } );
  else
    ObjMultiSet( { {"menu_but_extra", { active = false, visible = false, input = false }},
                   {"menu_but_strguide", { active = false, visible = false, input = false }},
                   {"spr_menu_logo_ce", { alp = 0 }} } );
                   
    if not IsSurveyEdition() then
      
      --убираем иконки CE из хелпа
      ObjMultiSet( { {"obj_dialog_help_common", { pos_y = 60 }},
                     {"obj_dialog_help_ce", { visible = false }} } );
                     
    else 
     
      ObjMultiSet( { {"obj_dialog_help_counter", { visible = false }},
                     {"obj_dialog_help_flower", { visible = false }},
                     {"obj_dialog_help_common", { pos_y = 20 }},
                     {"obj_dialog_help_ce", { pos_y = 50 }} } );

    end;

  end;

  public.SetProfileText( GetCurrentProfile() );
  public.ButtonSetPos();
  
  private.VirusAdd();
  
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  wait_gear = false;
  public.gearOverAngle();  
  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      iOS_LogEvents(2);
        
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
      ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
      ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
      ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
      ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;

    if port.isTablet() == 0 then
        ObjSet("tmr_menu_performance", {endtrig = function() private.PerformanceWarning(); end, time = 2, playing = 1 });
    end;
      
    

    if iOS_IsiSplashPressed() == 1 then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsRated() == 1 then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsBought() == 1 then
        ObjSet("menu_but_unlock", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });
    end;
  end;
      
end;
--******************************************************************************************
function public.Open()

  --DbgTrace( "***rm_menu::public.Open" );

  ng_global.currentprogress = "std";
  
  --private.set_anim_car( 1 );

  cmn.StopAllEnv("assets/levels/common/audio/aud_main_menu_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_main_menu_env");

  --if (IsCollectorsEdition() or IsSurveyEdition()) and rm_achievements.in_rm_acievements then
  --  rm_achievements.in_rm_acievements = false;
  --else
  --  cmn.PlayAudio( "mus", "assets/levels/common/audio/aud_surf8_main_mus", 1 );
  --end;

  if not public.playing_main_theme then
    public.playing_main_theme = true;
    cmn.PlayAudio( "mus", "assets/levels/common/audio/aud_main_menu_mus", 1 );
  end;

  if ng_global.progress
  and ng_global.progress[ "std" ].common.gamewin == true
  and ng_global.progress[ "ext" ].common.gamewin == false
  and not ng_global.gamewin_dialog
  and IsCollectorsEdition() then

    cmn.DialogWindowShow( "common", "bonus_level" );

    ng_global.gamewin_dialog = true;

  end;

  if ng_global.progress
  and ng_global.progress[ "ext" ].common.gamewin == true
  and not ng_global.gamewin_dialog_ext
  and IsCollectorsEdition() then

    cmn.DialogWindowShow( "common", "bonus_level_win" );

    ng_global.gamewin_dialog_ext = true;

  end;
  
  if IsCollectorsEdition() or IsSurveyEdition() then
    common_impl.CreateMenuProgress( "secret" );
  end;
  

  ----------------------

  --[[
  local autobot_start_lvl = ng.GetConfigInfo("autobot.auto_start_lvl");
  local current_profile = GetCurrentProfile();

  if IsCheater() and _G[ "cheater" ]
  and autobot_start_lvl ~= "" and autobot_start_lvl ~= "0" then

    if not ng_global.progress[ "std" ].common.gamestart
    and not ng_global.progress[ "ext" ].common.gamestart then

      DbgTrace( "1 autobot go lvl"..autobot_start_lvl );

      if     ( current_profile == "cheater" ) or ( current_profile == "CHEATER" ) then
        ne.dbg.FireInputEvent( 0, 0, 0, (111 + autobot_start_lvl), (111 + autobot_start_lvl) ); --[Fx]
      elseif ( current_profile == "ng_noprofiles" ) then
        ObjSet("tmr_menu_autobot_game_start", { time = 2, endtrig = function () private.AutobotGameStart(autobot_start_lvl) end, playing = true });
      end;

    elseif IsCollectorsEdition() and not IsSurveyEdition() and not IsDemoEdition()
    and ng_global.progress[ "std" ].common.gamestart
    and not ng_global.progress[ "ext" ].common.gamestart then

      DbgTrace( "2 autobot go lvl4" );

      ObjSet( "tmr_menu_autobot_game_start", { time = 1, playing = true, endtrig =
        function ()
          ne.dbg.FireInputEvent( 0, 0, 0, 115, 115 ); --[F4]
        end
      } );

    else

      DbgTrace( "АВТОБОТ: игра пройдена" );
      Quit();

    end;

  end;
  ]]
  ----------------------

end;
--***ios fix***************************************************************************************
function public.PreClose()
  ObjStopAnimate( "spr_menu_but_gear", "ang");
  ObjSet( "tmr_gear", { playing = 0 }); 
end;
--******************************************************************************************
function private.AutobotGameStart(autobot_start_lvl)

  --DbgTrace( "***rm_menu::private.AutobotGameStart: autobot_start_lvl == "..autobot_start_lvl );

  local autobot_text = "cheater";
  local text_codepoint;

  for i = 1, 7, 1 do
    text_codepoint = utf8.codepoint( ne.utf8.Sub( autobot_text, i ) );
    --DbgTrace( text_codepoint );
    ne.dbg.FireInputEvent( 0, 0, 1, text_codepoint, text_codepoint );
  end;

  ne.dbg.FireInputEvent( 0, 0, 0, 13, 13 ); --[Enter]

  ObjSet( "tmr_menu_autobot_game_start", { time = 1, playing = true, endtrig =
    function ()
      ne.dbg.FireInputEvent( 0, 0, 0, (111 + autobot_start_lvl), (111 + autobot_start_lvl) ); --[Fx]
    end
  } );

end;
--******************************************************************************************
function private.PerformanceWarning()
   if tostring(GetPlatform()) == "ios" then
    iOS_PerformanceWarning();
  else
    DbgTrace("SetPerformanceMode(1)");
    SetPerformanceMode(1);
  end;
end;
--******************************************************************************************
function private.Save50Timer()
  if iOS_IsiSplashPressed() == 1 then
    ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
  end;
end;
--******************************************************************************************
function private.SneakpeakTimer()
  if iOS_IsRated() == 1 then
    ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
  end;
end;
-------------------------ios----------------------------------------
function private.UnlockTimer()
  if iOS_IsBought() == 1 then
    ObjSet("menu_but_unlock", { input = 0, visible = 0, active = 0, alp = 0 });
  else
    ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });  
  end;
end;
  
--******************************************************************************************
--******************************************************************************************
function public.SetProfileText ( name )
  
  --local obj = "txt_menu_but_profile";
  --local profile_name = "";
  --if  ( name ~= "ng_noprofiles" )
  --and ( name ~= "ng_error" )
  --then
  --profile_name = name;
  --end;
  --ObjSet( obj, { text = profile_name } );

end;
--******************************************************************************************
function private.PlayDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");
  private.ButMouseEnter("play");
  port.TapDownTimer(0.5,
    function()
      private.ButMouseLeave("play");
      common.MenuPlay();
      end
    ); 
  
end;
--******************************************************************************************
function private.OptionsDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");
  common.MenuOptions();
end;
--******************************************************************************************
function private.CreditsDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");
  common.MenuCredits();
end;
--******************************************************************************************
function private.QuitDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");
  

end;
--******************************************************************************************
function private.ExtraDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");
   private.ButMouseEnter("extra");
  port.TapDownTimer(0.5,
    function()
      private.ButMouseLeave("extra");
      if port.isPortable() == 1 then
        if iOS_IsBought() == 1 then
          common.MenuExtra();
        else
          common.MenuUnlock();
        end;
      else
        common.MenuExtra();
      end;
    end
    ); 
   
end;
--******************************************************************************************
function private.AchDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");
  common_impl.go_acievements = true;
  common.MenuAchievements();
end;
--******************************************************************************************
function private.CollectDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");
  cmn.GotoRoom( "rm_collectable" );
end;
--******************************************************************************************
function private.StrguideDown()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");

  if IsCollectorsEdition() then
    interface.StrategyGuideShow();
  else
    local url = GetUrl();
    OpenBrowser( url );
  end;

end;
--******************************************************************************************
function private.MoreGamesDown()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");

  iOS_MoreGamesPressed();
  --cmn.GotoRoom( "rm_moregames" );

end;

--*************************************ios*****************************************************
function private.Save50Down()
  common.button_click_sound();
  common.MenuSave50();
end;
--*************************************ios*****************************************************
function private.UnlockDown()
  common.button_click_sound();
  private.ButMouseEnter("unlock");
  port.TapDownTimer(0.5,
    function()
      common.MenuUnlock();
      private.ButMouseLeave("unlock");
    end
   );
end;
--*************************************ios*****************************************************
function private.SneakPeakDown()
  common.button_click_sound();
  common.MenuSneakPeak();
end;
--*************************************ios*****************************************************
function private.ForumDown()
  common.button_click_sound();
  iOS_LaunchForum();
end;
--******************************************************************************************
function private.ProfileDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");
  common.MenuProfile();
end;
--******************************************************************************************
function private.ShopDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");
  common.MenuShop();
end;
--******************************************************************************************
function private.HelpDown()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_click_1");
  common.DialogWindowShow("help", nil, true);
end;
--******************************************************************************************
function private.ButtonMouseEnter( but_name )

  SetCursor( CURSOR_HAND );
  
  local obj = "spr_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( common_impl.animtime * ( 1 - alp ) );
  
  if tme > 0.2 then
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_move_"..math.random(1, 3));
  end;
  
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp,  tme, 0, 1 } );
  --ObjAnimate( obj.."_back", "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;
--******************************************************************************************
function private.ButtonMouseLeave( but_name )

  SetCursor( CURSOR_DEFAULT );
  local obj = "spr_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
  --ObjAnimate( obj.."_back", "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
function public.ButtonSetPos()
  local offwidth = 0.5 * ( GetAppWidth() - 1024 );
  ObjSet( "menu_objects_left",  { pos_x = ( 512 - offwidth ) } );
  ObjSet( "menu_objects_right", { pos_x = ( 512 + offwidth ) } );
end;
--******************************************************************************************
function private.VirusAdd()
  
  local tme = math.random(10, 20);
  local virus_num = private.last_virus + 1;
  local virus_total = 2;
  
  if virus_num > virus_total then
    virus_num = 1;
  end;
  
  private.last_virus = virus_num;
  
  local show_virus = function ()
    
    ObjMultiSet( { {"tmr_menu_timer", { time = 3.5, playing = 1, endtrig = private.VirusAdd }},
                   {"fx_menu_add_virus_"..virus_num, { active = 1, visible = 1 }} } );
                   
    ObjAnimate("fx_menu_add_virus_"..virus_num, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1,   3, 0, 1,   3.5, 0, 0 });
    ObjAnimate("fx_menu_add", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0,   3, 0, 0,   3.5, 0, 1 });
    
  end;
                 
  for i = 1, virus_total, 1 do
    ObjSet("fx_menu_add_virus_"..i,  { active = 0, visible = 0, alp = 0 });
  end;

  ObjMultiSet( { {"tmr_menu_timer", { time = tme, playing = 1, endtrig = show_virus }},
                 {"fx_menu_add", { active = 1, visible = 1 }}} );
  
end;
--------------------------------------------------------------------------------------------
function private.set_anim_car( side )
  
  local change_state = function ()
  
    local new_side = 2;
    if side == 2 then
      new_side = 1;
    end;
  
    ObjSet("anm_menu_car_"..side,  { alp = 0 });
    private.set_anim_car( new_side );
  
  end;
  
  local anim_car = function ()
  
    if side == 1 then
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_machine_right");
    else 
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_machine_left");
    end;
    
    ObjSet("anm_menu_car_"..side,  { alp = 1, playing = 1, endtrig = change_state });
  
  end;
  
  local delay = math.random(10, 35);
  ObjSet("tmr_menu_anim_car",  { time = delay, playing = 1, endtrig = anim_car });
  
end;
--******************************************************************************************