-- name=rm_moregames
--******************************************************************************************
function public.Init()

  private.first_image = 1;

end;
--******************************************************************************************
function public.PreOpen()

  --cmn.StopAllEnv();
  --cmn.PlayAudio( "mus", "assets/levels/common/audio/aud_achivement_mus", 1 );

  --for i = 1, 8, 1 do
  --  ObjStopAnimate( "spr_moregames_surface_"..i, 6 );
  --  ObjSet( "spr_moregames_surface_"..i, { scale_x = 1, scale_y = 1 } );
  --end;

  if IsCollectorsEdition() then

    ObjSet( "spr_moregames_ce", { alp = 1 } );

    for i = 1, 9, 1 do
      ObjSet( "spr_moregames_surface_"..i.."_text_ce", { alp = 1 } );
    end;

  else

    ObjSet( "spr_moregames_ce", { alp = 0 } );

    for i = 1, 9, 1 do
      ObjSet( "spr_moregames_surface_"..i.."_text_ce", { alp = 0 } );
    end;

  end;

end;
--******************************************************************************************
function public.Open()

end;
--******************************************************************************************
function public.PreClose()

  --cmn.StopAllMus();

end;
--******************************************************************************************
function public.Close()

end;
--******************************************************************************************
--выход из комнаты
function public.Exit()

  room.Switch("rm_menu");

end;
--******************************************************************************************
function public.MouseEnterBack()

  local alp = ObjGet( "spr_moregames_exit_focus" ).alp;
  ObjAnimate( "spr_moregames_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,1});
  SetCursor(CURSOR_HAND);

end;

function public.MouseLeaveBack()

  local alp = ObjGet( "spr_moregames_exit_focus" ).alp;
  ObjAnimate( "spr_moregames_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,0});
  SetCursor(CURSOR_DEFAULT);

end;
--******************************************************************************************
function public.ClickImage( num )

  local url_os = "_pc";
  if GetPlatform() == "mac" then
    url_os = "_mac";
  end;

  local url_game_ver = "_se";
  if IsCollectorsEdition() then
    url_game_ver = "_ce";
  end;

  --DbgTrace( "str_moregames_img_"..num..url_os..url_game_ver );

  local url = StringGet( "str_moregames_img_"..num..url_os..url_game_ver );

  OpenBrowser( url );

end;
--******************************************************************************************
function public.MEnterImage( num )

  SetCursor( CURSOR_HAND );
  --[[
  local obj = "spr_moregames_surface_"..num;
  local scale = ObjGet( obj ).scale_x;

  local max_scale = 1.1;  -- max_scale > 1
  local max_tme = 0.3;
  local tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );

  --DbgTrace( "MEnterImage, obj = "..obj..", scale = "..scale..", tme = "..tme );

  ObjAnimate( obj, 6, 0, 0, "", { 0, 0, scale, scale,   tme, 0, max_scale, max_scale } );
  ]]
end;
----------------------------------------------------------------------------
function public.MLeaveImage( num )

  SetCursor( CURSOR_DEFAULT );
  --[[
  local obj = "spr_moregames_surface_"..num;
  local scale = ObjGet( obj ).scale_x;

  local max_scale = 1.1;  -- max_scale > 1
  local max_tme = 0.3;
  local tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );

  --DbgTrace( "MLeaveImage, obj = "..obj..", scale = "..scale..", tme = "..tme );

  ObjAnimate( obj, 6, 0, 0, "", { 0, 0, scale, scale,    tme, 0, 1, 1 } );
  ]]
end;
-----------------------------------------------------------------------------------
function public.BtnClick( side )

  --DbgTrace( "BtnClick "..side );

  cmn.Lock( 1 );

  local hub_name;
  local side_animfunc;
  local first_image;
  local detach_image;

  local func_after = function ()
    ObjDetach( "spr_moregames_surface_"..detach_image );
    --DbgTrace( "detach spr_moregames_surface_"..detach_image );
    cmn.Lock( 0 );
  end;

  if side == 1 then

    private.first_image = private.first_image - 1 > 0 and private.first_image - 1 or 9;

    first_image = private.first_image;
    side_animfunc = "func_forward";
    hub_name = "obj_moregames_forward_img_";

    for i = 1, 3, 1 do
      ObjAttach( "spr_moregames_surface_"..first_image, hub_name..i );
      --DbgTrace( "spr_moregames_surface_"..first_image.." -> "..hub_name..i );
      first_image = first_image + 1 < 10 and first_image + 1 or 1;
    end;

    ObjAttach( "spr_moregames_surface_"..first_image, hub_name..4 );
    --DbgTrace( "spr_moregames_surface_"..first_image.." -> "..hub_name..4 );

    detach_image = first_image;

  else

    first_image = private.first_image;
    side_animfunc = "func_backward";
    hub_name = "obj_moregames_backward_img_";
    detach_image = first_image;

    for i = 4, 2, -1 do
      ObjAttach( "spr_moregames_surface_"..first_image, hub_name..i );
      --DbgTrace( "spr_moregames_surface_"..first_image.." -> "..hub_name..i );
      first_image = first_image + 1 < 10 and first_image + 1 or 1;
    end;

    ObjAttach( "spr_moregames_surface_"..first_image, hub_name..1 );
    --DbgTrace( "spr_moregames_surface_"..first_image.." -> "..hub_name..1 );

    private.first_image = private.first_image + 1 < 10 and private.first_image + 1 or 1;

  end;

  ObjSet( "anm_moregames_surfaces", { animfunc = side_animfunc, endtrig = func_after, frame = 0, playing = true } );

  --DbgTrace( "private.first_image = "..private.first_image );

end;
-----------------------------------------------------------------------------------
function public.BtnFocus( name, inout )
  
  local obj = "spr_moregames_btn_"..name.."_glow";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );
  
end;
--****************************************************************************************