-- name=rm_secretroom
--******************************************************************************************
function public.Init()
  
  public.secretroom_enter = "menu";
  public.npc_cost = {30, 70, 130};
  
  private.player_pos = {
    {213, 482}, {285, 508}, {362, 530}, {437, 557}, {441, 506}, {444, 454}, {527, 432}, {603, 455},
    {680, 481}, {759, 505}, {755, 457}, {749, 408}, {673, 390}, {599, 367}, {521, 352}, {450, 367},
    {376, 391}, {305, 367}, {239, 352}, {231, 390}, {163, 368}, {96, 352}, {107, 309}, {119, 273},
    {129, 236}, {139, 200}, {198, 218}, {260, 235}, {322, 253}, {387, 273}, {455, 254}, {521, 236},
    {595, 254}, {663, 272}, {732, 293}, {797, 272}, {860, 253}, {921, 235}, {912, 201}, {844, 185},
    {777, 167}, {719, 185}, {657, 200}, {592, 185}, {528, 168}, {460, 151}, {399, 134}, {342, 119},
    {344, 93}, {405, 81}, {464, 93}, {527, 59}, {605, 507}, {606, 557}, {518, 530}, {277, 133},
    {222, 118}, {157, 134}, {91, 151}, {79, 185}, {68, 218}, {331, 185}, {393, 200}, {457, 218},
    {930, 272}, {940, 309}, {876, 330}, {804, 310}, {769, 108}, {710, 118}, {651, 134}, {591, 151},
    {602, 407}, {172, 330}, {790, 236}, {784, 200}, {462, 118}
  };
  
  private.board_challenges = {
    0, 0, 0, 0, 2, 4, 0, 0, 0, 4, 0, 0, 0, 1, 0, 0, 0, 4, 1, 0, 0, 0, 0, 0, 2,
    0, 0, 4, 0, 4, 2, 0, 0, 4, 2, 1, 0, 4, 0, 0, 0, 0, 4, 2, 4, 0, 0, 0, 0, 4,
    1, 0, 2, 2, 2, 4, 2, 2, 4, 2, 2, 2, 2, 2, 2, 4, 2, 2, 4, 2, 2, 2, 1, 1, 1,
    1, 1
  };
  private.board_challenges_num = {
    0, 0, 0, 0, 1, 1, 0, 0, 0, 2, 0, 0, 0, 1, 0, 0, 0, 3, 2, 0, 0, 0, 0, 0, 2,
    0, 0, 12, 0, 4, 3, 0, 0, 13, 4, 3, 0, 5, 0, 0, 0, 0, 14, 5, 6, 0, 0, 0, 0, 7,
    4, 0, 1, 1, 1, 8, 2, 2, 9, 2, 2, 3, 3, 3, 4, 10, 4, 4, 11, 5, 5, 5, 1, 2, 3,
    3, 4
  };
  private.board_locked = { 6, 18, 31, 52 }; --max unlocked spot for each area
  
  private.dead_ends = {
    {53, 54, 55, 5}, {56, 57, 58, 59, 60, 61, 25}, {62, 63, 64, 31},
    {65, 66, 67, 68, 35}, {69, 70, 71, 72, 44}
  };
  private.dead_ends_enemies = { 56, 59, 66, 69 };
  
  private.add_ways = {
    {14, 73, 8}, {19, 74, 23}, {36, 75, 76, 41}, {51, 77, 46}
  };
  
  private.start_next = 0;
  
  private.enemies_type = { 1, 2, 1, 1, 2, 3, 4, 2, 1, 4, 2, 3, 4, 1 };
  private.enemies_win = { 1, 1, 2, 3 };
  
  private.enemies_hits = {
    { {3, 4, 5, 6} }, { {4, 5, 6} }, { {5, 6}, {3, 4, 5} }, { {5, 6}, {1, 3, 5}, {2, 4, 6} }
  };

end;
--*********************************************************************************************************************
function public.Load()

--  if not ng_global.progress[ "secret" ][ "win_secretroom" ].state then
--    private.StartConditions();
--  end;
--
--  private.state = ng_global.progress[ "secret" ][ "win_secretroom" ].state;
--  private.way = ng_global.progress[ "secret" ][ "win_secretroom" ].way;
--  private.enemies = ng_global.progress[ "secret" ][ "win_secretroom" ].enemies;

end;
--******************************************************************************************
function public.PreOpen()
  
  if  ( not cmn.is_inmenunow ) then
    
    interface.WidgetSetInput( InterfaceWidget_Achiev, false );
    interface.WidgetSetInput( InterfaceWidget_Bonus,  false );

    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );
    interface.WidgetSetInput( InterfaceWidget_ButtonDiary,   false );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, true );
    interface.WidgetSetVisible( InterfaceWidget_ButtonDiary,   false, true );

    ObjSet( "int_inventory_impl",        { input = 0 } );
    --ObjSet( "int_button_hint",      { input = 0, alp = 0 } );
    --ObjSet( "obj_int_button_guide", { input = 0, alp = 0 } );
    --ObjSet( "int_button_map",       { input = 0, alp = 0 } );
    --ObjSet( "int_button_menu",      { input = 0, alp = 0 } );

    --cmn.PlayAudio( "mus", "assets/levels/common/audio/aud_surf8_main_mus", 1 );

  end;
  
  if not ng_global.progress[ "secret" ][ "win_secretroom" ] then
    ng_global.progress[ "secret" ][ "win_secretroom" ] = {};
    --DbgTrace("1")
    private.StartConditions();
  elseif not ng_global.progress[ "secret" ][ "win_secretroom" ].state then
    --DbgTrace("2")
    private.StartConditions();
  end;
  
  if ng_global.progress[ "secret" ][ "win_secretroom" ].state[1] == private.board_locked[ 4 ]
  and ng_global.secretroom.prize_unlocked[4] and ng_global.secretroom.prize_unlocked[4] == 1 then
    private.StartConditions();
  end;
  
  private.state = ng_global.progress[ "secret" ][ "win_secretroom" ].state;
  private.way = ng_global.progress[ "secret" ][ "win_secretroom" ].way;
  private.enemies = ng_global.progress[ "secret" ][ "win_secretroom" ].enemies;
  
  cmn.StopAllEnv();
  cmn.PlayAudio("env", "assets/levels/menu/rm_secretroom/audio/aud_rm_secretroom_env");
  cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_mg_returning_mus", 1);

  private.DrawScene();

end;
--******************************************************************************************
function public.Open()
  
  --if private.state[1] ~= private.board_locked[ 4 ] then
    private.CheckWin();
  --end;
  
end;
--******************************************************************************************
function public.PreClose()

  cmn.StopAllEnv();
  cmn.StopAllMus();
  
  if  ( not cmn.is_inmenunow ) then

    --cmn.StopAllMus();
  
    interface.WidgetSetVisible( InterfaceWidget_Inventory, true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   true, true );
    interface.WidgetSetVisible( InterfaceWidget_ButtonDiary,   true, true );
    
    common_impl.PlayBackgroundMusic();
    
  end;

end;
--******************************************************************************************
function public.Close()

  --костыль - чтобы снимался блок в комнате из который мы вошли в ачивки при открытом сложном предмете
  if  ( not cmn.is_inmenunow ) then

    cmn.Lock( 0 );
    
    interface.WidgetSetInput( InterfaceWidget_Achiev,    true );
    interface.WidgetSetInput( InterfaceWidget_Bonus,     true );

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  true );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    true );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   true );
    interface.WidgetSetInput( InterfaceWidget_ButtonDiary,  true );

    ObjSet("int_inventory_impl", {input = 1});

  end;
  
end;
--******************************************************************************************
--выход из комнаты
function public.Exit()

  --if public.secretroom_enter == "menu" then
  if cmn.is_inmenunow then
    room.Switch("rm_extra");
  else 
    room.Switch(common.GetCurrentRoom());
  end;

end;
--******************************************************************************************
function public.MouseEnterBack()

  local alp = ObjGet( "spr_secretroom_exit_focus" ).alp;
  ObjAnimate( "spr_secretroom_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,1});
  SetCursor(CURSOR_HAND);

end;

function public.MouseLeaveBack()

  local alp = ObjGet( "spr_secretroom_exit_focus" ).alp;
  ObjAnimate( "spr_secretroom_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,0});
  SetCursor(CURSOR_DEFAULT);

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.DrawScene()
  
  for i = 1, 3, 1 do
  
    if ng_global.secretroom.prize_unlocked[i] == 0 then
      
      ObjSet("txt_secretroom_flowers_"..i,  { text = ng_global.bonus_count_total.."/"..public.npc_cost[i] });

      if ng_global.bonus_count_total >= public.npc_cost[i] then
        ng_global.secretroom.prize_unlocked[i] = 1;
        cmn.Lock(1);
        ObjAnimate("obj_secretroom_dark_"..i, "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 1,   0.5, 0, 0 });
      end;

    else

      ObjDelete("obj_secretroom_dark_"..i);

    end;
    
  end;
  
  private.SetBoard();
  
end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ "secret" ][ "win_secretroom" ].state = { 1, 1 }; 
  --[1] - current place, [2] - state of challenge: 0 - active, 1 - done
  
  ng_global.progress[ "secret" ][ "win_secretroom" ].way = { 0 };
  ng_global.progress[ "secret" ][ "win_secretroom" ].enemies = {
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  };

end;
-----------------------------------------------------------------------------------
function private.SetBoard()
  
  ObjSet("obj_secretroom_player", { pos_x = private.player_pos[ private.state[1] ][1], pos_y = private.player_pos[ private.state[1] ][2] });
  
  for i = 0, 4, 1 do
    
    if i == private.board_challenges[ private.state[1] ] then
      ObjSet("spr_secretroom_board_light_"..i,  { alp = 1 });
    else 
      ObjSet("spr_secretroom_board_light_"..i,  { alp = 0 });
    end;
      
  end;
  
  ObjSet("spr_secretroom_ball_light",  { alp = 1 });
  
  if private.board_challenges[ private.state[1] ] == 4 and 
  private.enemies[ private.board_challenges_num[ private.state[1] ] ] < private.enemies_win[ private.enemies_type[ private.board_challenges_num[ private.state[1] ] ] ] then
  
    private.state[2] = 0;
    private.SetEnemy( private.enemies_type[ private.board_challenges_num[ private.state[1] ] ] );
    ObjSet("obj_secretroom_enemy",  { alp = 1, input = 1 });
    
    local enemy = private.enemies_type[ private.board_challenges_num[ private.state[1] ] ];
    ObjSet("txt_secretroom_enemy_"..enemy.."_hits",  { text = private.enemies[ private.board_challenges_num[ private.state[1] ] ].."/"..private.enemies_win[ enemy ] });
  
  end;
  
end;
-----------------------------------------------------------------------------------
function public.ClickBall()
  
  local prize = private.FindUnlockedPrize();
  
  if private.state[1] == private.board_locked[ prize ] and 
  (private.board_challenges[ private.state[1] ] ~= 4 or 
  private.enemies[ private.board_challenges_num[ private.state[1] ] ] == private.enemies_win[ private.enemies_type[ private.board_challenges_num[ private.state[1] ] ] ]) then
    
    cmn.ShowBbt( "secretroom_no_moves" );
  
  else

    cmn.Lock( 1 );
    private.start_next = 0;
    local enemy_flag = false;
    
    local move = math.random(1, 100);
    if move <= 10 then
      move = 6;
    elseif move <= 20 then
      move = 5;
    elseif move <= 40 then
      move = 4;
    elseif move <= 60 then
      move = 3;
    elseif move <= 80 then
      move = 2;
    else
      move = 1;
    end;
    
    local move_places = {};
    local place = private.state[1];
    
    if private.state[2] == 1 then
      
      cmn.PlayAudio("snd", "assets/levels/menu/rm_secretroom/audio/aud_secret_room_click_field");
      
      private.state[1] = private.state[1] + move;
      if private.state[1] > private.board_locked[ prize ] then
        move = private.board_locked[ prize ] - place;
        private.state[1] = private.board_locked[ prize ];
      end;
      
      --local count = private.state[1] - place;
    
      for i = place, private.state[1], 1 do
        
        table.insert( move_places,  i);
        
      end;
      
      if private.board_challenges[ private.state[1] ] > 0 then
        private.state[2] = 0;
        private.start_next = private.board_challenges[ private.state[1] ];
      end;
      
      if private.board_challenges[ private.state[1] ] == 4 then
        private.enemies[ private.board_challenges_num[ private.state[1] ] ] = 0;
      end;
      
      if private.board_challenges[ private.state[1] ] == 2 then
        private.way[1] = 1;
        private.state[1] = private.dead_ends[ private.board_challenges_num[ private.state[1] ] ][1];
      end;
      
      if private.board_challenges[ private.state[1] ] == 1 then
        private.way[1] = 1;
      end;
      
    --in workaround
    elseif private.board_challenges[ private.state[1] ] == 1 then
    
      cmn.PlayAudio("snd", "assets/levels/menu/rm_secretroom/audio/aud_secret_room_click_field");
      
      place = private.state[1];
      
      local ind = {0, 0};
      if private.way[1] == 0 then
        ind[1] = 1;
      else 
        ind[1] = private.way[1];
      end;
      private.way[1] = private.way[1] + move;
      ind[2] = private.way[1];
      
      local chal;
      
      if private.board_challenges[ private.state[1] ] == 0 then
        
        for i = 1, #private.add_ways, 1 do
          for j = 1, #private.add_ways[i], 1 do
            
            if private.add_ways[i][j] == private.state[1] then
              chal = i;
              break;
            end;
            
          end;
        end;
        
      else 
        chal = private.board_challenges_num[ private.state[1] ];
      end;
      
      local len = #private.add_ways[ chal ];
      local max = private.add_ways[ chal ][ len ];
      
      if private.way[1] >= len then
        
        ind[2] = len;
        private.state[1] = max + private.way[1] - len;
        private.way[1] = 0;
        
        if private.state[1] > private.board_locked[ prize ] then
          --move = private.board_locked[ prize ] - place;
          private.state[1] = private.board_locked[ prize ];
        end;
        
        for i = ind[1], ind[2], 1 do
          table.insert( move_places, private.add_ways[ chal ][ i ]);
        end;
        
        for i = max+1, private.state[1], 1 do
          table.insert( move_places,  i);
        end;
        
        move = #move_places-1;
        
      else 
        
        private.state[1] = private.add_ways[ chal ][ private.way[1] ];
        
        for i = ind[1], ind[2], 1 do
          table.insert( move_places, private.add_ways[ chal ][ i ]);
        end;
        
        move = #move_places-1;
        
      end;
      
      if private.board_challenges[ private.state[1] ] == 4 then
        private.state[2] = 0;
        private.enemies[ private.board_challenges_num[ private.state[1] ] ] = 0;
        private.start_next = private.board_challenges[ private.state[1] ];
      end;
      
      if private.board_challenges[ private.state[1] ] == 0 then
        private.state[2] = 1;
      end;
      
    --in dead end
    elseif private.board_challenges[ private.state[1] ] == 2 or 
    ( private.board_challenges[ private.state[1] ] == 4 and 
    private.enemies[ private.board_challenges_num[ private.state[1] ] ] == private.enemies_win[ private.enemies_type[ private.board_challenges_num[ private.state[1] ] ] ] ) then
      
      cmn.PlayAudio("snd", "assets/levels/menu/rm_secretroom/audio/aud_secret_room_click_field");
      
      place = private.state[1];
      private.way[1] = private.way[1] + move;
      local chal;
      
      if private.board_challenges[ private.state[1] ] == 4 then
        
        for i = 1, #private.dead_ends, 1 do
          for j = 1, #private.dead_ends[i], 1 do
            
            if private.dead_ends[i][j] == private.state[1] then
              chal = i;
              break;
            end;
            
          end;
        end;
        
      else 
        chal = private.board_challenges_num[ private.state[1] ];
      end;
      
      local len = #private.dead_ends[ chal ];
      local max = private.dead_ends[ chal ][ len-1 ];
      local max2 = private.dead_ends[ chal ][ len ];
      
      if private.way[1] >= len then
        
        private.state[1] = max2 + private.way[1] - len;
        private.way[1] = 0;
        
        if private.state[1] > private.board_locked[ prize ] then
          --move = private.board_locked[ prize ] - place;
          private.state[1] = private.board_locked[ prize ];
        end;
        
        for i = place, max, 1 do
          table.insert( move_places,  i);
        end;
        
        for i = max2, private.state[1], 1 do
          table.insert( move_places,  i);
        end;
        
        move = #move_places-1;
        
      else 
        
        private.state[1] = private.dead_ends[ chal ][ private.way[1] ];
        
        for i = place, private.state[1], 1 do
          table.insert( move_places,  i);
        end;
        
        move = #move_places-1;
        
      end;
      
      if private.board_challenges[ private.state[1] ] == 4 then
        --private.state[2] = 0;
        private.enemies[ private.board_challenges_num[ private.state[1] ] ] = 0;
        private.start_next = private.board_challenges[ private.state[1] ];
      end;
      
      if private.state[1] == max2 then
        private.state[2] = 1;
      end;
      
      if private.board_challenges[ private.state[1] ] == 0 then
        private.state[2] = 1;
      end;
      
    --enemy
    elseif private.board_challenges[ private.state[1] ] == 4 then
    
      cmn.PlayAudio("snd", "assets/levels/menu/rm_secretroom/audio/aud_secret_room_square_click");
      enemy_flag = true;
      
    end;
    
    local make_move = function ()
      
      if not enemy_flag then
        ObjAnimate("spr_secretroom_board_light_"..private.board_challenges[ place ], "alp", 0, 0, function() private.MakeMoves( move_places, move ) end, { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
        ObjAnimate("spr_secretroom_ball_number_"..move, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      else 
        ObjAnimate("spr_secretroom_ball_number_"..move, "alp", 0, 0, function()  private.HitEnemy( move ); end, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
      end;
        
    end;
    
    local anm_ball = function ()
      ObjSet("anm_secretroom_ball", { playing = 1, endtrig = make_move });
    end;
    
    ObjAnimate("spr_secretroom_ball_light", "alp", 0, 0, anm_ball, { 0, 0, 1,   0.3, 0, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.MakeMoveEnd( move, last )
  
  if private.board_challenges[ private.state[1] ] > 0 then
    cmn.PlayAudio("snd", "assets/levels/menu/rm_secretroom/audio/aud_secret_room_wrong_place");
  else 
    cmn.PlayAudio("snd", "assets/levels/menu/rm_secretroom/audio/aud_secret_room_right_place");
  end;
  
  local func_after = function ()
    
    local func_2 = function ()
    
      if private.start_next == 0 then
        cmn.Lock( 0 );
      else 
        private.StartChallenge();
      end;
      
    end;
    
    ObjAnimate("spr_secretroom_ball_light", "alp", 0, 0, func_2, { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  ObjAnimate("spr_secretroom_ball_number_"..move, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
  if private.state[1] ~= private.board_locked[ 4 ] then
    ObjAnimate("spr_secretroom_board_light_"..private.board_challenges[ last ], "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  else 
    private.CheckWin( true );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.MakeMoves( move_places, move )
  
  if #move_places > 1 then
    
    cmn.PlayAudio( "snd", "assets/levels/menu/rm_secretroom/audio/aud_secret_room_atom_moves_"..math.random(1, 3) );
    
    local place = move_places[1];
    table.remove( move_places, 1 );
    
    ObjAnimate("obj_secretroom_player", "pos_xy", 0, 0, function() private.MakeMoves( move_places, move ) end, { 
        0, 0, private.player_pos[ place ][1], private.player_pos[ place ][2],   
      0.5, 0, private.player_pos[ move_places[1] ][1], private.player_pos[ move_places[1] ][2] ,   
      0.7, 0, private.player_pos[ move_places[1] ][1], private.player_pos[ move_places[1] ][2]
    });
    
  else
    private.MakeMoveEnd( move, move_places[1] );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.StartChallenge()
  
  local num = private.start_next;
  private.start_next = 0;
  
  if num == 1 then
    
    cmn.Lock( 0 );
    
  elseif num == 2 then
    
    local func_check = function ()
      
      if private.board_challenges[ private.state[1] ] == 4 then
        private.start_next = 4;
        private.StartChallenge();
      else 
        cmn.Lock( 0 );
      end;
      
    end;
    
    local func_after = function ()
      
      for i = 1, 4, 1 do
        if i == private.board_challenges[ private.state[1] ] then
          ObjSet("spr_secretroom_board_light_"..i,  { alp = 1 });
        else 
          ObjSet("spr_secretroom_board_light_"..i,  { alp = 0 });
        end;
      end;
      
      ObjSet("obj_secretroom_player", { pos_x = private.player_pos[ private.state[1] ][1], pos_y = private.player_pos[ private.state[1] ][2] });
      ObjAnimate("obj_secretroom_player", "alp", 0, 0, func_check, { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjAnimate("obj_secretroom_player", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
    
  elseif num == 4 then
    
    local enemy = private.enemies_type[ private.board_challenges_num[ private.state[1] ] ];
      
    private.SetEnemy( enemy );
    ObjAnimate("obj_secretroom_enemy", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 0,   0.5, 0, 1 });
      
  else
    cmn.Lock( 0 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.HitEnemy( hit )
  
  local enemy = private.enemies_type[ private.board_challenges_num[ private.state[1] ] ];
  local enemy_state = private.enemies[ private.board_challenges_num[ private.state[1] ] ];
  local check = false;
  
  for i = 1, #private.enemies_hits[enemy][enemy_state + 1], 1 do
    
    if hit == private.enemies_hits[enemy][enemy_state + 1][i] then
      check = true;
      break;
    end;
    
  end;
  
  if check then
    
    cmn.PlayAudio("snd", "assets/levels/menu/rm_secretroom/audio/aud_secret_room_square_right");
  
    private.enemies[ private.board_challenges_num[ private.state[1] ] ] = private.enemies[ private.board_challenges_num[ private.state[1] ] ] + 1;
    
    local chal = 0;
        
    for i = 1, #private.dead_ends_enemies, 1 do
        
      if private.dead_ends_enemies[i] == private.state[1] then
        chal = i;
        break;
      end;
      
    end;
    
    if chal == 0 and
    private.enemies[ private.board_challenges_num[ private.state[1] ] ] == private.enemies_win[ private.enemies_type[ private.board_challenges_num[ private.state[1] ] ] ] then
      private.state[2] = 1;
    end;
    
    local func_after = function ()
      
      if private.enemies[ private.board_challenges_num[ private.state[1] ] ] == private.enemies_win[ private.enemies_type[ private.board_challenges_num[ private.state[1] ] ] ] then
        private.CloseEnemy( enemy );
      else 
        cmn.Lock( 0 );
      end;
      
    end;
    
    ObjSet("txt_secretroom_enemy_"..enemy.."_hits",  { text = private.enemies[ private.board_challenges_num[ private.state[1] ] ].."/"..private.enemies_win[ enemy ] });
    ObjAnimate("spr_secretroom_ball_number_"..hit, "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0,   1, 0, 0 });
    ObjAnimate("spr_secretroom_ball_light", "alp", 0, 0, "", { 0, 0, 0,   0.7, 0, 0,   1, 0, 1 });
    
  else 
    
    cmn.PlayAudio("snd", "assets/levels/menu/rm_secretroom/audio/aud_secret_room_square_wrong");
    
    ObjAnimate("spr_secretroom_ball_number_"..hit, "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.2, 0, 0,    0.4, 0, 1,     0.6, 0, 0,    0.8, 0, 1,    1, 0, 0 });
    ObjAnimate("spr_secretroom_ball_light", "alp", 0, 0, "", { 0, 0, 0,   0.7, 0, 0,   1, 0, 1 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.SetEnemy( enemy )
  
  for i = 1, 4, 1 do
    
    if i ~= enemy then
      ObjSet("spr_secretroom_enemy_"..i,  { alp = 0 });
    else 
      ObjSet("spr_secretroom_enemy_"..i,  { alp = 1 });
    end;
    
  end;
  
  ObjMultiSet( { {"txt_secretroom_enemy_"..enemy.."_hits",  { text = "0/"..private.enemies_win[ enemy ] }},
                 {"obj_secretroom_enemy", { input = 1 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.CloseEnemy( enemy )
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    ObjSet("spr_secretroom_enemy_"..enemy,  { alp = 0 });
    
  end;
  
  ObjSet("obj_secretroom_enemy",  { input = 0 });
  ObjAnimate("obj_secretroom_enemy", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
  
end;
-----------------------------------------------------------------------------------
function private.CheckAddEnemies( place )
  
  local enemy = 0;
  
  for i = 1, #private.dead_ends_enemies, 1 do
    
    if private.dead_ends_enemies[i] == place then
      enemy = i;
      break;
    end;
    
  end;
  
  return enemy;
  
end;
-----------------------------------------------------------------------------------
function private.FindUnlockedPrize()
  
  local ind = 0;
  
  for i = 3, 1, -1 do
    
    if ng_global.secretroom.prize_unlocked[i] == 1 then
      ind = i;
      break;
    end;
    
  end;
  
  ind = ind + 1;
  
  return ind;
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin( ingame )
  
  ingame = ingame or false;
  
  if private.state[1] == private.board_locked[ 4 ] then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/menu/rm_secretroom/audio/aud_secret_room_win");
    
    local flag = 0;
    
    if ng_global.secretroom.prize_unlocked[4] and ng_global.secretroom.prize_unlocked[4] == 1 then
      flag = 1;
    end;
    
    ng_global.secretroom.prize_unlocked[4] = 1;
    
    local func_after = function ()
      
      cmn.Lock( 0 );
      
      if cmn.is_inmenunow then
      
        if flag == 1 then
          cmn.DialogWindowShow( "common", "secretroom_win2" );
        else 
          rm_extra.show_screen = true;
          cmn.DialogWindowShow( "common", "secretroom_win" );
        end;
        
      else 
        
        cmn.DialogWindowShow( "common", "secretroom_win3" );
        
      end;
      
    end;
    
    ObjSet("tmr_secretroom_timer",  { time = 1, playing = 1, endtrig = func_after });
      
  end;

end;
--***********************************************************************************